#!/usr/bin/perl

use DBI;


open (IN, "< npc.scp") if ( -e "npc.scp" );
open (OUT, ">> /tmp/npc.csv") ;

print OUT "".
	"nr;category;subcategory;desc;id;skin;namelist;race;gold_min;".
	"gold_max;str_min;str_max;dex_min;dex_max;int_min;int_max;karma;".
	"fame;spattack;spadelay;def;damage_min;damage_max;poison;npcwander;".
	"fx1;fy1;fz1;fx2;npcai;totame;shopkeeper\n";

while (<IN>){

	next unless /^SECTION NPC\b/ .. /^}/;
	
		SWITCH:{
		if (/^SECTION NPC\s(\d+).*$/){$nr=$1; last SWITCH;}
		if (/^\/\/CATEGORY\s(.*)$/){($category=$1) =~ s/\'/\'\'/; last SWITCH;} 
		if (/^\/\/SUBCATEG\s(.*)$/){($subcategory=$1) =~ s/\'/\'\'/; last SWITCH;} 
		if (/^\/\/DESCRIPT\s(.*)$/){($desc=$1) =~ s/\'/\'\'/; last SWITCH;}
		if (/^ID\s+(\w+).*$/){$id=$1; last SWITCH;}
		if (/^SKIN\s+(\w+).*$/){$skin=$1; last SWITCH;}
		if (/^NAMELIST\s+(\w+).*$/){$namelist=$1; last SWITCH;}
		if (/^RACE\s+(\w+).*$/){$race=$1; last SWITCH;}
		if (/^GOLD\s+(\w+)\s+(\w+).*$/){$gold_min=$1; $gold_max=$2; last SWITCH;}
		if (/^STR\s+(\w+)\s+(\w+).*$/){$str_min=$1; $str_max=$2; last SWITCH;}
		if (/^DEX\s+(\w+)\s+(\w+).*$/){$dex_min=$1; $dex_max=$2; last SWITCH;}
		if (/^INT\s+(\w+)\s+(\w+).*$/){$int_min=$1; $int_max=$2; last SWITCH;}
		if (/^KARMA\s+(-?\w+).*$/){$karma=$1; last SWITCH;}
		if (/^FAME\s+(-?\w+).*$/){$fame=$1; last SWITCH;}
		if (/^SPATTACK\s+(\w+).*$/){$spattack=$1; last SWITCH;}
		if (/^SPADELAY\s+(\w+).*$/){$spadelay=$1; last SWITCH;}
		if (/^DEF\s+(\w+).*$/){$def=$1; last SWITCH;}
		if (/^POISON\s+(\w+).*$/){$poison=$1; last SWITCH;}
		if (/^DAMAGE\s+(\w+)\s+(\w+).*$/){$damage_min=$1; $damage_max=$2; last SWITCH;}
		if (/^NPCWANDER\s+(\w+).*$/){$npcwander=$1; last SWITCH;}
		if (/^FX1\s+(-?\w+).*$/){$fx1=$1; last SWITCH;}
		if (/^FY1\s+(-?\w+).*$/){$fy1=$1; last SWITCH;}
		if (/^FZ1\s+(-?\w+).*$/){$fz1=$1; last SWITCH;}
		if (/^FX2\s+(-?\w+).*$/){$fx2=$1; last SWITCH;}
		if (/^NPCAI\s+(\w+).*$/){$npcai=$1; last SWITCH;}
		if (/^TOTAME\s+(\w+).*$/){$totame=$1; last SWITCH;}
		if (/^SHOPKEEPER.*$/){$shopkeeper="YES"; last SWITCH;}

	
		if (/^\}/){
			
			print OUT "".
				"$nr;$category;$subcategory;$desc;$id;$skin;$namelist;$race;$gold_min;".
				"$gold_max;$str_min;$str_max;$dex_min;$dex_max;$int_min;$int_max;$karma;".
				"$fame;$spattack;$spadelay;$def;$damage_min;$damage_max;$poison;$npcwander;".
				"$fx1;$fy1;$fz1;$fx2;$npcai;$totame;$shopkeeper\n";


			$nr="";
			$category=""; 
			$subcategory=""; 
			$desc="";
			$id="";
			$skin="";
			$namelist="";
			$race="";
			$gold_min=""; $gold_max="";
			$str_min=""; $str_max="";
			$dex_min=""; $dex_max="";
			$int_min=""; $int_max="";
			$karma="";
			$fame="";
			$spattack="";
			$spadelay="";
			$def="";
			$damage_min=""; $damage_max="";
			$poison="";
			$npcwander="";
			$fx1="";
			$fy1="";
			$fz1="";
			$fx2="";
			$npcai="";
			$totame="";
			$shopkeeper="";
			last SWITCH;
		
		} # IF }
	} # SWITCH
} # WHILE
close(IN);
