#!/usr/bin/perl

use DBI;


open (IN, "< npc.scp") if ( -e "npc.scp" );
open (OUT, ">> /tmp/npc.csv") ;

print OUT "".
	"nr;category;subcategory;desc;id;skin;namelist;race;gold_min;".
	"gold_max;str_min;str_max;dex_min;dex_max;int_min;int_max;karma;".
	"fame;spattack;spadelay;def;damage_min;damage_max;poison;npcwander;".
	"fx1;fy1;fz1;fx2;npcai;totame;shopkeeper\n";

$user="YOUR_DB_USER";
$pwd="YOUR_DB_PWD";
$host="localhost";
$db="lonewolfdb";

my $dbh = DBI->connect("DBI:mysql:database=$db;host=$host",
                                "$user", "$pwd",
                                {'RaiseError' => 1}) or die "Connecting : $DBI::errstr\n";

$dbh->do("DROP TABLE IF EXISTS NPC"); 

$dbh->do("CREATE TABLE NPC(".
        	"idnpc smallint(5) UNSIGNED PRIMARY KEY AUTO_INCREMENT,".
        	"num_npc smallint unsigned,".
        	"category_npc varchar(35),".
        	"subcategory_npc varchar(35),".
        	"desc_npc varchar(35),".
		"id_npc varchar(10),".
		"skin_npc varchar(10),".
		"namelist_npc smallint,".
		"race_npc varchar(35),".
		"goldmin_npc smallint unsigned,".
		"goldmax_npc smallint unsigned,".
		"strmin_npc smallint unsigned,".
		"strmax_npc smallint unsigned,".
		"dexmin_npc smallint unsigned,".
		"dexmax_npc smallint unsigned,".
		"intmin_npc smallint unsigned,".
		"intmax_npc smallint unsigned,".
		"fame_npc int,".
		"karma_npc int,".
		"damagemin_npc smallint unsigned,".
		"damagemax_npc smallint unsigned,".
		"def_npc smallint unsigned,".
		"poison_npc smallint unsigned,".
		"spattack_npc smallint unsigned,".
		"spadelay_npc tinyint unsigned,".
		"npcai_npc varchar(3),".
		"wander_npc varchar(3),".
		"fx1_npc tinyint,".
		"fy1_npc tinyint,".
		"fz1_npc tinyint,".
		"fx2_npc tinyint,".
		"totame_npc smallint unsigned,".
		"shopkeeper_npc char(3),".
        	"data  timestamp(14))");

while (<IN>){

	next unless /^SECTION NPC\b/ .. /^}/;
	
		SWITCH:{
		if (/^SECTION NPC\s(\d+).*$/){$nr=$1; last SWITCH;}
		if (/^\/\/CATEGORY\s(.*)$/){($category=$1) =~ s/\'/\'\'/; last SWITCH;} 
		if (/^\/\/SUBCATEG\s(.*)$/){($subcategory=$1) =~ s/\'/\'\'/; last SWITCH;} 
		if (/^\/\/DESCRIPT\s(.*)$/){($desc=$1) =~ s/\'/\'\'/; last SWITCH;}
		if (/^ID\s+(\w+).*$/){$id=$1; last SWITCH;}
		if (/^SKIN\s+(\w+).*$/){$skin=$1; last SWITCH;}
		if (/^NAMELIST\s+(\w+).*$/){$namelist=$1; last SWITCH;}
		if (/^RACE\s+(\w+).*$/){$race=$1; last SWITCH;}
		if (/^GOLD\s+(\w+)\s+(\w+).*$/){$gold_min=$1; $gold_max=$2; last SWITCH;}
		if (/^STR\s+(\w+)\s+(\w+).*$/){$str_min=$1; $str_max=$2; last SWITCH;}
		if (/^DEX\s+(\w+)\s+(\w+).*$/){$dex_min=$1; $dex_max=$2; last SWITCH;}
		if (/^INT\s+(\w+)\s+(\w+).*$/){$int_min=$1; $int_max=$2; last SWITCH;}
		if (/^KARMA\s+(-?\w+).*$/){$karma=$1; last SWITCH;}
		if (/^FAME\s+(-?\w+).*$/){$fame=$1; last SWITCH;}
		if (/^SPATTACK\s+(\w+).*$/){$spattack=$1; last SWITCH;}
		if (/^SPADELAY\s+(\w+).*$/){$spadelay=$1; last SWITCH;}
		if (/^DEF\s+(\w+).*$/){$def=$1; last SWITCH;}
		if (/^POISON\s+(\w+).*$/){$poison=$1; last SWITCH;}
		if (/^DAMAGE\s+(\w+)\s+(\w+).*$/){$damage_min=$1; $damage_max=$2; last SWITCH;}
		if (/^NPCWANDER\s+(\w+).*$/){$npcwander=$1; last SWITCH;}
		if (/^FX1\s+(-?\w+).*$/){$fx1=$1; last SWITCH;}
		if (/^FY1\s+(-?\w+).*$/){$fy1=$1; last SWITCH;}
		if (/^FZ1\s+(-?\w+).*$/){$fz1=$1; last SWITCH;}
		if (/^FX2\s+(-?\w+).*$/){$fx2=$1; last SWITCH;}
		if (/^NPCAI\s+(\w+).*$/){$npcai=$1; last SWITCH;}
		if (/^TOTAME\s+(\w+).*$/){$totame=$1; last SWITCH;}
		if (/^SHOPKEEPER.*$/){$shopkeeper="YES"; last SWITCH;}

	
		if (/^\}/){
			
			$sql =  "INSERT INTO NPC (".
				"num_npc,category_npc,subcategory_npc,desc_npc,id_npc,skin_npc,".
				"namelist_npc,race_npc,goldmin_npc,goldmax_npc,strmin_npc,strmax_npc,".
				"dexmin_npc,dexmax_npc,intmin_npc,intmax_npc,karma_npc,fame_npc,damagemin_npc,".
				"damagemax_npc,def_npc,poison_npc,spattack_npc,spadelay_npc,npcai_npc,".
				"wander_npc,fx1_npc,fy1_npc,fz1_npc,fx2_npc,totame_npc,shopkeeper_npc) ".
				"VALUES (".
                                "'$nr','$category','$subcategory','$desc','$id','$skin','$namelist','$race','$gold_min',".
                                "'$gold_max','$str_min','$str_max','$dex_min','$dex_max','$int_min','$int_max','$karma',".
                                "'$fame','$damage_min','$damage_max','$def','$poison','$spattack','$spadelay','$npcai',".
				"'$npcwander','$fx1','$fy1','$fz1','$fx2','$totame','$shopkeeper')";
                                



	
			print OUT "".
				"$nr;$category;$subcategory;$desc;$id;$skin;$namelist;$race;$gold_min;".
				"$gold_max;$str_min;$str_max;$dex_min;$dex_max;$int_min;$int_max;$karma;".
				"$fame;$spattack;$spadelay;$def;$damage_min;$damage_max;$poison;$npcwander;".
				"$fx1;$fy1;$fz1;$fx2;$npcai;$totame;$shopkeeper\n";

			$dbh->do("$sql"); 

			$nr="";
			$category=""; 
			$subcategory=""; 
			$desc="";
			$id="";
			$skin="";
			$namelist="";
			$race="";
			$gold_min=""; $gold_max="";
			$str_min=""; $str_max="";
			$dex_min=""; $dex_max="";
			$int_min=""; $int_max="";
			$karma="";
			$fame="";
			$spattack="";
			$spadelay="";
			$def="";
			$damage_min=""; $damage_max="";
			$poison="";
			$npcwander="";
			$fx1="";
			$fy1="";
			$fz1="";
			$fx2="";
			$npcai="";
			$totame="";
			$shopkeeper="";
			last SWITCH;
		
		} # IF }
	} # SWITCH
} # WHILE
close(IN);
