/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

/////////////////////////////////////////////////
/// initial version written by GM Pokey for ROJ
/////////////////////////////////////////////////

/////////////////////////////////////////////////////////
/// integration to LW and resulting bugs courtesy of LB
/////////////////////////////////////////////////////////


#include "Partysystem.h"

#include "Client.h"
#include "network.h"
#include "SndPkg.h"
#include "targeting.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "p_ai.cpp"

void cParty::AddMember(P_CHAR Player)
{
	char JoinMessage[80];	// charname can be  up to 50 chars.. so the message can be longer (Thrawn)
	sprintf(JoinMessage, "%s has joined the party.", Player->name);
	Player->Msg("You have joined the party.");

	for (list<P_CHAR>::iterator Trav = Members.begin(); Trav != Members.end(); Trav++)
	{
		(*Trav)->Msg(JoinMessage);
	}
	
	this->Members.push_back(Player);
	
	Player->PutInParty();
	SendMemberListToAll();
}

void cParty::SendMemberList(P_CHAR Player)
{
	unsigned char PartyList[50] = "\xBF\x00\x0F\x00\x06\x01";
	char NumMembers = 0;

	UOXSOCKET s = Player->getSlot();

	if (s<0) return;

	for (list<P_CHAR>::iterator Trav = Members.begin(); Trav != Members.end(); Trav++)
	{
		LongToCharPtr((*Trav)->serial,&PartyList[7+4*NumMembers]);
		NumMembers++;
	}

	int l=7+4*NumMembers;
	PartyList[6] = NumMembers;
	PartyList[2] = l;

	XStartPkt(0xBF, l);
	XAddPkt(&PartyList[0+3], l-3);
	XFinishPkt(s);
}

void cParty::SendMemberListToAll()
{
	unsigned char PartyList[50] = "\xBF\x00\x0F\x00\x06\x01";
	char NumMembers = 0;

	UOXSOCKET s;
	list<P_CHAR>::iterator Trav;

	for (Trav = Members.begin(); Trav != Members.end(); Trav++)
	{
		LongToCharPtr((*Trav)->serial,&PartyList[7+4*NumMembers]);
		NumMembers++;
	}

	PartyList[6] = NumMembers;
	PartyList[2] = 7+4*NumMembers;
	for (Trav = Members.begin(); Trav != Members.end(); Trav++)
	{
		s = (*Trav)->getSlot();
		if (s>=0)
		{
			int l=7+4*NumMembers;
			XStartPkt(0xBF, l);
			XAddPkt(&PartyList[0+3], l-3);
			XFinishPkt(s);
		}
	}
}

void cParty::Disband()
{
	unsigned char RemovePacket[15] = "\xBF\x00\x0B\x00\x06\x02\x00\x00\x00\x00\x00";
	UOXSOCKET s;
	for (list<P_CHAR>::iterator Trav = Members.begin(); Trav != Members.end(); Trav++)
	{
		LongToCharPtr((*Trav)->serial,&RemovePacket[7]);

		(*Trav)->RemoveFromParty();  
		(*Trav)->DisallowPartyLoot();

		s = (*Trav)->getSlot();
		if (s>=0)
		{
			XStartPkt(0xBF,11);
			XAddPkt(&RemovePacket[0+3], 11-3);
			XFinishPkt(s);
			(*Trav)->Msg("The party has been disbanded.");
		}
	}
	Members.clear();
}

void cParty::RemoveMember(P_CHAR Player)
{
	unsigned char RemovePacket[50] = "\xBF\x00\x0B\x00\x06\x02";
	char NumMembers = 0;
	char LeaveMessage[50];

	list<P_CHAR>::iterator Trav;

	if (Player == *(Members.begin()) || Members.size() == 2)
	{
		Disband();
		return;
	}

	LongToCharPtr(Player->serial,&RemovePacket[7]);

	for (Trav = Members.begin(); Trav != Members.end(); Trav++)
	{
		if (*Trav != Player)
		{
			LongToCharPtr((*Trav)->serial,&RemovePacket[11+4*NumMembers]);
			NumMembers++;
		}
	}

	RemovePacket[6] = NumMembers;
	RemovePacket[2] = 11+4*NumMembers;

	sprintf(LeaveMessage, "%s has left the party.", Player->name);
	
	for (Trav = Members.begin(); Trav != Members.end(); Trav++)
	{
		UOXSOCKET s = (*Trav)->getSlot();
		if (s>=0)
		{
			int l=11+4*NumMembers;

			XStartPkt(0xBF, l);
			XAddPkt(&RemovePacket[0+3], l-3);
			XFinishPkt(s);

			if (!Player->isSameAs(*Trav))
			{
				(*Trav)->Msg(LeaveMessage);
			}
			else
			{
				Player->Msg("You have left the party.");
			}
		}
	}

	Members.remove(Player);

	Player->RemoveFromParty();   
	Player->DisallowPartyLoot();

}

list<P_CHAR>::iterator cParty::FindMember(P_CHAR Player)
{
	for (list<P_CHAR>::iterator Trav = Members.begin(); Trav != Members.end(); Trav++)
	{
		if ((*Trav) == Player)
			return Trav;
	}
	return NULL;
}

void cPartySystem::RequestAuthorization(P_PLAYER PartyOwner, P_CHAR Target)
{
	if (!PartyOwner) return;

	if (!Target) return;

	list<cParty>::iterator Trav = FindParty(PartyOwner);
	if (Trav != NULL)
	{
		if (Trav->Members.size() > 9)
		{
			PartyOwner->Msg("Your party is already full.");
			return;
		}
	}

	if (Target == PartyOwner)
	{
		PartyOwner->Msg("You're already the life of your own party!");
		return;
	}

	if (Target->InParty())
	{
		PartyOwner->Msg("That person is already in a party.");
		return;
	}

	unsigned char JoinParty[] = "\xBF\x00\x0A\x00\x06\x07\x00\x00\x00\x00";
	LongToCharPtr(PartyOwner->serial,&JoinParty[6]);

	UOXSOCKET Cl_Targ = Target->getSlot();

	if (Cl_Targ>=0) 
	{
		XStartPkt(0xBF, 10);
		XAddPkt(&JoinParty[0+3], 10-3);
		XFinishPkt(Cl_Targ);
	}

	char RequestMessage[100];
	sprintf(RequestMessage, "%s has asked you to join his party.  Type /accept or /decline.", PartyOwner->name);
	Target->Msg(RequestMessage);

}

void cPartySystem::AddMemberTarg(P_PLAYER Player)
{
	if (!Player)
		return;

	list<cParty>::iterator Party = FindParty(Player);

	if (Party != NULL && !IsLeaderOfParty(Player, Party))
	{
		Player->Msg("You are not the leader of that party");
		return;
	}
	
	target(Player, T_350, "Select player to add to party.");
	return;
}

void cPartySystem::AddMember(P_PLAYER Player)
{
	if (!Player) return;

	UOXSOCKET s = Player->cs;
	if (Player->InParty())
	{
		Player->Msg("You are already in a party.");
		return;
	}

	P_CHAR PartyOwner = FindCharBySerPtr(&buffer[s][6]);

	if (PartyOwner == NULL || !PartyOwner->InGame()) return;

	list<cParty>::iterator Party = FindParty(PartyOwner);

	if (Party == NULL)
	{
		cParty NewParty;
		PartyList.push_back(NewParty);
		Party = PartyList.end();
		Party--;

		Party->AddMember(PartyOwner);
		Party->AddMember(Player);
	}
	else
	{
		if (Party->Members.size() > 9)
		{
			Player->Msg("That party is full.");
		}
		else
		{
			Party->AddMember(Player);
		}
	}
}

void cPartySystem::RemoveMemberTarg(P_PLAYER Player, P_CHAR Target)
{
	UOXSOCKET s = Player->cs;
	if (s<0) return;

	if (!Target) return;

	list<cParty>::iterator MyParty = FindParty(Target);
	if (MyParty != NULL)
	{
		MyParty->RemoveMember(Target);
	}
}

void cPartySystem::RemoveMember(P_PLAYER Player)
{
	UOXSOCKET s = Player->cs;
	if (s<0) return;

	int serial = LongFromCharPtr(&buffer[s][6]);

	if (serial == 0)
	{
		target(Player, T_351, "Select player to remove from the party.");
		return;
	}

	P_CHAR Member = FindCharBySerial(serial);
	if (!Member)
		return;

	list<cParty>::iterator MyParty = FindParty(Member);
	if (MyParty != NULL)
	{
		MyParty->RemoveMember(Member);
		if (MyParty->Members.size() == 0)
			PartyList.erase(MyParty);
	}
}

void cPartySystem::LogoutPartyMember(P_CHAR Player)
{
	if (!Player->InParty()) return; 

	list<cParty>::iterator MyParty = FindParty(Player);
	if (MyParty != NULL)
	{
		MyParty->RemoveMember(Player);
		if (MyParty->Members.size() == 0)
			PartyList.erase(MyParty);
	}

}

void cPartySystem::LoginPartyMember(P_CHAR Player)
{
	if (!Player->InParty()) 
		return;

	list<cParty>::iterator MyParty = FindParty(Player);
	if (MyParty != NULL)
	{
		MyParty->SendMemberList(Player);
	}
}

list<cParty>::iterator cPartySystem::FindParty(P_CHAR Player)
{
	if (!Player->InParty()) return NULL;

	for (list<cParty>::iterator Trav = PartyList.begin(); Trav != PartyList.end(); Trav++)
	{
		if (Trav->FindMember(Player) != NULL)
			return Trav;
	}
	Player->RemoveFromParty();
	return NULL;
}

bool cPartySystem::IsLeaderOfParty(P_CHAR Player, list<cParty>::iterator Party)
{
	return (Player == *Party->Members.begin());
}

void cPartySystem::SendPrivateMessage(P_PLAYER Player)
{
	if (!Player)
		return;

	UOXSOCKET s = Player->cs;
	if (s<0) return;

	P_CHAR Dest = FindCharBySerPtr(&buffer[s][6]);

	unsigned char PartySpeech[200] = "\xBF\x00\x00\x00\x06\x03\x00\x00\x00\x00";

	LongToCharPtr(Player->serial,&PartySpeech[6]);

	int x;
	for (x = 0; buffer[s][(2*x) + 11] != 0; x++)
	{
		PartySpeech[2*x + 10] = buffer[s][(2*x) + 10];
		PartySpeech[2*x + 11] = buffer[s][(2*x) + 11];
	}

	PartySpeech[2*x + 10] = 0;
	PartySpeech[2*x + 11] = 0;
	PartySpeech[1] = (2*x + 12) >> 8;
	PartySpeech[2] = (2*x + 12) % 256;

	if (Dest->InParty())
	{
		UOXSOCKET Cl_Dest = Dest->getSlot();
		if (Cl_Dest>=0)
		{
			int l = 2*x+12;

			XStartPkt(0xBF, l);
			XAddPkt(&PartySpeech[0+3], l-3);
			XFinishPkt(Cl_Dest);
		}
	}
}

void cPartySystem::SendPartyMessage(P_PLAYER Player)
{
	if (!Player) return;

	unsigned char PartySpeech[500] = "\xBF\x00\x00\x00\x06\x04\x00\x00\x00\x00";

	LongToCharPtr(Player->serial,&PartySpeech[6]);

	UOXSOCKET s = Player->cs;
	if (s<0) return;

	int x;
	for (x = 0; buffer[s][(2*x) + 7] != 0; x++)
	{
		PartySpeech[2*x + 10] = buffer[s][(2*x) + 6];
		PartySpeech[2*x + 11] = buffer[s][(2*x) + 7];
	}

	PartySpeech[2*x + 10] = 0;
	PartySpeech[2*x + 11] = 0;
	PartySpeech[1] = (2*x + 12) >> 8;
	PartySpeech[2] = (2*x + 12) % 256;

	list<cParty>::iterator MyParty = FindParty(Player);
	if (MyParty != NULL)
	{
		for (list<P_CHAR>::iterator Trav = MyParty->Members.begin(); Trav != MyParty->Members.end(); Trav++)
		{
			UOXSOCKET Cl_Dest = (*Trav)->getSlot();
			if ((*Trav)->InParty() && Cl_Dest>=0)
			{
				int l=2*x + 12;
				XStartPkt(0xBF, l);
				XAddPkt(&PartySpeech[0+3], l-3);
				XFinishPkt(Cl_Dest);
			}
		}
	}
}

void cPartySystem::DeclineInvitation(P_PLAYER Player)
{
	if (!Player) return;

	UOXSOCKET s = Player->cs;
	if (s<0) return;

	P_CHAR PartyOwner = FindCharBySerPtr(&buffer[s][6]);

	if (PartyOwner == NULL || !PartyOwner->InGame()) return;

	char declinemessage[100];
	sprintf(declinemessage, "%s has declined your invitation to join your party.", Player->name);
	PartyOwner->Msg(declinemessage);
}

bool cPartySystem::AreInSameParty(P_CHAR First, P_CHAR Second)
{
	if (!First->InParty() || !Second->InParty())
	{
		return false;
	}

	list<cParty>::iterator MyParty = FindParty(First);

	if (MyParty != NULL)
	{
		list<P_CHAR>::iterator Trav = MyParty->FindMember(Second);
		if (Trav != NULL)
		{
			return true;
		}
	}
	return false;
}
