/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#ifndef __PARTY_H__
#define __PARTY_H__

#include "wolfpack.h"
#include "verinfo.h"

#include <iostream>
#include <list>

using namespace std ;

class cParty
{
public:
	cParty()		{}
	void AddMember(P_CHAR Player);
	void SendMemberList(P_CHAR Player);
	void SendMemberListToAll();
	void RemoveMember(P_CHAR Player);
	void Disband();

	list<P_CHAR>::iterator FindMember(P_CHAR Player);

	list<P_CHAR>		Members;
};

class cPartySystem
{
public:
	cPartySystem()		{}
	
	void AddMember(P_PLAYER Player);
	void AddMemberTarg(P_PLAYER Player);
	void RequestAuthorization(P_PLAYER Player, P_CHAR Target);
	void RemoveMember(P_PLAYER Player);
	void RemoveMemberTarg(P_PLAYER Player, P_CHAR Target);
	void SendPrivateMessage(P_PLAYER Player);
	void SendPartyMessage(P_PLAYER Player);
	void DeclineInvitation(P_PLAYER Player);
	void LogoutPartyMember(P_CHAR Player);
	void LoginPartyMember(P_CHAR Player);
	bool AreInSameParty(P_CHAR First, P_CHAR Second);

private:
	list<cParty>::iterator		FindParty(P_CHAR Player);
	bool IsLeaderOfParty(P_CHAR Player, list<cParty>::iterator Party);

	list<cParty>				PartyList;
};

#endif
