/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#include "skills.h"

#include "Client.h"
#include <cmath>
#include "guilds.h"
#include "gumps.h"
#include "house.h"
#include "itemid.h"
#include "LoS.h"
#include "magic.h"
#include <map>
#include "mapS.h"
#include "mapstuff.h"
#include "necro.h"
#include "regions.h"
#include "scriptc.h"
#include "SndPkg.h"
#include "sregions.h"
#include "targeting.h"
#include "tiledata.h"
#include "TmpEff.h"
#include "trigger.h"
#include "weight.h"

#include "wolfpack.h"

using namespace std;

#include "debug.h"
#undef DBGFILE
#define DBGFILE "skiTarg.cpp"

P_ITEM Check4Pack(P_CHAR pc)
{
	P_ITEM Pack = NULL;
	if (pc)
	{
		Pack = pc->getBackpack();
		if (!Pack)
		{
			pc->Msg("Time to buy a backpack");
		}
	}
	return Pack;
}

bool CheckInPack(P_CHAR Player, P_ITEM pi)
{
	if (!Player) return false;
	P_ITEM Pack=Check4Pack(Player);
	if (!Pack) return false;
	if (!Pack->Contains(pi))
	{
		Player->Msg("You can't use material outside your backpack");
		return false;
	}
	return true;
}

void cSkills::Tailoring(P_PLAYER Player, P_ITEM pi)// -Frazurbluu- rewrite of tailoring 7/2001
{
	if (!Player || !pi) return; 
	short int amt=0;
	short int amt1=0;

	if (!pi->isLockedDown())
	{
		make_st* imk = Player->getMakeData();
		if (IsBoltOfCloth(pi->id()))
		{
			if (CheckInPack(Player,pi))
			{
				if (pi->amount>1)
					amt1=(pi->amount*50);//-Frazurbluu- changed to reflect current OSI 
				else amt1=50; 
				P_ITEM iC = Items->SpawnItem(ITY_None,amt1,"cut cloth",0x1766,pi->color(),Player);
				if (iC==NULL) return;// crash check
				iC->weight=10;
				iC->dye=1;
				
				Items->DeleItem(pi); //-Fraz- delete the bolts when ready 

				amt=imk->has=Player->CountItems(iC->id());
				if (amt<1)
				{ 
					Player->Msg("You don't have enough material to make anything.");
					return;
				}
				imk->Mat1id=iC->id();
				imk->newColor=iC->color();
				MakeMenu(Player,30,TAILORING);
			}
			return;
		}
		else if ( IsCloth(pi->id()) || IsCutLeather(pi->id()) || IsCutCloth(pi->id()) || IsHide(pi->id()))  
		{
			if (CheckInPack(Player,pi))
			{
				int amt=imk->has=Player->CountItems(pi->id());
				if (amt<1)
				{ 
					Player->Msg("You don't have enough material to make anything.");
					return;
				}
				imk->Mat1id=pi->id();
				imk->newColor=pi->color();
				if ( IsCutLeather(pi->id()) || IsHide(pi->id()) )
					MakeMenu(Player,40,TAILORING);
				else
					MakeMenu(Player,30,TAILORING);
			}
			return;
		}
		Player->Msg("You cannot use that material for tailoring.");
	}
}

void cSkills::Fletching(P_PLAYER Player, P_ITEM pi)
{
	if (!Player) return;

	if (pi && !pi->isLockedDown())
	{
		make_st* imk = Player->getMakeData();
		if (( IsShaft(imk->Mat1id) && IsFeather(pi->id()) ) ||	// first clicked shaft and now feather
			( IsFeather(imk->Mat1id) && IsShaft(pi->id()) ))		// or vice versa
		{
			if (CheckInPack(Player,pi))
			{
				imk->Mat2id=pi->id();	// 2nd material
				imk->has=Player->CountItems(imk->Mat1id);		// count both materials
				imk->has2=Player->CountItems(imk->Mat2id);
				MakeMenu(Player,60,BOWCRAFT);
			}
			return;
		}
	}
	Player->Msg("You cannot use that for fletching.");
}

void cSkills::BowCraft(int s,P_PLAYER Player,const P_ITEM pi)
{
	if (!Player || !pi) return;

	Player->DoAction(Player->onhorse ? 0x1C : 0x0D);
	
	if (!pi->isLockedDown())
	{
		short id = pi->id();
		if (IsLog(id) || IsBoard(id))
		{
			if (CheckInPack(Player,pi))
			{
				P_ITEM Tool = Player->getDclickedItem();
				if (!Tool)
				{
					Player->Msg("Where is your tool ?");
					return;
				}
				if (Player->ToolWearOut(Tool))
					return;

				make_st* imk = Player->getMakeData();
				if ((imk->has=Player->CountItems(id)) < 2)
					Player->Msg("You don't have enough material to make anything.");
				else 
				{
					imk->Mat1id = id;
					MakeMenu(Player,65,BOWCRAFT);
				}
			}
		} 
	}
}

////////////////////
// name:	Carpentry()
// history:	unknown, rewritten by Duke, 25.05.2000
// purpose:	sets up appropriate Makemenu when player targets logs or boards
//			after dclick on carpentry tool
//			
//			If logs are targetted, Makemenu 19 is called to produce boards
//			If boards, MM 20 is called for furniture etc.
//
void cSkills::Carpentry(P_PLAYER Player, P_ITEM pi)
{
	if (!Player) return;

	if (pi && !pi->isLockedDown())
	{
		short id = pi->id();
		if ( IsLog(id) || IsBoard(id) ) // logs or boards
		{
			if (CheckInPack(Player,pi))
			{
				make_st* imk = Player->getMakeData();
				imk->Mat1id = pi->id();
				imk->has=Player->CountItems(pi->id());
				short mm = IsLog(pi->id()) ? 19 : 20; // 19 = Makemenu to create boards from logs
				MakeMenu(Player,mm,CARPENTRY);
			}
		}
	}
	else
		Player->Msg("You cannot use that material for carpentry.");
}

static bool CookingPlaceInRange(P_CHAR Player)
{
	if (!Player) return false;
	PC_ITEM pi;
	int loopexit=0;

	RegGrid3x3Iterator4Items rg3ii(Player->pos);
	while((pi = rg3ii.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (IsCookingPlace(pi->id()) && iteminrange(Player,pi,3))
			return true;
	}
	return false;
}

static bool ForgeInRange(P_CHAR Player)
{
	if (!Player) return false;
	PC_ITEM pi;
	int loopexit=0;

	RegGrid3x3Iterator4Items rg3ii(Player->pos);
	while((pi = rg3ii.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (IsForge(pi->id()) && iteminrange(Player,pi,3))
			return true;
	}
	return false;
}

static bool AnvilInRange(P_CHAR pc)
{
	if (!pc) return false;
	bool rc = false;

	PC_ITEM pi;
	int loopexit=0;
	RegGrid3x3Iterator4Items rg3ii(pc->pos);
	while((pi = rg3ii.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (IsAnvil(pi->id()))
			if (iteminrange(pc,pi,3))
				rc = true;
	}
	return rc;
}

////////////////////
// name:	AnvilTarget2
// history:	by Duke, 28 March 2000
// Purpose:	little helper function for cSkills::Smith()
//			checks for anvil in reach and enough material
//			and invokes appropriate Makemenu
//
static void AnvilTarget2(P_PLAYER Player,	// socket #
						 P_ITEM pi,			// material item
						 int ma,			// minimum amount
						 int mm,			// makemenu # to invoke from create.scp
						 const char* matname)		// name of the metal
{
	if (!AnvilInRange(Player))
		Player->Msg("The anvil is too far away.");
	else
	{
		P_ITEM Pack = Player->getBackpack();
		if (Pack==NULL) return;

		make_st* imk = Player->getMakeData();
		int amt=Pack->CountItems( pi->id(), pi->color());
		if ((imk->has=amt) < ma)
		{
			char msg[100];
			sprintf(msg,"You don't have enough %s ingots to make anything.",matname);
			Player->Msg(msg);
		}
		else
			Skills->MakeMenu(Player,mm,BLACKSMITHING);
	}
}

//////////////////////////
// Function:	Smith
// History:		unknown, colored ore added by Cork,
//				28 March 2000 revamped by Duke
//				16.9.2000 removed array access and revamped s a bit more (Duke)
//
// Purpose:		checks if targeted material is ore of some kind,
//				checks if anvil is in reach and invokes appropriate Makemenu
// Remarks:		the ingottype var is problematic in a multiplayer environment!!
//
extern int ingottype;
void cSkills::Smith(P_PLAYER Player, P_ITEM pi)
{
	if (pi && !pi->isLockedDown())
	{
		make_st* imk = Player->getMakeData();
		imk->Mat1id = pi->id();
		imk->Mat1color = pi->color();

		if (!CheckInPack(Player,pi)) return;

		short id = pi->id();
		if (id==0x1BEF || id==0x1BF2)	// is it an ingot ?
		{
			const sOreResource* OI = Crafting.GetByIngotColor(pi->color());
			if (OI != NULL)
			{
				ingottype = OI->IngotColor;
				AnvilTarget2(Player, pi, 1, OI->SmithMenu, OI->Name);
				return;
			}
		}
		imk->Mat1id = 0;
		imk->Mat1color = 0;
	}
	Player->Msg("You cannot use that material for blacksmithing");
}

void cSkills::TasteIDTarget(P_PLAYER Player, P_ITEM pi)
{
	if (!Player) return;
	if (pi && !pi->isLockedDown())
	{
		if (!( pi->isType(ITY_Potion) || pi->isType(ITY_Food)))
		{
			Player->Msg("You cant taste that!");
			return;
		}
		if (!Player->checkSkill(TASTEID, 0, 250))
		{
			Player->Msg( "You can't quite tell what this item is...");
		}
		else
		{
			if (pi->corpse)
			{
				Player->Msg( "You have to use your forensics evalutation skill to know more on this corpse.");
				return;
			}
			
			// Identify Item by Antichrist // Changed by MagiusCHE)
			if (Player->checkSkill(TASTEID, 250, 500))
				if (pi->name2 && (strcmp(pi->name2,"#")))
					strcpy(pi->name,pi->name2); // Item identified! -- by Magius(CHE)
				
				// ANTICHRIST -- FOR THE "#" BUG -- now you see the real name
				if (pi->name[0]=='#') pi->getName(temp2);
				else strcpy(temp2, pi->name);
				sprintf(temp, "You found that this item appears to be called: %s", temp2);
				Player->Msg( temp);
				
				if (Player->checkSkill(TASTEID, 250, 500))
				{
					if (pi->Poisoned()>0 || (pi->morex==4 && pi->morey==6 && pi->morez==1))
						Player->Msg("This item is poisoned!");
					else
						Player->Msg("This item shows no poison.");
					
					// Show Creator by Magius(CHE)
					if (Player->checkSkill(TASTEID, 250, 500))
					{
						if (strlen(pi->creator)>0)
						{
							if (pi->madewith>0) sprintf(temp2, "It is %s by %s",SkillManager->getMadeWord(pi->madewith-1),pi->creator); // Magius(CHE)
							else if (pi->madewith<0) sprintf(temp2, "It is %s by %s",SkillManager->getMadeWord(0-pi->madewith-1),pi->creator); // Magius(CHE)
							else sprintf(temp2, "It is made by %s",pi->creator); // Magius(CHE)
						} else strcpy(temp2, "You don't know its creator!");
					} else strcpy(temp2, "You can't know its creator!");
					Player->Msg( temp2);
					// End Show creator
				}
		}
	}
}


//#define max_res_x 610 // max-resource cells x
//#define max_res_y 410 // max-resource cells y

inline void SetTimerSec(unsigned long *timer, const short seconds)
{
	*timer=seconds * MY_CLOCKS_PER_SEC + uiCurrentTime;
}

class cVein
{
	int amount;
	unsigned int time;
public:
	void init(unsigned int fullamount,unsigned int secs)
	{
		amount=fullamount;
		SetTimerSec((unsigned long *)&time,secs);
	}
	bool started() {return (time > 0);}	// used to check initialization of vein array :/
	void refill(unsigned int fullamount,unsigned int secs,unsigned int rate)
	{
		if (this->time<=uiCurrentTime)
		{
			unsigned int c;
			for(c=0;c<fullamount;c++)//Find how many periods have gone by, give 1 more ore for each period.
			{
				if ((time+(c*secs*MY_CLOCKS_PER_SEC))<=uiCurrentTime && amount<(int)fullamount)
					amount+=rate;//AntiChrist
				else break;
			}
			SetTimerSec((unsigned long *)&time,secs);
		}
		if (this->amount > fullamount) this->amount = fullamount;
	}
	bool isEmpty() {return (amount <= 0);}
	void reduce(int by=1)
	{
		if (amount >= by) amount-=by; else amount = 0;
	}
};

// Remark:	this does NOT REALY support multiple maps.
//			If two players mine(fish,lumberjack,..) at the same x/y, but on different maps,
//			they will share the same vein. Highly unlikely, though. (Duke, 18.6.2004)
class cAllVeins2
{
	map<int, cVein*> Veins;
	unsigned int _grid;					// width of a square in tiles
	unsigned int _fullamount;
	unsigned int _secs;
public:
	void init(unsigned int area,unsigned int fullamount,unsigned int secs)
	{
		_grid = area;
		_fullamount = fullamount;
		_secs = secs;
	}
	cVein* find(const cCoord& pos)
	{
		int a = ((pos.x/_grid)<<16) + pos.y/_grid;	// the key is a combination of x and y
		map<int, cVein*>::iterator vi = Veins.find(a);
		if (vi != Veins.end())
			return vi->second;		// found an existing vein there
		else
		{
			cVein* vp = new cVein;
			vp->init(_fullamount, _secs);
			Veins.insert(make_pair(a,vp));
			return vp;
		}
	}
};

void cSkills::Mine(P_PLAYER Player, const cCoord& minepos, short id)
{
	if (!Player) return;

	static cAllVeins2 *Veins = NULL;

	if (Player->isHidden())
	{
		Player->unhide();
	}
	if (Player->onhorse)
	{
		Player->Msg("You cant mine while you are mounted!");
		return;
	}

	if (resource.miningstamina<0 && abs(resource.miningstamina)>Player->Stm())
	{
		Player->Msg("You are too tired to mine.");
		return;
	}
	Player->changeStm(resource.miningstamina);

	if (!Veins)	//First time done since server started
	{
		Veins = new cAllVeins2();
		Veins->init(resource.orearea,resource.ore,resource.oretime);
	}

	if (!inRange(Player->pos,minepos,5) || abs(Player->pos.z - minepos.z) > 25)
	{
		Player->Msg("You are too far away to reach that");
		return;
	}

	P_ITEM Map=Player->HasSuitableTreasureMap(minepos);
	if (Map)
	{
		P_ITEM Chest=Items->CreateScriptItem(Player->cs,SrvParms->hci.TreasureChestBase+Map->morez,0);
		if (Chest)
		{
			Chest->refresh();
			Player->Msg("You found a treasure !");
			Items->DeleItem(Map);
		}
		return;
	}
	
	// lb's mining bugfix for mountains :
	// ( many things like streets were interpreted as mountain)
	// the target packet doesnt send ANY usefull info on map-types.
	// (only for dynamic+static objects)
	// checking for 0x11==0 and 0x12==0 isnt sufficient, it just indicates
	// that it is a map-typ, but a lot of other things are maptypes too ...
	// so everything with z>0 and maptype==1 was a mountain, what is wrong of course.
	// workaround: we have to get the x,y,z and calculate "manually" server side
	// if its a mountain.
	// stupid (OSI studipity) cause lag adding server side, but theres no other way
	

	char floor=0;
	char mountain=0;
	if (SrvParms->minecheck>0) // time consuming mountain mine check only if absolutely necassairy. (mincheck!=0 && maptype targeted && distance>5)
	{
		if (id != 0) mountain=0; // we tried to mine an static or dynamic item 
		else 		
		{
			// sorry, had to correct this because it cant and didnt work, LB 4'th JULY 2000
			// mountains are "map0's" and no statics !!!

			cellData map;
			AllMaps->SeekMap(minepos, map);
		
			const landData* land = TileData->SeekLand(map.TID);
			if ( !strcmp((const char*)land->name,"rock") || !strcmp((const char*)land->name, "mountain")) mountain=1;
			else mountain=0;
		}
	}
	
	// check if gravesight - added by Genesis
	if (minepos.z <= 28 &&
		(id==0x0ED3 || (id>=0x0EDF && id<=0x0EE2) || id==0x0EE8) )
	{
		GraveDig(Player);
		return;
	}
	
	// check if cave floor
	else if ((
		(id>=0x053B && id<=0x054F)||
		(id>=0x0551 && id<=0x0553)||
		(id==0x056A) )
/*		&&
		!(
		(id>=0x025c && id<=0x0276)||
		(id>=0x027d && id<=0x0280) ) */
		) 
		floor=1;
	
	cVein* Vein = Veins->find(minepos);
	if (!Vein) return;
	Vein->refill(resource.ore,resource.oretime,resource.orerate);

	if (Vein->isEmpty())
	{
		Player->Msg("There is no metal here to mine.");
		return;
	}
	
	if (SrvParms->minecheck==1 && !floor && !mountain)//Mine only mountains & floors
	{
		Player->Msg("You can't mine that!");
		return;
	}
	
	Player->faceTarget(minepos);
	Player->DoAction(Player->onhorse ? 0x1A : 0x0b);
	soundeffect(Player,0x0125); 
	
	if (!Player->checkSkill(MINING)) 
	{
		Player->Msg("You sifted thru the dirt and rocks, but found nothing useable.");
		if (rand()%2) Vein->reduce();//Randomly deplete resources even when they fail 1/2 chance you'll loose ore.
		return;
	}
	else Vein->reduce();
	
	
	//
	//AntiChrist - new implementation of triggered mining.(29/11/99)
	//
	//Mineral creation is now done all by trigger
	//so that we can create new scripted minerals.
	//(put resource.miningtrigger=0 to disable this feature
	//and use standard mining!)
	//
	if (resource.miningtrigger>0)
	{
		Player->targtrig=resource.miningtrigger;
		triggerItem(Player,Player->getDclickedItem());
		return;
	}
	else
	{//normal mining skill
		if (Player->Skill(MINING)>=850 && !(rand()%18))
		{
			int rand_item = Items->PickFromItemlist(999); //uses ITEMLIST
			
			if (rand_item != -1) // Make sure that there is a valid item list (Thrawn)
			{
				if (Items->SpawnItemBackpack(Player,rand_item)) Player->Msg("You place a gem in your pack.");
				return;
			}

		}

		int amt=1;
		short id = 0x19B9;
		if (!(rand()%20))			// a 5% chance for 5 small ores
		{
			amt=5;
			id=0x19BA;
		}

		const sOreResource* OI = Crafting.getColorFound(Player->Skill(MINING));	// get random ore
		if (OI==NULL) return;
		
		char tmp[100];
		sprintf(tmp,"%s Ore",OI->Name);
		Items->SpawnItem(ITY_None,amt,tmp,id, OI->OreColor,Player);
		
		sprintf(temp,"You place some %c%s ore in your pack.",tolower(OI->Name[0]),OI->Name+1);
		Player->Msg(temp);
	}
}

bool RandomLootItemNpcBySkill(P_PLAYER Player,enScripts scp_num,int skill_num,char * section_name )
{
	Script* Scp=getScript(scp_num);
	int skill_section=RandomNum(0,(int)(Player->Skill(skill_num)/10));
	Scp->Open();
	int loopexit=0;
	while(skill_section >= 0 && (++loopexit<MAXLOOPS) )
	{	
		if (Scp->find(section_name,skill_section)) break;
		skill_section--;		
	}
	if (skill_section < 0)
	{
		Scp->Close();
		return false;
	}

	int i=0;
	loopexit=0;
	char* token_temp=NULL;
	char default_message[256]={0};
	char loot_message[256]={0};
	Scp->NextLineSplitted();
 	while( !Scp->EndSect() && (++loopexit < MAXLOOPS) )
 	{
		if (!Scp->cmpTag("DEFAULT")) strcpy(default_message,script2);	
		else i++;
		Scp->NextLineSplitted();
	}
	Scp->find(section_name,skill_section);
	bool no_loot=true;
	int k=0;

	loopexit=0;
	if (i>0)
 	{
  		i=(rand()%(i))+1;
		do
		{
			Scp->NextLineSplitted();
			if (Scp->cmpTag("DEFAULT")) k++;
		} while((k<i) && ++loopexit<MAXLOOPS);
		Scp->Close();
		token_temp=strpbrk(script2," ");
		if (token_temp)
		{
			token_temp[0]=0;
			token_temp++;
			strcpy(loot_message,token_temp);
		}

		int ni = str2num(script2);	// the item to spawn
		if (!Scp->cmpTag("NPC"))
		{
			if (Player->inGuardedArea() && SrvParms->guardsactive) no_loot=false;
			else if (Npcs->AddRespawnNPC(Player->cs,ni)==NULL) no_loot=false;	
		}	
		else if (!Scp->cmpTag("ITEM")) 
		{
			if (!(Items->SpawnItemBackpack(Player,ni,1))) no_loot=false;
		}
		else if (!Scp->cmpTag("ITEMLIST"))
		{
			int rand_item=Items->PickFromItemlist(ni); //uses ITEMLIST
			if (!Items->SpawnItemBackpack(Player,rand_item,1))
				 no_loot=false;
		}
		if (!no_loot)
		{
			if (token_temp) Player->Msg(loot_message);
			else Player->Msg(default_message);
		}
	}
	return no_loot;
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Author: LB, (2.7.2000)
// Purpose: Finding Items per Item-Id in a x*y rectangle around a player
// Input paramters: player	-> players' index in the chars array. (= calling via currchar[s] )
//					id1,id2	-> item id to search for
//					x,y		-> x*y rectangle around the players current x,y location. (current x,y = middle point of the rect) 
//								thats the region where the searching takes place
//								warning: x and y should be max 10, because mapregions are used.
//
//					max_returns -> no more than return_max items are returned
//
// Output paramters: number of items found
//					items_found -> list of found items's serials.
//
// PRE: items_found pointer must have memory allocated for max_return int's. if not it might **crash**   
//		mapregion array has to be correct (no duplicate entries etc). 
//		It usually contains all items in a (10 until 15) * (10 until 15) grid/recantagle.
//		uncertian about exact number, but I'd say everything below 10 is save. ( -> x,y <= 10)
//	  player must be valid player_index
//   
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

static int Find_items_around_player(P_CHAR Player, short id, unsigned char x, unsigned char y, int max_returns, int* items_found)
{
	if (!Player) return -1;
	if (max_returns<1) return -1;

	cMapRectangle rect(Player->pos.x-x, Player->pos.y-y, Player->pos.x+x, Player->pos.y+y, Player->pos.map);
	int found=0;
	
	PC_ITEM pi;
	int loopexit=0;
	RegGrid3x3Iterator4Items rg3ii(Player->pos);
	while((pi = rg3ii.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (pi->id() == id) // found the item
		{				
			if (pi->pos.IsIn(rect))
			{
				// remark: case ignored where players' x,y - range x,y < 0
				
				if (found<max_returns) 
				{
					items_found[found] = pi->serial;
					found++;
				} else break;
			}
		}
	}		
	return found;
}

static bool TryToAddToFishPile(P_PLAYER Player, short id)
{
	const int max_fish_piles = 1;		// attention: thats per fish *type*, so the efffective limit of piles is *3
	const int max_fish_stacksize = 15;	// attention: rela max size = value+1

	int fishes_around_player;
	int fish_sers[max_fish_piles];

	fishes_around_player=Find_items_around_player(Player, id, 2, 2, max_fish_piles, fish_sers); // lets search for fish in a 2*2 rectangle around the player
	
	if (fishes_around_player<=0) // no fish around -> spawn a new one
	{
		return false;
	}
	else // fishes around ?
	{
		int min=1234567;
		P_ITEM Pile = NULL;
		int d;
		for (d=0;d<fishes_around_player;d++) // lets pick the smallest pile form the return list
		{
			P_ITEM iC = NULL;
			iC = FindItemBySerial( fish_sers[d] );
			if (iC)
			{
				int ss=iC->amount;
				if (ss<min) { min=ss; Pile=iC; }
			}
		}
		if (!Pile) return false;
		if (Pile->amount>max_fish_stacksize) // if smallest fish-stack > max_stacksize spawn a new fish anyway
		{
			if (fishes_around_player>=max_fish_piles)
			{
				Player->Msg("you catch a fish, but no place for it left");
			}
			return false;
		}
		else // if fish stack <=max_ -> just increase stack !!
		{
			Pile->amount++;
			Pile->refresh();
			return true;
		}
	}
	return false;
}

// LB: added fish stacking !!
static void Fish(P_PLAYER Player)
{
	if (!Player) return;

	// New Random fishing up items and monsters...OPIK
	if ((unsigned)RandomNum(0,100) <= fishing_data.loot_probability)
	{
		if (RandomLootItemNpcBySkill(Player,fishing_script,FISHING,"FISHLIST"))
			return;
	}

	///**** exotic fish stuff *****//
	int color;
	float mv=-0.087087087f*(float)Player->Skill(FISHING)+100.087087087086f; // gm fish -> 1/13 % probability on new spawn(!) to have exotic color, neophyte: 1/92 % probability, linear interpolation in between
	int no_idea_for_variable_name = (int) mv;
	if (no_idea_for_variable_name<=0) no_idea_for_variable_name=1; // prevent modulo crashes	
	if (rand()%no_idea_for_variable_name==0) 
	{ 		
		color=(Player->pos.x+Player->pos.y);
		color+=rand()%10;
		color=color%0x03E9; 
		if (color<0x0002 || color>0x03E9)
		{
			color=0x03E9;
		}
		if (color&0xC000)
		{
			color=0x100+rand()%255;
		}
	} else color=0;
	/**** end of exotic fish stuff stuff */

	P_ITEM pFish;
	short id=0x09CC+rand()%3;
	if (SrvParms->fishtobp)
	{
		pFish=Items->SpawnItem(ITY_Food,1,"#",id,color,Player);
		if (!pFish) return;
		pFish->AddFoodType(FOOD_FISH+FOOD_RAW); // set flags for new food system
	}
	else
	{
		if (!TryToAddToFishPile(Player, id))
		{
			pFish=Items->SpawnItem(ITY_Food,1,"#",id,color,Player->pos);	// place it at their feet
			if (!pFish) return;//AntiChrist to prevent crashes
			pFish->AddFoodType(FOOD_FISH+FOOD_RAW); // set flags for new food system
			pFish->SetMultiSerial(Player->multis);
		}
	}

	if ((color&0x00FF)>0)
		Player->Msg("You pull out an exotic fish!");
	else
		Player->Msg("You pull out a fish!");
}

void cSkills::FishTarget(P_PLAYER Player, const cCoord& Tpos, const short landid)
{
	static cAllVeins2 *FishingSpots = NULL;

	if (!Player) return;

	if (!inRange(Player->pos,Tpos,6))	// fixes an exploit with fishing, LB
	{
		Player->Msg("You are too far away to reach that");
		return;
	}

	bool ok=false;
	if (IsFishWater(landid))
		ok = true;
	else
	{	// it might be offshore fishing (client returns id=0 for deep sea ) Duke, Thx for the hint goes to Avanoon guys

		cellData map;
		AllMaps->SeekMap(Tpos, map); // search the ground tile where they casted		
		if ( map.TID == 0x00A8 || map.TID == 0x00A9 || map.TID == 0x00AA || map.TID == 0x00AB )
			ok = true;
	}
	if (!ok)
	{
		Player->Msg("You need to be closer to the water to fish!");
		return;
	}
	
	if (!FishingSpots)	//First time done since server started
	{
		FishingSpots = new cAllVeins2();
		FishingSpots->init(resource.fisharea,resource.fishes,resource.fishtime);
	}
	
	Player->faceTarget(Tpos);
	Player->DoAction(0x0B);
	if (fishing_data.randomtime!=0)
		Player->fishingtimer=rand()%fishing_data.randomtime+fishing_data.basetime;
	else
		Player->fishingtimer=fishing_data.basetime;
	
	soundeffect(Player, 0x023F);
	Player->unhide();

	if (resource.fishstamina<0 && abs(resource.fishstamina) > Player->Stm())
	{
		Player->Msg("You are too tired to fish, you need to rest!");
		return;
	}
	Player->changeStm(resource.fishstamina);

	cVein* Spot = FishingSpots->find(Tpos);
	if (!Spot) return;
	Spot->refill(resource.fishes,resource.fishtime,resource.fishrate);
	
	if (Spot->isEmpty())
	{
		Player->Msg("They don't seem to bite here anymore.");
		return;
	}
	
	if (!Player->checkSkill(FISHING))
	{
		Player->Msg("You fish for a while, but fail to catch anything.");
		if (rand()%2) Spot->reduce();//Randomly deplete resources even when they fail 1/2 chance you'll loose wood.
		return;
	}
	else
		Spot->reduce();

	if (resource.fishtrigger>0)
	{
		Player->targtrig=resource.fishtrigger;
		triggerItem(Player,Player->getDclickedItem());
	}
	else
	{
		Fish(Player);
	}
}

void cSkills::TreeTarget(P_PLAYER Player, const cCoord& Tpos)
{
	if (!Player) return;

	static cAllVeins2 *Trees = NULL;

	//Logging stamina, AntiChrist
	if (resource.logstamina<0 && abs(resource.logstamina) > Player->Stm())
	{
		Player->Msg("You are too tired to chop.");
		return;
	}
	Player->changeStm(resource.logstamina);

	if (!Trees)	//First time done since server started
	{
		Trees = new cAllVeins2();
		Trees->init(resource.logarea,resource.logs,resource.logtime);
	}

	if (!inRange(Player->pos,Tpos,5))
	{
		Player->Msg("You are to far away to reach that");
		return;
	}

	cVein* Tree = Trees->find(Tpos);
	if (!Tree) return;
	Tree->refill(resource.logs,resource.logtime,resource.lograte);
	
	if (Tree->isEmpty())
	{
		Player->Msg("There is no more wood here to chop.");
		return;
	}
	
	P_ITEM Pack=Player->getBackpack();
	if (!Pack) {Player->Msg("No backpack to store logs"); return; } //LB
	
	Player->faceTarget(Tpos);
	Player->DoAction(Player->onhorse ? 0x1C : 0x0D);
	soundeffect(Player,0x013E);

	if (Player->ToolWearOut()) return;
	
	if (!Player->checkSkill(LUMBERJACKING)) 
	{
		Player->Msg("You chop for a while, but fail to produce any usable wood.");
		if (rand()%2) Tree->reduce();//Randomly deplete resources even when they fail 1/2 chance you'll loose wood.
		return;
	}
	else Tree->reduce();
	
	//
	//29/11/99
	//
	//AntiChrist - new implementation of triggered logging.
	//
	//Log creation is now done all by trigger
	//so that we can create new scripted minerals.
	//(put resource.logtrigger=0 to disable this feature
	//and use standard logging!)
	//
	if (resource.logtrigger>0)
	{
		//Player->targtrig=resource.logtrigger;
		triggerItemId(Player,Player->getDclickedItem());	// routing to wtrigrs instead of triggers.scp Duke, 5.11.2000
		return;
	} else
	{//normal lumberjacking skill
		
		P_ITEM Logs = Items->SpawnItem(ITY_None,10,"#",0x1BE0,0,Player);
		if (!Logs) return;//AntiChrist to prevent crashes
		if (Logs->amount>10) Player->Msg("You place more logs in your pack.");
		else Player->Msg("You place some logs in your pack.");		
	}
}

void cSkills::GraveDig(P_PLAYER Player)
{
	if (!Player) return;

	Karma(Player,NULL,-2000); // Karma loss no lower than the -2 pier
	//if (Player->onhorse) action(s,0x1A); else // no mining on horse allowed
	Player->DoAction(0x0b);
	soundeffect(Player,0x0125);
	if (RandomNum(0,1000)>(Player->Skill(MINING)-150))//minimum skill to gravedig 16
	{
		Player->Msg("You sifted through the dirt and found nothing.");
		return;
	}
	else
	{
		Player->DoAction(0x0B);
		soundeffect(Player,0x0125);
		//uses tha same function that fishing
		if (!RandomLootItemNpcBySkill(Player,necro_script,ITEMID,"GRAVELIST"))
		{
			short id=0;
			switch(rand()%17) //bones and skulls
			{
				case 0: id=0x1B11; break;
				case 1: id=0x1B12; break;
				case 2: id=0x1B13; break;
				case 3: id=0x1B14; break;
				case 4: id=0x1B15; break;
				case 5: id=0x1B16; break;
				case 6: id=0x1B17; break;
				case 7: id=0x1B18; break;
				case 8: id=0x1B19; break;
				case 9: id=0x1B1A; break;
				case 10: id=0x1B1B;break;
				case 11: id=0x1B1C;break;
				case 12: id=0x1AE0;break;
				case 13: id=0x1AE1;break;
				case 14: id=0x1AE2;break;
				case 15: id=0x1AE3;break;
				case 16: id=0x1AE4;break;
			}
			Items->SpawnItem(ITY_None,1,"#",id,0x00,Player);
			Player->Msg("You have unearthed some old bones and placed them in your pack.");
		}
	}	
} 

///////////////////////
// name:	SmeltOre2
// history:	by Duke, 31 March 2000
// Purpose: helper function for cSkills::SmeltOre()
//			checks if the player's mining skill meets the requirements
//			if yes, he'll get the specified ingots and appropriate messages
// Remarks: CheckSkill does NOT use minskill (cause it was like that before)
//
static void SmeltOre2(P_PLAYER Player, P_ITEM Ore)
{
	if (!Player || !Ore) return;

	const sOreResource* OI = Skills->Crafting.GetByOreColor(Ore->color());
	if (!OI) return;

	if (Player->Skill(MINING) < OI->MinSkill)	// minimum skill required for ore color
	{
		Player->Msg("You have no idea what to do with this strange ore");
		return;					
	}
	if (!Player->checkSkill(MINING))
	{
		if (Ore->amount==1)
		{
			Player->Msg("Your hand slips and the last of your materials are destroyed.");
			Items->DeleItem(Ore);
		}
		else
		{
			Player->Msg("Your hand slips and some of your materials are destroyed.");
			Ore->amount /= 2;
			Ore->refresh();				// tell the client item has been changed
		}
	}
	else
	{
		char tmp[100];
		int numore=Ore->amount*2;			// one ore gives two ingots
		sprintf(tmp,"%s Ingot",OI->Name);
		
		cItem* Ingot=Items->SpawnItem(ITY_None,numore,tmp,0x1BF2,OI->IngotColor,Player);
		if (Ingot)
		{
			Ingot->weight = 20;	// that's 0.2 stone
		}

		Player->Msg("You have smelted your ore.");
		Player->Msg("You place some ingots in your pack.");
		Items->DeleItem(Ore);
	}
}

//////////////////////////
// Function:	SmeltOre
// History:		unknown, colored ore by Cork,
//				31 March 2000 totally revamped by Duke
//				16.9.2000 removed array access and revamped a bit more (Duke)
//
// Purpose:		checks if targeted item is a forge and in range
//				then executes the smelting function with the appropriate
//				minskill and ingot type
// Remarks:		NOTE: ingot color is different from ore color for silver & iron!
//
void cSkills::SmeltOre(P_PLAYER Player, P_ITEM pi)
{
	if (!Player || !pi) return;
	
	if (IsForge(pi->id()))
	{
		if (!iteminrange(Player,pi,3))		//Check if the forge is in range
			Player->Msg("You cant smelt here.");
		else
		{
			P_ITEM Ore = Player->getDclickedItem();
			if (!Ore) return;
			SmeltOre2(Player,Ore);
		}
	}
	
	Weight->NewCalc(Player);	// Ison 2-20-99
	statwindow(Player,Player);
}

void cSkills::Wheel(P_PLAYER Player, P_ITEM pi, int mat)//Spinning wheel
{
	if (!Player || !pi) return;
	
	if (IsSpinningWheel(pi->id()))
	{
		if (iteminrange(Player,pi,3))
		{
			if (!Player->checkSkill(TAILORING)) 
			{
				Player->Msg("You failed to spin your material.");
				return;
			}
			Player->Msg("You have successfully spun your material.");

			const P_ITEM pti=Player->getDclickedItem();
			if (!pti) return;
			
			if (mat==YARN)
			{
				strcpy(pti->name,"#");
				pti->setId(0x0E1D);
				pti->amount=pti->amount*3;
				pti->weight = 100;	//1 stone
			}
			else if (mat==THREAD)
			{
				strcpy(pti->name,"#");
				pti->setId(0x0FA0);
				pti->amount=pti->amount*3;
				pti->weight = 100;	//1 stone
			}

			pti->refresh();
			return;
		}
	}
	Player->Msg("You cant tailor here.");
}

void cSkills::Loom(P_PLAYER Player, P_ITEM pi)
{
	if (!Player) return;
	
	if (pi && !pi->isLockedDown())
	{
		if ( pi->id() >= 0x105F && pi->id() <= 0x1066 )
		{
			if (iteminrange(Player,pi,3))
			{
				const P_ITEM pti=Player->getDclickedItem();
				if (!pti) return;

				if (pti->amount<4)
				{
					Player->Msg("You do not have enough material to make anything!");
					return;
				}
				if (!Player->checkSkill(TAILORING, 300)) 
				{
					Player->Msg("You failed to make cloth.");
					Player->Msg("You have broken and lost some material!");
					pti->ReduceAmount(1+(rand() % (pti->amount)));
					return;
				}
				
				if ( pti->id()==0x0E1E || pti->id()==0x0E1D || pti->id()==0x0E1F )	// yarn
				{
					Player->Msg("You have made your cloth.");

					strcpy(pti->name,"#");
					pti->setId(0x175D);
					pti->amount /= 4;
				}
				else if ( pti->id()==0x0FA0 || pti->id()==0x0FA1 )	// thread
				{
					Player->Msg("You have made a bolt of cloth.");

					strcpy(pti->name,"#");
					pti->setId(0x0F95);
					pti->amount /= 4;
				}
				pti->refresh();
				return;
			}
		}
	}
	Player->Msg("You cant tailor here.");
}

////////////
// Name:	CookOnFire
// By:		Ripper & Duke, 07/20/00
// Purpose: so you can use raw meat on fire
//
void cSkills::CookOnFire(P_CHAR Player, P_ITEM RawMat)
{
	if (!Player || !RawMat) return;
	if (RawMat->isLockedDown()) return;
	if (!CheckInPack(Player,RawMat)) return;
	if (!IsRawFood(RawMat->id()))
	{
		Player->Msg("You can't cook that.");
		return;
	}
	if (!CookingPlaceInRange(Player))
	{
		Player->Msg("You must be closer to the fire.");
		return;
	}

	char tmpmsg[250];
	char matname[250];
	RawMat->getName(matname);
	short id;
	switch (RawMat->id())
	{
	case 0x097A: id=0x097B; break; // fish steak
	case 0x09B9: id=0x09B7; break; // bird
	case 0x09F1: id=0x09F2; break; // ribs
	case 0x1607: id=0x1608; break; // chicken legs
	case 0x1609: id=0x160A; break; // lamb
	default: return;
	}

	soundeffect(Player,0x01DD);	// cooking sound
	if (!Player->checkSkill(COOKING)) 
	{
		sprintf(tmpmsg,"You failed to cook the %s and drop some into the ashes.",matname);
		RawMat->ReduceAmount(1+(rand() %(RawMat->amount)));
	}
	else
	{
		sprintf(tmpmsg,"You have cooked the %s,and it smells great.",matname);
		P_ITEM iC = Items->SpawnItem(ITY_Food,RawMat->amount,"#",id,0,Player);
		if (!iC) return;
		iC->SubFoodType(FOOD_RAW); // set flag for new food system (thrawn)
		switch(id)
		{
		case 0x097B:
			iC->AddFoodType(FOOD_FISH);
			break;
		case 0x09B7:
		case 0x160A:
		case 0x09F2:
		case 0x1608:
			iC->AddFoodType(FOOD_MEAT);
			break;
		default:
			LogError("switch reached default in CookInFire()");
		}
		iC->refresh();
		Items->DeleItem(RawMat);
	}
	Player->Msg(tmpmsg);
}

void cSkills::MakeDough(P_PLAYER Player, P_ITEM pi)
{
	if (!Player) return;

	if (pi && !pi->isLockedDown())
	{
		if (pi->id()==0x103A)
		{
			if (iteminrange(Player,pi,3))
			{
				if (!Player->checkSkill(COOKING)) 
				{
					Player->Msg("You failed to mix, and spilt your water.");
					return;
				}
				Player->Msg("You have mixed very well to make your dough.");
				
				const P_ITEM pti=Player->getDclickedItem();
				if (!pti) return;
				strcpy(pti->name,"#");
				
				pti->setId(0x103D);
				pti->amount *= 2;
				
				pti->refresh();
				return;
			}
		}
	}
	Player->Msg("You cant mix here.");
}

void cSkills::MakePizza(P_PLAYER Player, P_ITEM pi)
{
	if (!Player) return;

	if (pi && !pi->isLockedDown())
	{
		if (pi->id()==0x103D)
		{
			if (iteminrange(Player,pi,3))
			{
				if (!Player->checkSkill(COOKING)) 
				{
					Player->Msg("You failed to mix.");
					Items->DeleItem(pi);
					return;
				}
				Player->Msg("You have made your uncooked pizza, ready to place in oven.");
				
				const P_ITEM pti=Player->getDclickedItem();
				if (!pti) return;
				strcpy(pti->name,"#");
				
				pti->setId(0x1083);
				pti->amount *= 2;
				
				pti->refresh();
				return;
			}
		}
	}
	Player->Msg("You cant mix here.");
}

/*
* I decided to base this on how OSI will be changing detect hidden. 
* The greater your skill, the more of a range you can detect from target position.
* Hiders near the center of the detect circle are easier to detect than ones near
* the edges of the detect circle. Also low skill detecters cannot find high skilled
* hiders as easily as low skilled hiders.
*/

void cSkills::DetectHidden(P_PLAYER Player, const cCoord& Tpos)
{
	if (!Player) return;
	
	int dx,dy,j,low;
	double c,range;		//int is too restricting
	
	j=Player->Skill(DETECTINGHIDDEN);
	
	range = (j*j/1.0E6)*VISRANGE;	// this seems like an ok formula
	
	cChar* pc;
	int loopexit=0;
	bool found=false;
	RegGrid3x3Iterator4Chars rg3ic(Player->pos);
	while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (pc->isHiddenBySkill() && !pc->IsPermaHidden() && !pc->isDummy() ) // do not detect invis people only hidden ones
		{//do not reveal permanently hidden chars - AntiChrist
			dx=abs(pc->pos.x - Tpos.x);
			dy=abs(pc->pos.y - Tpos.y);
			
			c=hypot(dx, dy);
			low = (int)(pc->Skill(HIDING)*pc->Skill(HIDING)/1E3 - (range*50/VISRANGE)*(range-c)/range);
			if (low<0) low=0;
			else if (low>=1000) low=999;
			
			if (Player->checkSkill(DETECTINGHIDDEN,low) && c <= range)
			{
				pc->unhide();
				found=true;
				pc->Msg("You have been revealed!");
			}
			
		}
	}
	if (!found)
		Player->Msg("You did not find anyone.");
}

void cSkills::EnticementTarget1(P_PLAYER Player, P_CHAR pc)
{
	if (!pc) return;

	P_ITEM Inst = Skills->GetInstrument(Player);
	if (!Inst) 
	{
		Player->Msg("You do not have an instrument to play on!");
		return;
	}
	if ( pc->isInvul() || pc->shop )
	{
		Player->Msg("You cant entice that npc!");
		return;
	}
	if (pc->inGuardedArea())
	{
		Player->Msg("You cant do that in town!");
		return;
	}

	if (!pc->npc)
		Player->Msg("You cannot entice other players.");
	else
	{
		setAddid1_4(Player->cs,pc->serial);
		target(Player, T_82, "You play your music, luring them near. Whom do you wish them to follow?");
		soundeffect2(Player, Inst->GetSound());
	}
}

void cSkills::EnticementTarget2(P_PLAYER Player, P_CHAR pc)
{
	if (!Player || !pc) return;

	P_ITEM Inst = Skills->GetInstrument(Player);
	if (!Inst) 
	{
		Player->Msg("You do not have an instrument to play on!");
		return;
	}

	if (Player->PlayInstrument(Inst))
	{
		if (Player->checkSkill(ENTICEMENT))
		{
			P_CHAR Target = FindCharBySerial(getAddid1_4(Player->cs));
			Target->SetFollowTarget(pc);
			Target->npcWander = 1;
			Player->Msg("You play your hypnotic music, luring them near your target.");
			return;
		}
	}
	Player->Msg("Your music fails to attract them.");
}

void cSkills::ProvocationTarget1(P_PLAYER Player, P_CHAR pc)
{
	if (!pc) return;

	P_ITEM Inst = GetInstrument(Player);
	if (!Inst) 
	{
		Player->Msg("You do not have an instrument to play on!");
		return;
	}
	
	if (!pc->npc)
		Player->Msg("You cannot provoke other players.");
	else
	{
		setAddid1_4(Player->cs,pc->serial);
		target(Player, T_80, "You play your music, inciting anger, and your target begins to look furious. Whom do you wish it to attack?");
		soundeffect2(Player, Inst->GetSound());
	}
}

void cSkills::ProvocationTarget2(UOXSOCKET s, P_PLAYER Player, P_CHAR Victim2)
{
	if (!Player || !Victim2) return;

	P_CHAR Victim1 = FindCharBySerial(getAddid1_4(s));
	if (!Victim1) return;

	if (Victim2->inGuardedArea())
	{
		Player->Msg("You cant do that in town!");
		return;
	}
	if (Victim1->isSameAs(Victim2))
	{
		Player->Msg("Silly bard! You can't get something to attack itself.");
		return;
	}

	P_ITEM Inst = GetInstrument(Player);
	if (!Inst) 
	{
		Player->Msg("You do not have an instrument to play on!");
		return;
	}
	if (Player->PlayInstrument(Inst))
	{
		if (Player->checkSkill(PROVOCATION))
		{
			if (Player->inGuardedArea())
				Npcs->SpawnGuard(Player,Player,Player->pos); //ripper
			Player->Msg("Your music succeeds as you start a fight.");
		}
		else 
		{
			Player->Msg("Your music fails to incite enough anger.");
			Victim2 = Player;		// make the targeted one attack the Player
		}

		Victim1->fight(Victim2);
		Victim1->setAttackFirst();
		
		Victim2->fight(Victim1);
		Victim2->resetAttackFirst();
		
		sprintf(temp, "* You see %s attacking %s *", Victim1->name, Victim2->name);
		npctalkall(Victim1, temp);
	}
	else
	{
		Player->Msg("You play rather poorly and to no effect.");
	}
}

//////////////////////////
// name:	AlchemyTarget
// history: unknown, revamped by Duke,21.04.2000
// Purpose:	checks for valid reg and brings up gumpmenu to select potion
//			This is called after the user dblclicked a mortar and targeted a reg
//
void cSkills::AlchemyTarget(P_PLAYER Player, P_ITEM pi)
{
	if (!Player || !pi) return;
	
	switch (pi->id())
	{
	case 0x0F7B: itemmenu(Player, 991);break;	// Agility,
	case 0x0F84: itemmenu(Player, 992);break;	// Cure, Garlic
	case 0x0F8C: itemmenu(Player, 993);break;	// Explosion, Sulfurous Ash
	case 0x0F85: itemmenu(Player, 994);break;	// Heal, Ginseng
	case 0x0F8D: itemmenu(Player, 995);break;	// Night sight
	case 0x0F88: itemmenu(Player, 996);break;	// Poison, Nightshade
	case 0x0F7A: itemmenu(Player, 997);break;	// Refresh, 
	case 0x0F86: itemmenu(Player, 998);break;	// Strength,
	case 0x0F78: itemmenu(Player, 1002);break;	// shrink
	case 0x0E9B: break;	// Mortar
	default:
		if ( pi->id()>=0x1B11 && pi->id()<=0x1B1C )
		{
			MakeNecroReg(Player,pi,pi->id());
			Player->Msg("You grind some bone into powder.");
		}
		else
			Player->Msg("That is not a valid reagent.");
	}
}

void cSkills::CreateBandageTarget(P_PLAYER Player, P_ITEM pi)//-Frazurbluu- rewrite of tailoring to current OSI
{
	if (!Player) return;

	if (pi && !pi->isLockedDown())
	{
		short amt=0;
		unsigned short color = pi->color(); //-Frazurbluu- added color retention for bandage cutting from cloth
		P_ITEM iC=NULL;

		if ( IsCloth(pi->id()) )
		{
			amt=pi->amount;  //-Frazurbluu- changed to reflect current OSI 
			Player->Msg("You cut some cloth into bandages, and put it in your backpack");
			iC=Items->SpawnItem(ITY_None,amt,"#",0x0E21,color,Player);
			if (!iC) return;
			// need to set amount and weight and pileable, note: cannot set pilable while spawning item -Fraz-
			iC->weight=10;
		}	
		else if ( IsBoltOfCloth(pi->id()) )
		{
			if (pi->amount>1)
				amt=(pi->amount*50);//-Frazurbluu- changed to reflect current OSI 
			else
				amt=50;
			iC=Items->SpawnItem(ITY_None,amt,"cut cloth",0x1766,color,Player);
			if (!iC) return;
			iC->weight=10;
			iC->dye=1;
		}
		else if ( IsHide(pi->id()) )
		{
			amt=pi->amount;
			iC=Items->SpawnItem(ITY_None,amt,"leather piece",0x1067,color,Player);
			if (!iC) return;
			iC->weight=100;
		}
		else
		{
			Player->Msg("You cannot cut anything from that item.");
			return;
		}
		if (iC)		// did we create something ?
		{
			soundeffect(Player,0x0248);
			Items->DeleItem(pi);
			Weight->NewCalc(Player);
			statwindow(Player,Player);
		}
	}
}

////////////////////////
// name:	HealingSkillTarget
// history: unknown, revamped by Duke, 4.06.2000
//
void cSkills::HealingSkillTarget(P_PLAYER Player, P_CHAR Patient)
{
	if (!Player || !Patient) return;

	P_ITEM Bandage=Player->getDclickedItem();
	if (!Bandage) return;

	P_CHAR Attacker=Player->getAttacker(); // Ripper...cant heal while in a fight
	if (!SrvParms->bandageincombat
		&& (Patient->war || Player->war || (Attacker && Attacker->war)))
	{
		Player->Msg("You can`t heal while in a fight!");
		return;
	}
	if (!npcinrange(Player, Patient, 1))
	{
		Player->Msg("You are not close enough to apply the bandages.");
		return;
	}
	if (Player->isInnocent() && !Player->isSameAs(Patient))
	{
		if ( Patient->crimflag>0 || Patient->isMurderer())
		{
			criminal(Player);
		}
	}
	
	if (Patient->dead)
	{
		if (!SrvParms->bandagecanres)
		{
			Player->Msg("Too late! The bandages won't help anymore.");
			return;
		}
		if (Player->Skill(HEALING) < 800 || Player->Skill(ANATOMY)<800)
		{
			Player->Msg("You are not skilled enough to resurrect");
			return;
		}
		PC_ITEM House = findHouseAt( Patient->pos );	// prevent house break-ins by Uber 07-27-2002
		if (House && !Patient->Owns(House))
		{
			Player->Msg("That player is in someone else's house!");
			return;
		}
		if (!Player->checkSkill(HEALING,800) || 
			!Player->checkSkill(ANATOMY,800) )
		{
			Player->Msg("You failed to resurrect the ghost");
		}
		else
		{
			Patient->resurrect();
			Player->Msg("Because of your skill, you were able to resurrect the ghost.");			
		}
		Bandage->ReduceAmount(1);
		Player->objectdelay.setSecs(SrvParms->objectdelay+SrvParms->bandagedelay);
		return;
	}
	
	// changed by Uber to let curing pet check vet/animal lore instead of healing
	if (Patient->Poisoned()>0)
	{
		bool canCure=true;
		if (Patient->isHuman())
		{
			if (Player->Skill(HEALING)<=600 || Player->Skill(ANATOMY)<=600)
				canCure=false;
		}
		else
		{
			if (Player->Skill(VETERINARY)<=600 || Player->Skill(ANIMALLORE)<=600)
				canCure=false;
		}
		if (!canCure)
		{
			Player->Msg("You are not skilled enough to cure poison.");
			Player->Msg("The poison in your target's system counters the bandage's effect.");
		}
		else
		{
			bool success=false;
			if (Patient->isHuman())
			{
				if (Player->checkSkill(HEALING,600) &&
					Player->checkSkill(ANATOMY,600) )
					success=true;
			}
			else
			{
				if (Player->checkSkill(VETERINARY,600) &&
					Player->checkSkill(ANIMALLORE,600) )
					success=true;
			}
			if (success)
			{
				Patient->ResetPoisoned();
				Player->Msg("Because of your skill, you were able to counter the poison.");
				impowncreate(Player->cs, Patient,1);	// needed to make the green bar blue
				if (!Player->isSameAs(Patient) && !Patient->npc)
				{
					UOXSOCKET sp = Patient->getSlot();
					if (sp > -1)
						impowncreate(sp, Patient,1);	// update his green bar too
				}
			}
			else
				Player->Msg("You fail to counter the poison");

			Player->objectdelay.setSecs(SrvParms->objectdelay+SrvParms->bandagedelay);
			Bandage->ReduceAmount(1);
		}
		return;
	}
	
	if (Patient->Hp() == Patient->getHitMax())
	{
		Player->Msg("That being is not damaged");
		return;
	}

	if (Patient->isHuman())
	{
		if (!Player->checkSkill(HEALING))
		{
			Player->Msg("You apply the bandages, but they barely help!");
			Patient->increaseHp(1);
		}
		else
		{
			// GM heal/anatomy should heal between 43-80
			int low=Player->Skill(ANATOMY)/50 + Player->Skill(HEALING)/50 + 3;
			int hi=Player->Skill(ANATOMY)/50 + Player->Skill(HEALING)/20 + 10;
			int j = RandomNum(low,hi);
			int iMore1 = min(static_cast<int>(Patient->getHitMax()), j+Patient->Hp())-Patient->Hp();
			if (Patient->isSameAs(Player)) tempeffect(Patient,TEF_HealMsg,iMore1/2,0,10,0);  //allow a delay
			else tempeffect(Player,Patient,TEF_HealMsg,iMore1/2,0,4,0);// added suggestion by Ramases //-Fraz- must be checked
		}
	}
	else //Bandages used on a non-human
	{
		if (!Player->checkSkill(VETERINARY))
			Player->Msg("You are not skilled enough to heal that creature.");
		else
		{
			// GM lore/vet should heal between 43-80
			int low=Player->Skill(ANIMALLORE)/50 + Player->Skill(VETERINARY)/50 + 3;
			int hi=Player->Skill(ANIMALLORE)/50 + Player->Skill(VETERINARY)/20 + 10;
			Patient->increaseHp(RandomNum(low,hi));
			Player->Msg("You apply the bandages and the creature looks a bit healthier.");
		}
	}
	Bandage->ReduceAmount(1);
	Player->objectdelay.setSecs(SrvParms->objectdelay+SrvParms->bandagedelay);
}

void cSkills::ArmsLoreTarget(P_PLAYER Player, P_ITEM pi)
{
	if (!Player || !pi) return;

	if ( (pi->def==0 || pi->pileable)
		&& ((pi->lodamage==0 && pi->hidamage==0) && (pi->rank<1 || pi->rank>9)))
	{
		Player->Msg("That does not appear to be a weapon.");
		return;
	}
	if (Player->isGM())
	{
		sprintf(temp, "Defense [%i] Lodamage [%i] Hidamage [%i]",
			pi->def, pi->lodamage, pi->hidamage);
		Player->Msg(temp);
		return;
	}
	
	char p2[100];
	
	if (!Player->checkSkill(ARMSLORE, 0, 250))
		Player->Msg("You are not certain...");
	else
	{
		if ( pi->maxhp==0)
			Player->Msg(" Sorry this is a old item and it doesn't have maximum hp");
		else
		{
			float totalhp = (float) pi->hp/pi->maxhp;
			strcpy(temp,"This item ");
			if		(totalhp>0.9) strcpy(p2, "is brand new."); 
			else if (totalhp>0.8) strcpy(p2, "is almost new.");
			else if (totalhp>0.7) strcpy(p2, "is barely used, with a few nicks and scrapes.");
			else if (totalhp>0.6) strcpy(p2, "is in fairly good condition.");
			else if (totalhp>0.5) strcpy(p2, "suffered some wear and tear.");
			else if (totalhp>0.4) strcpy(p2, "is well used.");
			else if (totalhp>0.3) strcpy(p2, "is rather battered.");
			else if (totalhp>0.2) strcpy(p2, "is somewhat badly damaged.");
			else if (totalhp>0.1) strcpy(p2, "is flimsy and not trustworthy.");
			else				  strcpy(p2, "is falling apart.");
			strcat(temp,p2);
			char temp2[33];
			sprintf(temp2," [%.1f %%]",totalhp*100);
			strcat(temp,temp2);	// Magius(CHE) 
		}
		if (Player->checkSkill(ARMSLORE, 250, 510))
		{
			if (pi->hidamage)
			{
				int total = (pi->hidamage + pi->lodamage)/2;
				if		( total > 26) strcpy(p2, " Would be extraordinarily deadly.");
				else if ( total > 21) strcpy(p2, " Would be a superior weapon.");
				else if ( total > 16) strcpy(p2, " Would inflict quite a lot of damage and pain."); 
				else if ( total > 11) strcpy(p2, " Would probably hurt your opponent a fair amount.");
				else if ( total > 6)  strcpy(p2, " Would do some damage.");
				else if ( total > 3)  strcpy(p2, " Would do minimal damage.");
				else				  strcpy(p2, " Might scratch your opponent slightly.");
				strcat(temp,p2);
				
				if (Player->checkSkill(ARMSLORE, 500))
				{
					if		(pi->spd > 35) strcpy(p2, " And is very fast.");
					else if (pi->spd > 25) strcpy(p2, " And is fast.");
					else if (pi->spd > 15) strcpy(p2, " And is slow.");
					else				   strcpy(p2, " And is very slow.");
					strcat(temp,p2);
				}
			}
			else
			{
				if		(pi->def> 12) strcpy(p2, " Is superbly crafted to provide maximum protection.");
				else if (pi->def> 10) strcpy(p2, " Offers excellent protection.");
				else if (pi->def> 8 ) strcpy(p2, " Is a superior defense against attack.");
				else if (pi->def> 6 ) strcpy(p2, " Serves as a sturdy protection.");
				else if (pi->def> 4 ) strcpy(p2, " Offers some protection against blows.");
				else if (pi->def> 2 ) strcpy(p2, " Provides very little protection.");
				else if (pi->def> 0 ) strcpy(p2, " Provides almost no protection.");
				else				  strcpy(p2, " Offers no defense against attackers.");
				strcat(temp,p2);
			}
		}
		Player->Msg(temp);

		if (!(pi->rank<1 || pi->rank>10 || SrvParms->rank_system==0))
		{
			if (Player->checkSkill(ARMSLORE, 250, 500))
			{
				switch(pi->rank)
				{
					case 1: strcpy(p2, "It seems an item with no quality!");				break;
					case 2: strcpy(p2, "It seems an item very below standard quality!");	break;
					case 3: strcpy(p2, "It seems an item below standard quality!");			break;
					case 4: strcpy(p2, "It seems a weak quality item!");					break;
					case 5: strcpy(p2, "It seems a standard quality item!");				break;
					case 6: strcpy(p2, "It seems a nice quality item!");					break;
					case 7: strcpy(p2, "It seems a good quality item!");					break;
					case 8: strcpy(p2, "It seems a great quality item!");					break;
					case 9: strcpy(p2, "It seems a beautiful quality item!");				break;
					case 10:strcpy(p2, "It seems a perfect quality item!");					break;
				}
				Player->Msg(p2);
			}
		}
	}
}

void cSkills::ItemIdTarget(P_PLAYER Player, P_ITEM pi)
{
	if (!Player) return;

	if (pi && !pi->isLockedDown())
	{
		if (!Player->checkSkill(ITEMID, 0, 250))
		{
			Player->Msg("You can't quite tell what this item is...");
		}
		else
		{
			if (pi->corpse)
			{
				Player->Msg("You have to use your forensics evaluation skill to know more on this corpse.");
				return;
			}

			// Identify Item by Antichrist // Changed by MagiusCHE)
			if (Player->checkSkill(ITEMID, 250, 500))
				if (pi->name2 && (strcmp(pi->name2,"#"))) strcpy(pi->name,pi->name2); // Item identified! -- by Magius(CHE)

			if (pi->name[0]=='#') pi->getName(temp2);
			else strcpy(temp2, pi->name);
			sprintf(temp, "You found that this item appears to be called: %s", temp2);
			Player->Msg(temp);

			// Show Creator by Magius(CHE)
			if (Player->checkSkill(ITEMID, 250, 500))
			{
				if (strlen(pi->creator)>0)
				{
					if (pi->madewith>0) sprintf(temp2, "It is %s by %s",SkillManager->getMadeWord(pi->madewith-1),pi->creator); // Magius(CHE)
					else if (pi->madewith<0) sprintf(temp2, "It is %s by %s",SkillManager->getMadeWord(0-pi->madewith-1),pi->creator); // Magius(CHE)
					else sprintf(temp2, "It is made by %s",pi->creator); // Magius(CHE)
				} else strcpy(temp2, "You don't know its creator!");
			} else strcpy(temp2, "You can't know its creator!");
			Player->Msg(temp2);
			// End Show creator

			if (!Player->checkSkill(ITEMID, 250, 500))
			{
				Player->Msg("You can't tell if it is magical or not.");
			}
			else if (!pi->isType(ITY_CastingItem))
			{
				Player->Msg("This item has no hidden magical properties.");
			}
			else if (!Player->checkSkill(ITEMID, 500))
			{
				Player->Msg("This item is enchanted with a spell, but you cannot determine which");
			}
			else if (!Player->checkSkill(ITEMID, 750, 1100))
			{
				sprintf(temp, "It is enchanted with the spell %s, but you cannot determine how many charges remain.",spellname[(8*(pi->morex-1))+pi->morey-1]);
				Player->Msg(temp);
			}
			else
			{
				sprintf(temp, "It is enchanted with the spell %s, and has %d charges remaining.",spellname[(8*(pi->morex-1))+pi->morey-1],pi->morez);
				Player->Msg(temp);
			}
		}
	}
}

///////////////
// Name:	Evaluate_int_Target
// history:	unknown, revamped by Duke, 2.10.2000
// Purpose:	implements the 'evaluate intelligence' skill
//
void cSkills::EvaluateIntTarget(P_PLAYER Player, P_CHAR pc)
{
	if (!pc || !Player) return;

	// blackwind distance fix 
	if ( pc->pos.distance(Player->pos) >= 10 ) 
	{ 
		Player->Msg("You need to be closer to find out" ); 
		return; 
	} 

	if (!Player->checkSkill(EVALUATINGINTEL)) 
	{
		Player->Msg("You are not certain..");
		return;
	}
	short in = pc->effInt();
	if (in == 0) 
		Player->Msg("That does not appear to be a living being.");
	else
	{
		strcpy(temp,"That person looks ");
		if		(in <= 10)	strcat(temp, "slightly less intelligent than a rock.");
		else if (in <= 20)	strcat(temp, "fairly stupid.");
		else if (in <= 30)	strcat(temp, "not the brightest.");
		else if (in <= 40)	strcat(temp, "about average.");
		else if (in <= 50)	strcat(temp, "moderately intelligent.");
		else if (in <= 60)	strcat(temp, "very intelligent.");
		else if (in <= 70)	strcat(temp, "extraordinarily intelligent.");
		else if (in <= 80)	strcat(temp, "like a formidable intellect, well beyond the ordinary.");
		else if (in <= 90)	strcat(temp, "like a definite genius.");
		else if (in > 90)	strcat(temp, "superhumanly intelligent in a manner you cannot comprehend.");
		Player->Msg(temp);
	}
}

///////////////
// Name:	AnatomyTarget
// history:	unknown, revamped by Duke, 2.10.2000
// Purpose:	implements the 'evaluate anatomy' skill
//
void cSkills::AnatomyTarget(P_PLAYER Player, P_CHAR pc)
{
	if (!pc || !Player)	return;

	if (Player->dist(pc) >= 10)
	{
		Player->Msg("You need to be closer to find out more about them" );
		return;
	}
	
	if (!Player->checkSkill(ANATOMY)) 
	{
		Player->Msg("You are not certain..");
		return;
	}

	short dx = pc->effDex();
	short st = pc->effStr();
	if (st == 0 && dx == 0) 
		Player->Msg("That does not appear to be a living being.");
	else
	{
		char *ps1,*ps2;
		if		(st <= 10)	ps1="rather feeble";
		else if (st <= 20)	ps1="somewhat weak";
		else if (st <= 30)	ps1="to be of normal strength";
		else if (st <= 40)	ps1="somewhat strong";
		else if (st <= 50)	ps1="very strong";
		else if (st <= 60)	ps1="extremely strong"; 
		else if (st <= 70)	ps1="extraordinarily strong";
		else if (st <= 80)	ps1="as strong as an ox";
		else if (st <= 90)	ps1="like one of the strongest people you have ever seen";
		else if (st > 90)	ps1="superhumanly strong";

		if		(dx <= 10)	ps2="very clumsy";
		else if (dx <= 20)	ps2="somewhat uncoordinated";
		else if (dx <= 30)	ps2="moderately dexterous";
		else if (dx <= 40)	ps2="somewhat agile";
		else if (dx <= 50)	ps2="very agile";
		else if (dx <= 60)	ps2="extremely agile";
		else if (dx <= 70)	ps2="extraordinarily agile";
		else if (dx <= 80)	ps2="like they move like quicksilver";
		else if (dx <= 90)	ps2="like one of the fastest people you have ever seen";
		else if (dx > 90) 	ps2="superhumanly agile";
		sprintf(temp,"That person looks %s and %s.", ps1, ps2); 
		Player->Msg(temp);
	}
}

static int CalcRetamePenalty(P_CHAR Player, P_CHAR pc)
{
	int retameingdifficulty;
	float f=(float)pc->totame;	
	int b=40*(pc->totame>700);

	switch(pc->tamedamount)
	{
	case 0: retameingdifficulty=0; break;
	case 1: retameingdifficulty=b+60+(int)(f*0.15); break;
	case 2: retameingdifficulty=b+70+(int)(f*0.24); break;
	case 3: retameingdifficulty=b+70+(int)(f*0.37); break;
	case 4: retameingdifficulty=b+90+(int)(f*0.59); break;	  	  
	default: retameingdifficulty=11000;
	}
	return retameingdifficulty;
}

void cSkills::TameTarget(P_PLAYER Player, P_CHAR pc)
{
	if (!pc || !Player) return;

	if (!line_of_sight(Player->pos, pc->pos))
		return;

	if (!(pc->npc && Player->dist(pc) <= 3))
	{
		Player->Msg("You can't tame that!");
		return;
	}

	int effectiveToTame = pc->totame + CalcRetamePenalty(Player, pc);

	//printf("base:%i eff:%i ta:%i rtd:%i f:%i\n", pc->totame, effectiveToTame, pc->tamedamount, retameingdifficulty, (int)f);
	
	if (effectiveToTame>1000 || effectiveToTame<=0)
	{
		Player->Msg("You can't tame that creature.");
		return;
	}

	int skill=(Player->Skill(TAMING)*4 + Player->Skill(ANIMALLORE))/5;
	if (pc->totame<300) skill=Player->Skill(TAMING);
	if (skill < effectiveToTame)
	{
		Player->Msg("You have no chance to tame that creature.");
		return;
	}

	if (pc->tamed)
	{
		if (Player->Owns(pc))
			Player->Msg("You already control that creature!" );
		else
			Player->Msg("That creature looks tame already." );
		return;
	}
	tempeffect(Player, pc, TEF_Taming, max(2,effectiveToTame/250), 2);	// up to five times, every 2 seconds
}

void cSkills::TameTargetPart2(P_CHAR Tamer, P_CHAR Pet)
{
	if (!Tamer || !Pet) return;
	
	switch(rand()%4)
	{
	case 0: npctalkall(Tamer, "I've always wanted a pet like you."); break;
	case 1: npctalkall(Tamer, "Will you be my friend?"); break;
	case 2: sprintf(temp, "Here %s.",Pet->name); npctalkall(Tamer, temp); break;
	case 3: sprintf(temp, "Good %s.",Pet->name); npctalkall(Tamer, temp); break;
	default: 
		LogError("switch reached default");
	}
}

void cSkills::TameTargetPart3(P_CHAR Player, P_CHAR Pet)
{
	if (!Player || !Pet) return;
	UOXSOCKET s = Player->getSlot();

	int effectiveToTame = Pet->totame + CalcRetamePenalty(Player, Pet);

	if (! (Player->checkSkill(TAMING,effectiveToTame) &&
		Player->Skill(TAMING) > Pet->totame) )
	{
		Player->Msg("You were unable to tame it.");
		return;
	}

	Pet->tamedamount++;
	npctalk(s, Player, "It seems to accept you as it's master!");
	Pet->SetOwnSerial(Player->serial);
	Pet->SetSpawnSerial(-1);
	DecSpawnCount(Pet->spawnregion);	// fix for spawn blocking by Uber 5-26-2002
	
	if (Pet->war) npcToggleCombat(Pet);
	Pet->ResetTarget();
	Pet->setAttacker(NULL);

	P_CHAR pc = Player->GetTarget();
	if (pc)
	{
		if (Pet->isSameAs(pc))
			Player->ResetTarget();
	}
	pc = Player->getAttacker();
	if (pc)
	{
		if (Pet->isSameAs(pc))
			Player->setAttacker(NULL);
	}
	Pet->npcWander=0;
	if (Pet->id()==0x000C || Pet->id()==0x003B)
	{
		if (Pet->skin != 0x0481)
			Pet->setAi(10);
		else
			Pet->setAi(0);
	}
}

static void StealingAndGotCaught(P_PLAYER Player, P_CHAR Victim, P_ITEM pi)
{
	Player->Msg("You have been caught!");
	
	if (Victim->npc && Victim->isInnocent())
		npctalkall(Victim, "Guards!! A thief is amoung us!");
	
	if (Victim->isInnocent() && !Victim->isSameAs(Player->getAttacker()) && Guilds->Compare(Player,Victim)==0)//AntiChrist
		criminal(Player);//Blue and not attacker and not guild
	
	char item_name[300];
	if (pi->name[0] != '#')
		strcpy(item_name,pi->name);
	else
		pi->getName(item_name);

	sprintf(temp, "You notice %s trying to steal %s from you!",Player->name,item_name);
	sprintf(temp2,"You notice %s trying to steal %s from %s!", Player->name,item_name,Victim->name);
	
	UOXSOCKET sv = -1;
	if (!Victim->npc)
	{
		sv = Victim->getSlot();
		Victim->Msg(temp);
	}

	P_CHAR pc;
	AllPlayersIterator api;
	for (pc = api.First(); pc != NULL; pc = api.Next())
	{
		UOXSOCKET i = api.getSocket();
		if (!pc->isSameAs(Player) && i!=sv &&	// don't send temp2 to thief nor victim (sv will be -1 for npc victims)
			inrange1pl(Player,currchar(i)) &&
			(rand()%10==0 || (rand()%2==0 && pc->effInt()>=Player->effInt())))
			pc->Msg(temp2);
	}
}

static void RandomSteal(P_PLAYER Player, P_CHAR Victim)
{
	if (!Player || !Victim) return;

	int cansteal=2+Player->Skill(STEALING)/100; // 0 stealing 2 stones, 10  3 stones, 99.9 12 stones, 100 17 stones !!!
	if (Player->Skill(STEALING)>999) cansteal=17;
	cansteal *= 100;

	cItem* Pack=Victim->getBackpack();
	if (!Pack) {Player->Msg("bad luck, your victim doesnt have a backpack"); return; } //LB
	
	int i=0;	// to count the items in the victim's pack
	int ci=0,loopexit=0;
	P_ITEM pi;
	while ( ((pi=Pack->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		i++;
	}
	if (i<=0)
	{ 
		Player->Msg("your victim doesn't have posessions");
		return;
	}
	int r=rand()%i;	// determine which item to steal
	i=0;ci=0;loopexit=0;
	while ( ((pi=Pack->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if (i==r)
			break;	// stop searching, using current pi as the loot
		i++;
	}


	if (Victim->isSameAs(Player))
	{
		Player->Msg("You catch yourself red handed.");
		return;
	}
	
	if (Victim->isAiVendor())
	{
		Player->Msg("You cannot steal that.");
		return;
	}

	sprintf(temp, "You reach into %s's pack and try to take something...%s",Victim->name, pi->name);
	Player->Msg(temp);
	if (npcinrange(Player,Victim,1))
	{
		bool heavy=false;
		if (pi->isContainerType())
		{
			if ((Weight->RecursePacks(pi)*100) > cansteal) //cansteal is "weight"*100, RecursePacks(pi) is only the normal weight.. so use RecursePacks(pi)*100 (thrawn)
				heavy=true;
		}
		else
		{
			if (pi->getWeight() * pi->amount > cansteal)
				heavy=true;
		}
		if (heavy)
		{
			Player->Msg("That is too heavy.");
			return;
		}
		if (Victim->isGMorCounselor())
		{
			Player->Msg("You can't steal from gods.");
			return;
		}
		if (pi->newbie())
		{
			Player->Msg("That item has no value to you.");
			return;
		}
		
		bool succ=Player->checkSkill(STEALING);
		if (succ)
		{
			P_ITEM iPack=Player->getBackpack();
			if (iPack!=NULL)
			{
				pi->SetContSerial(iPack->serial);
				Player->Msg("You successfully steal that item.");
				pi->refresh();
			}
		}
		else
			Player->Msg("You failed to steal that item.");
		
		if ((!succ && rand()%5==0) || (Player->Skill(STEALING)<rand()%1001))
		{//Did they get caught? (If they fail 1 in 5 chance, other wise their skill away from 1000 out of 1000 chance)
			StealingAndGotCaught(Player, Victim, pi);
		}
	} else Player->Msg("You are too far away to steal that item.");
}

void cSkills::StealingTarget(P_PLAYER Player, int serial) // re-arranged by LB 22-dec 1999
{
	if (!Player) return;

	int cansteal=2+Player->Skill(STEALING)/100; // 0 stealing 2 stones, 10  3 stones, 99.9 12 stones, 100 17 stones !!!
	if (Player->Skill(STEALING)>999) cansteal=17;
	cansteal *= 100;
		
	if (isCharSerial(serial))
	{
		P_CHAR Victim=FindCharBySerial(serial);
		RandomSteal(Player,Victim);
		return;
	}

	const P_ITEM pi=FindItemBySerial(serial);
	if (!pi)
	{
		Player->Msg("You cannot steal that.");
		return;
	}
	if ( pi->id()==0x1E2D || pi->id()==0x1E2C )
	{
		Skills->PickPocketTarget(Player);
		return;
	}
	if ( pi->layer!=0	// no stealing for items on layers other than 0 (equipped!) ,
		|| pi->newbie()	// newbie items,
		|| pi->isInWorld() )	// and items not being in containers allowed !
	{
		Player->Msg("You cannot steal that.");
		return;
	}

	bool heavy=false;
	if (pi->isContainerType())
	{
		if ((Weight->RecursePacks(pi)*100) > cansteal) //cansteal is "weight"*100, RecursePacks(pi) is only the normal weight.. so use RecursePacks(pi)*100 (thrawn)
			heavy=true;
	}
	else
	{
		if (pi->getWeight() * pi->amount > cansteal)
			heavy=true;
	}
	if (heavy)
	{
		Player->Msg("That is too heavy.");
		return;
	}
	
	PC_ITEM VictimPack = GetOutmostCont(pi);
	if (!VictimPack) return;
	P_CHAR Victim = GetPackOwner(VictimPack);
	if (!Victim) return;

	if (Victim->isAiVendor() ||		// player vendor
		VictimPack->layer != 0x15)	// must be a regular backpack, can't steal from buy containers
	{
		Player->Msg("You cannot steal that.");
		return;
	}
	
	if (Victim->isSameAs(Player))
	{
		Player->Msg("You catch yourself red handed.");
		return;
	}

	if (npcinrange(Player,Victim,1))
	{
		int succ=Player->checkSkill(STEALING);
		if (succ)
		{
			P_ITEM iPack=Player->getBackpack();
			if (iPack==NULL) return;
			pi->SetContSerial(iPack->serial);
			Player->Msg("You successfully steal that item.");
			pi->refresh();
		}
		else
			Player->Msg("You failed to steal that item.");
		
		if ((!succ && rand()%16==0) || Player->Skill(STEALING)<rand()%1001)
		{
			StealingAndGotCaught(Player, Victim, pi);
		}
	}
	else
		Player->Msg("You are too far away to steal that item.");
}

void cSkills::BeggingTarget(P_PLAYER Player, P_CHAR pc)
{
	if (!Player || !pc) return;
	
	if (pc->getSlot()!=-1)
	{
		Player->Msg("Maybe you should just ask.");
		return;
	}
	if (Player->dist(pc) >= begging_data.range)
	{
		Player->Msg("You are not close enough to beg.");
		return;
	}
	
	if (pc->isHuman() && pc->realInt() != 0) //Used on human
	{
		if (!pc->begging_timer.hasExpired())
		{
			npctalk(Player->cs,pc,"Annoy someone else !");
			return;
		}
		
		npctalkall(Player, begging_data.text[rand()%3]); // npcemoteall?
		if (!Player->checkSkill(BEGGING))
			Player->Msg("They seem to ignore your begging plees.");
		else
		{
			pc->begging_timer.setSecs(begging_data.timer); 
			// pre-calculate the random amout of gold that is "targeted"
			
			int x=pc->Skill(BEGGING)/50;
			if (x<1) x=1; 
			int y=rand()%x;
			y+=RandomNum(1,4); 
			if (y>25) y=25;
			
			// check for gold in target-npc pack
			int gold=pc->CountGold();
			
			if (gold<=0)
			{				
				npctalk(Player->cs,pc,"Sorry, I'm poor myself");
				return;
			}
			int realgold=min(y,gold);
			cItem* Pack=pc->getBackpack();
			if (Pack)
				Pack->DeleteAmount(realgold,0x0EED);
			
			npctalkall(pc,"Ohh thou lookest so poor, Here is some gold I hope this will assist thee."); // zippy
			addgold(Player,realgold);
			Player->Msg("Some gold is placed in your pack.");
		}
	}
	else
		Player->Msg( "That would be foolish.");
}

void cSkills::AnimalLoreTarget(P_PLAYER Player, P_CHAR pc)
{
	if (!pc || !Player) return;

	if (pc->isDummy()) return;	// dont look at dummy npcs (thrawn)

	// blackwind distance fix 
	if (Player->dist(pc) >= 10 ) 
	{ 
		Player->Msg("You need to be closer to find out more about them" ); 
		return; 
	} 

	if (pc->isGMorCounselor())
	{
		Player->Msg("Little is known of these robed gods.");
		return;
	}
	if (pc->isHuman())
	{
		Player->Msg("The human race should use dvorak!");
		return;
	}
	else // Lore used on a non-human
	{
		if (Player->checkSkill(ANIMALLORE))
		{
			sprintf(temp, "Damage [%i-%i] Defense [%i] Taming [%i] Hit Points [%i]", pc->lodamage, pc->hidamage, pc->def, pc->totame/10, pc->Hp());
			npcemote(Player->cs, pc, temp, 0);
			return;
		}
		else
		{
			Player->Msg("You can not think of anything relevant at this time.");
			return;
		}
	}
}

void cSkills::ForensicsTarget(P_PLAYER Player, P_ITEM pi) //AntiChrist
{
	if (!Player) return;
	int curtim=uiCurrentTime;

	if (!pi || !pi->corpse)
	{
		Player->Msg("That does not appear to be a corpse.");
		return;
	}
	
	if (Player->isGM())
	{
		sprintf(temp,"The %s is %lu seconds old and the killer was %s.", pi->name, (curtim-pi->murdertime)/MY_CLOCKS_PER_SEC, pi->murderer);
		Player->Msg(temp);
	}
	else
	{
		if (!Player->checkSkill(FORENSICS, 0, 500))
			Player->Msg("You are not certain about the corpse.");
		else
		{
			if (((curtim-pi->murdertime)/MY_CLOCKS_PER_SEC)<=60) strcpy(temp2,"few");
			if (((curtim-pi->murdertime)/MY_CLOCKS_PER_SEC)>60) strcpy(temp2,"many");
			if (((curtim-pi->murdertime)/MY_CLOCKS_PER_SEC)>180) strcpy(temp2,"many many");
			sprintf(temp,"The %s is %s seconds old.", pi->name, temp2);
			Player->Msg(temp);
			if (!Player->checkSkill(FORENSICS, 500) || *(pi->murderer)=='\0')
				Player->Msg("You can't say who was the killer.");
			else
			{
				sprintf(temp,"The killer was %s.",pi->murderer);
				Player->Msg(temp);
			}
		}
	}
}

void cSkills::PoisoningTarget(P_PLAYER Player, P_ITEM pi) //AntiChrist
{
	P_ITEM Poison=FindItemBySerial(Player->target1serial);
	if (!Poison) return;

	if (!Poison->isType(ITY_Potion) || Poison->morey!=6)
	{
		Player->Msg("That is not a valid poison!");
		return;
	}
	
	if (!pi)
	{
		Player->Msg("You can't poison that item.");
		return;
	}

	int low=0,high=0;
	switch(Poison->morez)
	{
	case 1:	low=0;	high=500;	break;//lesser poison
	case 2:	low=151;high=651;	break;//poison
	case 3:	low=551;high=1051;	break;//greater poison
	case 4:	low=901;high=1401;	break;//deadly poison
	default:
		LogError("switch reached default");
		return;
	}

	soundeffect2(Player, 0x0247); //poisoning effect
	LogAssert(high!=0);
	if (Player->checkSkill(POISONING, low, high))
	{
		//-Frazurbluu-  adding the weapons that may be posioned here..
		// also need to adjust poisoning damages..
		if (pi->Poisoned()<(int)Poison->morez) pi->poisoned=Poison->morez;
		Player->Msg("You successfully poison that item.");
	}
	else
		Player->Msg("You fail to apply the poison.");
	
	Poison->ReduceAmount(1);
	Items->SpawnItem(ITY_None,1,"#",0x0F0E,0,Player);		//empty bottle after poisoning
}

void cSkills::PickPocketTarget(P_PLAYER Player) // PickPocket dip`s..Ripper
{
	if (!Player) return;

	if (Player->Skill(STEALING) < 300)	// check if under 30 in stealing
	{
		Player->checkSkill(STEALING);
		// check their skill
		soundeffect(Player, 0x0249);
		// rustling sound..dont know if right but it works :)
	}
	else
	{
		Player->Msg("You learn nothing from practicing here");
		// if over 30 Stealing..dont learn.
	}
}

void cSkills::LockPick(P_PLAYER Player, P_ITEM pi)
{
	if (!Player || !pi) return;

	if (!pi->isLockedDown())
	{
		P_ITEM piPick=Player->getDclickedItem();
		if (!piPick) return;
		if (pi->isType(ITY_Container) || pi->isType(ITY_Door) || pi->isType(ITY_SpawnChest)) 
		{
			Player->Msg("That is not locked.");
			return;
		}
		
		if (pi->isType(ITY_LockedContainer) || pi->isType(ITY_LockedDoor) || pi->isType(ITY_LockedSpawnChest))
		{
			if (pi->getMore1_4() == 0) //Make sure it isn't an item that has a key (i.e. player house, chest..etc)
			{				
				if (Player->checkSkill(LOCKPICKING))
				{
					switch(pi->type)
					{
					case 8:		pi->setType(ITY_Container);	break;
					case 13:	pi->setType(ITY_Door);		break;
					case 64:	pi->setType(ITY_SpawnChest);break;
					default:
						LogError("switch reached default");
						return;
					}
					soundeffect3(pi, 0x0241);
					Player->Msg("You manage to pick the lock.");
				}
				else
				{
					if ((rand()%100)>50) 
					{
						Player->Msg("You broke your lockpick!");
						piPick->ReduceAmount(1);
					}
					else
					{
						Player->Msg("You fail to open the lock.");
					}
				}
			}
			else
			{
				Player->Msg("That cannot be unlocked without a key.");
			}
		}
	}
}

void cSkills::Tinkering(P_PLAYER Player, P_ITEM pi)
{
	if (!Player || !pi) return;

	if (!pi->isLockedDown())
	{
		if (pi->id()==0x1BEF || pi->id()==0x1BF2 || IsLog(pi->id()) ) 
		{
			if (CheckInPack(Player,pi))
			{
				make_st* imk = Player->getMakeData();
				int amt;
				imk->has=amt=Player->CountItems(pi->id(), pi->color());
				imk->Mat1id=pi->id();
				if ( IsLog(pi->id()) )
				{
					if (amt<4)
					{
						Player->Msg("You don't have enough log's to make anything.");
						return;
					} 
					else Skills->MakeMenu(Player,70,TINKERING);
				}
				else
				{
					if (amt<2)
					{ 
						Player->Msg("You don't have enough ingots to make anything.");
						return;
					}
					imk->Mat1color=pi->color();	// only if ingots are used
					if (pi->color() == 0x005B)				// glass ingots ?
						Skills->MakeMenu(Player,75,TINKERING);
					else
						Skills->MakeMenu(Player,80,TINKERING);
				}
			}
			return;
		}
	}
	Player->Msg("You cannot use that material for tinkering.");
}

//////////////////////////////////
// name:	cTinkerCombine
// history: by Duke, 3.06.2000
// Purpose: handles the combining of two (tinkering-)items after the user
//			dclicked one and then targeted the second item
//
//			It's a base class for three derived classes that handle the
//			old interfaces
//
class cTinkerCombine	// Combining tinkering items
{
protected:
	char* failtext;
	short _badsnd;
	short itembits;
	short minskill;
	short id;
public:
	cTinkerCombine(short badsnd=0x51, char *failmsg="You break one of the parts.")
	{
		_badsnd=badsnd;
		failtext=failmsg;
		itembits=0;
		minskill=100;
	}
	virtual void failmsg(P_PLAYER Player)	{Player->Msg(failtext);}
	virtual void playbad(P_PLAYER Player)	{soundeffect(Player,_badsnd);}
	virtual void playgood(P_PLAYER Player)	{soundeffect(Player,0x002A);}
	virtual void checkPartID(short id)		{;}
	virtual bool decide()					{return (itembits == 3) ? true : false;}
	virtual void createIt(int s, P_CHAR Player)		{;}
	static cTinkerCombine* factory(short combinetype);
	virtual void DoIt(P_PLAYER Player, P_ITEM piTarg)
	{
		if (!Player) return;

		P_ITEM piClick = FindItemBySerial( getAddid1_4(Player->cs) );
		if ( piClick == NULL )
		{
			Player->Msg("Original part no longer exists" );
			return;
		}
		
		if (piTarg==NULL || piTarg->isLockedDown())
		{
			Player->Msg("You can't combine these.");
			return;
		}
		
		// make sure both items are in the player's backpack
		P_ITEM Pack=Check4Pack(Player);
		if (Pack==NULL) return;
		if ( !Pack->Contains(piTarg) || !Pack->Contains(piClick))
		{
			Player->Msg("You can't use material outside your backpack");
			return;
		}
		
		// make sure the parts are of correct IDs AND they are different
		checkPartID( piClick->id() );
		checkPartID( piTarg->id() );
		if (!decide())
			Player->Msg("You can't combine these.");
		else
		{
			if (Player->Skill(TINKERING) < minskill)
			{
				Player->Msg("You aren't skilled enough to even try that!");
				return;
			}
			UOXSOCKET s = Player->cs;
			if (!Player->checkSkill(TINKERING, minskill))
			{
				failmsg(Player);
				P_ITEM piLoser= rand()%2 ? piTarg : piClick;
				piLoser->ReduceAmount(1);
				playbad(Player);
			}
			else
			{
				Player->Msg("You combined the parts");
				piClick->ReduceAmount(1);
				piTarg->ReduceAmount(1);		// delete both parts 
				createIt(s,Player);						// spawn the item
				playgood(Player);
			}
		}
	}
};

class cTinkCreateAwG : public cTinkerCombine
{
public:
	cTinkCreateAwG() : cTinkerCombine() {}
	virtual void checkPartID(short id)
	{
		if (id==0x105B || id==0x105C) itembits |= 0x01; // axles
		if (id==0x1053 || id==0x1054) itembits |= 0x02; // gears
	}
	virtual void createIt(int s, P_CHAR Player)
	{
		Items->SpawnItem(ITY_None,1,"an axle with gears",0x1051,0,Player);
	}
};

class cTinkCreateParts : public cTinkerCombine
{
public:
	cTinkCreateParts() : cTinkerCombine() {}
	virtual void checkPartID(short id)
	{
		if (id==0x1051 || id==0x1052) itembits |= 0x01; // axles with gears
		if (id==0x1055 || id==0x1056) itembits |= 0x02; // hinge
		if (id==0x105D || id==0x105E) itembits |= 0x04; // springs
	}
	virtual bool decide()
	{
		if (itembits == 3) {id=0x1059; minskill=300; return true;}	// sextant parts
		if (itembits == 5) {id=0x104F; minskill=400; return true;}	// clock parts
		return false;
	}
	virtual void createIt(int s, P_CHAR Player)
	{
		char sztemp[15] ;
		if (id == 0x104F)
			strcpy(sztemp,"clock parts") ;
		else
			strcpy(sztemp,"sextant parts") ;
		char *pn = sztemp ;
		//#else
		//char *pn = (id2==0x4F) ? "clock parts" : "sextant parts";
		//#endif
		Items->SpawnItem(ITY_None,1,pn,id,0,Player);
	}
};

class cTinkCreateClock : public cTinkerCombine
{
public:
	cTinkCreateClock() : cTinkerCombine() {}
	virtual void checkPartID(short id)
	{
		if (id==0x104D || id==0x104E) itembits |= 0x01; // clock frame
		if (id==0x104F || id==0x1050) itembits |= 0x02; // clock parts
	}
	virtual bool decide()   {minskill=600; return cTinkerCombine::decide();}
	virtual void createIt(int s, P_CHAR Player)
	{
		Items->SpawnItem(ITY_None,1,"clock",0x104B,0,Player);
	}
};

#define cTC_AwG		11
#define cTC_Parts	22
#define cTC_Clock	33

cTinkerCombine* cTinkerCombine::factory(short combinetype)
{
	switch (combinetype)
	{
		case cTC_AwG:   return new cTinkCreateAwG();break;
		case cTC_Parts: return new cTinkCreateParts();break;	// clock/sextant parts
		case cTC_Clock: return new cTinkCreateClock();break;	// clock
		default:		return new cTinkerCombine();break;		// a generic handler
	}
	return NULL ;
}

void cSkills::TinkerAxel(P_PLAYER Player, P_ITEM pi)
{
	cTinkerCombine *ptc = cTinkerCombine::factory(cTC_AwG);
	ptc->DoIt(Player,pi);
}

void cSkills::TinkerAwg(P_PLAYER Player, P_ITEM pi)
{
	cTinkerCombine *ptc = cTinkerCombine::factory(cTC_Parts);
	ptc->DoIt(Player,pi);
}

void cSkills::TinkerClock(P_PLAYER Player, P_ITEM pi)
{
	cTinkerCombine *ptc = cTinkerCombine::factory(cTC_Clock);
	ptc->DoIt(Player,pi);
}

void cSkills::RepairTarget(P_PLAYER Player, P_ITEM pi)
{ // Ripper..Repair items.
	if (!pi || !Player) return; 

	short smithing=Player->Skill(BLACKSMITHING);
	if (smithing < 500)
	{
		Player->Msg("* Your not skilled enough to repair items.*");
		return;
	}

	if (!pi->isLockedDown())
	{
		if (!CheckInPack(Player,pi)) 
			return;
		if (!pi->hp)
		{
			Player->Msg("That item cant be repaired.");
			return;
		}
		if (!AnvilInRange(Player))
		{
			Player->Msg("Must be closer to the anvil.");
			return;
		}
		if (pi->hp>=pi->maxhp)
		{
			Player->Msg("That item is at full strength.");
			return;
		}
		short dmg=4;	// damage to maxhp
		if		((smithing>=900)) dmg=1;
		else if ((smithing>=700)) dmg=2;
		else if ((smithing>=500)) dmg=3;

		if (Player->checkSkill(BLACKSMITHING))
		{
			pi->maxhp-=dmg;
			pi->hp=pi->maxhp;
			Player->Msg("* the item has been repaired.*");
		}
		else
		{
			pi->hp-=2;
			pi->maxhp-=1;
			Player->Msg("* You fail to repair the item. *");
			Player->Msg("* You weaken the item.*");
		}
	}
}

//////////////////////////////////
// name:	SmeltItemTarget
// history: by Ripper
//			revamped by Duke, 30.11.2001
// Purpose: Smelting items.
//			Only items crafted by a (player-)Blacksmith can be smelted
//
void cSkills::SmeltItemTarget(P_PLAYER Player, P_ITEM pi)
{
	if (!pi || !Player) return; 
	if (!CheckInPack(Player,pi)) return;
	if (!SrvParms->smeltableitems)
	{
		Player->Msg("Smelting items is currently disabled!");
		return;
	}


	short ID = pi->id();
	if (pi->isLockedDown()
		|| !(IsMetalArmour(ID) || IsMetalWeapon(ID) || IsMetalShield(ID) ))
	{
		Player->Msg("You cant smelt that item!");
		return;
	}
	if (!ForgeInRange(Player))
	{
		Player->Msg(" Must be closer to the forge.");
		return;
	}

	const sOreResource* OI = Crafting.GetByItemColor(pi->color());
	if (!OI) return;
	if (Player->Skill(MINING) < OI->MinSkill)
	{
		Player->Msg("You aren't skilled enough to even try that!");
		return;
	}

	int amt=1+pi->weight/100;	// number of ingots you get depends on the weight (Duke)

	if (Player->checkSkill(MINING,OI->MinSkill))
		Player->Msg("You smelt the item and place some ingots in your pack.");
	else
	{
		amt = 1;
		Player->Msg("You smelt the item but merely get usable ingots.");
	}

	char iname[100];
	sprintf(iname,"%s ingot",OI->Name);

	cItem* Ingot=Items->SpawnItem(ITY_None,amt,iname,0x1BF2,OI->IngotColor,Player);
	if (Ingot)
	{
		Ingot->weight = 20;	// that is 0.2 stone
		Items->DeleItem(pi);
	}
}

