/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#ifndef __CHARS_H__
#define __CHARS_H__

#include "typedefs.h"
#include "SrvParms.h"
#include "skills.h"
#include "timers.h"

#include "debug.h"
// just temporary
#undef  DBGFILE
#define DBGFILE "chars.h"

// hardcoded Script Numbers for Chars
/*
#define SNC_EnergyVortex	295
#define SNC_AirElemental	291
#define SNC_Deamon			290
#define SNC_EarthElemental	292
#define SNC_FireElemental	293
#define SNC_WaterElemental	294
#define SNC_BladeSpirits	296
#define SNC_Mercenary		227
#define SNC_PlayerVendor	2117
#define SNC_MountA0			8
#define SNC_MountA1			9
#define SNC_MountA2			10
#define SNC_MountA3			429
#define SNC_MountA4			427
#define SNC_MountA5			428
#define SNC_MountA6			54
#define SNC_Mount9Fa		430
#define SNC_Mount9Fb		7
#define SNC_SummonList		10000
*/
class cSpell; //forward declaration
class cRace;
class cSpawnContext;

class cStat
{
protected:
	short real;		// The true value of the Stat
	short dec;		// holds the 3 digits behind the decimal point. Reserved for calculation of advancement
	short temp;		// holds all temporary effects on Stat, eg. plate, spells, potions
	short limit;	// holds the maximum value possible for the char
public:

	void  setTmp(short t)	{ temp = t; }
	short Eff()				{return real+temp>0 ? real+temp : 0;}	// returns current effective Dexterity
	short Real()			{return real;}	// returns the true Dexterity
	short Dec()				{return dec;}	// returns the 3 digits behind the decimal point
	short Limit()			{return limit;} // returns the stat limit
	void  setReal(short val){real = val;}	// set the true Dex
	void  setDec(short val)	{dec = val;}	// set the 3 digits
	void  setLimit(short val){limit = val;} // set the stat limit
	void  chgTemp(short val){temp += val;}	// intended for temporary changes of Dex
	void  chgReal(short val,short limit)	// intended for permanent changes of Dex
							{real += val; if (real<1) real=1; if ((limit) && (real>limit)) real=limit;}
	bool  chgDec(short val,short limit)
							{dec += val;
							if (dec>1000) {dec-=1000;chgReal(1,limit);return true;}
							else return false;}
};

enum eMerchants
{
	BANKER,GUARD,BARD,MINER,WEAPONSMITH=4,BAKER,PROVISIONER,
	COBBLER,INNKEEPER,MAGE,HERBALIST,BUTCHER,TAILOR,BOWYER,
	JEWELER,LEATHERWORKER,SHIPWRIGHT,SPINNER,ARMORER,BLACKSMITH=19,
	ARCHITECT,CARPENTER,FARMER,COOK,ANIMALTRAINER,FISHERMAN,FISHERLADY,
	ALCHEMIST,TINKER,ENGINEER,
	MERCHANTENTRIES
};

class cCmdSet
{
private:
	unsigned int cmds[7];
public:
	bool equals(cCmdSet Other);
	unsigned int get(int whichInt);
	void set(cCmdSet Other);
	void set(int whichInt);
	void set(int whichInt, int whichBit);
	void setValue(int whichInt, int value);
	void setAll();
	void reset();
	void reset(int whichInt, int whichBit);
};


class cChar
{
protected:
	int index;		// this char's inx in the allchars array
	cRace* Race;
public:
//	unsigned int race; // -Fraz- Race AddOn
	int getRace();			// get the race #
	int getRaceName(char* name, int maxlen);
	void setRace(int r);	// set it
	
    int doppelgaenger_serial; // used for doppelgaenger AI (dupe enemy body + skills)
	                          // holds serial of temporary storage NPC of old body + skills
	                          // dummy storage holder npcs get -1 to tag special treatment (invisible, invul etc)
	                          // npc's/players that dupe/polymorph receive the serial of the dummy storage npc
	                          // 0 = default = neither doppelgaenger/duper NPc nor dummy storage npc

	bool			automode;
	bool			isclone;
	int				serial; // Character serial number
	int				qsf;

	unsigned int    delayed_disconnect_reason;
	void              set_delayed_disconnect(int t, char reason=0)     { if (t==0) this->delayed_disconnect=0; else this->delayed_disconnect=uiCurrentTime+t*MY_CLOCKS_PER_SEC; delayed_disconnect_reason=reason;}
	unsigned long int get_delayed_disconnect_time(char & reason) { reason=delayed_disconnect_reason; return this->delayed_disconnect; }

	int             scriptnum; // script#

	int				multis; //Multi serial

    bool			free;
	char			name[50];
	char			orgname[50]; //original name - for Incognito
	char			title[50];
	bool			unicode;    // This is set to 1 if the player uses unicode speech, 0 if not
	int				account;    // changed to signed, lb
	cCoord			pos;
	signed char	dispz;          // Z that the char is SHOWN at. Server needs other coordinates for real movement calculations.
	                            // changed from unsigned to signed, LB

	unsigned char	dir; //&0F=Direction

    //private:
	unsigned char	id1; // Character body type
	unsigned char	id2; // Character body type

public:
	short			d_xid;      // Backup of body type for ghosts
	bool			incognito;  // AntiChrist - true if under incognito effect
	bool			polymorph;  // AntiChrist - true if under polymorph effect
	UI16			skin;       // Skin color
	int             keynumb;    // for renaming keys 
	UI16			xskin;      // Backup of skin color
	unsigned int creationday;	// Day since EPOCH this character was created on
	
protected:
	unsigned char	priv;			// 1:GM clearance, 2:Broadcast, 4:Invulnerable, 8: single click serial numbers
									// 10: Don't show skill titles, 20: GM Pagable, 40: Can snoop others packs, 80: Counselor clearance
	unsigned char	priv2;			// 1:Allmove, 2: Frozen, 4: View houses as icons, 8: permanently hidden
									// 10: no need mana, 20: dispellable, 40: permanent magic reflect, 80: no need reagents
	void	day(unsigned long day);	// set the day it was created
	unsigned long day();			// Retrieve the day it was created
	short			priv3;			// # of set of commands in metagm
	unsigned char	priv4;
	short viewingdepth;				// switch between different npc-viewing depths
									// 0 = show only things normal players can see
									// 1 = dont show offline chars
									// 2 = dont show "internal used invis npcs"
									// 3 = default for gms: show everything

public:
	unsigned short	        gmrestrict;	// for restricting GMs to certain regions

	cCmdSet					cmds;		// needed for Lord binarys meta-gm stuff
	unsigned char			fonttype;   // Speech font to use
	UI16					saycolor;   // Color for say messages
	short					emotecolor; // Color for emote messages
	unsigned char           tamedamount;

	bool isMount();

	inline void setPriv3(short value)				{priv3 = value;}
	inline short getPriv3()							{return priv3;}
	inline void SetPriv4(unsigned char value)		{priv4 = value;}
	inline unsigned char GetPriv4()					{return priv4;}

	inline bool IsPermaFrozen()						{return (priv4&0x01 ?true:false);}
	inline void MakePermaFrozen()					{priv4 |= 0x01;}
	inline void RemovePermaFrozen()					{priv4 &= 0xFE;}

	inline bool InParty()							{return (priv4&0x02 ?true:false);}
	inline void PutInParty()						{priv4 |= 0x02;}
	inline void RemoveFromParty()					{priv4 &= 0xFD;}

	inline bool PartyCanLoot()						{return (priv4&0x04 ?true:false);}
	inline void AllowPartyLoot()					{priv4 |= 0x04;}
	inline void DisallowPartyLoot()					{priv4 &= 0xFB;}

	inline bool PrivHide()							{return (priv4&0x08 ?true:false);}
	inline void PrivHideOn()						{priv4 |= 0x08;}
	inline void PrivHideOff()						{priv4 &= 0xF7;}

	////////////////////////

	inline void SetPriv2(unsigned char value)		{priv2 = value;}
	inline unsigned char GetPriv2()				    {return priv2;}

	inline bool CanMoveAll()						{return (priv2&0x01 ?true:false);}
	inline void AllowMoveAll()						{priv2 |= 0x01;}
	inline void DisallowMoveAll()					{priv2 &= 0xFE;}

	inline bool IsFrozen()							{return (priv2&0x02 ?true:false);}
	inline void Freeze()							{priv2 |= 0x02;}
	inline void Unfreeze()							{priv2 &= 0xFD;}

	inline bool DoesViewHouseIcons()				{return (priv2&0x04 ?true:false);}
	inline void MakeShowHouseIcons()				{priv2 |= 0x04;}
	inline void MakeNoShowHouseIcons()				{priv2 &= 0xFB;}

	inline bool IsPermaHidden()					    {return (priv2&0x08 ?true:false);}
	inline void MakePermaHidden()					{priv2 |= 0x08;}
	inline void RemovePermaHidden()				    {priv2 &= 0xF7;}

	inline bool DoesNotNeedMana()					{return (priv2&0x10 ?true:false);}
	inline void MakeNotNeedMana()					{priv2 |= 0x10;}
	inline void MakeNeedMana()						{priv2 &= 0xEF;}

	inline bool IsDispellable()					    {return (priv2&0x20 ?true:false);}
	inline void MakeDispellable()					{priv2 |= 0x20;}
	inline void MakeNotDispellable()				{priv2 &= 0xDF;}

	inline bool HasMagicReflect()					{return (priv2&0x40 ?true:false);}
	inline void GiveMagicReflect()					{priv2 |= 0x40;}
	inline void RemoveMagicReflect()				{priv2 &= 0xBF;}

	inline bool DoesNotNeedRegs()					{return (priv2&0x80 ?true:false);}
	inline void MakeNotNeedRegs()					{priv2 |= 0x80;}
	inline void MakeNeedRegs()						{priv2 &= 0x7F;}

	/// party system end

	// a temporary (quick&dirty) encapsulation for Dexterity. (Duke, 21.8.2001)
protected:
	cStat st;		// Strength
	cStat dx;		// Dexterity
	cStat in;
	int hp;		                // Hitpoints
	int stm;	                // Stamina
	int mn;                     // Mana

public:
	short hitmodifier;
	short stammodifier;
	short manamodifier;

	short effStr();				// returns current effective Strength
	short realStr();			// returns the true Strength
	short decStr();				// returns the 3 digits behind the decimal point
	short StrLimit();			// returns the individual stat limit
	void  setStr(short val);	// set the true Str
	void  setDecStr(short val);	// set the 3 digits
	void  setTmpStr(short t)	{ st.setTmp(t); } 
	void  chgStr(short val);	// intended for temporary changes of Str
	void  chgRealStr(short val);// intended for permanent changes of Str
	bool  incDecStr(short val);
	void  setStrLimit(short val);
	short getStrLimit();
	int   getHitMax();

	short effDex();				// returns current effective Dexterity
	short realDex();			// returns the true Dexterity
	short decDex();				// returns the 3 digits behind the decimal point
	short DexLimit();			// returns the individual stat limit
	void  setDex(short val);	// set the true Dex
	void  setDecDex(short val);	// set the 3 digits
	void  setTmpDex(short t)	{ dx.setTmp(t); } 
	void  chgDex(short val);	// intended for temporary changes of Dex
	void  chgRealDex(short val);// intended for permanent changes of Dex
	bool  incDecDex(short val);
	void  setDexLimit(short val);
	short getDexLimit();
	int   getStamMax();

	short effInt();				// returns current effective Intelligence
	short realInt();			// returns the true Intelligence
	short decInt();				// returns the 3 digits behind the decimal point
	short IntLimit();			// returns the individual stat limit
	void  setInt(short val);	// set the true Int
	void  setDecInt(short val);	// set the 3 digits
	void  setTmpInt(short t)	{ in.setTmp(t); } 
	void  chgInt(short val);	// intended for temporary changes of Int
	void  chgRealInt(short val);// intended for permanent changes of Int
	bool  incDecInt(short val);
	void  setIntLimit(short value);
	short getIntLimit();
	int   getManaMax();

	bool isBadBody();
	bool isNpcBody();
	bool isAnimalBody();        
	bool isWaterCreatureBody(); 
	bool isMonsterBody();        
	bool isPackAnimal()			{return ((this->id()==0x0123||this->id()==0x0124) ? true : false);}
        
	bool fixAnims();

	int Hp();	                // getter
	void setHp(int value);
	void increaseHp(int value);
	void reduceHp(int damage);
	void fullHp();				// full heal

	int Stm();	                // getter
	void setStm(int value);
	void increaseStm(int value);
	void reduceStm(int loss);
	void changeStm(int value);
	void fullStm();				// full refreshment

	int Mana();	                // getter
	void setMana(int value);
	void increaseMana(int value);
	void reduceMana(int loss);
	void changeMana(int value);
	void fullMana();			// full refreshment
	
	int hidamage;               // NPC Damage
	int lodamage;               // NPC Damage
protected:
	class cSkill
	{
	public:
		unsigned short real;	// Base skills without stat modifiers
		unsigned short eff;		// effective skill
		short temp;
		char lock;
	} skills[ALLSKILLSMAX+1];
public:
	unsigned short Skill(int sk)		{return skills[sk].eff + skills[sk].temp;}
	void setSkill(int sk, int val)		{skills[sk].eff = val;}
	unsigned short getRealSkill(int sk) {return skills[sk].real;}
	void setRealSkill(int sk, int val)	{skills[sk].real = val;}
	void chgRealSkill(int sk, int val);
	void setTempSkill(int sk, int val)	{skills[sk].temp = val;}
	void chgTempSkill(int sk, int val)	{skills[sk].temp += val;}

	char LockSkill(int sk)				{return skills[sk].lock;}
	void setLockSkill(int sk, char val)	{skills[sk].lock = val;}

	char npc;            // 1=Character is an NPC
	char shop;           // 1=npc shopkeeper, 2=npc merchant
	unsigned char cell;  // Reserved for jailing players
	cTimer jailtimer;    // Blackwind - Timer used for crystall ball and jail time.

	int ownserial;       // If Char is an NPC, this sets its owner
	int robe;            // Serial number of generated death robe (If char is a ghost)
	int karma;
	signed int fame;
	unsigned int kills;  //PvP Kills
	unsigned int deaths;
	bool dead;                 // Is character dead
	unsigned char fixedlight;  // Fixed lighting level (For chars in dungeons, where they dont see the night)
	char speech;               // For NPCs: Number of the assigned speech block
	int weight;                // Total weight
	short WeightAtCursor;
	unsigned int def;          // Intrinsic defense
	char war;                  // War Mode
protected:		// combat stuff
	int targ;                  // Current combat target
	int attacker;              // Character who attacked this character
	int hunger;                // Level of hungerness, 6 = full, 0 = "empty"
public:
	unsigned int timeout;      // Combat timeout (For hitting)
	unsigned int timeout2;     // memory of last shot timeout
	unsigned int regen, regen2, regen3; //Regeneration times for mana, stamin, and str
	short inputmode;			// Used for entering text; 0= none, 4=rename rune
	int inputitem;				// serial of item the text is referring to
	cSimpleTimer npcmovetimer;	// Next time npc will walk
	int walkspeed;			// time per step in millisecs
	char npcWander;            // NPC Wander Mode
	char oldnpcWander;         // Used for fleeing npcs
	int ftarg;                 // NPC Follow Target
	int fx1;                   // NPC Wander Point 1 x
	int fx2;                   // NPC Wander Point 2 x
	int fy1;                   // NPC Wander Point 1 y
	int fy2;                   // NPC Wander Point 2 y
	signed char fz1;           // NPC Wander Point 1 z
	int spawnserial;           // Spawned by
	char hidden;               // 0 = not hidden, 1 = hidden, 2 = invisible spell
	unsigned int invistimeout;
	char attackfirst;          // 0 = defending, 1 = attacked first
	bool onhorse;              // On a horse?
	int Hunger(){return hunger;} // Level of hungerness, 6 = full, 0 = "empty"
	void setHunger(int h){hunger= h>6?6:(h<0?0:h);}
	void chgHunger(int d){setHunger(hunger+d);}
	cTimer hungertimer;			// Timer used for hunger, one point is dropped every 20 min
	int dclickedserial;			// serial of dclicked char or item
	int target1serial;			// serial of targeted char or item
	int npcaitype;				// NPC ai
	short craftAI;
	cTimer nextCraft;

	int callnum;       //GM Paging
	int playercallnum; //GM Paging
	int pagegm;        //GM Paging	
	unsigned short region;
	cSimpleTimer skilldelay;
	cSimpleTimer objectdelay;
//	int combathitmessage;
	int making;        // skill number of skill using to make item, 0 if not making anything.
	char blocked;
	char dir2;
	cTimer spiritspeaktimer; // Timer used for duration of spirit speak
	int spattack;
	int spadelay;
	cSimpleTimer spatimer;
	int totame;                     //Skill level required for taming
	bool summoned;					//false = normal NPC, true = summoned NPC
	cTimer summontimer;				//Timer for summoned creatures.
	cSimpleTimer trackingtimer;		// Timer used for the duration of tracking
	int trackingtarget;				// Tracking target serial	
	int trackingtargets[MAXTRACKINGTARGETS];
	unsigned int fishingtimer;      // Timer used to delay the catching of fish
 
	int advobj;                     //Has used advance gate?

	int poison;                     // used for poison skill 
	int poisoned;					// type of poison
	cTimer poisondamagetime;        // poison damage timer
	cTimer poisontxt;				// poision text timer
	cTimer poisonwearofftime;		// LB, makes poision wear off ...

	short fleeat;
	short reattackat;
	int trigger;			//Trigger number that character activates
	char trigword[31];		//Word that character triggers on.
	cTimer disabledTimer;	//Character is disabled, cant trigger.
	char disabledmsg[256];	//Character is disabled, so display this message. -- added by Magius(CHE) 
	int split;
	int splitchnc;
	int targtrig;          //Stores the number of the trigger the character for targeting
	char ra;               // Reactive Armor spell
	int trainer;           // Serial of the NPC training the char, -1 if none.
	char trainingplayerin; // Index in skillname of the skill the NPC is training the player in
	bool cantrain;
	short trainlevel;		// level system. up to which level the npc can train players

	// Begin of Guild Related Character information (DasRaetsel)
	int guildtoggle;		// Toggle for Guildtitle								(DasRaetsel)
	char guildtitle[21];	// Title Guildmaster granted player						(DasRaetsel)
	int	guildfealty;		// Serial of player you are loyal to (default=yourself)	(DasRaetsel)
	int	guildnumber;		// Number of guild player is in (0=no guild)			(DasRaetsel)
	char flag;              //1=red 2=grey 4=Blue 8=green 10=Orange
	// End of Guild Related Character information
	//  Chaos/Order Guild Stuff for Ripper
	short GuildType;    // (0) Standard guild, (1) Chaos Guild, (2) Order guild
	bool GuildTraitor; // (true) This character converted, (false) Neve converted, or not an order/chaos guild member
	

	unsigned long int murderrate; //#of ticks until one murder decays //REPSYS 
	int crimflag;            //Time when No longer criminal -1=Not Criminal
	int casting;                  // 0/1 is the cast casting a spell?
	unsigned int spelltime;       //Time when they are done casting....
	int spell;                    //current spell they are casting....
	int spellaction;              //Action of the current spell....
	int nextact;                  //time to next spell action....
	
	int squelched;                        // zippy  - squelching
	int mutetime;                         //Time till they are UN-Squelched.
	int med;                              // 0=not meditating, 1=meditating //Morrolan - Meditation 
	int stealth;                          //AntiChrist - stealth ( steps already done, -1=not using )
	unsigned int running;                 //AntiChrist - Stamina Loose while running
	cTimer delayedLogoutTimer;				// Time until logout for this char
	unsigned long int clientidletime;		// LB   

	unsigned int holdg;                   // Gold a player vendor is holding for Owner	
	char fly_steps;                       // number of step the creatures flies if it can fly
	cSimpleTimer trackingdisplaytimer;
	bool tamed;
	bool guarded;					      // (Abaddon) if guarded
    unsigned int smoketimer;              // LB
	unsigned int smokedisplaytimer;
	cSimpleTimer antispamtimer;           //LB - anti spam

	unsigned int antiguardstimer;         //AntiChrist - anti "GUARDS" spawn

	int carve;                            //AntiChrist - for new carve system

	int	hairserial;                       //there are needed for incognito stuff
	int	beardserial;

	cSimpleTimer begging_timer;
	int postType;
	int questType;
	int questDestRegion;
	int questOrigRegion;
	int questBountyReward;      // The current reward amount for the return of this chars head
	int questBountyPostSerial;  // The global posting serial number of the bounty message
	int murdererSer;            // Serial number of last person that murdered this char
	cCoord prevPos;				// fix for looping gate travel bug (bounce back problem)

	unsigned char commandLevel; // 0 = player, 1 = counselor, 2 = GM

	int spawnregion; 

	int stablemaster_serial; 
	char npc_type;		// currently only used for stabling, (type==1 -> stablemaster)
						// can be used for other npc types too of course

	unsigned long int time_unused;     
	unsigned long int timeused_last;

	inline unsigned short id()				{return (unsigned short)((id1<<8)+id2);}
	void  setId(unsigned short id)	
	{
		id1=id>>8; 
		id2=id&0x00FF; 
		if (this->isBadBody() ) //id1+id2 have to be set before calling isbadbody
		{ 
			id1=0; 
			id2=1; 
		}
	}

	inline unsigned short xid()				{return d_xid;}
	inline void  setXid(unsigned short id)	{d_xid=id;}

	inline bool  isHuman()			{return (this->id()==0x190 || this->id()==0x191);} 
	inline bool  isAdmin()			{return (account == 0);} 
	inline bool  isTrueGM()			{return (priv&0x01);} 
	inline bool  isGM()				{return (priv&0x01 && (!gmrestrict || region==gmrestrict)) || isAdmin();} 
	inline bool  isCounselor()		{return (priv&0x80 ?true:false);} 
	inline bool  isGMorCounselor()	{return (priv&0x81 ?true:false);} 
	inline bool  isInvul()			{return (priv&0x04 ?true:false);}
	inline bool  canSnoop()			{return (priv&0x40 ?true:false);}
	inline bool  canBroadcast()		{return (priv&0x02 ?true:false);}
	inline bool  canSeeSerials()	{return (priv&0x08 ?true:false);}
	inline bool  isInnocent()		{return (flag&0x04 ?true:false);}
	inline bool  isMurderer()		{return (flag&0x01 ?true:false);}
	inline bool  isCriminal()		{return (flag&0x02 ?true:false);}
	inline unsigned char getPriv()		{return priv;}
	inline void setPriv(unsigned char p)	{this->priv=p;}
	inline void makeInvulnerable()		{priv|=4;}
	inline void makeVulnerable()		{priv &= (0xFF-4);}
	inline void setMurderer()		{flag=0x01;}
	inline void setInnocent()		{flag=0x04;}
	inline void setCriminal()		{flag=0x02;}

	void setAttackFirst()		{this->attackfirst=1;}
	void resetAttackFirst()		{this->attackfirst=0;}
	void fight(cChar* pOpponent);
	void setNextMoveTime(short percent=100);
	void disturbMed();
	void hide() {hidden=1;}
	void unhide();
	bool isHidden() { return hidden > 0 ? true : false; }
	bool isHiddenBySpell() { return hidden & 2 ? true : false; }
	bool isHiddenBySkill() { return (hidden & 1); }
	bool isDummy() { return doppelgaenger_serial < 0 ? true : false; }
	int  CountItems(short ID= -1, short col= -1, short type= -1);
	int  CountGold()			{return CountItems(0x0EED);}
	int	 deleteItems(int amount, unsigned short ID, short col= -1, short type= -1);
	int	 deleteBankGold(int amount);
	int	 deleteGold(int amount);
	P_ITEM GetItemOnLayer(unsigned char layer) const;
	void removeItemsFromHands(unsigned short id);
	P_ITEM GetBankBox( short type = 1);
	int  CountBankGold();
	void addHalo(PC_ITEM pi);
	void removeHalo(P_ITEM pi);
	void glowHalo(PC_ITEM pi);
	P_ITEM getWeapon();
	P_ITEM getCarvingTool();
	P_ITEM getShield();
	P_ITEM getBackpack() const ;
	void SetSerial(long ser);
	void SetSerialOnly(long ser);
	void setOwnSerialOnly(long ownser);
	bool SetOwnSerial(long ownser);
	long GetOwnSerial()	{return ownserial;}
	bool SetSpawnSerial(long spawnser);
	bool SetMultiSerial(long mulser);
	// The bit for setting what effect gm movement 
	// commands shows 
	// 0 = off 
	// 1 = FlameStrike 
	// 2-6 = Sparkles
	char gmMoveEff;
	void MoveTo(const cCoord& newpos);
	void MoveToOneOff(const cCoord& newpos);
	void teleTo(const cCoord& newpos, bool boatcheck=true);
	void travelTo(const cCoord& newpos, UOXSOCKET s);
	int getSkillSum();
	int getTeachingDelta(cChar* Player, int skill, int sum);
	void addItemBonus(PC_ITEM pi, UOXSOCKET s=-1);
	void removeItemBonus(cItem* pi, UOXSOCKET s=-1);
	virtual void Init(bool ser = true);
	bool inGuardedArea();
	bool canPickUp(cItem* pi);
	bool isSameAs(cChar* pc);
	bool Owns(cChar* pc)	{return (serial==pc->ownserial);}
	bool Owns(PC_ITEM pi);
	bool Wears(PC_ITEM pi);
	unsigned dist(cChar* pc);
	unsigned dist(PC_ITEM pi);
	void endCasting();
	void disturbCasting(UOXSOCKET s);
	P_ITEM hasKeyFor(PC_ITEM Lockable);
	P_ITEM HasSuitableTreasureMap(const cCoord& pos);
	int getBowType();
	bool resurrect();
	void setAi(int val);
	int  getAi();
	int  getSubAi();
	bool isAiMonster();
	bool isAiTeleGuard();
	bool isAiVendor();
	void setInput(short mode, P_ITEM pi);
	P_ITEM getDclickedItem();
	bool checkSkill(unsigned short skill, short mini, short maxi);
	bool checkSkill(unsigned short skill, short mini);
	bool checkSkill(unsigned short skill);
	int  calcSocket();
	unsigned char lastlightvalue;
	int useBankToPay(int amount);
	bool canAfford(int amount);
	int pay(int amount);
	void checkEquipment();
	void setAttacker(P_CHAR pc);
	P_CHAR getAttacker();

	void SetFollowTarget(P_CHAR pc);
	void ResetFollowTarget();
	bool IsFollowing();
	P_CHAR GetFollowTarget();

	void SetTarget(P_CHAR pc);
	void ResetTarget();
	bool HasTarget();
	P_CHAR GetTarget();
	void attack(P_CHAR Victim);
	void FightBack(P_CHAR Agressor);

	P_ITEM addBackpack();
	bool AddGift(int item_scp_num);
	P_ITEM Search(int *ci) const ;
	P_ITEM SearchHands(int *ci);
	int  HasFreeHand();
	bool WieldsAntiMagicalItem();

	void PoisonStart(UOXSOCKET s, int poisonstrength);
	void PoisonWearOff(UOXSOCKET s);
	int  Poisoned()			{return poisoned;}
	void ResetPoisoned()	{poisoned=0;}
	int  Poison()			{return poison;}
	void SetPoison(int p)	{poison=p;}
	void  SetViewingDepth(short depth);
	short GetViewingDepth();
	P_ITEM Shrink(); // by Thrawn: "shrinks" the npc and returns the item
	void DoAction(int hex);
	int  MaxWeight();	// calc carrying capacity
	void SetIndex(int i);
	int GetIndex();	// this is ONLY for places where we will continue to use an index !
	void SetOnline();
	void SetOffline();
	int InGame();	// comprises both online and instalog status
	bool isOfflinePlayer();
	// new magery related stuff
protected:
	short	tithingpoints;		//tithing points for paladins

	bool	spelldelay;			//true if we are waiting for the end of the spelldelay
	char	currentspelltype;	//is the player casting from book/scroll/wand?
	cSpell* currentspell;		//for later use with new magic system (thrawn)
								//always points to the spell, the char is currently casting
								//NULL if the char is not casting
	void*	preTarg;			//pointer to a predefined magic target (at the moment only used for runebooks)
public:
	short	GetTithingPoints() {return tithingpoints;}
	void	AddTithingPoints(short points) {tithingpoints+=points;}
	void*	GetPreTarget() {return preTarg;}

	bool	IsCasting();
	void	SetCastingSpell(cSpell* spell,char type,void* preTarget = NULL);
	void	EndSpellDelay();
	cSpell* GetCastingSpell();
	char	GetCastingSpellType();
	// end magery related stuff

	// new food system (thrawn)
protected:
	unsigned char food;
public:
	char GetFood() {return food;}
	void SetFood(char f) {food  = f;}
	void AddFood(char f) {food |= f;}
	void SubFood(char f) {food &= (0xFF - f);}
	bool CanEat(P_ITEM pi);
	// end food system
	void Wear(P_ITEM pi, char lay);
	virtual int applyCommonTags();

protected:
	unsigned char onlinestatus;
private:
	unsigned long int delayed_disconnect;

public:
	virtual int applyScriptTags(Script* Scp, int npcNum, cSpawnContext* CT);
	int applyBirthLootTags(Script* Scp, int npcNum, cSpawnContext* CT);
	void applyDeathLootTags(Script* Scp, int npcNum, cSpawnContext* CT);
	int applyDeathLootTags();

	bool isScriptedwalkingAi();
	int  getScriptedwalkingAi();
	bool mayEnter(PC_ITEM House);
	virtual void Msg(char* text) {;}
	virtual void Msg(unsigned short col,char* text) {;}
	bool ToolWearOut();
	bool ToolWearOut(P_ITEM pi);
	virtual UOXSOCKET getSlot() {return -1;}
	inline int calcDirTo(P_CHAR other) {return other ? this->pos.calcDirTo(other->pos) : -1;}
	void faceTarget(const cCoord& tpos);
	void setCraftAI(int ai);
	void resetCraftAI();
	void checkCraftAI();
};

///////////////
// WARNING! Do NOT move *persistent* data members to these classes yet

class cPlayer : public cChar
{
protected:
public:
	UOXSOCKET cs;	// 'client slot'
	class cTransactionData	// to store data between dclick, target1 etc.
	{
	public:
		cCoord _Target1Pos;
		bool _inverse;
		bool _dragging;
		void reset();
	} TD;

	virtual void Init(bool ser = true);
	virtual UOXSOCKET getSlot() {return cs;}
	bool IsDragging() const;
	void SetDragging();
	void ResetDragging();
	bool PlayInstrument(P_ITEM Instrument);
	void Msg(char* text);
	void Msg(unsigned short color, char* text);
	void travelTo(const cCoord& newpos);
	void telePets(const cCoord& newpos,int multiserial=-1);
	void StartSpellDelay();
	make_st* getMakeData();
};

P_PLAYER MakePlayerRef(P_CHAR pc);

class cSpawnContext	// used to pass info to subroutines in npc spawning process
{
public:
	P_ITEM LastItem;
	P_ITEM MyPack;
	P_ITEM ShopPack1A;
	P_ITEM ShopPack1B;
	P_ITEM ShopPack1C;
	int haircolor; // we need this to remember the haircolor for COLORMATCHHAIR
	cCoord KillPos;		// position where the npc was killed; needed for applying loot, NOT set in other situations
	void Init();
};

class cNpc : public cChar
{
public:
	cTimer peacemaking;
	virtual void Init(bool ser = true);
	virtual int applyScriptTags(Script* Scp, int npcNum, cSpawnContext* CT);
	virtual int applyCommonTags();
	void LoadShopList(int npc_num,int listnum);
	void restock(bool full = false);
};

P_NPC MakeNpcRef(P_CHAR pc);

#define MAKE_CHAR_REF(i) Npcs->MakeRef(i)

#define MAKE_CHARREF_LR(i)						Npcs->MakeRef(i); {int err=Npcs->GetError(); if (err) { sprintf(schei___, "invalid char index %i",i); LogCritical(schei___); return;} }
#define MAKE_CHARREF_LRV(i,retval)				Npcs->MakeRef(i); {int err=Npcs->GetError(); if (err) { sprintf(schei___, "invalid char index %i",i); LogCritical(schei___); return retval;} }
// this one expects the the variables cfn and cln to exost and set to the filename and linenumber of the calling function
// you can do this by "#define foo(x) _foo(x, __LINE__, DBGFILE)" and changing the foo fucntion to _foo(x,char* cfn, int cln)
#define MAKE_CHARREF_LR_LOGCALLER(i)			Npcs->MakeRef(i); {int err=Npcs->GetError(); if (err) { sprintf(schei___, "called from %s , %i : invalid char index %i",cfn,cln,i); LogCritical(schei___); return;} }
#define MAKE_CHARREF_LRV_LOGCALLER(i,retval)	Npcs->MakeRef(i); {int err=Npcs->GetError(); if (err) { sprintf(schei___, "called from %s , %i : invalid char index %i",cfn,cln,i); LogCritical(schei___); return retval;} }


struct wander_st
{
	short fx1;
	short fx2;
	short fy1;
	short fy2;
	short fz1;
};

#define MAXRACES 30

class cBrain;

class cCharStuff
{
private:
	bool moreCharMemoryRequested;
	int  charcount2;
	unsigned int  cmem;
	int  errorCA;	// for invalid index
	cBrain* MercenaryBrain;
	cBrain* MonsterBrain;
	cBrain* VortexBrain;
	cBrain* PixieBrain;
	cBrain* InWorldGuardBrain;

	bool ResizeMemory();
	int  GetReusableSlot();
	int  MemCharFree();

	bool EmptyandCopyBp(cItem* pi_bpSource,cItem* pi_bpTarget);
	bool copyNpcRawData(const cChar* const source,cChar* target);  // overwrites ALL source member values with that one from target (except serial)
	bool copyNpcClothing(const cChar* const source,cChar* target); // copies cloths + backpack
	bool copyBps(cItem* pi_bpSource,cItem* pi_bpTarget);
	bool copyShopPacks(const cChar* const source, P_CHAR target);
	P_CHAR createNpcFromScript(int npcnum, struct wander_st * wan, int rec=10);
	int checkForSkillTags(Script* Scp);

public:
	cCmdSet metagm[256];

	cCharStuff();
	void initBrains();
	int GetCount();
	int GetCapacity();
	P_CHAR MakeRef(int c);
	inline int GetError() { return errorCA; }
	int	 GetNextFreeSerial();
	void DetermineHighestSerial(int ser);
	void DeleteChar(P_CHAR pc);
	void FreeMemory();
	void CheckMemoryRequest();
	bool AllocateMemory(int NumberOfChars);
	bool TempDupeNpc(P_CHAR toDupe, P_CHAR Dupee, int modifier);
	bool TempDupeNpcRevert(P_CHAR Dupee);
	P_CHAR CloneNpc(const cChar* const source, bool setclonetag);
	P_CHAR MakeBaseChar(bool newserial=true);
	P_NPC MakeBaseNpc(bool newserial=true);
	P_PLAYER MakeBasePlayer(bool newserial=true);

	P_ITEM AddRandomLoot(P_ITEM Pack, char* lootlist);
	int PickFromNpcList(int npclist);
	int PickFromLootList(int lootlist);
	P_CHAR AddRespawnNPC(PC_ITEM pi, int npcNum);
	P_CHAR AddRespawnNPC(UOXSOCKET s, int npcNum);
	P_CHAR AddNPC(int s, int npcNum, const cCoord &pos);
	P_CHAR AddNPC(int s, PC_ITEM Spawner, int npcNum, const cCoord &pos);
	void Split(P_CHAR pc);
	void CheckAI(P_CHAR pc_i);
	void SpawnGuard(P_CHAR Offender, P_CHAR Caller, const cCoord& at);

	int applySkillTags(Script* Scp, P_CHAR pc);
	int applySkillTags(Script* Scp, cRace* Race);
	void LoadRaces();
	P_PLAYER findPlayerByAccount(int acct, int number);
};

class AllCharsIterator
{
protected:
	unsigned int pos;
public:
	AllCharsIterator();
	~AllCharsIterator();
	void Begin();
	P_CHAR End();
	P_CHAR GetData(void);
	AllCharsIterator& operator++(int);
};

void setrandomname(P_CHAR pc, char * namelist);
int addrandomcolor(int colorlist);
P_ITEM Packitem(P_CHAR pc); // Find packitem

#endif

