/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

/*
 * This code is an attempt to clean up the messy "if/then/else" routines
 * currently in use for GM commands, as well as adding more functionality
 * and more potential for functionality.
 *
 * Current features:
 * - Actual table of commands to execute, what perms are required, dialog
 *   messages for target commands, etc handled by a central system
 *
 * - /SETPRIV3 user-friendliness - /SETPRIV3 <command> works now instead of
 *   all that cumbersome bitmask math (Eg; /SETPRIV3 + SAVE and click on a
 *   char and they get SAVE command perms, /SETPRIV3 - SAVE and click on a
 *   char and their SAVE privs are removed)
 */

#include "cmdtable.h"

#include "accounts.h"
#include "bounty.h"
#include "Client.h"
#include "commands.h"
#include "guilds.h"
#include "gumps.h"
#include "house.h"
#include "magic.h"
#include "mapS.h"
#include "mapstuff.h"
#include "msgboard.h"
#include "multi.h"
#include "network.h"
#include "qsf.h"
#include "regions.h"
#include "skills.h"
#include "SndPkg.h"
#include "sregions.h"
#include "targeting.h"
#include "teleport.h"
#include "titles.h"
#include "Trade.h"
#include "walking.h"
#include "worldmain.h"
#include "games.h"


#include "wolfpack.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "cmdtable.cpp"

TARGET_S target_use = { T_24, "What object will you use?" };
TARGET_S target_jail = { T_126, "Select player to jail." };
TARGET_S target_release = { T_127, "Select player to release from jail." };
TARGET_S target_istats = { T_12, "Select item to inspect." };
TARGET_S target_cstats = { T_13, "Select char to inspect." };
TARGET_S target_tele = { T_2, "Select teleport target." };
TARGET_S target_xbank = { T_107, "Select target to open bank of." };
TARGET_S target_xsbank = { T_107, "Select target to open specialbank of." };//AntiChrist
TARGET_S target_remove = { T_3, "Select item to remove." };
TARGET_S target_makegm = { T_14, "Select character to make a GM." };
TARGET_S target_makecns = {T_15, "Select character to make a Counselor." };
TARGET_S target_killhair = { T_16, "Select character for cutting hair." };
TARGET_S target_killbeard = { T_17, "Select character for shaving." };
TARGET_S target_kill = { T_20, "Select character to kill." };
TARGET_S target_resurrect = { T_21, "Select character to resurrect." };
TARGET_S target_bolt = { T_22, "Select character to bolt." };
// This fires a harmless bolt at the user.
TARGET_S target_kick = { T_25, "Select character to kick." };
// This disconnects the player targeted from the game. They
// can still log back in.
TARGET_S target_movetobag = { T_111, "Select an item to move into your bag." };
TARGET_S target_xgo = { T_8, "Select char to teleport." };
TARGET_S target_setmorex = { T_63, "Select object to set morex on." };
TARGET_S target_setmorey = { T_64, "Select object to set morey on." };
TARGET_S target_setmorez = { T_65, "Select object to set morez on." };
TARGET_S target_setmorexyz = { T_66, "Select object to set morex, morey, and morez on." };
TARGET_S target_sethexmorexyz = { T_66, "Select object to set hex morex, morey, and morez on." };
TARGET_S target_setnpcai = { T_106, "Select npc to set AI type on." };
TARGET_S target_settype = { T_6, "Select item to edit type." };
TARGET_S target_itrig = { T_200, "Select item to trigger." };
TARGET_S target_ctrig = { T_201, "Select NPC to trigger." };
TARGET_S target_ttrig = { T_202, "Select item to set trigger type." };
TARGET_S target_setid = { T_7, "Select item to polymorph." };
TARGET_S target_setmore = { T_10, "Select item to edit 'more' value." };
TARGET_S target_setmore2 = { T_90, "Select item to edit 'more2' value." };
TARGET_S target_setfont = { T_19, "Select character to change font." };
TARGET_S target_npcaction = { T_53, "Select npc to make act." };
TARGET_S target_setamount = { T_23, "Select item to edit amount." };
TARGET_S target_setamount2 = { T_129, "Select item to edit amount." };
TARGET_S target_setmovable = { T_28, "Select item to edit mobility." };
TARGET_S target_setvisible = { T_61, "Select item to edit visibility." };
TARGET_S target_setdir = { T_88, "Select item to edit direction." };
TARGET_S target_setspeech = { T_135, "Select NPC to edit speech." };
TARGET_S target_setowner = { T_30, "Select NPC or OBJECT to edit owner." };
TARGET_S target_freeze = { T_34, "Select player to freeze in place." };
TARGET_S target_unfreeze = { T_35, "Select player to unfreeze." };
TARGET_S target_tiledata = { T_46, "Select item to inspect." };
TARGET_S target_recall = { T_38, "Select rune from which to recall." };
TARGET_S target_mark = { T_39, "Select rune to mark." };
TARGET_S target_gate = { T_43, "Select rune from which to gate." };
TARGET_S target_heal = { T_44, "Select person to heal." };
TARGET_S target_npctarget = { T_56, "Select player for the NPC to follow." };
TARGET_S target_tweak = { T_62, "Select item or character to tweak." };
//TARGET_S target_sbopen = { 87, "Select spellbook to open as a container." };
TARGET_S target_mana = { T_113, "Select person to restore mana to." };
TARGET_S target_stamina = { T_114, "Select person to refresh." };
TARGET_S target_makeshop = { T_116, "Select the character to add shopkeeper buy containers to." };
TARGET_S target_buy = { T_121, "Select the shopkeeper you'd like to buy from." };
TARGET_S target_setvalue = { T_122, "Select item to edit value." };
TARGET_S target_setrestock = { T_123, "Select item to edit amount to restock." };
TARGET_S target_sell = { T_112, "Select the NPC to sell to." };
TARGET_S target_setspattack = { T_150, "Select creature to set SPATTACK on." };
TARGET_S target_setspadelay = { T_177, "Select creature to set SPADELAY on." };
TARGET_S target_setpoison = { T_175, "Select creature to set POISON." };
TARGET_S target_setpoisoned = { T_176, "Select creature to set POISONED." };
TARGET_S target_setadvobj = { T_178, "Select creature to set ADVOBJ." };
TARGET_S target_setwipe = { T_133, "Select item to modify." };
TARGET_S target_fullstats = { T_151, "Select creature to restore full stats." };
TARGET_S target_hide = { T_131, "Select creature to hide." };
TARGET_S target_unhide = { T_132, "Select creature to reveal." };
TARGET_S target_house = { T_207, "Select location for house." };
TARGET_S target_split = { T_209, "Select creature to make able to split." };
TARGET_S target_splitchance = {T_210, "Select creature to set it's chance of splitting." };
TARGET_S target_possess = { T_212, "Select creature to possess." };
TARGET_S target_telestuff = { T_214, "Select player/object to teleport." };
TARGET_S target_killpack = { T_18, "Select character to remove pack." };
TARGET_S target_trainer = { T_206, "Select character to become a trainer." };
TARGET_S target_showpriv3 = { T_226, "Select character to display priviliges." };
TARGET_S target_ban = { T_235, "Select character to BAN." };
TARGET_S target_unban = { T_238, "Select character to UNBAN." };
TARGET_S target_newx = { T_251, "Select item to reposition." };
TARGET_S target_newy = { T_252, "Select item to reposition." };
TARGET_S target_newz = { T_5, "Select item to reposition." };
TARGET_S target_incx = { T_253, "Select item to reposition." };
TARGET_S target_incy = { T_254, "Select item to reposition." };
TARGET_S target_incz = { T_260, "Select item to reposition." };
TARGET_S target_glow = { T_255, "Select item to make glowing." };
TARGET_S target_unglow = { T_249, "Select item to deactivate glowing." };
TARGET_S target_showskills = { T_247, "Select char to see skills" };
TARGET_S target_setc = { T_258, "Select char to set attributes."};
TARGET_S target_setrevertswap = { T_259, "Select target to revert swap effect."};
TARGET_S target_seti =		{ T_261, "Select item to set attributes."};
TARGET_S target_clonenpc = { T_262, "Select NPC to clone"};
TARGET_S target_permact = { T_263, "Select NPC to do perma-action"};
TARGET_S target_xsay =	{ T_264, "Select char to speak your words."};
TARGET_S target_unequip =	{ T_85, "Select item to unequip."};

/* Actual commands go below. Define all the dynamic command_ functions as
 * the name of the function in lowercase, a void function, accepting one
 * integer, which is the player # that sent the command.
 * Like this:
 * void command_rain(int s)
 *
 * If you stick comments (double-slash comments) between the function definition
 * and the opening block, they will automatically be used as the
 * HTML documentation for that command. The first line will be used as the
 * short documentation, any subsequent lines will be used as a seperate
 * "more info" page for your command. HTML is allowed, but remember that
 * everything is fit into a template.
 */


void command_clientver(P_PLAYER Player)
{
	char tmp[512];
	UOXSOCKET s = Player->cs;
	sprintf(tmp,"[%s]", clientData[s].clientVersion.c_str());
	Player->Msg("you are using client version");
	Player->Msg( tmp);
	sprintf(tmp,"Nr:[%i] 3D:[%i]", ClientVersion->getClientNr(clientData[s].clientVersion), ClientVersion->get3DNess(clientData[s].clientVersion));
	Player->Msg(tmp);
}

// When player has been murdered and they are 
// a ghost, they can use the bounty command to 
// place a bounty on the murderers head

void command_bounty(P_PLAYER Player)
{
	if (!SrvParms->bountysactive)
	{
		Player->Msg("The bounty system is not active.");
		return;
	}
	
	if ( !Player->dead )
	{
		Player->Msg("You can only place a bounty while you are a ghost.");
		Player->murdererSer = 0;
		return;
	}
	
	if ( Player->murdererSer == 0 )
	{
		Player->Msg("You can only place a bounty once after someone has murdered you.");
		return;
	}
	
	if ( tnum == 2 )
	{
		int nAmount = makenumber(1);
		if ( BountyWithdrawGold( Player, nAmount ) )
		{
			P_CHAR Murderer = FindCharBySerial(Player->murdererSer);
			if ( BountyCreate( Murderer, nAmount ) )
			{
				sprintf( temp, "You have placed a bounty of %d gold coins on %s.", nAmount, Murderer->name );
				Player->Msg(temp);
			}
			else
				Player->Msg("You were not able to place a bounty (System Error)" );
			
			// Set murdererSer to 0 after a bounty has been 
			// placed so it can only be done once
			Player->murdererSer = 0;
		}
		else
			Player->Msg("You do not have enough gold to cover the bounty.");
		
	}
	else
		Player->Msg("To place a bounty on a murderer, use BOUNTY <amount>");	
}


void command_maptravel(P_PLAYER Player)
{
	if (tnum==2)
	{
		int map = makenumber(1);
		if (map<0 || map>4) { Player->Msg("invalid map"); return; }
		
		cCoord newPos(Player->pos);
		newPos.map = map;
		Player->travelTo(newPos);
	}
}

void command_serversleep(P_PLAYER Player)
{
	int seconds;
	unsigned int a;
	
	if (tnum==2)
	{
		seconds = makenumber(1);
		sprintf(temp,"server is going to sleep for %i seconds!",seconds);
		
		sysbroadcast(temp); // broadcast server sleep
		for (a=0; a<now; a++) // make sure all send buffers are flushed (=the messages are really send beffore server sleeps)
		{
			if (perm[a]) PacketSender.FlushBuffers(a);
		}
		
		seconds=seconds*1000; 
		
		Sleep(seconds);
		
		sprintf(temp,"server is back from a %i second break",seconds/1000);
		
		sysbroadcast(temp); 
		for (a=0; a<now; a++) // not absolutely necassairy ..
		{
			if (perm[a]) PacketSender.FlushBuffers(a);
		}
		
	}
	else Player->Msg("invalid number of arguments");
}

void command_makeplayerposfile(P_PLAYER Player)
{
	makePlayerPosFile();
	Player->Msg("Player Posfile succsessfully created!");
}

void command_reloadcachedscripts(P_PLAYER Player)
{
	Titles->Reload();
	loadregions();
	loadspawnregions();
	OldMagic->InitSpells();
	loadmetagm();
	SkillManager->loadskills();
	read_in_teleport(); // hope i've cought all  ...
	Network->LoadHosts_deny();

	Player->Msg("Cached scripts reloaded");
}

// Returns the current bulletin board posting mode for the player
void command_post(P_PLAYER Player)
{
	strcpy( temp, "You are currently posting " );
	
	switch( Player->postType )
	{
	case LOCALPOST:		strcat( temp, "a message to a single board [LOCAL]." );		break;
	case REGIONALPOST:	strcat( temp, "a message to all boards in this area [REGIONAL]." );	break;
	case GLOBALPOST:	strcat( temp, "a message to all boards in the world [GLOBAL]." );	break;
	default:
		strcat( temp, "an unknown message type. Setting to normal [LOCAL]." );
		Player->postType = LOCALPOST;
	}
	Player->Msg(temp );
}

// Sets the current bulletin board posting mode for the player to GLOBAL
// ALL bulletin boards will see the next message posted to any bulletin board
void command_gpost(P_PLAYER Player)
{
	Player->postType = GLOBALPOST;
	Player->Msg("Now posting GLOBAL messages." );
}

// Sets the current bulletin board posting mode for the player to REGIONAL
// All bulletin boards in the same region as the board posted to will show the
// next message posted
void command_rpost(P_PLAYER Player)
{
	Player->postType = REGIONALPOST;
	Player->Msg("Now posting REGIONAL messages." );
}

// Sets the current bulletin board posting mode for the player to LOCAL
// Only this bulletin board will have this post
void command_lpost(P_PLAYER Player)
{
	Player->postType = REGIONALPOST;
	Player->Msg("Now posting LOCAL messages." );
}

// taken from 6904t2(5/10/99) - AntiChrist
void command_setmurder(P_PLAYER Player)
{
	if ( tnum == 2 )
	{
		addmitem[Player->cs]=makenumber(1);
		target(Player, T_240, "Select the person to set the murder count of: ");
	}
}

/*
void command_setacct(UOXSOCKET s)
{

}

void command_addacct(UOXSOCKET s)
{

}

void command_banacct(UOXSOCKET s)
{

}

void command_unbanacct(UOXSOCKET s)
{

}

void command_removeacct(UOXSOCKET s)
{

}*/


// bug clearing if players get account already in use for no reason.
// that bug should be gone in 11.9 but I got a bit paranoid bout it. LB
void command_letusin(P_PLAYER Player)
{
	int a,x;
	for (a=0,x=0; a<MAXCLIENT; a++) // maxclient instead of now is essential here !
	{
		if ( acctno[a]>=0 )
		{
			Accounts->SetOffline(acctno[a]);
			x++;
		}
	}
	
	sprintf(temp,"command successfull, cleared %i poor souls",x);
	Player->Msg(temp);
}

void command_readaccounts(P_PLAYER Player)
{
	Accounts->LoadAccounts();
	Player->Msg("Accounts reloaded...attention, if you changed existing(!) account numbers you should use the letusin command afterwards ");
}

void command_showp(P_PLAYER Player)
// Displays hex values of your PRIV3 settings.
{
	static char *hch="abcdefg";
	int i;
	for (i=0;i<7;i++) 
	{
		sprintf(temp,"priv3%c : %X ", hch[i],Player->cmds.get(i));
		Player->Msg(temp);
	}
}


void command_setpriv3(P_PLAYER Player)
// Alter GM Command Privs
// <P>The Setpriv3 command has 3 different formats:</P>
// <UL>
// <LI><B>One argument</B> - Set priv3 to a template found in the game script.</LI>
// <LI><B>Two arguments</B> - SETPRIV3 [+ or -] COMMAND, example: To allow a user to
// have access to the SAVE command, use <B>SETPRIV3 + SAVE</B>, to take awake a
// user's access to MAKECNS, use <B>SETPRIV3 - MAKECNS</B></LI>
// <LI><B>Six or Seven Arguments</B> - Manually set the entire setpriv3
// structure as a sequence of six or seven eight-digit hexadecimal
// numbers.</LI>
// </UL>
// <P>For more information on Meta-GM permissions, check out
{
	int y, z;
	unsigned int i;
	int loopexit=0;
	UOXSOCKET s = Player->cs;
    
	switch(tnum)
	{
	case 7:
	case 8:
		if (SrvParms->gm_log) { sprintf(temp,"%s.log",Player->name); savelog("setpriv3 executed!\n",temp); }
		priv3a[s]=hexnumber(1);
		priv3b[s]=hexnumber(2);
		priv3c[s]=hexnumber(3);
		priv3d[s]=hexnumber(4);
		priv3e[s]=hexnumber(5);
		priv3f[s]=hexnumber(6);
		if (tnum==8) priv3g[s]=hexnumber(7);
		else priv3g[s]=0;
		target(Player, T_250, "Select player to set command clearance");
		break;
	case 2:
		y=makenumber(1);
		if (SrvParms->gm_log) { sprintf(temp,"%s.log",Player->name); savelog("setpriv3 executed!\n",temp); }
		//AntiChrist-this was metagm[y%255]-
		if (y>255)
		{
			LogError("setpriv3-command: avoiding crash. argument was >255!\n");
			Player->Msg("Setpriv3-command argument has to be between 0 and 255.");
			return;
		}
		priv3a[s]=Npcs->metagm[y].get(0);
		priv3b[s]=Npcs->metagm[y].get(1);
		priv3c[s]=Npcs->metagm[y].get(2);
		priv3d[s]=Npcs->metagm[y].get(3);
		priv3e[s]=Npcs->metagm[y].get(4);
		priv3f[s]=Npcs->metagm[y].get(5);
		priv3g[s]=Npcs->metagm[y].get(6);
		target(Player, T_250, "Select player to set command clearance");
		break;
	case 3:	/* new code to allow + COMMAND or - COMMAND 07/24/99 */
		if (!strcmp((char*)comm[1], "+") || !strcmp((char*)comm[1], "-"))
		{
			y=comm[1][0]=='+' ? 1 : 0;
			for (i=0;i<strlen((char*)comm[2]);i++)
			{
				comm[2][i]=toupper(comm[2][i]);
			}
			i=0; z=-1;
			loopexit=0;
			while((Commands->command_table[i].cmd_name)&&(z==-1) && (++loopexit < MAXLOOPS))
			{
				if (!strcmp(Commands->command_table[i].cmd_name, (char*)comm[2])) z=i;
				i++;
			}
			if (z==-1)
			{
				Player->Msg("That command doesn't exist.");
			} else if (Commands->command_table[z].cmd_priv_m==255)
			{
				Player->Msg("No special permissions are neccessary to use that command.");
			} else
			{
				addx[s]=z;
				addy[s]=y;
				sprintf(temp, "Select player to alter %s command access.", Commands->command_table[z].cmd_name);
				target(Player, T_225, temp);
			}
		} else {
			Player->Msg("2-Argument Usage: /SETPRIV3 +/- COMMAND");
		}
		break;
	default:
		Player->Msg("This command takes 1, 2, 6, or 7 arguments.");
		break;
	}
}

void command_resend(P_PLAYER Player)
// Resends server data to client.
{
	all_items(Player->cs);
	LogMessage("ALERT: all_items() called in command_resend().\nThis function could cause a lot of lag!\n");
	teleport(Player, Player->pos);
}

void command_point(P_PLAYER Player)
{
	teleport(Player, Player->pos); 
}

void command_where(P_PLAYER Player)
// Prints your current coordinates+region.
// added region-name too, LB
{
	if (strlen(region[Player->region].name)>0)
		sprintf(temp, "You are at: %s",region[Player->region].name); 
	else
		strcpy(temp,"You are at: unknown area");
	Player->Msg(temp);

	sprintf(temp, "%i %i (%i)",Player->pos.x,Player->pos.y,Player->pos.z); 
	Player->Msg(temp);
}

void command_q(P_PLAYER Player)	// Shows the GM or Counsellor queue.
{
	Commands->ShowGMQue(Player, Player->isGM());
}

void command_next(P_PLAYER Player)	// For Counselors or GM's, goes to next call in queue
{
	Commands->NextCall(Player, Player->isGM());
}

void command_clear(P_PLAYER Player)	// For Counselor's and GM's, removes current call from queue
{
	donewithcall(Player, Player->isGM());
}

void command_goplace(P_PLAYER Player)	// (d) Teleports you to a location from the LOCATIONS.SCP file
{ 
	if (tnum==2) 
	{ 
		cCoord newPos(0,0,0,0);
		if (Commands->MakePlace(Player, makenumber(1),newPos)) 
		{ 
			Player->travelTo(newPos); 
		} 
	} 
}

void command_gochar(P_PLAYER Player)	// (h h h h) Teleports you to another character
{ 
	P_CHAR pc; 
	
	if (tnum == 5) 
	{ 
		int serial = hexnumber(1,2,3,4);
		AllCharsIterator aci;
		for (aci.Begin(); (pc=aci.GetData()) != NULL; aci++) 
		{ 
			if (pc->serial == serial) 
			{ 
				Player->travelTo(pc->pos); 
				break;
			} 
		} 
	} 
	else if (tnum == 2) 
	{ 
		UOXSOCKET si = makenumber(1);
		AllPlayersIterator api;
		for (pc = api.First(); pc != NULL; pc = api.Next())
		{
			if (si == api.getSocket()) 
			{ 
				Player->travelTo(pc->pos);
				break;
			} 
		} 
	} 
}

void command_fix(P_PLAYER Player)
// Try to compensate for messed up Z coordinates. Use this if you find yourself half-embedded in the ground.
{
	if (tnum == 2)
	{
		if (validtelepos(Player)==-1)
		{
			Player->dispz = Player->pos.z = makenumber(1);
		}
		else
		{
			Player->dispz = Player->pos.z = validtelepos(Player);
		}

		teleport(Player, Player->pos); // only x/y used for old coords, we changed only z, so can use new for old coords param
	}
}

void command_xgoplace(P_PLAYER Player)	// (d) Send another character to a location in your LOCATIONS.SCP file
{
	if (tnum==2)
	{
		if (Commands->MakePlace(Player, makenumber(1),Player->TD._Target1Pos))
		{
			target(Player, T_8, "Select char to teleport.");
		}
	}
}

void command_showids(P_PLAYER Player)	// Display the serial number of every item on your screen
{
	P_CHAR pc;
	int loopexit=0;
	RegGrid3x3Iterator4Chars rg3ic(Player->pos);
	while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (inrange1p(Player, pc)) 
			Titles->ShowCname(Player->cs, Player, pc, 1);
	}
}

void command_poly(P_PLAYER Player)	// (h h) Polymorph yourself into any other creature
{
	if (tnum==3)
	{
		int k=(hexnumber(1)<<8)+hexnumber(2);
		if (k>=0x000 && k<=0x3e1) // lord binary, body-values >0x3e crash the client
			
		{ 
			Player->setXid(k); // allow only non crashing ones
			Player->setId(k);
			
			unsigned short color = Player->skin; // transparency for mosnters allowed, not for players, 
			// if polymorphing from monster to player we have to switch from transparent to semi-transparent
			// or we have that sit-down-client crash
			if ((color&0x4000) && (k >=0x0190 && k<=0x03e1))
			{
				if (color!=0x8000)
				{
					Player->skin = Player->xskin = 0xF000;
				}
			}
		}
		updatechar(Player);
	}
}

void command_skin(P_PLAYER Player)	// (h h) Change the hue of your skin
{
	if (tnum == 3)
	{
		int k, b, body;
		
		body = Player->id();
		k = (hexnumber(1) << 8) + hexnumber(2);
		b = k&0x4000; 
		if (b == 16384 &&(body >=0x0190 && body <= 0x03e1))
			k = 0xf000; 
		
		if (k != 0x8000)
		{	
			Player->skin = Player->xskin = k;
			updatechar(Player);
		}
	}
}

void command_action(P_PLAYER Player)	// (h) Perform an animated action sequence
{
	if (tnum==2) Player->DoAction(hexnumber(1));
}

void command_setseason(P_PLAYER Player)
// Sets the season globally
// Season change packet structure:
// BYTE 0xBC	(Season change command)
// BYTE season	(0 spring, 1 summer, 2 fall, 3 winter, 4 dead, 5 unknown (rotating?))
// BYTE unknown	If 0, cannot change from undead, so 1 is the default
{
	if (tnum==2)
	{
		timeLight.season = hexnumber(1);
		P_CHAR pc;
		AllPlayersIterator api;
		for (pc = api.First(); pc != NULL; pc = api.Next())
		{
			SndSeason(api.getSocket());
			Player->Msg("Season set");
		}
	}
	else
		Player->Msg("Setseason takes one argument.");	
}

void command_xtele(P_PLAYER Player)
// (d / h h h h / nothing) Teleport a player to your position.
// <UL><LI>If you specify nothing (/XTELE), you click on the player to teleport in.</LI>
// <LI>If you specify a serial number (/XTELE .. .. .. ..), you teleport that player to you.</LI>
// <LI>If you specify a single number (/XTELE ..), you teleport the player logged in
// under that slot to you.</LI>
// </UL>
{
	if (tnum==5 || tnum==2)
	{
		Targ->XTeleport(Player, tnum);
	}
	else
	{
		target(Player, T_136, "Select char to teleport to your position.");
	}
}

void command_go(P_PLAYER Player) 
// (d d d [d]) Go to the specified X/Y/Z[/map] coordinates 
{ 
	if (tnum==4 || tnum == 5) 
	{ 
		int x=makenumber(1);int y=makenumber(2);
		int z;
		int nmap = (tnum==5) ? makenumber(4) : Player->pos.map;
		if (!strcmp((char*)comm[3],"d"))	// 'd' like 'default for Z'
		{
			cCoord goPos(x,y,0,nmap);
			z = Map->MapElevation(goPos);
		}
		else
			z=makenumber(3);

		if (x<6144 && y<4096 && z>-127 && z<128) 
		{
			cCoord newPos(x,y,z,nmap);
			Player->travelTo(newPos);			
		} 
	} 
}

void command_setstatlimits(P_PLAYER Player)	// (d d d [d]) Go to the specified X/Y/Z[/map] coordinates 
{ 
	if (tnum!=4) return;

	int x=makenumber(1);
	int y=makenumber(2);
	int z=makenumber(3);

	if (!x && !y && !z)	// remove individual limits
	{
		Player->setStrLimit(x);
		Player->setDexLimit(y);
		Player->setIntLimit(z);
		return;
	}

	if (x<1) x=1;
	if (y<1) y=1;
	if (z<1) z=1;

	if (x	  >SrvParms->statcap) x=SrvParms->statcap-2;
	if (x+y	  >SrvParms->statcap) y=SrvParms->statcap-x-1;
	if (x+y+z >SrvParms->statcap) z=SrvParms->statcap-y-x;

	char msg[128];
	Player->setStrLimit(x);
	Player->setStr(x);
	sprintf(msg,"Strength limited to %d",Player->getStrLimit());
	Player->Msg(0x127,msg);

	Player->setDexLimit(y);
	Player->setDex(y);
	sprintf(msg,"Dexterty limited to %d",Player->getDexLimit());
	Player->Msg(0x127,msg);

	Player->setIntLimit(z);
	Player->setInt(z);
	sprintf(msg,"Intelligence limited to %d",Player->getIntLimit());
	Player->Msg(0x127,msg);
}

void command_showstatlimits(P_PLAYER Player) 
{
	char msg[128];

	Player->Msg(0x127,"Your statlimits are set to:");

	sprintf(msg,"Strength: %d",Player->getStrLimit());
	Player->Msg(0x127,msg);
	sprintf(msg,"Dexterty: %d",Player->getDexLimit());
	Player->Msg(0x127,msg);
	sprintf(msg,"Intelligence: %d",Player->getIntLimit());
	Player->Msg(0x127,msg);

	sprintf(msg,"Sum of all stats is limited to: %d",SrvParms->statcap);
	Player->Msg(0x127,msg);
}

void command_zerokills(P_PLAYER Player)
// Sets all PK counters to 0.
{
	Player->Msg("Zeroing all player kills...");
	P_CHAR pc;
	AllCharsIterator aci;
	for (aci.Begin(); (pc=aci.GetData()) != NULL; aci++)
	{
		pc->kills=0;
		setcharflag(pc);//AntiChrist
	}		
	Player->Msg("All player kills are now 0.");
}

void command_tile(P_PLAYER Player)
// (h h) Tiles the item specified over a square area.
// To find the hexidecimal ID code for an item to tile,
// either create the item with /add or find it in the
// world, and get /ISTATS on the object to get it's ID
// code.
{
	if (tnum==3)
	{
		UOXSOCKET s = Player->cs;
		addid1[s]=hexnumber(1);
		addid2[s]=hexnumber(2);
		clickx[s]=-1;
		clicky[s]=-1;
		target(Player,T_198,"Select first corner of bounding box.");  // 198 didn't seem taken...
	}
}

void command_tilescript(P_PLAYER Player)
// (D) Tiles the item specified over a square area.
// tilenumer D (dec) is taken from itemscript
{
	if (tnum==2)
	{
		UOXSOCKET s = Player->cs;
		addx2[s]=makenumber(1);						
		clickx[s]=-1;
		clicky[s]=-1;
		target(Player,T_299,"Select first corner of bounding box for tilescript.");
	}
}

void command_killnpcs(P_PLAYER Player)
{
	if (tnum==1)
	{			
		UOXSOCKET s = Player->cs;
		clickx[s]=-1;
		clicky[s]=-1;
		target(Player,T_300,"Select first corner of bounding box for killnpcs.");
	}
}

void command_swap(P_PLAYER Player)
{
	UOXSOCKET s = Player->cs;
	if (tnum==2)
	{			
		clickx[s]=-1; // damn multipurpose global array. stroring serials here, hence it has to be int
		// clickx,y IS int, so no prob. but for x,y only short required. 
		// DONT change it short cauze used here
		
		addx2[s]=makenumber(1);	
		target(Player,T_301,"Select target creature");
	}
	else 
		Player->Msg("you haven't selected a swap duration");
}



void command_wipe(P_PLAYER Player)
// (d d d d / nothing) Deletes ALL NPC's and items inside a specified square.
// <UL><LI>With no arguments, /WIPE will ask you to click in opposing corners of
// the square.</LI>
// <LI>You may also specify coordinates - X1, Y1, X2, Y2.</LI>
// </UL>
{
	UOXSOCKET s = Player->cs;
	addid1[s]=0; // addid1[s]==0 is used to denote a true wipe
	if (tnum==1)
	{
		clickx[s]=-1;
		clicky[s]=-1;
		target(Player,T_199,"Select first corner of wiping box.");  // 199 didn't seem taken...
	}
	else if (tnum==2)
	{
		//mstring dummy = Commands->params[1];
		std::string dummy = Commands->params[1];
		std::transform(dummy.begin(), dummy.end(), dummy.begin(), ::tolower);
		//dummy.lower();
		if (!strcmp("all", dummy.c_str()))
		{
			// Really should warn that this will wipe ALL objects...
			Commands->Wipe(Player);
		}
	}
	else if (tnum==5)
	{ // Wipe according to world coordinates
		cMapRectangle rect(makenumber(1),makenumber(2),makenumber(3),makenumber(4),Player->pos.map);
		Commands->PartialWipe(Player,rect,false);
	}
}

void command_killclones(P_PLAYER Player)
{	
	int cnt=0;
	P_CHAR pc;
	AllCharsIterator aci;
	for (aci.Begin(); (pc = aci.GetData()) != aci.End(); aci++)
	{
		if ( pc->npc && pc->account<0 )
		{			  			   
			if (pc->isclone)
			{
				cnt++;						
				Npcs->DeleteChar(pc);
			}
			
		}
	}

	sprintf(temp,"All Britannian clones killed (%i)", cnt);
	Player->Msg(temp);
}

void command_iwipe(P_PLAYER Player)
// (d d d d / nothing) Deletes ALL NPC's and items NOT inside a specified square.
// <UL><LI>With no arguments, /IWIPE will ask you to click in opposing corners of
// the square.</LI>
// <LI>You may also specify coordinates - X1, Y1, X2, Y2.</LI>
// </UL>
{
	UOXSOCKET s = Player->cs;
	addid1[s]=1;  // addid1[s]==1 is used to denote the INVERSE wipe
	if (tnum==1)
	{
		clickx[s]=-1;
		clicky[s]=-1;
		target(Player,T_199,"Select first corner of inverse wiping box.");  // 199 didn't seem taken...
	}
	else if (tnum==2)
	{
		std::string dummy = Commands->params[1];
		std::transform(dummy.begin(), dummy.end(), dummy.begin(), ::tolower);

		if (!strcmp("all", dummy.c_str()))
		{
			Player->Msg("Well aren't you the funny one!");
		}
	}
	else if (tnum==5)
	{ // Wipe according to world coordinates
		cMapRectangle rect(makenumber(1),makenumber(2),makenumber(3),makenumber(4),Player->pos.map);
		Commands->PartialWipe(Player,rect,true);
	}
}

void command_add(P_PLAYER Player)
// (h h) Adds a new item, or opens the GM menu if no hex codes are specified.
{
	UOXSOCKET s = Player->cs;
	if (tnum==2 || tnum>3)//AntiChrist
	{
		Player->Msg("Syntax error. Usage: /add <id1> <id2>");
		return;
	} 
	else if (tnum==3)
	{
		addid1[s]=hexnumber(1);
		addid2[s]=hexnumber(2);
		if (addid1[s]<0x40) target(Player, T_0, "Select location for item.");		
	}
	else if (tnum==1)
	{
		//itemmenu(s, 1);
		CAddMenu *Grr = new CAddMenu(1, -1);
		Grr->showAddGump(s);
		delete Grr;
	}
}

void command_addx(P_PLAYER Player)
// (h h) Adds a new item to your current location.
{
	UOXSOCKET s = Player->cs;
	if (tnum==3)
	{
		addid1[s] = (unsigned char) hexnumber(1);
		addid2[s] = (unsigned char) hexnumber(2);
		Commands->AddHere(Player, Player->pos.z);
	}
	if (tnum==4)
	{
		addid1[s] = (unsigned char) hexnumber(1);
		addid2[s] = (unsigned char) hexnumber(2);
		Commands->AddHere(Player, makenumber(3));
	}
}

void command_rename(P_PLAYER Player)
// (text) Renames any dynamic item in the game.
{
	if (tnum>1)
	{
		addx[Player->cs]=0;	// addx[s] = 1 will set name2
		strcpy(xtext[Player->cs], Commands->GetAllParams().c_str());
		target(Player, T_1, "Select item or character to rename.");
	}
}

void command_rename2(P_PLAYER Player)
// (text) Rename an item or character.
{
	if (tnum>1)
	{
		addx[Player->cs]=1;
		strcpy(xtext[Player->cs], Commands->GetAllParams().c_str());
		target(Player, T_1, "Select item or character to rename.");
	} 
	return;
}

void command_title(P_PLAYER Player)
// (text) Changes the title of any player or NPC.
{
	if (tnum>1)
	{
		strcpy(xtext[Player->cs], Commands->GetAllParams().c_str());
		target(Player, T_47, "Select character to change the title of.");
	}
}

void command_save(P_PLAYER Player)
// Saves the current world data into ITEMS.WSC and CHARS.WSC.
{
	Player->Msg("Initialising World Data save...");
	cwmWorldState->savenewworld(1);
	Player->Msg("World has been saved successfully!");
}

void command_dye(P_PLAYER Player)
// (h h/nothing) Dyes an item a specific color, or brings up a dyeing menu if no color is specified.
{
	UOXSOCKET s = Player->cs;
	dyeall[s]=1;
	if (tnum==3)
	{
		addid1[s]=hexnumber(1);
		addid2[s]=hexnumber(2);
	}
	else
	{
		addid1[s]=255;
		addid2[s]=255;
	}
	target(Player, T_4, "Select item to dye.");
}

void command_wtrig(P_PLAYER Player)
// (word) Sets the trigger word on an NPC.
{
	if (tnum>1)
	{
		strcpy(xtext[Player->cs], &tbuffer[7]);
		target(Player, T_203, "Select the NPC to set trigger word on.");
	}
}

void command_setpriv(P_PLAYER Player)
// (Chars/NPCs: h h, Objects: h) Sets priviliges on a Character or object.
{
	UOXSOCKET s = Player->cs;
	if (tnum==3)
	{
		addid1[s]=hexnumber(1);
		addid2[s]=hexnumber(2);
		target(Player, T_9, "Select char to edit priv.");
	}
	if (tnum==2)
	{
		addid1[s]=3;
		addid2[s]=hexnumber(1);
		target(Player, T_89, "Select object to edit priv.");
	}
}

void command_nodecay(P_PLAYER Player)
// Prevents an object from ever decaying.
{
	addid1[Player->cs]=0; 
	target(Player, T_89, "Select object to make permanent.");
}

void command_send(P_PLAYER Player)
// Debugging command
{
	int i;
	if (tnum<=2) return;
	temp[0]=hexnumber(1);
	temp[1]=hexnumber(2);
	if (temp[0]!=0x69) return; // kindersicherung / magic number ;)	
	
	switch(temp[1])
	{
	case 1: // raw data via console (0x69 0x1 raw data)
		for (i=3;i<tnum;i++) temp[i-3]=hexnumber(i);
		Player->Msg("Mode1: Raw data send to client");
		//Xsend(s, temp, tnum-3); // need rewrite for new packet send stuff, currently no need for it and time
		break;
		
	case 2: // raw data via dump file (0x69 0x2 filename)
		char t[512];
		char *buff, *buff2;
		buff= new char[128*1024]; // 128kb dump file max
		buff2=new char[128*1024];
		
		makestring(3, t, false); // get dump file
		
		FILE *f;
		f = fopen(t,"rb");
		if (f==NULL) 
		{
			delete[] buff;
			delete[] buff2;
			return;
		}
		
		int so = fread(buff, sizeof(char), 127*1024, f);
		fclose(f);
		if (so<=0) return;
		buff[so]=0;
		
		// tokenize string
		char *token;
		char seps[]   = " ";
		char *r;
		token = strtok( buff, seps );
		int x=0;
		
		while( token != NULL )
		{     
			int i=-1;
			r = strstr(token, ":");
			if (r==NULL) sscanf(token, "%x", &i);
			if (i!=-1) 
			{
				//Xsend(s, &i, 1);
				buff2[x++]=i;
			}
			
			token = strtok( NULL, seps );
		}
		
		int a;
		printf("\n");
		for (a=0; a<x; a++)
		{
			printf("%02x ", buff2[a]);
			if (((a+1)%20)==0) printf("\n");
		}
		printf("\n");
		
		delete[] buff2;
		delete[] buff;
		
		break;
	}
}

void command_showtime(P_PLAYER Player)
// Displays the current UO time.
{
	if (timeLight.ampm || (!timeLight.ampm && timeLight.hour==12))
		sprintf(temp, "%s %2.2d %s %2.2d %s", "LoneWolf: Time: ", timeLight.hour, ":", timeLight.minute, "PM");
	else
		sprintf(temp, "%s %2.2d %s %2.2d %s", "LoneWolf: Time: ", timeLight.hour, ":", timeLight.minute, "AM");
	Player->Msg(temp);
}

void command_settime(P_PLAYER Player)
// (d d) Sets the current UO time in hours and minutes.
{
	int newhours, newminutes;
	if (tnum==3)
	{
		newhours = makenumber(1);
		newminutes = makenumber(2);
		if ((newhours < 25) && (newhours > 0) && (newminutes > -1) && (newminutes <60))
		{
			if (newhours > 12)
			{
				timeLight.ampm=1;
				timeLight.hour=newhours-12;
			}
			else
			{
				timeLight.ampm=0;
				timeLight.hour=newhours;
			}
			timeLight.minute=newminutes;
		}
	}
}

void command_shutdown(P_PLAYER Player)
// (d) Shuts down the server. Argument is how many minutes until shutdown.
{
	if (tnum==2)
	{
		endtime=uiCurrentTime+(MY_CLOCKS_PER_SEC*makenumber(1));
		if (makenumber(1)==0)
		{
			endtime=0;
			sysbroadcast("Shutdown has been interrupted.");
		}
		else endmessage(0);
	}
}

void command_wholist(P_PLAYER Player)
// Same as playerlist but has offline players...Ripper
{
	char x[256];
	int f;
	makestring(1,x);
	if (tnum!=2) x[0]=0;
	if (tnum==3) f=makenumber(2); else f=-1;
	whomenu(Player, 4, x,f);
}

void command_playerlist(P_PLAYER Player)
{ // Brings up an interactive listing of online users.
	char x[256];
	makestring(1,x);
	if (tnum!=2) x[0]=0;
	playermenu(Player, 4, x);
}


void command_sfx(P_PLAYER Player)
// (h h) Plays the specified sound effect.
{
	if (tnum==3)
	{
		soundeffect(Player, (hexnumber(1)<<8)+hexnumber(2));
	}
}

void command_light(P_PLAYER Player)
// (h) Sets the light level. 0=brightest, 15=darkest, -1=enable day/night cycles.
{
	if (tnum==2)
	{
		timeLight.worldfixedlevel=hexnumber(1);
		if (timeLight.worldfixedlevel!=255) setabovelight(timeLight.worldfixedlevel,-1);
		else setabovelight(timeLight.worldcurlevel,-1);
		sprintf(temp, "lightlevel: %i set globally\n", timeLight.worldfixedlevel);
		Player->Msg(temp);
	}
	
	if (tnum==3)
	{
		unsigned char level=hexnumber(1);
		int reg=hexnumber(2);
		
		if (reg<0 || reg>MAXREGIONS)
		{
			Player->Msg("invalid region");
			return;
		}
		
		sprintf(temp, "lightlevel: %i set for region: %s\n", level, region[reg].name);
		Player->Msg(temp);
		
		region[reg].fixedlight=level;
		
		if (level!=255) setabovelight(level,reg);
		else setabovelight(region[reg].curlight,reg);
	}
}

void command_disconnect(P_PLAYER Player)
// (d) Disconnects the user logged in under the specified slot.
{
	if (tnum==2) Network->Disconnect(makenumber(1));
}

void command_tell(P_PLAYER Player)
// (d text) Sends an anonymous message to the user logged in under the specified slot.
{
	if (tnum>2) 
	{ 
		//mstring dummy = Commands->GetAllParams();
		std::string dummy = Commands->GetAllParams();
		
		int m = makenumber(1);
		if (m<0) sysbroadcast(dummy.c_str()); else
		tellmessage(Player, makenumber(1), (char*) dummy.c_str());
	}
}
#define WEATHER 0
void command_dry(P_PLAYER Player)
// Set weather to dry (no rain or snow).
{
	Player->Msg("Being Worked On!\n");
/*	int i;
	wtype=0;
	for (i=0;i<now;i++) if (perm[i]) weather(i,0);*/
#if WEATHER
	AllPlayersIterator api;
	P_CHAR pc; 
	for (pc = api.First(); pc != NULL; pc = api.Next())
	{
		UOXSOCKET si=api.getSocket();
		SndDry(si);
	}
#endif
}

void command_rain(P_PLAYER Player)
// Sets the weather condition to rain.
{
	Player->Msg("Being Worked On!\n");
/*		int i;
		if (wtype==2)
		{
		   wtype=0;
		   for (i=0;i<now;i++) if (perm[i]) weather(i,0);
		}
		wtype=1;
		for (i=0;i<now;i++) if (perm[i]) weather(i,0); */


#if WEATHER
	AllPlayersIterator api;
	P_CHAR pc; 
	for (pc = api.First(); pc != NULL; pc = api.Next())
	{
		UOXSOCKET si=api.getSocket();
//		SndDry(si);
		SndRain(si);
	}
#endif
}

void command_snow(P_PLAYER Player)
// Sets the weather condition to snow.
{
	Player->Msg("Being Worked On!\n");
/*	int i;
	if (wtype==1)
	{
		wtype=0;
		for (i=0;i<now;i++) if (perm[i]) weather(i,0);
	}
	wtype=2;
	for (i=0;i<now;i++) if (perm[i]) weather(i,0);*/

#if WEATHER
	AllPlayersIterator api;
	P_CHAR pc; 
	for (pc = api.First(); pc != NULL; pc = api.Next())
	{
		UOXSOCKET si=api.getSocket();
//		SndDry(si);
		SndSnow(si);
	}
#endif
}

void command_gmmenu(P_PLAYER Player)
// (d) Opens the specified GM Menu.
{
	if (tnum==2) gmmenu(Player, makenumber(1));
}

void command_itemmenu(P_PLAYER Player)
// (d) Opens the specified Item Menu from ITEMS.SCP.
{
	if (tnum==2) itemmenu(Player, makenumber(1));
}

void command_additem(P_PLAYER Player)
// (d) Adds the specified item from ITEMS.SCP.
{
	if (tnum==2)
	{
		addmitem[Player->cs] = makenumber(1); // Anthracks' fix
		sprintf(temp, "Select location for item. [Number: %i]", addmitem[Player->cs]);
		target(Player, T_26, temp);
	}
}

void command_dupe(P_PLAYER Player)
// (d / nothing) Duplicates an item. If a parameter is specified, it's how many copies to make.
{
	UOXSOCKET s = Player->cs;
	if (tnum==2)
		addid1[s]=makenumber(1);
	else
		addid1[s]=1;

	target(Player, T_110, "Select an item to dupe.");
}

void command_command(P_PLAYER Player)
// Executes a trigger scripting command.
{
	int i;
	if (tnum>1)
	{
		i=0;
		script1[0]=0;
		script2[0]=0;
		strcpy(script1, Commands->params[1].c_str());
		if (Commands->params.size() > 2)
			strcpy(script2, Commands->params[2].c_str());

		scriptcommand(Player, script1, script2);
	}
}

void command_gcollect(P_PLAYER Player)
// Runs garbage collection routines.
{
	gcollect();
	Player->Msg("command succesfull");
}

void command_allmoveon(P_PLAYER Player)	// Enables GM ability to pick up all objects.
{
	Player->AllowMoveAll();
	teleport(Player,Player->pos);		// resend items with new movabilty attribute
	Player->Msg("ALLMOVE enabled.");
}

void command_allmoveoff(P_PLAYER Player)// Disables GM ability to pick up all objects.
{
	Player->DisallowMoveAll();
	teleport(Player,Player->pos);		// resend items with new movabilty attribute
	Player->Msg("ALLMOVE disabled.");
}

void command_showhs(P_PLAYER Player)
// Makes houses appear as deeds. (The walls disappear and there's a deed on the ground in their place.)
{
	Player->MakeShowHouseIcons();

	PC_ITEM pi;
	int loopexit = 0;
	RegGrid3x3Iterator4Items rg3ii(Player->pos);
	while((pi = rg3ii.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (ishouse(pi)) SndRemoveItem(Player,pi);
	}

	teleport(Player,Player->pos);
	Player->Msg("House icons visible. (Houses invisible)");
}

void command_hidehs(P_PLAYER Player)	// Makes houses appear as houses (opposite of /SHOWHS).
{
	Player->MakeNoShowHouseIcons();
	teleport(Player, Player->pos);
	Player->Msg("House icons hidden. (Houses visible)");
}

void command_viewdepth(P_PLAYER Player)	// change the viewingdepth
{
	if (tnum==2)
	{
		short depth = makenumber(1);
		Player->SetViewingDepth(depth);

		P_CHAR pc;
		int loopexit=0;
		RegGrid3x3Iterator4Chars rg3ic(Player->pos);
		while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
		{
			if (!Player->isSameAs(pc) && inrange1p(Player, pc))
				impowncreate(Player->cs, pc, 1);
		}
	}
	else Player->Msg("Syntax: viewdepth <num>");
}

void command_set(P_PLAYER Player)
// (text, d) Set STR/DEX/INT/Skills on yourself arguments are skill & amount.
{
	int i;
	UOXSOCKET s = Player->cs;
	if (tnum==3)
	{
		i=0;
		script1[0]=0;
		strcpy(script1, Commands->params[1].c_str());
		strupr(script1);
		addx[s]=-1;
		
		for (i=0;i<SKILLS;i++)
		{
			if (!strcmp(SkillManager->getSkillName(i), script1)) 
			{ /*Console.send("%s\n",skillname[i]);*/
				if (SrvParms->AOS_Mode || SrvParms->SE_Mode) addx[s]=i;
				else
				{
					if (i!=NECROMANCY && i!=CHIVALRY && i!=FOCUS && i!=BUSHIDO && i!=NINJITSO) addx[s]=i;

				}
			}
			if (!strcmp(script1, "ALLSKILLS")) { addx[s]=ALL; }
		}
		if (addx[s]!=-1)
		{
			addy[s]=makenumber(2);
			target(Player, T_36, "Select character to modify.");
		}
	}
}

void command_addnpc(P_PLAYER Player)
// (d or h h) Add the specified NPC from NPC.SCP or by hex ID code.
{
	UOXSOCKET s = Player->cs;
	if (tnum==3)
	{
		addid1[s]=hexnumber(1);
		addid2[s]=hexnumber(2);
		target(Player, T_33, "Select location for the NPC.");
	}
	else if (tnum==2)
	{
		addmitem[s]=makenumber(1);
		target(Player, T_27, "Select location for the NPC.");
	}
}

void command_gumpmenu(P_PLAYER Player)
// (d) Opens the specified GUMP menu.
{
	if (tnum==2)
	{
		Gumps->Menu(Player->cs, makenumber(1));
	}
}

void command_npcrect(P_PLAYER Player)
// (d d d d) Set bounding box for a NPC with a NPCWANDER of 3.
{
	if (tnum==5)
	{
		UOXSOCKET s = Player->cs;
		addx[s]=makenumber(1); // bugfix, LB, old npcshape worked only if its only excuted by ONE player at the same time
		addy[s]=makenumber(2);
		addx2[s]=makenumber(3);
		addy2[s]=makenumber(4);
		target(Player, T_67, "Select the NPC to set the bounding rectangle for."); // lb bugfix, was 58 ...
	}
}

void command_npccircle(P_PLAYER Player)
// (d d d) Set bounding circle for a NPC with a NPCWANDER of 2.
{
	if (tnum==4)
	{
		UOXSOCKET s = Player->cs;
		addx[s]=makenumber(1);
		addy[s]=makenumber(2);
		addx2[s]=makenumber(3);
		target(Player, T_59, "Select the NPC to set the bounding circle for.");
	}
}

void command_npcwander(P_PLAYER Player)
// (d) Sets the type of wandering a NPC does.
// <UL><LI>0 = NPC Does not move.</LI>
// <LI>1 = NPC Follows specified target. (See
// <A HREF="npctarget.html">/NPCTARGET</A>)</LI>
// <LI>2 = NPC Wanders Freely.</LI>
// <LI>3 = NPC stays in box specified by <A HREF="npcrect.html">NPCRECT</A>.</LI>
// <LI>4 = NPC stays in circle specified by <A HREF="npccircle.html">NPCCIRCLE</A>.</LI></UL>
{
	if (tnum==2)
	{
		addx[Player->cs]=makenumber(1);
		target(Player, T_60, "Select the NPC to set the wander method for.");
	}
}

void command_secondsperuominute(P_PLAYER Player)
// (d) Sets the number of real-world seconds that pass for each UO minute.
{
	if (tnum==2)
	{
		timeLight.secondsperuominute=makenumber(1);
		Player->Msg("Seconds per UO minute set.");
	}
}

void command_brightlight(P_PLAYER Player)
// (h) Sets default daylight level.
{
	if (tnum==2)
	{
		timeLight.worldbrightlevel=hexnumber(1);
		Player->Msg("World bright light level set.");
	}
}

void command_darklight(P_PLAYER Player)
// (h) Sets default nighttime light level.
{
	if (tnum==2)
	{
		timeLight.worlddarklevel=hexnumber(1);
		Player->Msg("World dark light level set.");
	}
}

void command_dungeonlight(P_PLAYER Player)
// (h) Sets default dungeon light level.
{
	if (tnum==2)
	{
		timeLight.dungeonlightlevel=min(hexnumber(1), 27);
		Player->Msg("Dungeon light level set.");
	}
}

void command_gmopen(P_PLAYER Player)
// (h / nothing) Opens specified layer on player/NPC, or player's pack if no layer specified.
// Useful hex codes for this command are:
// 15	Backpack
// 1A	NPC Buy Restock container
// 1B	NPC Buy no restock container
// 1C	NPC Sell container
// 1D	Bank Box
{
	int layer = 0x15;
	if (tnum==2)
		layer = hexnumber(1);
	target(Player, T_115, "Select the character to open the container on.");
	addmitem[Player->cs] = layer;
}

void command_restock(P_PLAYER Player)
// Forces a manual vendor restock.
{
	restock(0);
	Player->Msg("Manual shop restock has occurred.");
}

void command_restockall(P_PLAYER Player)
// Forces a manual vendor restock to maximum values.
{
	restock(1);
	Player->Msg("Restocking all shops to their maximums");
}

void command_setshoprestockrate(P_PLAYER Player)
// (d) Sets the universe's shop restock rate.
{
	if (tnum==2)
	{
		shoprestockrate=makenumber(1);
		Player->Msg("NPC shop restock rate changed.");
	}
	else
		Player->Msg("Invalid number of parameters.");
}

void command_midi(P_PLAYER Player)	// (d d) Plays the specified MIDI file.
{
	if (tnum==3) playmidi(Player->cs, makenumber(1), makenumber(2));
}

void command_gumpopen(P_PLAYER Player)	// (h h) Opens the specified GUMP menu.
{
	if (tnum==3) Gumps->Open(Player->cs, Player->serial, hexnumber(1), hexnumber(2));
}

void command_respawn(P_PLAYER Player)	// Forces a respawn.
{
	sprintf(temp,"Respawn command called by %s.\n", Player->name);//AntiChrist
	sysbroadcast("World is now respawning, expect some lag!");
	LogMessage(temp);
	Respawn->Start();
}

void command_regspawnmax(P_PLAYER Player)
// (d) Spawns in all regions up to the specified maximum number of NPCs/Items.
{
	if (tnum==2)
	{
		sprintf(temp,"MAX Region Respawn command called by %s.\n", Player->name);//AntiChrist
		LogMessage(temp);
		Commands->RegSpawnMax(Player, makenumber(1));
	}
}

void command_regspawn(P_PLAYER Player)
// (d d) Performs a region spawn. First argument is region, second argument is max # of items/NPCs to spawn in that region.
{
	if (tnum==3)
	{
		sprintf(temp,"Specific Region Respawn command called by %s.\n", Player->name);//AntiChrist
		LogMessage(temp);
		Commands->RegSpawnNum(Player, makenumber(1), makenumber(2));
		Player->Msg("Region has been spawned!");
	}
}

void command_reloadserver(P_PLAYER Player)	// Reloads the SERVER.SCP file.
{
	SrvParms->Load();
	Player->Msg("Server.scp reloaded.");
}

void command_loaddefaults(P_PLAYER Player)	// Loads the server defaults.
{
	SrvParms->Init();
	Player->Msg("Defaults Server Settings have been loaded!");
}

void command_cq(P_PLAYER Player)	// Display the counselor queue.
{
	Commands->ShowGMQue(Player, 0);	// Show the Counselor queue, not GM queue   
}

void command_cnext(P_PLAYER Player)	// Attend to the next call in the counselor queue.
{
	Commands->NextCall(Player, 0);	// Show the Counselor queue, not GM queue   
}

void command_cclear(P_PLAYER Player)// Remove the current call from the counselor queue.
{
	donewithcall(Player, 0);		// Show the Counselor queue, not GM queue   
}

void command_minecheck(P_PLAYER Player)
// (d) Set the server mine check interval in minutes.
{
	if (tnum==2)
		SrvParms->minecheck=makenumber(1);
}

void command_invul(P_PLAYER Player)
// Makes the targeted character immortal.
{
	addx[Player->cs]=1;
	target(Player,T_179,"Select creature to make invulnerable.");
}

void command_noinvul(P_PLAYER Player)
// Makes the targeted character mortal.
{
	addx[Player->cs]=0;
	target(Player,T_179,"Select creature to make mortal again.");
}

void command_guardson(P_PLAYER Player)
// Activates town guards.
{
	SrvParms->guardsactive=1;
	sysbroadcast("Guards have been reactivated.");
}

void command_guardsoff(P_PLAYER Player)
// Deactivates town guards.
{
	SrvParms->guardsactive=0;
	sysbroadcast("Warning: Guards have been deactivated globally.");
}

void command_announceon(P_PLAYER Player)
// Enable announcement of world saves.
{
	SrvParms->announceworldsaves=1;
	sysbroadcast("WorldStat Saves will be displayed.");
}

void command_announceoff(P_PLAYER Player)
// Disable announcement of world saves.
{
	SrvParms->announceworldsaves = 0;
	sysbroadcast("WorldStat Saves will not be displayed.");
}

void command_wf(P_PLAYER Player)
// Make the specified item worldforge compatible.
{
	if (tnum==2)
	{
		addid1[Player->cs]=255;
		target(Player, T_6, "Select item to make WorldForge compatible.");
	}
}

void command_decay(P_PLAYER Player)
// Enables decay on an object.
{
	addid1[Player->cs]=1;
	target(Player, T_89, "Select object to decay.");
}

void command_killall(P_PLAYER Player)
// (d text) Kills all of a specified item.
{
	if (tnum>2)
	{
		//mstring dummy = Commands->GetAllParams();
		std::string dummy = Commands->GetAllParams();
		dummy = dummy.substr(dummy.find_first_not_of(" "));
		if (makenumber(1)<10)
			Commands->KillAll(Player, makenumber(1), dummy.c_str());
		else if (makenumber(1)<100)
			Commands->KillAll(Player, makenumber(1), dummy.c_str());
		else
			Commands->KillAll(Player, makenumber(1), dummy.c_str());
	}
	return;
}

void command_pdump(P_PLAYER Player)
// Display some performance information.
{
	Player->Msg("Performance Dump:");
	pdump(Player);
}

void command_readspawnregions(P_PLAYER Player)
// Re-read the SPAWN.SCP file.
{
	loadspawnregions();
	Player->Msg("Spawnregions reloaded.");
	return;
}

void command_gy(P_PLAYER Player)
// (text) GM Yell - Announce a message to all online GMs.
{
	char ttx[300];
	sprintf(ttx, "(GM ONLY): %s", Commands->GetAllParams().c_str());//AntiChrist bugfix - cms_offset+4, not +7
	Commands->broadcast(Player,ttx,true);
}

void command_tilew(P_PLAYER Player)
// (h h d d d d d) id id x1 x2 y1 y2 z - Tile an object using specified id & coordinates.
// <UL><LI>The first two numbers are hexidecimal, and are the ID codes for
// the item to tile.</LI>
// <LI>The second pair of numbers is the decimal coordinates of the upper
// left hand corner of the box being tiled. To get this value, go to the
// upper left hand corner and type /WHERE.</LI>
// <LI>The third pair of numbers is the lower right hand corner of the
// box being tiled.</LI>
// <LI>The final number is the Z-Axis of the box being tiled.</LI></UL>
{
	if (tnum==8)
	{
		UOXSOCKET s = Player->cs;
		addid1[s] = static_cast<unsigned char>(hexnumber(1));//id1
		addid2[s] = static_cast<unsigned char>(hexnumber(2));//id2
		short id = (addid1[s]<<8)+addid2[s];
		signed char z = makenumber(7);
		int pile=0;
		if (isTruelyPileable(id)) pile=1;

		for (int x=makenumber(3);x<=makenumber(4);x++)
		{
			for (int y=makenumber(5);y<=makenumber(6);y++)
			{
				cCoord tpos(x,y,z,Player->pos.map);
				P_ITEM pi_a = Items->SpawnItem(ITY_None, 1, "#", id, 0, tpos);
				if (pi_a) // AntiChrist - to prevent crashes
				{
					pi_a->decayOff();	//Make them not decay
				}
			}
		}
		addid1[s]=0; // lb, i was so free and placed it here so that we dont have y-1 rows of 0-id items ... hope that was not intentinal ..
		addid2[s]=0;
	}  
	else { Player->Msg("Format: /tilew ID1 ID2 X1 X2 Y1 Y2 Z"); }
	return;
}

void command_squelch(P_PLAYER Player)
// (d / nothing) Squelchs specified player. (Makes them unnable to speak.)
{
	if (tnum==2)
    {
		int n = makenumber(1);
		if (n!=0 || n!=-1)
        {
            addid1[Player->cs]=n;
        }
    }
    target(Player,T_223,"Select character to squelch.");
}

void command_spawnkill(P_PLAYER Player)
// (d) Kills spawns from the specified spawn region in SPAWN.SCP.
{
	if (tnum==2)
	{
		Commands->KillSpawn(Player, makenumber(1));
		Player->Msg("Spawn killed!");
	}
}


void command_wanim(P_PLAYER Player)
// (d d) Changes server lighting animation.
{
   if (tnum==3)
   {
	   w_anim[0]=(signed char) hexnumber(1);
	   w_anim[1]=(signed char) hexnumber(2);
	   Player->Msg("new GLOBAL bolt animation set!");
   }
}

void command_gotocur(P_PLAYER Player)	// Goes to the current call in the GM/Counsellor Queue
{
	Commands->GotoCur(Player);
}

void command_gmtransfer(P_PLAYER Player)
// Escalate a Counsellor Page into the GM Queue
{
	Commands->GMtransfer(Player);
}

void command_who(P_PLAYER Player)
// Displays a list of users currently online.
{
	if (now==1)
	{
		Player->Msg("There are no other users connected.");
		return;
	}

	int j=0;
	unsigned int i;
	Player->Msg("Current Users in the World:");
	for (i=0;i<now;i++)
	{
		if (perm[i]) //Keeps NPC's from appearing on the list
		{
			P_CHAR pc = MAKE_CHAR_REF(currchar(i));
			//if (!pc) continue;
			if (!pc)
			{
				char tt[444];
				sprintf(tt,"Invalid char index detected !! now=%i, i=%i, index=%i",now,i,currchar(i));
				LogError(tt);
				continue;
			}
			j++;
			char serstr[20];
			LongToHexChunks(pc->serial,serstr);
			sprintf(temp, "%i) %s %s", (j-1), pc->name, serstr);
			Player->Msg(temp);
		}
	}
	sprintf(temp,"Total Users Online: %d\n", j);
	Player->Msg(temp);
	Player->Msg("End of userlist");
}

void command_gms(P_PLAYER Player)
{
	int j=0;
	Player->Msg("Current GMs and Counselors in the world:");

	P_CHAR pc;
	AllPlayersIterator api;
	for (pc = api.First(); pc != NULL; pc = api.Next())
	{
		if (pc->isCounselor()) //Keeps NPC's from appearing on the list
		{
			j++;
			Player->Msg(pc->name);
		}
	}
	sprintf(temp, "Total Staff Online: %d\n", j);
	Player->Msg(temp);
	Player->Msg("End of stafflist");
}

void command_regspawnall(P_PLAYER Player)
{
	sysbroadcast("ALL Regions Spawning to MAX, this will cause some lag.");
	
	int spawned=AllSpawnMax();

	sprintf(temp, "Done. %d total NPCs/items spawned in %d regions.", spawned, NumberOfSpawnRegions());
	Player->Msg(temp);
}

void command_wipenpcs(P_PLAYER Player)
{
	int deleted = 0;
	
	P_CHAR pc;
	AllCharsIterator aci;
	for (aci.Begin(); (pc=aci.GetData()) != NULL; aci++)
	{
        if (pc->npc && !pc->isAiVendor() && !pc->tamed) // Ripper
		{			
			Npcs->DeleteChar(pc);
			deleted++;
		}
	}
	
	if (SrvParms->gm_log) 
	{ 
		char temp2[1024];
		sprintf(temp,"%s.log",Player->name); 
		sprintf(temp2,"npc wipe done, %i npcs deleted\n",deleted); 
		savelog(temp2,temp); 
	}

	gcollect();

	sprintf(temp,"All NPC's have been wiped (%i).", deleted);
	Player->Msg(temp);
}

void command_cleanup(P_PLAYER Player)
{
	int corpses=0;
	char temp[100];
	
	Player->Msg("Cleaning corpses and closing gates...");
	PC_ITEM pi;
	AllItemsIterator aii;
	for (aii.Begin(); (pi = aii.GetData()) != aii.End(); aii++)
	{
		if (pi->corpse==1 || pi->isType(ITY_Gate1) || pi->isType(ITY_Gate2))
		{
			Items->DeleItem(pi->unconst());
			corpses++;
		}
	}
	gcollect();
	Player->Msg("Done.");
	sprintf(temp, "%i corpses or gates have been cleaned.",corpses);
	Player->Msg(temp);
}

void command_delid(P_PLAYER Player)
{
	if (tnum != 3)
	{
		Player->Msg("Syntax Error. Usage: /delid <id1> <id2>" );
		return;
	}

	short id = (hexnumber(1)<<8)+hexnumber(2);
	PC_ITEM pi;
	AllItemsIterator aii;
	for (aii.Begin(); (pi = aii.GetData()) != aii.End(); aii++)
	{
		if (pi->id() == id)
			Items->DeleItem( pi->unconst() );
	}
}

void command_deltype(P_PLAYER Player)
{
	if (tnum != 2)
	{
		Player->Msg("Syntax Error. Usage: /deltype <type>" );
		return;
	}

	unsigned int type = makenumber( 1 );
	PC_ITEM pi;
	AllItemsIterator aii;
	for (aii.Begin(); (pi = aii.GetData()) != aii.End(); aii++)
	{
		if ( pi->isType(type) )
			Items->DeleItem( pi->unconst() );
	}
}

// blackwind system message 
void command_sysm(P_PLAYER Player) 
{ 
	if (now == 1)
	{ 
		Player->Msg("There are no other users connected."); 
		return; 
	}	
	strcpy(xtext[Player->cs], Commands->GetAllParams().c_str()); 
	sysbroadcast(xtext[Player->cs]); 
} 

void command_jail(P_PLAYER Player)
// (d) Jails the target with given secs.
{
	int jsecs = SrvParms->default_jail_time;
	if (tnum == 2)
	{
		jsecs = makenumber(1);
		sprintf(temp, "Select Character to jail. [Jailtime: %i secs]", jsecs);
		target(Player, T_126, temp);
	}
	else
	{
		sprintf(temp, "Select Character to jail. [Jailtime:Server default of %i secs]", jsecs);
		target(Player, T_126, temp);
	}
	addmitem[Player->cs] = jsecs; // We temporary use addmitem for jail secs.
}

void command_setGmMoveEff(P_PLAYER Player)	// (h) set your movement effect (by Aldur) 
{
	if (tnum == 2)
		Player->gmMoveEff = makenumber(1);
}

void command_password(P_PLAYER Player)		// (text) Changes the account password
{
	if ( tnum > 1 )
	{
		char pwd[200] = {0,};
		strncpy(pwd, &tbuffer[Commands->cmd_offset+9], 198);
		if (!isalpha(pwd[0]) && !isdigit(pwd[0]))
		{
			Player->Msg("Passwords must start with a letter or a number\n");
			return;
		}
		if (Accounts->ChangePassword(Player->account, pwd)) 
		{
			sprintf(temp,"Password changed to %s", &tbuffer[Commands->cmd_offset+9]);
			Player->Msg(temp);
		}
		else 
		{
			Player->Msg("Some Error occured while changing password!");
		}
	}
	else 
		Player->Msg("You must digit 'PASSWORD <newpassword>");
}

void command_gift(P_PLAYER Player) 
// (d) script # of item to distribute. 
{
	if (tnum != 3)	return;	// wrong number of arguments

	int sin = makenumber(1);
	script1[0]=0;
	strcpy(script1, Commands->params[2].c_str());
	strupr(script1);
	int who = 0;
	if (!strcmp("ONLINE",script1)) who = 1;
	if (!strcmp("ACCOUNT",script1)) who = 2;
	if (!strcmp("PLAYER",script1)) who = 3;
	if (!who)
	{
		Player->Msg("Syntax: gift <item#> ONLINE or ACCOUNT or PLAYER");
		return;
	}

	P_CHAR pc;
	switch (who)
	{
	case 1:	// to all online players
		{
			AllPlayersIterator api;
			for (pc = api.First(); pc != NULL; pc = api.Next())
			{
				pc->AddGift(sin);
			}
		}
		break;
	case 2:	// to the first char on each account
		Accounts->AddGift(sin);
		break;
	case 3:	// to every player char
		AllCharsIterator aci;
		for (aci.Begin(); (pc=aci.GetData()) != NULL; aci++)
		{
			if (pc->npc) continue;
			pc->AddGift(sin);
		}
		break;
	}
}

void command_eraseaccount(P_PLAYER Player) 
// (d) account # to delete 
{
	if (tnum != 2)	// wrong number of arguments
	{
		Player->Msg("Syntax: eraseaccount <account#>");
		return;
	}

	int noc = 0;
	int acc = makenumber(1);
	P_CHAR pc;
	AllCharsIterator aci;
	for (aci.Begin(); (pc=aci.GetData()) != NULL; aci++)
	{
		if (pc->npc) continue;
		if (pc->account == acc)
		{
			Npcs->DeleteChar(pc);
			noc++;
		}
	}
	Accounts->RemoveAccount(acc);
	sprintf(temp,"Erased %i characters",noc);
	Player->Msg(temp);
}

void command_createaccount(P_PLAYER Player) 
{
	if (tnum != 3)	// wrong number of arguments
	{
		Player->Msg("Syntax: createaccount <account> <password>");
		return;
	}

	char acct[256];
	char pass[256];

	if ( (makestring(1,acct,false)) && (makestring(2,pass,false)) )
	{
		if (Accounts->CheckExistence(acct))
		{
			Player->Msg("Error: account already exists");
			return;
		}

		Accounts->CreateAccount(acct,pass);
		sprintf(temp,"Account '%s' with pass '%s' created",acct,pass);
		Player->Msg(temp);
	}
	else Player->Msg("Error: account could not be created");
}

void command_qsfimport(P_PLAYER Player) 
{
	if (tnum != 2)	// wrong number of arguments
	{
		Player->Msg("Syntax: qsfimport <filename>");
		return;
	}
	char fn[300];
	strcpy(fn, Commands->params[1].c_str());
	qsfLoad(fn, 0);
}

void command_qsfexport(P_PLAYER Player) 
{
	if (tnum != 2)	// wrong number of arguments
	{
		Player->Msg("Syntax: qsfexport <filename>");
		return;
	}
	char fn[300];
	strcpy(fn, Commands->params[1].c_str());
	qsfExport(fn);
}

void command_qsfremove(P_PLAYER Player) 
{
	if (tnum != 2)	// wrong number of arguments
	{
		Player->Msg("Syntax: qsfremove <filename>");
		return;
	}
	char fn[300];
	strcpy(fn, Commands->params[1].c_str());
	qsfRemove(fn, 0);
}

void command_qsfwhere(P_PLAYER Player) 
{
	if (tnum != 1)	// wrong number of arguments
	{
		Player->Msg("Syntax: qsfwhere");
		return;
	}
	char msg[300];
	sprintf(msg,"QSF-block is %4.4X",qsfWhere(Player->pos));
	Player->Msg(msg);
}

void command_devtest(P_PLAYER Player)
{
	target(Player, T_58, "Select target for devtest"); 
}

void command_privhide(P_PLAYER Player)
{
	if (!Player->PrivHide())
	{
		Player->PrivHideOn();
		Player->Msg("PrivHide toggled to ON");
	}
	else
	{
		Player->PrivHideOff();
		Player->Msg("PrivHide toggled to OFF");
	}
}

void command_guildtalk(P_PLAYER Player)
{
	if (Player->guildnumber==0) 
	{
		Player->Msg("you are in no guild");
		Player->Msg("hence using the GUILD talk command is rather pointless");
		return;
	}
	
	int l=Commands->GetAllParams().size();
	if (l<=0) 
	{
		Player->Msg("silence can not be broadcasted");
		return;
	} 
	else if (l>300) 
	{
		Player->Msg("too much data to broadcast");
		return;
	}
	
	AllPlayersIterator api;
	P_CHAR pc; 
	for (pc = api.First(); pc != NULL; pc = api.Next())
	{
		if (!Player->isSameAs(pc))
		{
			int g = Guilds->Compare(Player, pc);
			if (g==2) // if same guild
			{
				char data[512];				
				sprintf(data, "GUILDTALK from %s", Player->name);
				pc->Msg(3, data);
				
				strcpy(data, Commands->GetAllParams().c_str());
				pc->Msg(5, data);
			}
		}
	}
}

void command_golseed(P_PLAYER Player)
{
	if (tnum != 9)	// wrong number of arguments
	{
		Player->Msg("Syntax: golseed <gol.scp section> <universe size> <item script num> <intervall time> <cycles> <color effect> <0> <0>");
		return;
	}
	
	int pattern,size, intervall, cycles,eff2,eff3,eff4,script;
	pattern=makenumber(1);
	size=makenumber(2);
	script=makenumber(3);
	intervall=makenumber(4);
	cycles=makenumber(5);
	eff2=makenumber(6);
	eff3=makenumber(7);
	eff4=makenumber(8);
	
	cLife* x = new cLife(pattern, size, Player->pos, script, intervall, cycles, eff2, eff3, eff4);
	golSeeds.push_back(x);
	x->print();
}

void command_golremoveall(P_PLAYER Player)
{
	unsigned int a;int ctr=0;
	
	for (a=0; a<golSeeds.size();a++)
	{	
		int ser=golSeeds[a]->getSeedSerial();
		P_ITEM pi = FindItemBySerial(ser);
		pi->setType(ITY_Last); // deleitem has special treatment for GOL_SEED items, which would screw everytihng here. "cloak" as normal item
		if (pi!=NULL) Items->DeleItem(pi);	
		delete golSeeds[a];
		ctr++;
	}

	golSeeds.clear();

	char tmp[512];
	sprintf(tmp, "%i GOLSEEDS removed",ctr);
	Player->Msg(tmp);
}
void command_sstats(P_PLAYER Player)
{
	int totalitems=0;
	int totalgold=0;
	int modified=0;
	cMapRectangle permudaTriangle(0,0,200,200);
	int outOnTheSea=0;
	
	PC_ITEM pi;
	AllItemsIterator aii;
	for (aii.Begin(); (pi = aii.GetData()) != aii.End(); aii++)
	{
		if (pi->id()==0x0EED) totalgold += pi->amount;
		if (pi->HasChanged()) modified++;
		totalitems++;
		if (pi->isInWorld() && pi->pos.IsIn(permudaTriangle)) outOnTheSea++;
	}
	char msg[100];
	sprintf(msg,"Total gold: %i",totalgold);
	Player->Msg(msg);
	sprintf(msg,"Modified items: %i/%i",modified,totalitems);
	Player->Msg(msg);
	sprintf(msg,"Out on the sea: %i",outOnTheSea);
	Player->Msg(msg);
}

void command_pofj(P_PLAYER Player)
{
	if (tnum != 2)	// wrong number of arguments
	{
		Player->Msg("Syntax: pofj <# of char in account>");
		return;
	}

#if EXP1
	int x = makenumber(1);
	if (x < 1)
	{
		Player->Msg("The first char is *1*");
		return;
	}
	x -= 1;

	P_PLAYER Other = Npcs->findPlayerByAccount(Player->account,x);
	if (!Other)
	{
		Player->Msg("No char at that position");
		return;
	}

	Other->hungertimer.setSecs(SrvParms->hungerrate);

	Other->automode = true;
	Other->npcWander=0;
	Other->npcaitype=14;
	Other->SetOwnSerial(Player->serial);
	teleport(Other, Other->pos); // make char show up
#endif
}

void command_pofs(P_PLAYER Player)
{
	if (tnum != 2)	// wrong number of arguments
	{
		Player->Msg("Syntax: pofs <# of char in account>");
		return;
	}

#if EXP1
	int x = makenumber(1);
	if (x < 1)
	{
		Player->Msg("The first char is *1*");
		return;
	}
	x -= 1;

	cCoord oldPos = Player->pos;
	P_PLAYER Other = Npcs->findPlayerByAccount(Player->account,x);
	Player->travelTo(Other->pos);

	setCurrSerial(gameSerial(Player->serial),Other);
	setcurrchar(Player->cs,Other->GetIndex());
	Other->cs = Player->cs;
	Player->cs = -1;
	mapRegions->Add(Other);

	int ci=0,loopexit=0;
	P_ITEM pi;
	while ( ((pi=Player->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		SndRemoveItemToAll(pi,true);
	}

//	SndRemoveNpcToAll(Other,true);
//	impowncreate(Other->cs,Other,Other->pos.z);
	teleport(Other, Other->pos); // change gender
//	wornitems(Other->cs,Other);
	statwindow(Other,Other);
	skillwindow(Other->cs,Other);
//	SndPaperdoll(Other,Other);	// doesn't help; only works when PD was NOT open :(

	Player->automode = true;
	Player->npcWander=0;
	Player->npcaitype=14;
	Player->travelTo(oldPos);
//	Player->SetOwnSerial(Other->serial);
#endif
}

void cCommands::add(char* cmd, int privByte, int privBit, int type, struct target_s* tarptr)
{
	cmdtable_s* cte = new cmdtable_s;
	cte->cmd_name = cmd;
	cte->cmd_priv_m = privByte;	// PRIV3 byte# - 0-6, 255=no privs needed
	cte->cmd_priv_b = privBit;	// PRIV3 bit within byte - 0-31
	cte->cmd_type = type;		// Type of command - see above
	cte->cmd_extra = (void*)tarptr;		// extra data - see above
	command_table.push_back(*cte);
}
void cCommands::add(char* cmd, int privByte, int privBit, int type, void (*fp) (P_PLAYER) )
{
	cmdtable_s* cte = new cmdtable_s;
	cte->cmd_name = cmd;
	cte->cmd_priv_m = privByte;		// PRIV3 byte# - 0-6, 255=no privs needed
	cte->cmd_priv_b = privBit;		// PRIV3 bit within byte - 0-31
	cte->cmd_type = CMD_FUNCP;		// Type of command - see above
	cte->cmd_extra = (void*)fp;		// extra data - see above
	command_table.push_back(*cte);
}
void cCommands::init()
{
	add("SETGMMOVEEFF",	0, 21,	CMD_FUNCP,		&command_setGmMoveEff);
	add("BOUNTY",		255,0,  CMD_FUNCP,		&command_bounty);
	add("POST",			1,  2,  CMD_FUNCP,		&command_post);
	add("GPOST",		1,  2,  CMD_FUNCP,		&command_gpost);
	add("RPOST",		1,  2,  CMD_FUNCP,		&command_rpost);
	add("LPOST",		1,  2,  CMD_FUNCP,		&command_lpost);
	add("SHOWP",		255,0,	CMD_FUNCP,		&command_showp);
	add("SETPRIV3",		0,	0,	CMD_FUNCP,		&command_setpriv3);
	add("USE",			0,	1,	CMD_TARGET,		&target_use);
	add("RESEND",		0,	2,	CMD_FUNCP,		&command_resend);
	add("POINT",		0,	3,	CMD_FUNCP,		&command_point);
	add("WHERE",		0,	4,	CMD_FUNCP,		&command_where);
//	add("ADDU",			0,	5,	CMD_ITEMMENU,	(CMD_DEFINE)1); // Opens the GM add menu.
	add("Q",			0,	6,	CMD_FUNCP,		&command_q);
	add("NEXT",			0,	7,	CMD_FUNCP,		&command_next);
	add("CLEAR",		0,	8,	CMD_FUNCP,		&command_clear);
	add("GOTOCUR",		0,	9,	CMD_FUNCP,		&command_gotocur);
	add("GMTRANSFER",	0,	10,	CMD_FUNCP,		&command_gmtransfer);
	add("JAIL",			0,  27, CMD_FUNCP,		&command_jail);
	add("RELEASE",		0,	12,	CMD_TARGET,		&target_release);
	add("ISTATS",		0,	13,	CMD_TARGET,		&target_istats);
	add("CSTATS",		0,	14,	CMD_TARGET,		&target_cstats);
	add("GOPLACE",		0,	15,	CMD_FUNCP,		&command_goplace);
	add("GOCHAR",		0,	16,	CMD_FUNCP,		&command_gochar);
	add("FIX",			0,	17,	CMD_FUNCP,		&command_fix);
	add("XGOPLACE",		0,	18,	CMD_FUNCP,		&command_xgoplace);
	add("SHOWIDS",		0,	19,	CMD_FUNCP,		&command_showids);
	add("POLY",			0,	20,	CMD_FUNCP,		&command_poly);
	add("SKIN",			0,	21,	CMD_FUNCP,		&command_skin);
	add("ACTION",		0,	22,	CMD_FUNCP,		&command_action);
	add("TELE",			0,	23,	CMD_TARGET,		&target_tele);
	add("XTELE",		0,	24,	CMD_FUNCP,		&command_xtele);
	add("GO",			0,	25,	CMD_FUNCP,		&command_go);
	add("XGO",			0,	26,	CMD_TARGETPOS,	&target_xgo);
	add("SETMOREX",		0,	27,	CMD_TARGETX,	&target_setmorex);
	add("SETMOREY",		0,	28,	CMD_TARGETX,	&target_setmorey);
	add("SETMOREZ",		0,	29,	CMD_TARGETX,	&target_setmorez);
	add("ZEROKILLS",	0,	30,	CMD_FUNCP,		&command_zerokills);
	add("SETMOREXYZ",	0,	31,	CMD_TARGETXYZ,	&target_setmorexyz);
	add("SETHEXMOREXYZ",1,	0,	CMD_TARGETHXYZ,	&target_sethexmorexyz);
	add("SETNPCAI",		1,	1,	CMD_TARGETHX,	&target_setnpcai);
	add("XBANK",		1,	2,	CMD_TARGET,		&target_xbank);
	add("XSBANK",		1,	2,	CMD_TARGET,		&target_xsbank);//AntiChrist
	add("TILE",			1,	3,	CMD_FUNCP,		&command_tile);
	add("WIPE",			1,	4,	CMD_FUNCP,		&command_wipe);
	add("IWIPE",		1,	5,	CMD_FUNCP,		&command_iwipe);
	add("ADD",			1,	6,	CMD_FUNCP,		&command_add);
	add("ADDX",			1,	7,	CMD_FUNCP,		&command_addx);
	add("RENAME",		1,	8,	CMD_FUNCP,		&command_rename);
	add("TITLE",		1,	9,	CMD_FUNCP,		&command_title);
	add("SAVE",			1,	10,	CMD_FUNCP,		&command_save);
	add("REMOVE",		1,	11,	CMD_TARGET,		&target_remove);
	add("TRAINER",		1,	12,	CMD_TARGET,		&target_trainer);
	add("DYE",			1,	13,	CMD_FUNCP,		&command_dye);
	add("SETTYPE",		1,	15,	CMD_TARGETX,	&target_settype);
	add("ITRIG",		1,	16,	CMD_TARGETX,	&target_itrig);
	add("CTRIG",		1,	17,	CMD_TARGETX,	&target_ctrig);
	add("TTRIG",		1,	18,	CMD_TARGETX,	&target_ttrig);
	add("WTRIG",		1,	19,	CMD_FUNCP,		&command_wtrig);
	add("SETID",		1,	20,	CMD_TARGETHXY,	&target_setid);
	add("SETPRIV",		1,	21,	CMD_FUNCP,		&command_setpriv);
	add("NODECAY",		4,	30,	CMD_FUNCP,		&command_nodecay);
	add("SEND",			255,0,	CMD_FUNCP,		&command_send);
	add("SHOWTIME",		1,	23,	CMD_FUNCP,		&command_showtime);
	add("SETTIME",		5,	2,	CMD_FUNCP,		&command_settime);
	add("SETMORE",		1,	24,	CMD_TARGETHID4,	&target_setmore);
	add("SETMORE2",		1,	24,	CMD_TARGETHID4,	&target_setmore2);
	add("SHUTDOWN",		1,	25,	CMD_FUNCP,		&command_shutdown);
	add("MAKEGM",		1,	26,	CMD_TARGET,		&target_makegm);
	add("MAKECNS",		1,	27,	CMD_TARGET,		&target_makecns);
	add("KILLHAIR",		1,	28,	CMD_TARGET,		&target_killhair);
	add("KILLBEARD",	1,	29,	CMD_TARGET,		&target_killbeard);
	add("KILLPACK",		1,	30,	CMD_TARGET,		&target_killpack);
	add("SETFONT",		1,	31,	CMD_TARGETHID1,	&target_setfont);
	add("WHOLIST",		2,	0,	CMD_FUNCP,		&command_wholist);
	add("PLAYERLIST",	2,	0,	CMD_FUNCP,		&command_playerlist);
	add("KILL",			2,	1,	CMD_TARGET,		&target_kill);
	add("RESURRECT",	2,	2,	CMD_TARGET,		&target_resurrect);
	add("RES",			2,	2,	CMD_TARGET,		&target_resurrect);
	add("BOLT",			2,	3,	CMD_TARGET4OPT,	&target_bolt);
	add("BAN",			2,	3,	CMD_TARGET,		&target_ban);
	add("UNBAN",		2,	3,	CMD_TARGET,		&target_unban);
	add("SFX",			2,	4,	CMD_FUNCP,		&command_sfx);
	add("NPCACTION",	2,	5,	CMD_TARGETHID1,	&target_npcaction);
	add("LIGHT",		2,	6,	CMD_FUNCP,		&command_light);
	add("SETAMOUNT",	2,	7,	CMD_TARGETX,	&target_setamount);
	add("SETAMOUNT2",	2,	8,	CMD_TARGETX,	&target_setamount2);
	add("DISCONNECT",	2,	9,	CMD_FUNCP,		&command_disconnect);
	add("KICK",			2,	10,	CMD_TARGET,		&target_kick);
	add("TELL",			2,	11,	CMD_FUNCP,		&command_tell);
	add("DRY",			2,	12,	CMD_FUNCP,		&command_dry);
	add("RAIN",			2,	13,	CMD_FUNCP,		&command_rain);
	add("SNOW",			2,	14,	CMD_FUNCP,		&command_snow);
	add("GMMENU",		2,	15,	CMD_FUNCP,		&command_gmmenu);
	add("ITEMMENU",		2,	16,	CMD_FUNCP,		&command_itemmenu);
	add("ADDITEM",		2,	17,	CMD_FUNCP,		&command_additem);
	add("DUPE",			2,	18,	CMD_FUNCP,		&command_dupe);
	add("MOVETOBAG",	2,	19,	CMD_TARGET,		&target_movetobag);
	add("COMMAND",		2,	20,	CMD_FUNCP,		&command_command);
	add("GCOLLECT",		2,	21,	CMD_FUNCP,		&command_gcollect);
	add("ALLMOVEON",	2,	22,	CMD_FUNCP,		&command_allmoveon);
	add("ALLMOVEOFF",	2,	23,	CMD_FUNCP,		&command_allmoveoff);
	add("SHOWHS",		2,	24,	CMD_FUNCP,		&command_showhs);
	add("HIDEHS",		2,	25,	CMD_FUNCP,		&command_hidehs);
	add("VIEWDEPTH",	3,	15,	CMD_FUNCP,		&command_viewdepth);
	add("SETMOVABLE",	2,	26,	CMD_TARGETX,	&target_setmovable);
	add("SET",			2,	27,	CMD_FUNCP,		&command_set);
	add("SETVISIBLE",	2,	28,	CMD_TARGETX,	&target_setvisible);
	add("SETDIR",		2,	29,	CMD_TARGETX,	&target_setdir);
	add("SETSPEECH",	2,	30,	CMD_TARGETX,	&target_setspeech);
	add("SETOWNER",		2,	31,	CMD_TARGETHID4,	&target_setowner);
	add("ADDNPC",		3,	0,	CMD_FUNCP,		&command_addnpc);
	add("FREEZE",		3,	1,	CMD_TARGET,		&target_freeze);
	add("UNFREEZE",		3,	2,	CMD_TARGET,		&target_unfreeze);
	add("GUMPMENU",		3,	4,	CMD_FUNCP,		&command_gumpmenu);
	add("TILEDATA",		3,	5,	CMD_TARGET,		&target_tiledata);
	add("RECALL",		3,	6,	CMD_TARGET,		&target_recall);
	add("MARK",			3,	7,	CMD_TARGET,		&target_mark);
	add("GATE",			3,	8,	CMD_TARGET,		&target_gate);
	add("HEAL",			3,	9,	CMD_TARGET,		&target_heal);
	add("NPCTARGET",	3,	10,	CMD_TARGET,		&target_npctarget);
	add("NPCRECT",		3,	12,	CMD_FUNCP,		&command_npcrect);
	add("NPCCIRCLE",	3,	13,	CMD_FUNCP,		&command_npccircle);
	add("NPCWANDER",	3,	14,	CMD_FUNCP,		&command_npcwander);
	add("TWEAK",		3,	15,	CMD_TARGET,		&target_tweak);
//	add("SBOPEN",		3,	16,	CMD_TARGET,		&target_sbopen);
	add("SECONDSPERUOMINUTE",3,17,CMD_FUNCP,	&command_secondsperuominute);
	add("BRIGHTLIGHT",	3,	18,	CMD_FUNCP,		&command_brightlight);
	add("DARKLIGHT",	3,	19,	CMD_FUNCP,		&command_darklight);
	add("DUNGEONLIGHT",	3,	20,	CMD_FUNCP,		&command_dungeonlight);
	add("TIME",			3,	21,	CMD_FUNCP,		&telltime);
	add("MANA",			3,	22,	CMD_TARGET,		&target_mana);
	add("STAMINA",		3,	23,	CMD_TARGET,		&target_stamina);
	add("GMOPEN",		3,	24,	CMD_FUNCP,		&command_gmopen);
	add("MAKESHOP",		3,	25,	CMD_TARGET,		&target_makeshop);
	add("BUY",			3,	26,	CMD_TARGET,		&target_buy);
	add("SETVALUE",		3,	27,	CMD_TARGETX,	&target_setvalue);
	add("SETRESTOCK",	3,	28,	CMD_TARGETX,	&target_setrestock);
	add("RESTOCK",		3,	29,	CMD_FUNCP,		&command_restock);
	add("RESTOCKALL",	3,	30,	CMD_FUNCP,		&command_restockall);
	add("SETSHOPRESTOCKRATE",3,31,CMD_FUNCP,	&command_setshoprestockrate);
	add("WHO",			4,	0,	CMD_FUNCP,		&command_who);
	add("GMS",			4,	1,	CMD_FUNCP,		&command_gms);
	add("SELL",			4,	2,	CMD_TARGET,		&target_sell);
	add("MIDI",			4,	3,	CMD_FUNCP,		&command_midi);
	add("GUMPOPEN",		4,	4,	CMD_FUNCP,		&command_gumpopen);
	add("RESPAWN",		4,	5,	CMD_FUNCP,		&command_respawn);
	add("REGSPAWNALL",	4,	5,	CMD_FUNCP,		&command_regspawnall);
	add("REGSPAWNMAX",	4,	5,	CMD_FUNCP,		&command_regspawnmax);
	add("REGSPAWN",		4,	5,	CMD_FUNCP,		&command_regspawn);
	add("SETSPATTACK",	4,	6,	CMD_TARGETHTMP,	&target_setspattack);
	add("SETSPADELAY",	4,	7,	CMD_TARGETHTMP,	&target_setspadelay);
	add("SETPOISON",	4,	8,	CMD_TARGETHTMP,	&target_setpoison);
	add("SETPOISONED",	4,	9,	CMD_TARGETHTMP,	&target_setpoisoned);
	add("SETADVOBJ",	4,	10,	CMD_TARGETHTMP,	&target_setadvobj);
	add("SETWIPE",		4,	11,	CMD_TARGETID1,	&target_setwipe);
	add("FULLSTATS",	4,	12,	CMD_TARGET,		&target_fullstats);
	add("HIDE",			4,	13,	CMD_TARGET,		&target_hide);
	add("UNHIDE",		4,	14,	CMD_TARGET,		&target_unhide);
	add("RELOADSERVER",	4,	15,	CMD_FUNCP,		&command_reloadserver);
	add("LOADDEFAULTS",	4,	16,	CMD_FUNCP,		&command_loaddefaults);
	add("CQ",			4,	17,	CMD_FUNCP,		&command_cq);
	add("WIPENPCS",		4,	18,	CMD_FUNCP,		&command_wipenpcs);
	add("CNEXT",		4,	19,	CMD_FUNCP,		&command_cnext);
	add("CCLEAR",		4,	20,	CMD_FUNCP,		&command_cclear);
	add("MINECHECK",	4,	21,	CMD_FUNCP,		&command_minecheck);
	add("INVUL",		4,	22,	CMD_FUNCP,		&command_invul);
	add("NOINVUL",		4,	23,	CMD_FUNCP,		&command_noinvul);
	add("GUARDSON",		4,	24,	CMD_FUNCP,		&command_guardson);
	add("GUARDSOFF",	4,	25,	CMD_FUNCP,		&command_guardsoff);
	add("HOUSE",		4,	26,	CMD_TARGETHTMP,	&target_house);
	add("ANNOUNCEON",	4,	27,	CMD_FUNCP,		&command_announceon);
	add("ANNOUNCEOFF",	4,	28,	CMD_FUNCP,		&command_announceoff);
	add("WF",			4,	29,	CMD_FUNCP,		&command_wf);
	add("DECAY",		1,	22,	CMD_FUNCP,		&command_decay);
	add("SPLIT",		4,	31,	CMD_TARGETHTMP,	&target_split);
	add("SPLITCHANCE",	5,	0,	CMD_TARGETHTMP,	&target_splitchance);
	add("POSSESS",		5,	1,	CMD_TARGET,		&target_possess);
	add("KILLALL",		5,	3,	CMD_FUNCP,		&command_killall);
	add("PDUMP",		5,	4,	CMD_FUNCP,		&command_pdump);
	add("RENAME2",		5,	5,	CMD_FUNCP,		&command_rename2);
	add("READSPAWNREGIONS",5,6,	CMD_FUNCP,		&command_readspawnregions);
	add("CLEANUP",		5,	7,	CMD_FUNCP,		&command_cleanup);
	add("GY",			5,	8,	CMD_FUNCP,		&command_gy);
	add("TILEW",		5,	9,	CMD_FUNCP,		&command_tilew);
	add("SQUELCH",		5,	10,	CMD_FUNCP,		&command_squelch);
	add("MUTE",			5,	10,	CMD_FUNCP,		&command_squelch);
	add("TELESTUFF",	5,	11,	CMD_TARGET,		&target_telestuff);
	add("SPAWNKILL",	5,	12,	CMD_FUNCP,		&command_spawnkill);
	add("SHOWPRIV3",	5,	13,	CMD_TARGET,		&target_showpriv3);
	add("NEWX",			5,	14,	CMD_TARGETX,	&target_newx);
	add("NEWY",			5,	15,	CMD_TARGETX,	&target_newy);
	add("NEWZ",			1,	14,	CMD_TARGETX,	&target_newz);
	add("INCX",			5,	16,	CMD_TARGETX,	&target_incx);
	add("INCY",			5,	17,	CMD_TARGETX,	&target_incy);
	add("INCZ",			6,	1,	CMD_TARGETX,	&target_incz);
	add("WANIM",		5,	18,	CMD_FUNCP,		&command_wanim);
	add("READACCOUNTS",	5,	20, CMD_FUNCP,		&command_readaccounts);
	add("LETUSIN",		5,	21, CMD_FUNCP,		&command_letusin);
	add("SERVERSLEEP",	5,	22, CMD_FUNCP,		&command_serversleep);
	add("RELOADCACHEDSCRIPTS",5,23,CMD_FUNCP,	&command_reloadcachedscripts);
	add("SETMURDER",	5,	26, CMD_FUNCP,		&command_setmurder);//taken from 6904t2(5/10/99) - AntiChrist
	add("GLOW",			5,	25,	CMD_TARGET,		&target_glow);
	add("UNGLOW",		5,	26,	CMD_TARGET,		&target_unglow);
//	add("SETMENUPRIV",	5,	27,	CMD_FUNC,		&command_setmenupriv);
	add("SHOWSKILLS",	5,	28,	CMD_TARGETX,	&target_showskills);
	add("TILESCRIPT",	5,	29, CMD_FUNCP,		&command_tilescript);
	add("KILLNPCS",		5,	30, CMD_FUNCP,		&command_killnpcs);
	add("SWAP",			5,	31, CMD_FUNCP,		&command_swap);
	add("REVERTSWAP",	6,	0,	CMD_TARGETX,	&target_setrevertswap);
	add("CLONENPC",		6,	5,	CMD_TARGET4OPT,	&target_clonenpc);
	add("KILLCLONES",	6,	6,	CMD_FUNCP,		&command_killclones);
	add("DELID",		2,	35,	CMD_FUNCP,		&command_delid);
	add("DELTYPE",		2,	36,	CMD_FUNCP,		&command_deltype);
	add("SETSEASON",	2,	13,	CMD_FUNCP,		&command_setseason);
	add("SYSM",			5,  8,  CMD_FUNCP,		&command_sysm);
	add("PASSWORD",		5,	19,	CMD_FUNCP,		&command_password);
	add("GIFT",			6,	2,	CMD_FUNCP,		&command_gift);
	add("SETC",			6,	3,	CMD_TARGETSTR,	&target_setc);
	add("SETI",			6,	3,	CMD_TARGETSTR,	&target_seti);
	add("ERASEACCOUNT",	6,	4,	CMD_FUNCP,		&command_eraseaccount);
	add("CREATEACCOUNT",6,	4,	CMD_FUNCP,		&command_createaccount);
	add("QSFIMPORT",	6,	7,	CMD_FUNCP,		&command_qsfimport);
	add("QSFEXPORT",	6,	7,	CMD_FUNCP,		&command_qsfexport);
	add("QSFREMOVE",	6,	7,	CMD_FUNCP,		&command_qsfremove);
	add("QSFWHERE",		6,	7,	CMD_FUNCP,		&command_qsfwhere);
	add("MAKEPLAYERPOSFILE",6,8,CMD_FUNCP,		&command_makeplayerposfile);
	add("DEVTEST",		6,	9,	CMD_FUNCP,		&command_devtest);
	add("PERMACT",		6,	10,	CMD_TARGET4OPT,	&target_permact);
	add("PRIVHIDE",		6,	11,	CMD_FUNCP,		&command_privhide);
	add("MAPTRAVEL",	6,  12, CMD_FUNCP,		&command_maptravel); 
	add("CV",			6,  13, CMD_FUNCP,		&command_clientver);
	add("GT",			6,  14, CMD_FUNCP,		&command_guildtalk);
	add("XSAY",			6,	15,	CMD_TARGETSTR,	&target_xsay);
	add("SETSTATLIMITS",6,	16,	CMD_FUNCP,		&command_setstatlimits);
	add("SHOWSTATLIMITS",6,	16,	CMD_FUNCP,		&command_showstatlimits);
	add("SSTATS",		6,	17,	CMD_FUNCP,		&command_sstats);
	add("GOLSEED",		6,	18, CMD_FUNCP,		&command_golseed);
	add("GOLREMOVEALL",	6,	19, CMD_FUNCP,		&command_golremoveall);
	add("UNEQUIP",		6,	20, CMD_TARGET,		&target_unequip);
	add("POFS",			6,	21, CMD_FUNCP,		&command_pofs);
	add("POFJ",			6,	21, CMD_FUNCP,		&command_pofj);
}

// note: 6,7: last meta gm priv level


