/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

/* cmdtable.h - Crackerjack <crackerjack@crackerjack.net> July 24/99
 * This code is an attempt to clean up the messy "if/then/else" routines
 * currently in use for GM commands, as well as adding more functionality
 * and more potential for functionality.
 *
 * Current features:
 * - Actual table of commands to execute, what perms are required, dialog
 *   messages for target commands, etc handled by a central system
 *
 * - /SETPRIV3 user-friendliness - /SETPRIV3 <command> works now instead of
 *   all that cumbersome bitmask math (Eg; /SETPRIV3 SAVE and click on a
 *   char and they get SAVE command perms, /SETPRIV3 !SAVE and click on a
 *   char and their SAVE privs are removed)
 */



#ifndef __CMDTABLE_H__
#define __CMDTABLE_H__

#include "targeting.h"

///////////////////////////////////////////
/*

NOTE: something similar to this (hopefully a bit smarter) will arrive after
the clients ARRAY and it's terrible array-shuffling get kicked out.
in othe words, if we got rid of CArray<MAXCLIENT, ..> 's

 the idea is to retire those cumbersome addxyz... arrays
 but it ultimitvly doesnt make sense to add this class to the array shuffling on login/logout
 what we'd have to do while client arrays still present

*/
///////////////////////////////////////////

/*
#include "CArray.h"
#include "globals.h"

enum mytype{str, integer};

class targetStorage
{
  public:

   inline void clearData(UOXSOCKET s) 
   { 	  
	 unsigned int a; 
	 for (a=0;a<CMAX;a++) 
	 {
	   intPos[s][a]=false; 
	   strPos[s][a]=false;		   
	 } 
   }

   inline void setData(UOXSOCKET s, mytype t, char position, string &st, int i)
   {
	 if (position>=CMAX) return;
	 if (t==str) 
	 {
	   theStrings[s][position]=st;	 
	   strPos[s][position]=true;
	 } 
	 else if (t==integer)
	 {
	   theInts[s][position]=i;	 
	   intPos[s][position]=true;
	 }
   }

   inline void getStringData(UOXSOCKET s, char argnum, string&st, bool ok)
   {
   }

   inline void getIntData(UOXSOCKET s, char argnum, int i, bool ok)
   {
   }

  private:
	CArray<MAXCLIENT, CArray<CMAX, bool> >intPos;
	CArray<MAXCLIENT, CArray<CMAX, bool> >strPos;
	CArray<MAXCLIENT, CArray<CMAX, unsigned int> >theInts;
	CArray<MAXCLIENT, CArray<CMAX, string> >theStrings;
};
*/

/* Types of commands */
#define CMD_TARGET		2	/* Call target struct specified in cmd_extra */
//#define	CMD_FUNC		3	/* Call function specified in cmd_extra	must be of type GMFUNC */
#define CMD_TARGETX		4	/* target with addx[] argument */
#define CMD_TARGETXY	5	/* target with addx & y [] arguments */
#define CMD_TARGETXYZ	6	/* target with addx & y & z [] arguments */
#define CMD_TARGETHX	7	/* target with hex addx[] argument */
#define CMD_TARGETHXY	8	/* target with hex addx & y arguments */
#define CMD_TARGETHXYZ	9	/* target with hex addx & y & z arguments */
#define CMD_TARGETID1	10	/* target with 1 addid # */
#define CMD_TARGETID2	11	/* target with 2 addid #s */
#define CMD_TARGETID3	12	/* target with 3 addid #s */
#define CMD_TARGETID4	13	/* target with 4 addid #s */
#define CMD_TARGETHID1	14	/* target with 1 hex addid # */
#define CMD_TARGETHID2	15	/* target with 2 hex addid #s */
#define CMD_TARGETHID3	16	/* target with 3 hex addid #s */
#define CMD_TARGETHID4	17	/* target with 4 hexaddid #s */
#define CMD_TARGETTMP	18	/* target with tempint */
#define CMD_TARGETHTMP	19	/* target with hex tempint */
#define CMD_TARGET4OPT  20  /* target with up to 4 params in addx,y,z and tempint. num params in addid1. no param required */
#define CMD_TARGETSTR	21  // target with one string as param, for later use in targethandler
#define	CMD_FUNCP		22	// Call function specified in cmd_extra, but with P_PLAYER instead of UOXSOCKET
#define CMD_TARGETPOS	23	// target with x & y & z & m arguments

typedef struct target_s TARGET_S;
struct target_s
{	/* arguments to the target() function */
	eTargets a1;
	char txt[128];
};


#endif /* __CMDTABLE_H */
