/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#if !defined(__COMMANDS_H__)
#define __COMMANDS_H__

#include "platform.h"	// Platform specifics
#include "typedefs.h"
//#include "mstring.h"
#include <string>
#include <vector>
using namespace std ;

class cMapRectangle;
class cCoord;

void InitPages();
void donewithcall(P_PLAYER Player, int type);

struct cmdtable_s
{
	char*			cmd_name;
	unsigned int	cmd_priv_m;	/* PRIV3 byte# - 0-6, 255=no privs needed */
	unsigned int	cmd_priv_b;	/* PRIV3 bit within byte - 0-31 */
	unsigned int	cmd_type;	/* Type of command - see above */
	void*			cmd_extra;	/* extra data - see above */
};

class cCommands
{
private:
	void add(char* cmd, int privByte, int privBit, int type, struct target_s* tarptr);
	void add(char* cmd, int privByte, int privBit, int type, void (*fp) (int) );
	void add(char* cmd, int privByte, int privBit, int type, void (*fp) (P_PLAYER) );

public:
	vector<cmdtable_s> command_table;
	//mstring command_line;
	std::string command_line;

	//vector<mstring> params;
	vector<string> params;
	//mstring GetAllParams(void);
	std::string GetAllParams(void);

	void init();
	void NextCall(P_PLAYER Player, int type);
	//void RepairWorld(int s);
	void KillSpawn(P_PLAYER Player, int r);
	void RegSpawnMax(P_PLAYER Player, int r);
	void RegSpawnNum(P_PLAYER Player, int r, int n);
	void KillAll(P_PLAYER Player, int percent, const char * sysmsg);
	void AddHere(P_PLAYER Player, char z);
	void ShowGMQue(P_PLAYER Player, int type);
	void Wipe(P_PLAYER Player);
	void PartialWipe(P_PLAYER Player, const cMapRectangle& rect, bool inverse);
	void WhoCommand(P_PLAYER Player, int type, int buttonnum);
	void CPage(P_PLAYER Player, char * reason);
	void GMPage(P_PLAYER Player, char * reason);
	bool MakePlace(P_PLAYER Player, int i, cCoord& pos);
	void Command(P_PLAYER Player, string );
	void MakeShop(P_CHAR pc, int shoptype);
	void DyeItem(P_PLAYER Player, int serial, unsigned short color);
	void SetItemTrigger(P_PLAYER Player, P_ITEM pi);
	void SetTriggerType(P_PLAYER Player, P_ITEM pi);
	void SetTriggerWord(P_PLAYER Player, P_CHAR pc);
	void SetNPCTrigger(P_PLAYER Player, P_CHAR pc);
	void DupeItem(P_PLAYER Player, P_ITEM pi, int amount);
	void Possess(P_PLAYER Player);
	int cmd_offset;
	void GMtransfer(P_PLAYER Player);
	void GotoCur(P_PLAYER Player);
	bool GetPageReason(P_PLAYER Player, char* comm);
	std::vector<std::string> split(std::string sep,std::string value);
	void broadcast(P_PLAYER Player, char* text, bool gmonly = false);
};

#endif

