/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#if !defined(__COORD_H__)
#define __COORD_H__


#include "platform.h"	// Platform specifics

class cMapRectangle;	// avoid inclusion of rectangle.h

class cCoord
{
public:

	cCoord(void);
	cCoord(const cCoord& clCoord) ;
//	cCoord(UI16, UI16, SI08, UI08 uiMap = 0);
	// separated the contructors to better find fields of action for multi-map-support (Duke)
	cCoord(UI16, UI16, SI08, UI08 uiMap);
	cCoord(UI16, UI16, SI08);
	// Operators
	cCoord& operator= (const cCoord& clCoord);
	bool operator==(const cCoord&) const;
	cCoord operator+(const cCoord& src) const;

	void reset();
	bool isNotSet() const;
	UI32 distance(const cCoord &src) const;
	bool IsSameXY(const cCoord &other) const;
	bool IsSameXY(short ox, short oy) const;
	bool IsIn(const cMapRectangle& mrect) const;
	void Add(short dx, short dy=0, short dz=0);
	int calcDirTo(const cCoord &other) const;

public:

	UI16 	x;
	UI16 	y;
	SI08 	z;
	UI08    map;
};

#endif
