/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#ifndef __DEBUG_H__
#define __DEBUG_H__

#include <cstdio>
#include <cstdarg>

#ifndef __unix__
// #include <windows.h>
#else
 #include <time.h>
 //#include <varargs.h>
#endif
#if defined _WIN32 
 //#include <crtdbg.h>
#endif
          

//---------------------------------------------------------------------------
//     Prototypes of functions
//---------------------------------------------------------------------------
bool NewErrorsLogged();
bool NewWarningsLogged();
void MessageReady(char *OutputMessage,char type);
void MakeTimeStamp(char *ts);
void LogMessageF(unsigned char Type, long Line, char *File, char *Message, ...);

//---------------------------------------------------------------------------
//     Translator macros for functions
//---------------------------------------------------------------------------
#define LogMessage(Message)	LogMessageF('M', __LINE__, DBGFILE, Message)
#define LogWarning(WarningMessage)	LogMessageF('W', __LINE__, DBGFILE, WarningMessage)
#define LogError(ErrorMessage)	LogMessageF('E', __LINE__, DBGFILE, ErrorMessage)
#define LogCritical(CriticalMessage) LogMessageF('C', __LINE__, DBGFILE, CriticalMessage)

#define LogMessageVar(FormatString,var)	{char t[512];sprintf(t,FormatString,var);LogMessage(t);}
#define LogWarningVar(FormatString,var)	{char t[512];sprintf(t,FormatString,var);LogWarning(t);}
#define LogErrorVar(FormatString,var)	{char t[512];sprintf(t,FormatString,var);LogError(t);}
#define LogCriticalVar(FormatString,var){char t[512];sprintf(t,FormatString,var);LogCritical(t);}
#define LogAssert(expr)					{if (!(expr)){char t[512];sprintf(t,"assert (%s) failed",#expr);LogError(t);}}

#define XStartPkt(packet, laenge) {  PacketSender.prepareDebug(DBGFILE,__LINE__); PacketSender.StartPacketConstruction(packet,laenge); }
#define XAddPkt(data, laenge)     {  PacketSender.prepareDebug(DBGFILE,__LINE__); PacketSender.AddPacketData(data,laenge); }
#define XFinishPkt(s)             {  PacketSender.prepareDebug(DBGFILE,__LINE__); PacketSender.FinishPacket(s); }

#endif

