/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#if !defined(__GLOBALS_H__)
#define __GLOBALS_H__
// Platform specifics
#include "platform.h"
#include "Client.h"
#include "pointer.h"

// System Includes

#include <vector>
#include <map>
#include <list>

#if defined(__unix__)
#include <termios.h>
#endif

#include "netsys.h"			// Needed by fd_set
using namespace std;


// Third Party


//Forward Class Declaration

class Script;
class PacketReader;
class PacketWriter;

//Wolfpack Includes

#include "structs.h"
#include "sregions.h"
#include "SrvParms.h"	// server_data struct
//#include "verinfo.h"
struct wp_version_info;
#include "storage.h"
#include "accounts.h"

// Global Variables
class cConsole;
extern cConsole Console;
extern bool Daemon;
#include "CArray.h"

extern list<connectionAccountSt>connections;


extern unsigned int uiCurrentTime;
extern unsigned int raindroptime;
extern unsigned int polyduration;
extern wp_version_info wp_version;

extern unsigned char numMaps;

/*
Time variables
*/

extern timeLight_st timeLight;

extern int len_connection_addr;
extern struct sockaddr_in connection;
extern struct sockaddr_in client_addr;
extern int err, error;
extern int keeprun;
extern unsigned int a_socket;
extern fd_set conn ;
extern fd_set all ;
extern fd_set errsock ;
extern unsigned int nfds;
extern timeval uoxtimeout;
extern unsigned int now;
extern int serverkey;

extern FILE *wscfile;

extern char debug_network;

extern int global_lis;

class CVirtues;
extern CVirtues *Virtues;

extern char *cline;

extern int tnum;
extern unsigned int starttime, endtime, lclock;
extern unsigned char overflow;

extern unsigned char wtype;

extern int executebatch;
extern int showlayer;
extern int openings;
extern int escortRegions;

extern int shoprestockrate;

extern tracking_st tracking_data;
extern begging_st begging_data;
extern fishing_st fishing_data;
extern speed_st speed;
extern cSrvParms *SrvParms;
extern int triggerx;
extern int triggery;
extern signed char triggerz;

extern unsigned long int serverstarttime;


extern bool lastConnectionDisconned;

extern unsigned long int TotalLoopCount;
extern unsigned long int TotalLoopCountII;
extern unsigned long int LastMeasureCycleLoopCount;
extern unsigned long int TotalCpuTime;
extern unsigned long int sleptTotal;
extern int               TotalMC;
extern unsigned long int TotalEmuTime;
extern unsigned long int LastMeasureCycleTime;
extern const unsigned long int MinMeasureCycleTime;
extern bool firstcycleok;
extern unsigned long int EmuStartTime;
extern bool worldsaved;


extern repsys_st repsys;
extern resource_st resource;

extern Container_cl stablesp, cmultisp, imultisp;
extern ServerList_st serv; // Servers list

extern PacketWriter PacketSender;
extern PacketReader PacketFetcher[MAXCLIENT];

extern unsigned char particleSystem[49];

///////////////////////////////////////////
//          ARRAYS
//////////////////////////////////////////

/////////////////////////////////////////////
///             MAXCLIENT arrays          ///
/////////////////////////////////////////////
// maximum too cause maxclient = maximum +1

extern CArray<MAXCLIENT, antimacro_st>AntiMacro;
extern CArray<MAXCLIENT+1, unsigned long int>LASTRECVTIME;
extern CArray<MAXCLIENT+1, char>noweather; //LB
extern CArray<MAXCLIENT, unsigned char>LSD;
extern CArray<MAXCLIENT, unsigned char>EVILDRAGG; // we need this for UO3D clients to save dragging history , LB
extern CArray<MAXCLIENT, bool>firstpacket;
extern CArray<MAXCLIENT, char>FBERRCNT;

// meta gm variables

extern CArray<MAXCLIENT, int>priv3a; // sorry, my stupidity, (Lord Binary). basically not necassairy. but no time to rewrite now.
extern CArray<MAXCLIENT, int>priv3b; // needed until priv3target rewritten
extern CArray<MAXCLIENT, int>priv3c;
extern CArray<MAXCLIENT, int>priv3d;
extern CArray<MAXCLIENT, int>priv3e;
extern CArray<MAXCLIENT, int>priv3f;
extern CArray<MAXCLIENT, int>priv3g;

// end of meta gm variables


extern CArray<MAXCLIENT, CArray<MAXBUFFER_REAL, char unsigned> >buffer;
extern CArray<(MAXCLIENT)*10, int>whomenudata; 

extern CArray<MAXCLIENT, unsigned int>client;
extern CArray<MAXCLIENT, short int>walksequence;
extern CArray<MAXCLIENT, signed char>addid5;
extern CArray<MAXCLIENT, int>acctno;

//#define currchar currchar_.prepare(DBGFILE,__LINE__)
extern CArray<MAXCLIENT, CHARACTER>currchar_;
inline int currchar(UOXSOCKET s) {return currchar_[s];}
inline void setcurrchar(UOXSOCKET s, int val) {currchar_[s]=val;}

extern CArray<MAXCLIENT,make_st>itemmake;
extern CArray<MAXCLIENT,int>tempint;
extern CArray<MAXCLIENT,unsigned char>addid1;
extern CArray<MAXCLIENT,unsigned char>addid2;
extern CArray<MAXCLIENT,unsigned char>addid3;
extern CArray<MAXCLIENT,unsigned char>addid4;
extern CArray<MAXCLIENT,unsigned char>dyeall;
extern CArray<MAXCLIENT,int>addx;
extern CArray<MAXCLIENT,int>addy;
extern CArray<MAXCLIENT,int>addx2;
extern CArray<MAXCLIENT,int>addy2;
extern CArray<MAXCLIENT,signed char>addz;
extern CArray<MAXCLIENT,int>addmitem;
 
extern CArray<MAXCLIENT,unsigned char>perm;
extern CArray<MAXCLIENT,unsigned char>cryptclient;
extern CArray<MAXCLIENT,unsigned char>usedfree;
 
extern CArray<MAXCLIENT,int>clickx;
extern CArray<MAXCLIENT,int>clicky;
//extern CArray<MAXCLIENT,int>currentSpellType; // 0=spellcast, 1=scrollcast, 2=wand cast
extern CArray<MAXCLIENT,unsigned char>targetok;
extern CArray<MAXCLIENT,unsigned char>clientDimension;

extern CArray<MAXCLIENT,cClientData>clientData;


///////////////////////////////////////////
///   and the rest                        /
///////////////////////////////////////////

#include "sregions.h"

extern CArray<MAXREGIONS, region_st>region;

//#define menupriv menupriv_.prepare(DBGFILE,__LINE__)
//extern CArray<64, CArray<256, signed short> >menupriv_; // for menu priv script

extern CArray<CMAX, unsigned char *>comm;

extern CArray<MAXREGIONS, int>validEscortRegion;
extern CArray<11, jail_st>jails;



/////////////////////////////////////////
///////////// global string vars /////////
/////////////////////////////////////////



extern char xtext[MAXCLIENT][121];
extern char tbuffer[MAXBUFFER_REAL];
extern const unsigned char zeros[1024];
extern start_loc start[MAXSTART]; // startpoints list
extern char spellname[71][25];
extern char script1[512];
extern char script2[512];
extern char script3[512];
extern char gettokenstr[256];

extern char temp[1024];
extern char temp2[1024];
extern char temp3[1024];
extern char schei___[512];

extern char scpfilename[32];//AntiChrist


////////////////////////////////
//  small packet-arrays
///////////////////////////////

extern CArray<3, unsigned int>w_anim;

extern CArray<MAXCLIENT, SERIAL>runebookg;

#ifdef __unix__
extern termios termstate ;
#endif


extern std::vector<std::string> clientsAllowed;

//-=-=-=-=-=-=-Classes Definitions=-=-=-=-=-=//
class  cBoat;
extern cBoat			*Boats;
class  CWorldMain;
extern CWorldMain		*cwmWorldState;
class  cAccount;
extern cAccount			*Accounts;
class  cAdmin;
extern cAdmin			*Admin;
class  cCombat;
extern cCombat			*Combat;
class  cCommands;
extern cCommands		*Commands;
class  cGuilds;
extern cGuilds			*Guilds;
class  cGump;
extern cGump			*Gumps;
class  cAllItems;
extern cAllItems		*Items;
class  cMapStuff;
extern cMapStuff		*Map;
class  cCharStuff;
extern cCharStuff		*Npcs;
class  cSkills;
extern cSkills			*Skills;
class  cWeight;
extern cWeight			*Weight;
class  cTargets;
extern cTargets			*Targ;
class  cNetworkStuff;
extern cNetworkStuff	*Network;
class  cOldMagic;
extern cOldMagic		*OldMagic;
class  cMagic;
extern cMagic			*Magic;
class  cBooks;
extern cBooks           *Books;
class  cAllTmpEff;
extern cAllTmpEff       *AllTmpEff;
class  cRegion;
extern cRegion			*mapRegions; //setup map regions Tauriel
class  mapDispatcher;
extern mapDispatcher    *AllMaps;
class  LWCrypt;
extern LWCrypt          *LightweightCrypt;
class  tileInfo;  
extern tileInfo         *TileData;
class  multis;
extern multis           *Multi; 
class  cPartySystem;
extern cPartySystem     *PartySystem;   
class cTitle;
extern cTitle			*Titles;
class countTraffic;
extern countTraffic     *Traffic;
class CParticleEffects;
extern CParticleEffects *ParticleEffects;
class  cSkillManagement;
extern cSkillManagement	*SkillManager;
class cClientVersion;
extern cClientVersion   *ClientVersion;


//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-//

//
int getAddid1_4(UOXSOCKET s);
void setAddid1_4(UOXSOCKET s, int ser);

// --------------------------------------------------------

extern std::string ascii_art_1[8];
extern std::string ascii_art_2[8];
extern std::string ascii_art_3[8];
extern std::string ascii_art_4[8];
extern std::string ascii_art_5[25];
extern char ascii_art_rows[5];

extern wchar_t wscript1[512];
extern wchar_t wscript2[512];
extern wchar_t wscript3[512];

///////////////////////////////////////////////////////////

struct gmpage_st
{
	string reason;
	SERIAL serial;
	char timeofcall[9];
	string name;
	int handled;
};

extern CArray<MAXPAGES, gmpage_st>gmpages_CArray;
extern CArray<MAXPAGES, gmpage_st>counspages_CArray;

//#include "walking.h"
class CScriptedWalking;
extern std::map<int, CScriptedWalking *> scriptedwalkingnpcs;

#define gmpages gmpages_CArray.prepare(DBGFILE,__LINE__)
#define counspages counspages_CArray.prepare(DBGFILE,__LINE__)

//#include "games.h"

class cLife;
extern std::vector<cLife*> golSeeds;

#endif
