/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

// Guildstones.cpp
//
// Author		:	DasRaetsel
// EMail		:	sascha@toxic.franken.de
// Web			:	
// Last Edited	:	30. May 1999

// Last touch 9'th November 2000 by LB
// removed all cases of guild[-1]
// and loads of stupid other things/bugs

#include "guilds.h"

#include "SndPkg.h"
#include "gumps.h"
#include "house.h"
#include "network.h"
#include "targeting.h"
#include "worldmain.h"

#include "wolfpack.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "guildstones.cpp"

// placeguildstone() : spawns a renamed gravestone at players location and removes deed
// Placer gets guildmaster, whatever he does ;)
// Force placer to give that damn guild a damn name :)
void cGuilds::StonePlacement(P_PLAYER Player, P_ITEM Deed)
{
	int guildnumber;
	P_ITEM pStone=NULL;

	if (CheckValidPlace(Player)!=1)
	{
		Player->Msg("You cannot place guildstones at any other location than your house");
		return;
	}
	
	UOXSOCKET s = Player->cs;
	if (Deed->id()==0x14F0)
	{
		if (Player->guildnumber!=0)
		{
			itemmessage(s,Deed,"You are already in a guild.");
			return;
		}
		guildnumber=Guilds->SearchSlot(0,1);
		if (guildnumber==-1)
		{
			itemmessage(s,Deed,"There are already enough guildstones placed.");
			return;
		}
		Player->guildnumber=guildnumber;
		pStone=Items->SpawnItem(ITY_GuildStone,1,"Guildstone for an unnamed guild",0x0ED5,0);
		if (!pStone)
		{//AntiChrist - to prevent crashes
			Player->Msg("Cannot create guildstone");
			return;
		}
		strcpy(Player->guildtitle,"Guildmaster");
		if (Player->id() == 0x0191)	
		{
			strcpy(Player->guildtitle, "Guildmistress");	
		}


		guild_st *Guild=&guilds[guildnumber];
		Guild->free = 0;
		Guild->members = 1;
		Guild->member[1] = Player->serial;
		Guild->type = 0;
		Guild->abbreviation[0] = 0;
		strcpy(Guild->webpage,DEFAULTWEBPAGE);
		strcpy(Guild->charter,DEFAULTCHARTER);
		pStone->resetPriv();
		pStone->setLockedDown();
		pStone->setOwnSerialOnly(Player->serial);
		pStone->MoveTo2(Player->pos);

		Items->DeleItem(Deed);
		Guild->stone=pStone->serial;
		Guild->master=Player->serial;
		entrygump(s, Player->serial,100,1,40,"Enter a name for the guild.");
	}
	else
	{
		guildnumber = SearchByStone(Player);
		if (guildnumber==-1)
		{//AntiChrist
			Player->Msg("There are already enough guildstones placed.");
			return;
		}
		guild_st *Guild=&guilds[guildnumber];
		if (( Deed->serial==Guild->stone &&
			Player->serial == Guild->master) ||
			Player->isGM() )
		{
			char stonename[60];
			sprintf(stonename, "Guildstone for %s", Guild->name);
			pStone = Items->SpawnItem(ITY_GuildStone, 1, stonename, 0x0ED5, 0);
			if (!pStone)
			{
				Player->Msg("Cannot create guildstone");
				return;
			}
			pStone->resetPriv();
			pStone->MoveTo2(Player->pos);
			Items->DeleItem(Deed);
			Guild->stone = pStone->serial;
		}
		else
			itemmessage(s,Deed,"You are not the guildmaster of this guild. Only the guildmaster may use this guildstone teleporter.");
	}
}

static P_CHAR GetMember(guild_st *Guild, int mi)
{
	return FindCharBySerial(Guild->member[mi]);
}

static P_CHAR GetRecruit(guild_st *Guild, int ri)
{
	return FindCharBySerial(Guild->recruit[ri]);
}

// guildstonemenu() : Opens the guild menu for a player
// Recognizes Guildmaster with the owner fields of the stone.
// Ofcourse checks for membership before opening any gump ;)
void cGuilds::Menu(P_PLAYER Player, int page)
{
	int total,i,counter,guild,ri,war,mi;
	int lentext;
	int gumpnum=0;
	char guildfealty[60],guildt[16],toggle[6];
	static char mygump[MAXMEMRECWAR][257];

	if (!Player) return;

	P_ITEM iStone = Player->getDclickedItem();
	if (iStone==NULL)
	{
		Player->Msg("Strange error: Guildstone not existing.");
		return;
	}
	

	int guildnumber=Guilds->SearchByStone(Player);
	if (guildnumber==-1)
	{
		Player->Msg("You are not a member of this guild. Ask an existing guildmember to invite you into this guild.");
		return;
	}
	guild_st *Guild=&guilds[guildnumber];

	if (Guild->stone != iStone->serial && !Player->isGM())
	{
		itemmessage(Player->cs,iStone,"You are not a member of this guild. Ask an existing guildmember to invite you into this guild.");
		return;
	}

	strcpy(guildfealty, "yourself");
	if (Player->guildfealty != Player->serial && Player->guildfealty != 0)
	{
		for (mi=1;mi<MAXGUILDMEMBERS;mi++)
		{
			if (Player->guildfealty == Guild->member[mi])
			{
				P_CHAR Member = GetMember(Guild,mi);
				if (Member)
					strcpy(guildfealty, Member->name);
				break;
			}
		}
	}
	else
		Player->guildfealty = Player->serial;
	
	if (Guild->master==0) Guilds->CalcMaster(guildnumber);
	P_CHAR GuildMaster = FindCharBySerial(Guild->master);
	if (!GuildMaster) return;

	switch (Guild->type) 
	{
		case 0:		strcpy(guildt, " Standard");	break;
		case 1:		strcpy(guildt, "n Order");		break;
		case 2:		strcpy(guildt, " Chaos");		break;
	}
	
	if (Player->guildtoggle) 
		strcpy(toggle, "On");
	else
		strcpy(toggle, "Off");

	int menuid = 0;
	switch(page)
	{
	case 1:
		gumpnum=9;
		menuid=8001;

		lentext=sprintf(mygump[0], "%s (%s %s)",Guild->name,GuildMaster->guildtitle,GuildMaster->name);
		strcpy(mygump[1],"Recruit someone into the guild.");
		strcpy(mygump[2],"View the current roster.");
		strcpy(mygump[3],"View the guild's charter.");
		sprintf(mygump[4],"Declare your fealty. You are currently loyal to %s.",guildfealty);
		sprintf(mygump[5],"Toggle showing the guild's abbreviation in your name to unguilded people. Currently %s.",toggle);
		strcpy(mygump[6],"Resign from the guild.");
		strcpy(mygump[7],"View list of candidates who have been sponsored to the guild.");
	    if (Player->serial==Guild->master || Player->isGM())		// Guildmaster Access?
		{															
			gumpnum=10;
			menuid=8000;
			sprintf(mygump[8],"Access %s functions.",GuildMaster->guildtitle);
			sprintf(mygump[9],"View list of guild that %s has declared war on.",Guild->name);
			sprintf(mygump[10],"View list of guilds that have declared war on %s.",Guild->name);
		} else {												// Normal Members access!
			sprintf(mygump[8],"View list of guilds that %s have declared war on.",Guild->name);
			sprintf(mygump[9],"View list of guilds that have declared war on %s.",Guild->name);
		}
		break;
	case 2:														// guildmaster menu
		gumpnum=14;
		lentext=sprintf(mygump[0], "%s, %s functions",Guild->name,GuildMaster->guildtitle);
		strcpy(mygump[1], "Set the guild name.");
		strcpy(mygump[2], "Set the guild's abbreviation.");
		sprintf(mygump[3], "Change the type of the guild. (Currently a%s guild.)",guildt);
		strcpy(mygump[4], "Set the guild's charter.");
		strcpy(mygump[5], "Dismiss a member.");
		strcpy(mygump[6], "Declare war from menu.");
		strcpy(mygump[7], "Declare war from targeting enemy.");
		strcpy(mygump[8], "Declare peace.");
		strcpy(mygump[9], "Accept a candidate seeking membership.");
		strcpy(mygump[10],"Refuse a candidate seeking membership.");
		strcpy(mygump[11],"Set the guildmaster's title.");
		strcpy(mygump[12],"Grant a title to another member.");
		strcpy(mygump[13],"Move this guildstone.");
		strcpy(mygump[14],"Return to the main menu.");
		menuid=8002;
		break;
	case 3:														// guild type
		gumpnum=4;
		lentext=sprintf(mygump[0], "Please select the type you want your guild to be related to.");
		strcpy(mygump[1], "Select this to return to main menu.");
		strcpy(mygump[2], "Set to Standard.");
		strcpy(mygump[3], "Set to Order.");
		strcpy(mygump[4], "Set to Chaos.");
		menuid=8003;
		break;
	case 4:														// edit charter
		gumpnum=3;
		lentext=sprintf(mygump[0], "Set %s charter.",Guild->name);
		strcpy(mygump[1], "Select this to return to main menu.");
		strcpy(mygump[2], "Set the charter.");
		strcpy(mygump[3], "Set the webpage.");
		menuid=8004;
		break;
	case 5:														// view charter
		gumpnum=2;
		lentext=sprintf(mygump[0], "%s charter.",Guild->name);
		sprintf(mygump[1], "%s. Select this to return to the main menu.",Guild->charter);
		sprintf(mygump[2], "Visit the guild website at %s",Guild->webpage);
		menuid=8005;
		break;
	case 6:														// Candidates list
		gumpnum=Guild->recruits+1;
		lentext=sprintf(mygump[0], "%s list of candidates.",Guild->name);
		sprintf(mygump[1], "Select this to return to the menu.");
		counter=1;
		for (ri=1;ri<MAXGUILDRECRUITS;ri++)
		{
			if (Guild->recruit[ri]!=0)
			{
				counter++;
				P_CHAR Recruit = GetRecruit(Guild,ri);
				if (Recruit)
					strcpy(mygump[counter],Recruit->name);
			}
		}
		menuid=8006;
		break;
	case 7:														// roster
		gumpnum=Guild->members+1;
		lentext=sprintf(mygump[0], "%s members roster.",Guild->name);
		strcpy(mygump[1], "Select this to return to the menu.");
		counter=1;
		for (mi=1;mi<MAXGUILDMEMBERS;mi++)
		{
			if (Guild->member[mi]!=0)
			{
				counter++;
				P_CHAR Member = GetMember(Guild,mi);
				if (Member)
					strcpy(mygump[counter], Member->name);
			}
		}
		menuid=8007;
		break;
	case 8:														// member dismiss
		gumpnum=Guild->members+1;
		lentext=sprintf(mygump[0], "Dismiss what member?");
		strcpy(mygump[1], "Select this to return to the menu.");
		counter=1;
		for (mi=1;mi<MAXGUILDMEMBERS;mi++)
		{
			if (Guild->member[mi]!=0)
			{
				counter++;
				P_CHAR Member = GetMember(Guild,mi);
				if (Member)
					strcpy(mygump[counter],Member->name);
			}
		}
		menuid=8008;
		break;
	case 9:														// Refuse Candidates
		gumpnum=Guild->recruits+1;
		lentext=sprintf(mygump[0], "Refuse what candidate? %s",Guild->name);
		strcpy(mygump[1], "Select this to return to the menu.");
		counter=1;
		for (ri=1;ri<MAXGUILDRECRUITS;ri++)
		{
			if (Guild->recruit[ri]!=0)
			{
				counter++;
				P_CHAR Recruit = GetRecruit(Guild,ri);
				if (Recruit)
					strcpy(mygump[counter],Recruit->name);
			}
		}
		menuid=8009;
		break;
	case 10:														// Accept Candidates
		gumpnum=Guild->recruits+1;
		lentext=sprintf(mygump[0], "Accept what candidate?.%s",Guild->name);
		strcpy(mygump[1], "Select this to return to the menu.");
		counter=1;
		for (ri=1;ri<MAXGUILDRECRUITS;ri++)
		{
			if (Guild->recruit[ri]!=0)
			{
				counter++;
				P_CHAR Recruit = GetRecruit(Guild,ri);
				if (Recruit)
					strcpy(mygump[counter],Recruit->name);
			}
		}
		menuid=8010;
		break;
	case 11:														// War list
		gumpnum=Guild->wars+1;
		lentext=sprintf(mygump[0], "Guild that %s has declared war on.",Guild->name);
		strcpy(mygump[1], "Select this to return to the menu.");
		counter=1;
		for (war=1;war<MAXGUILDWARS;war++)
		{
			if (Guild->war[war]!=0)
			{
				counter++;
				strcpy(mygump[counter],guilds[Guild->war[war]].name);
			}
		}
		menuid=8011;
		break;
	case 12:														// grant title
		gumpnum=Guild->members+1;
		lentext=sprintf(mygump[0], "Grant a title to whom?");
		strcpy(mygump[1], "Select this to return to the menu.");
		counter=1;
		for (mi=1;mi<MAXGUILDMEMBERS;mi++)
		{
			if (Guild->member[mi]!=0)
			{
				counter++;
				P_CHAR Member = GetMember(Guild,mi);
				if (Member)
					strcpy(mygump[counter],Member->name);
			}
		}
		menuid=8012;
		break;
	case 13:														// fealty
		gumpnum=Guild->members+1;
		lentext=sprintf(mygump[0], "Whom do you wish to be loyal to?");
		strcpy(mygump[1], "Select this to return to the menu.");
		counter=1;
		for (mi=1;mi<MAXGUILDMEMBERS;mi++)
		{
			if (Guild->member[mi]!=0)
			{
				counter++;
				P_CHAR Member = GetMember(Guild,mi);
				if (Member)
					strcpy(mygump[counter],Member->name);
			}
		}
		menuid=8013;
		break;
	case 14:														// declare War list
		int dummy;
		gumpnum=1;
		lentext=sprintf(mygump[0], "What guilds do you wish to declare war on?");
		strcpy(mygump[1], "Select this to return to the menu.");
		counter=1;
		for (guild=1;guild<MAXGUILDS;guild++)
		{
			if ((guilds[guild].free==0)&&(guildnumber!=guild))
			{
				dummy=0;
				for (war=1;war<MAXGUILDWARS;war++)
				{
					if (Guild->war[war]==guild) dummy=1;
				}
				if (dummy!=1) {counter++;gumpnum++;strcpy(mygump[counter],guilds[guild].name);}
			}
		}
		menuid=8014;
		break;
	case 15:														// declare peace list
		gumpnum=Guild->wars+1;
		lentext=sprintf(mygump[0], "What guilds do you wish to declare peace with?");
		strcpy(mygump[1], "Select this to return to the menu.");
		counter=1;
		for (war=1;war<MAXGUILDWARS;war++)
		{
			if (Guild->war[war]!=0)
			{
				counter++;
				strcpy(mygump[counter],guilds[Guild->war[war]].name);
			}
		}
		menuid=8015;
		break;
	case 16:														// War list 2
		gumpnum=1;
		lentext=sprintf(mygump[0], "Guilds that have declared war on %s.",Guild->name);
		strcpy(mygump[1], "Select this to return to the menu.");
		counter=1;
		for (guild=1;guild<MAXGUILDS;guild++)
		{
			if (guilds[guild].free==0)
			{
				for (war=1;war<MAXGUILDWARS;war++)
				{
					if (guilds[guild].war[war]==guildnumber)
					{
						counter++; gumpnum++;
						strcpy(mygump[counter],guilds[guild].name);
					}
				}
			}
		}
		menuid=8016;
		break;
	}
	
	unsigned char gmprefix[9]={0,};
	unsigned char gmmiddle[4]={0,};
	ShortToCharPtr(menuid,&gmprefix[7]);

	total=9+1+lentext+1;
	for (i=1;i<=gumpnum;i++)
	{
		total+=4+1+strlen(mygump[i]);
	}
		
	XStartPkt(0x7c, total);

	LongToCharPtr(Player->serial,&gmprefix[3]);

	XAddPkt(&gmprefix[0+3], 9-3);
	XAddPkt((unsigned char*)&lentext, 1);
	XAddPkt((unsigned char*)&mygump[0], lentext);
	lentext = gumpnum;
	XAddPkt((unsigned char*)&lentext, 1);
	for (i = 1; i <= gumpnum; i++)
	{
		gmmiddle[0]=0;
		gmmiddle[1]=0;
		XAddPkt(&gmmiddle[0],4);
		lentext=strlen(mygump[i]);
		XAddPkt((unsigned char*)&lentext,1);
		XAddPkt((unsigned char*)&mygump[i],lentext);
	}

	XFinishPkt(Player->cs);
	return;
}


// OKAY (but take another look)
// guildresign() : Player gets removed from the guilddatabase, and gets a message.
// Offcourse guilddatabase gets checked for members left, if everyone is gone, then vanish
// the guildstone. After Guildmaster resigns, the fealty of each remaining member calculates
// a new guildmaster, if there is a draw then we'll have no master until they change their minds ;)
void cGuilds::Resign(P_PLAYER Player)
{
	if (!Player) return;

	int guildnumber = Player->guildnumber;
	if (guildnumber==-1)
	{
		Player->Msg("You are in no guild");
		return;
	}
	guild_st *Guild=&guilds[guildnumber];

	Guilds->EraseMember(Player);
	Player->Msg("You are no longer in that guild.");
	if ((Guild->master == Player->serial) && (Guild->members!=0))
	{
		Guild->master=0;
		Guilds->CalcMaster(guildnumber);
	}
	if (Guild->members==0)
	{
		Guilds->EraseGuild(guildnumber);
		Player->Msg("You have been the last member of that guild so the stone vanishes.");
	}
	return;
}


// OKAY
// guilderaseguild() Wipes all information about a guild and removes the guildstone
void cGuilds::EraseGuild(int guildnumber)
{
	if (guildnumber<0 || guildnumber >=MAXGUILDS) return;
	guild_st *Guild=&guilds[guildnumber];

	P_ITEM Stone = FindItemBySerial(Guild->stone);
	if (Stone)
		Items->DeleItem(Stone);
	
	memset(&guilds[guildnumber], 0, sizeof(guild_st));
	Guild->free=1;

	int war;
	int g;
	for (g=1;g<MAXGUILDS;g++)
	{
		if (guilds[g].free==0)
		{
			for (war=1;war<MAXGUILDWARS;war++)
			{
				if (guilds[g].war[war]==guildnumber)
				{
					guilds[g].war[war]=0;
					guilds[g].wars--;
				}
			}
		}
	}
}


static void RemoveShields(P_CHAR pc)
{
	pc->removeItemsFromHands(0x1BC3);
	pc->removeItemsFromHands(0x1BC4);
	pc->removeItemsFromHands(0x1BC5);
	P_ITEM Pack = pc->getBackpack();
	if (Pack)
	{
		Pack->DeleteAmount(666,0x1BC3);	// hope they don't have more than 666 shields ;-) (Duke)
		Pack->DeleteAmount(666,0x1BC4);
		Pack->DeleteAmount(666,0x1BC5);
	}
}

// guilderasemember() Wipes all guild related data from a player
void cGuilds::EraseMember(P_CHAR pc)
{
	if (!pc) return;
	int guildnumber = pc->guildnumber;

	if (guildnumber>=0 && guildnumber <MAXGUILDS)
	{
		guild_st *Guild=&guilds[guildnumber];
		int j,member;
		for(j=0;j<=Guild->members;j++)
		{
			if (Guild->member[j] == pc->serial)
			{
				RemoveShields(pc);
			}
		}

		for (member=1;member<MAXGUILDMEMBERS;member++)
		{
			if (Guild->member[member] == pc->serial)
			{
				Guild->member[member] = 0;
				Guild->members--;
				pc->guildnumber = 0;
				pc->guildtoggle = 0;
				pc->guildfealty = 0;
				pc->guildtitle[0] = 0;
				return;
			}
		}
	}
}



// guildtoggleabbreviation() Toggles the settings for showing or not showing the guild title
// Informs player about his change
void cGuilds::ToggleAbbreviation(P_PLAYER Player)
{
	if (!Player) return;

	int guildnumber = Player->guildnumber;

	if (guildnumber<0 || guildnumber>MAXGUILDS) 
	{
		Player->Msg("you are in no guild");
		return;
	}
	guild_st *Guild=&guilds[guildnumber];

	if (Guild->type!=0)							// Check for Order/Chaos
	{
		Player->Msg("You are in an Order/Chaos guild, you cannot toggle your title.");
																// They may not toggle it off!
	}
	else
	{
		if (Player->guildtoggle==0)								// If set to Off then
		{
			Player->guildtoggle=1;								// Turn it On
			Player->Msg("You toggled your abbreviation on.");	// Tell player about the change
		}
		else													// Otherwise
		{
			Player->guildtoggle=0;								// Turn if Off
			Player->Msg("You toggled your abbreviation off.");	// And tell him also
		}
	}
	Guilds->Menu(Player,1);									// Send him back to the menu
	return;
}


// guildrecruit() Let the guild members recruit some player into the guild.
// Checks the guild database if "to be recruited" player already in any other guild.
// puts a tag with players serial number into the guilds recruit database.
void cGuilds::Recruit(P_PLAYER Player, P_CHAR pc)
{
	int slot, dummy;
	int guildnumber = SearchByStone(Player);

	if (guildnumber==-1) 
	{
		Player->Msg("you are in no guild");
		return;
	}
	guild_st *Guild=&guilds[guildnumber];

	if (pc != NULL)
	{
		if (pc->guildnumber!=0) 
			Player->Msg("This person is already in a guild.");
		else 
		{
			if (!pc->npc)
			{
				slot = SearchSlot(guildnumber, 3);
				for ( dummy = 1; dummy < MAXGUILDRECRUITS; dummy++ )
				{
					if ( Guild->recruit[dummy] == pc->serial ) slot = 0;
				}
				if ((slot!=-1)&&(slot!=0))
				{
					Guild->recruits++;
					Guild->recruit[slot] = pc->serial;
				}
				else
				{
					if (slot==-1) Player->Msg("No more recruit slots free.");
					if (slot==0) Player->Msg("This being is already a candidate.");
				}
			} else Player->Msg("This is not a player.");
		}
	}
	Guilds->Menu(Player,1);
	return;
}


// guildtargetwar() Let us target some player and add his guild to the warlist
// Checks the guild database if "to be wared" guild is already in warlist.
// puts a tag with guilds number into the guilds war database.
void cGuilds::TargetWar(P_PLAYER Player, P_CHAR pc)
{
	if (!Player) return;
	int guildnumber = Guilds->SearchByStone(Player);

	if (guildnumber==-1)
	{
		Player->Msg("you are in no guild");
		return;
	}
	guild_st *Guild=&guilds[guildnumber];

	if ( pc != NULL)
	{
		if (pc->guildnumber==0) 
			Player->Msg("This person is not in a guild.");
		else if (pc->guildnumber==guildnumber) Player->Msg("War yourself? Nah.");
		else 
		{
			if (!pc->npc)
			{
				int dummy;
				int slot = Guilds->SearchSlot( guildnumber, 4 );
				for ( dummy = 1; dummy < MAXGUILDWARS; dummy++ )
				{
					if ( Guild->war[dummy] == pc->guildnumber ) slot = 0;
				}
				if ((slot!=-1)&&(slot!=0))
				{
					char text [200];
					Guild->wars++;
					Guild->war[slot] = pc->guildnumber;
					sprintf(text,"%s declared war to %s",Guild->name,guilds[pc->guildnumber].name);
					Guilds->Broadcast(guildnumber,text);
				}
				else
				{
					if (slot==-1) Player->Msg("No more war slots free.");
					if (slot==0) Player->Msg("This guild is already in our warlist.");
				}
			}
			else Player->Msg("This is not a player.");
		}
		//break;
		//} for
	}
	Guilds->Menu(Player,2);
	return;
}



// guildstonemove() : Let the guildmaster move the stone anytime
// removes the stone item, gives Guildmaster a teleporterstone
// guild will be still active
// teleporterstone id 0x1869
void cGuilds::StoneMove(P_PLAYER Player)
{
	int guildnumber=Guilds->SearchByStone(Player);
	if (guildnumber==-1) return;
	guild_st *Guild=&guilds[guildnumber];

	P_ITEM Stone = FindItemBySerial( Guild->stone );
	if (!Stone) return;
															// Get stone
	char stonename[80];                                     // And for its name
	sprintf(stonename,"a guildstone teleporter for %s",Guild->name);
															// Give it a name
	P_ITEM Newstone = Items->SpawnItem(ITY_GuildStone, 1, stonename, 0x1869, 0, Player);	// Spawn the stone in the masters backpack
	if (!Newstone) return;

	Guild->stone=Newstone->serial;					// Remember its serial number
	Items->DeleItem(Stone);							// Remove the guildstone
	Player->Msg("Take care of that stone!");		// And tell him also
}


// guildsearch() Okay this is for highlighting/guards and other stuff, so you know what relation
// player 1 and player 2 have. results are:
// 1= both in same guild (so fighting is okay, green hightlighting)
// 2= both in opposite guilds/guildtypes (so fighting is okay, orange highlighting)
// 0= no guildwarfare, or no guild relation (so no fighting, normal highlighting)
// Oh, Order/Order or Chaos/Chaos guilds (in different guilds) may not war eachother! 
int cGuilds::Compare(P_CHAR Player1, P_CHAR Player2)
{
	int counter;
	if (!Player1 || !Player2) return 0;

	int guildnumber=Player1->guildnumber;
    int guildnumber2=Player2->guildnumber;

	// one of both not in a guild -> no guildwarfare
	if (guildnumber<0 || guildnumber>=MAXGUILDS || guildnumber2<0 || guildnumber2>=MAXGUILDS) return 0;

	if ((guildnumber!=0)&&(guildnumber2!=0))
	{
		if (guildnumber==guildnumber2) return 1;

		if (((guilds[guildnumber].type==1)&&(guilds[guildnumber2].type==2))||
			((guilds[guildnumber].type==2)&&(guilds[guildnumber2].type==1)))
		{return 2;}

		for (counter=1;counter<MAXGUILDWARS;counter++)
		{
			if (guilds[guildnumber].war[counter]==guildnumber2)
			{
				for (counter=1;counter<MAXGUILDWARS;counter++)
				{
					if (guilds[guildnumber2].war[counter]==guildnumber)
					{return 2;}
				}
			}
		}
	}
	return 0;
}


// guildgumpinput() result branching for those niffy little gump text fields
// Called by: gumpinput()
void cGuilds::GumpInput(P_PLAYER Player, int type, int index, char *text)
{
	if (type==100)
	{
		switch (index)
		{
		case 1:	ChangeName(Player,text);	return;			// Guild name requester
		case 2:	ChangeAbbreviation(Player,text);return;		// Guild abbreviation requester
		case 3:	ChangeTitle(Player,text);	return;			// Guild master title requester
		case 4:	ChangeTitle(Player,text);	return;			// Guild member title requester
		case 5:	ChangeCharter(Player,text);	return;			// Guild charter requester
		case 6:	ChangeWebpage(Player,text);	return;			// Guild webpage requester
		}
	}
}


// guildgumpchoice() branches the results of those checkbox gumps
// Called by: choice() 
void cGuilds::GumpChoice(P_PLAYER Player,int main,int sub)
{
	int member, recruit, war, guild, counter, slot;
	//int members[MAXGUILDMEMBERS];
	//int recruits[MAXGUILDRECRUITS];
	char text[200];

	int guildnumber=Guilds->SearchByStone(Player);
	if (guildnumber==-1) return;
	guild_st *Guild=&guilds[guildnumber];

	UOXSOCKET s = Player->cs;
	switch(main)
	{
	case 8000:
	case 8001:									// main menu
		switch( sub )
		{
		case 1: target(Player,T_220,"Select person to invite into the guild.");	break;
		case 2:	Menu(Player,7);													break;
		case 3: Menu(Player,5);													break;
		case 4: Menu(Player,13);												break;
		case 5: ToggleAbbreviation(Player);										break;
		case 6: Resign(Player);													break;
		case 7: Menu(Player,6);													break;
		case 8:
		default:
			if ( sub == 8 && main == 8000 ) 
				Menu(Player, 2);
			else if ( ( sub == 8 && main == 8001 ) || ( sub == 9 && main == 8000 ) ) 
				Menu(Player, 11);
			else if ( ( sub == 9 && main == 8001 ) || ( sub == 10 && main == 8000 ) ) 
				Menu(Player, 16);
			break;
		}
		return;
	case 8002:													// guildmaster menu
		switch(sub)
		{
		case 1:  entrygump(s,Player->serial,100,1,40,"Enter a new guildname.");				break;
		case 2:  entrygump(s,Player->serial,100,2,3,"Enter a new guild abbreviation.");		break;
		case 3:  Guilds->Menu(Player,3);													break;
		case 4:  Guilds->Menu(Player,4);													break;
		case 5:  Guilds->Menu(Player,8);													break;
		case 6:  Guilds->Menu(Player,14);													break;
		case 7:  target(Player,T_221,"Select person to declare war to.");					break;
		case 8:  Guilds->Menu(Player,15);													break;
		case 9:	 Guilds->Menu(Player,10);													break;
		case 10: Guilds->Menu(Player,9);													break;
		case 11: entrygump(s,Player->serial,100,3,20,"Enter new guildmastertitle.");		break;
		case 12: Guilds->Menu(Player,12);													break;
		case 13: Guilds->StoneMove(Player);													break;
		case 14: Guilds->Menu(Player,1);													break;
		}
		return;
	case 8003:													// set type menu
		if (sub >= 2 && sub <=4) 
			Guilds->SetType(guildnumber, sub-2);
		Guilds->Menu(Player,2);
		return;
	case 8004:													// edit charter menu
		switch( sub )
		{
		case 1: Menu(Player, 2 );													break;
		case 2: entrygump( s, Player->serial, 100, 5, 50, "Enter a new charter." );	break;
		case 3:	entrygump( s, Player->serial, 100, 6, 50, "Enter a new URL." );		break;
		}
		return;
	case 8005:													// view charter menu
		if (sub==1) Guilds->Menu(Player,1);
		if (sub==2) weblaunch(Player,Guild->webpage);
		return;
	case 8006:													// candidates menu
		Guilds->Menu(Player,1);
		return;
	case 8007:													// roster menu
		Guilds->Menu(Player,1);
		return;
	case 8008:													// dismiss menu
		counter=1;
		for (member=1;member<MAXGUILDMEMBERS;member++)
		{
			P_CHAR Member = GetMember(Guild,member);
			if (Member)
			{
				counter++;
				if (sub==counter)
				{
					if (Member->isSameAs(Player))
					{
						Player->Msg("You cannot dimiss yourself, please resign from the guild if you wish.");
					}
					else
					{
						Guilds->EraseMember(Member);
						Player->Msg("Kicked that member out of the guild.");
						if (Member->InGame())
							Member->Msg("You got dismissed out of your guild.");
					}
					break;
				}
			}
		}	
		Guilds->Menu(Player,2);
		return;
	case 8009:													// refuse menu
		counter=1;
		for (recruit=1;recruit<MAXGUILDRECRUITS;recruit++)
		{
			if (Guild->recruit[recruit]!=0)
			{
				counter++;
				if (sub==counter)
				{
					Guild->recruit[recruit]=0;
					Guild->recruits--;
					Player->Msg("Removed candidate from the list.");
				}
			}		
		}
		Guilds->Menu(Player,2);
		return;
	case 8010:													// accept
		counter=1;
		for (recruit=1;recruit<MAXGUILDRECRUITS;recruit++)
		{
			if (Guild->recruit[recruit]!=0)
			{
				counter++;
				if (sub==counter)
				{
					P_CHAR pc = FindCharBySerial ( Guild->recruit[recruit] );
					if (pc != NULL) //lb
					{
						if (pc->guildnumber==0)
						{
							slot = Guilds->SearchSlot(guildnumber,2);
							if (slot!=-1)
							{
								Guild->member[slot] = pc->serial;
								Guild->members++;
								pc->guildnumber = guildnumber;
								Guild->recruit[recruit] = 0;
								Guild->recruits--;
								if (Guild->type!=0) pc->guildtoggle = 1;
								Player->Msg("This candidate is now a guildmember.");
								if ( Guild->type == 1 )
									Items->SpawnItemBackpack2( pc->getSlot(), SrvParms->hci.OrderShield );
								if ( Guild->type == 2 )
									Items->SpawnItemBackpack2( pc->getSlot(), SrvParms->hci.ChaosShield );
							}
							else Player->Msg("This guild is full, maximum amount of members reached!" );
						}
						else 
						{
							Player->Msg("This candidate is already in another guild, I'll remove him from your list now.");
							Guild->recruit[recruit] = 0;
							Guild->recruits--;
						}
					}
				}
			}		
		}
		Guilds->Menu(Player,2);
		return;
	case 8011:													// warlist menu
		Guilds->Menu(Player,1);
		return;
	case 8012:													// grant title menu
		if (sub==1) Guilds->Menu(Player,2);
		counter=1;
		for (member=1;member<MAXGUILDMEMBERS;member++)
		{
			if (Guild->member[member]!=0)
			{
				counter++;
				if (sub==counter)
				{
					P_CHAR pc = FindCharBySerial( Guild->member[member] );
					Guild->priv = pc ? pc->serial : 0;
					entrygump(s,Player->serial,100,3,20,"Enter new guildtitle.");
					return;
				}
			}		
		}
		return;
	case 8013:													// fealty menu
		counter=1;
		for (member=1;member<MAXGUILDMEMBERS;member++)
		{
			if (Guild->member[member]!=0)
			{
				counter++;
				if (sub==counter)
				{
					Player->guildfealty=Guild->member[member];
				}
			}
		}
		Guilds->Menu(Player,1);
		return;
	case 8014:													// declare war menu
		counter=1;
		for (guild=1;guild<MAXGUILDS;guild++)
		{
			if ((strcmp(Guild->name,guilds[guild].name))&&
				(guilds[guild].free!=1))
			{
				counter++;
				if (sub==counter)
				{
					slot=Guilds->SearchSlot(guildnumber,4);
					for (war=1;war<MAXGUILDWARS;war++)
					{
						if (Guild->war[war]==guild) slot=0;
					}
					if ((slot!=-1)&&(slot!=0))
					{
						Guild->wars++;
						Guild->war[slot]=guild;
						sprintf(text,"%s declared war to %s",Guild->name,guilds[guild].name);
						Guilds->Broadcast(guildnumber,text);
					}
					else
					{
						if (slot==-1) Player->Msg("No more war slots free.");
						else if (slot == 0) Player->Msg("This guild is already in our warlist.");
					}
				}
			}
		}
		Guilds->Menu(Player,2);
		return;
	case 8015:													// declare peace menu
		counter=1;
		for (war=1;war<MAXGUILDWARS;war++)
		{
			if (Guild->war[war]!=0)
			{
				counter++;
				if (sub==counter)
				{
					sprintf(text,"%s declared peace to %s",Guild->name,guilds[Guild->war[war]].name);
					Guilds->Broadcast(guildnumber,text);
					Guild->war[war]=0;
					Guild->wars--;
				}
			}
		}
		Guilds->Menu(Player,2);
		return;
	case 8016:													// warlist menu 2
		Guilds->Menu(Player,1);
		return;
	}
}




// TESTED: OKAY
// guildnamechange(character, text) copies the text info the guildstones name field 
// (guildnumber gets calculated from the double clicked guildstones), and notifies all online
// guildmambers about the change.
void cGuilds::ChangeName(P_PLAYER Player, char *text)
{
	int guildnumber=Guilds->SearchByStone(Player);
	if (guildnumber==-1) return;
	guild_st *Guild=&guilds[guildnumber];

	P_ITEM Stone = FindItemBySerial( Guild->stone );
	if (!Stone) return;
	int guild;
	bool exists = false;
	char txt[200];

	for (guild=1;guild<MAXGUILDS;guild++)
	{
		if (!strcmp(text,guilds[guild].name)) exists = true;
	}
	if (!exists)
	{
		strcpy(Guild->name, text);
		sprintf(Stone->name,"Guildstone for %s",Guild->name);
		sprintf(txt,"Your guild got renamed to %s",Guild->name);
		Guilds->Broadcast(guildnumber,txt);
	}
	else Player->Msg("This name is already taken by another guild.");
}


// TESTED: OKAY
// guildabbreviationchange(character, text) copies the text info the guildstones abbreviation field 
// (guildnumber gets calculated from the double clicked guildstones), and notifies editing player about
// the change.
void cGuilds::ChangeAbbreviation(P_PLAYER Player, char *text)
{
	int guildnumber=Guilds->SearchByStone(Player);
	if (guildnumber==-1) return;
	guild_st *Guild=&guilds[guildnumber];

	int guild;
	bool exists = false;
	char txt[200];

	for ( guild = 1; guild < MAXGUILDS; guild++ )
	{
		if (!strcmp(text,guilds[guild].abbreviation)) exists = true;
	}
	if (!exists)
	{
		strcpy(Guild->abbreviation,text);
		sprintf(txt,"Your guild has now the abbreviation: %s",Guild->abbreviation);
		Guilds->Broadcast(guildnumber,txt);
	}
	else Player->Msg("This abbreviation is already taken by another guild.");
	Guilds->Menu(Player,2);
}


// guildtitlechange(character, text) copies the text info the characters title field (guildnumber
// gets calculated from the double clicked guildstones), changed character was buffered in the guilds
// private field (as backup buffer) and notifies editing player about the change.
void cGuilds::ChangeTitle(P_PLAYER Player, char *text)
{
	int guildnumber=Guilds->SearchByStone(Player);
	if (guildnumber==-1) return;
	guild_st *Guild=&guilds[guildnumber];

	P_CHAR pc = FindCharBySerial(Guild->priv);
	if (!pc) pc = Player;
	Guild->priv=0;

	strcpy(pc->guildtitle,text);
	if (pc->isSameAs(Player)) Player->Msg("You changed your own title.");
	else Player->Msg("You changed the title.");
	Guilds->Menu(Player,2);
}


// TESTED: OKAY
// guildcharterchange(character, text) copies the text info the guildstones charter field (guildnumber
// gets calculated from the double clicked guildstones), and notifies editing player about the change.
void cGuilds::ChangeCharter(P_PLAYER Player, char *text)
{
	int guildnumber=Guilds->SearchByStone(Player);
	if (guildnumber==-1) return;
	guild_st *Guild=&guilds[guildnumber];

	strcpy(Guild->charter, text);
	Player->Msg("You changed the guilds charter.");
	Guilds->Menu(Player,2);
}




// TESTED: OKAY
// guildwebpagechange(character, text) copies the text info the guildstones webpage field (guildnumber
// gets calculated from the double clicked guildstones), and notifies editing player about the change.
void cGuilds::ChangeWebpage(P_PLAYER Player, char *text)
{
	int guildnumber = Guilds->SearchByStone(Player);
	if (guildnumber==-1) return;
	guild_st *Guild=&guilds[guildnumber];

	strcpy(Guild->webpage, text);
	Player->Msg("You changed the guilds webpage url.");
	Guilds->Menu(Player,2);
}

int cGuilds::GetType(int guildnumber)
{
	if (guildnumber<0 || guildnumber >=MAXGUILDS)
		return 0;
	else
		return guilds[guildnumber].type;
}

void cGuilds::SetType(int guildnumber, int type)
{
	int j;
	int member;
	cChar* pc;

	if (guildnumber<0 || guildnumber >=MAXGUILDS) return;
	guild_st *Guild=&guilds[guildnumber];

	Guild->type = type;
    // Redone by Ripper and LB - march 19, 2000	
	//	I think the idea here is to either remove shields from ALL 
	//	(order/chaos) guilds members and replace them with opposite
	//	sheild types, or remove them alltogether
	switch(type)
	{
		case 1:	//	Convert into a order guild
			for(j=0;j<=Guild->members;j++)
			{
				pc=FindCharBySerial(Guild->member[j]);
                if (pc) 
				{
					RemoveShields(pc);
					Items->SpawnItemBackpack2( pc->getSlot(), SrvParms->hci.OrderShield );	// will not work for offline chars (Duke)
				}
			}
			Guilds->Broadcast( guildnumber, "Your guild is now an Order guild." );
			Guilds->Broadcast( guildnumber, "An order shield has been placed in your pack!" );
			break;
		case 2:	//	Convert guild into an choas guild
			for(j=0;j<=Guild->members;j++)
			{
				pc=FindCharBySerial(Guild->member[j]);
                if (pc) 
				{
					RemoveShields(pc);
					Items->SpawnItemBackpack2( pc->getSlot(), SrvParms->hci.ChaosShield );
				}
			}
			Guilds->Broadcast( guildnumber, "Your guild is now a Chaos guild." );
			Guilds->Broadcast( guildnumber, "A chaos shield has been placed in your pack!" );
			break;
		case 0:	// Convert guild into a standard guild
		default:	//	Just let it fall through 
			//	Idea is to remove the items from this guilds members(Im gonna use your item loop for clarity)
			for(j = 0;j <= Guild->members; j++)
			{
				pc=FindCharBySerial(Guild->member[j]);
                if (pc) 
				{
					RemoveShields(pc);
				}
			}
			Guilds->Broadcast( guildnumber, "Your guild is now a Standard guild." );
			break;
	}

	// Im goging to leave this here cause I am not sure what it does.
	if (type!=0)
	{
		for (member=1;member<MAXGUILDMEMBERS;member++)
		{
			if (Guild->member[member]!=0)
			{
				P_CHAR Member = GetMember(Guild, member);
				if (Member) Member->guildtoggle=1;
			}
		}
	}

}

// TESTED: OKAY
// Uhm.. do i need char or socket for sysmessage? hehe.. a socket ofcourse, FiXED iT!
// guildbroadcast(guildnumber, text) broadcasts message to all online members of guild
void cGuilds::Broadcast(int guildnumber, char *text)
{
	int member;

	if (guildnumber==-1) return;
	guild_st *Guild=&guilds[guildnumber];

	for (member=1;member<MAXGUILDMEMBERS;member++)
	{
		if (Guild->member[member]!=0)
		{
			P_CHAR pc = FindCharBySerial(Guild->member[member]);
			if (pc)
				if (pc->InGame()) pc->Msg(text);
		}
	}
}


// TESTED: OKAY (but not the best solution ;))
// guildSearchByStone(guildstone serial) get the guildnumber from the stones serial number
int cGuilds::SearchByStone(P_PLAYER pc)
{
	if (!pc) return -1;

	P_ITEM Stone = pc->getDclickedItem();
	if (!Stone) return -1;

	int guildnumber;
	if (pc->isGM())
	{
		for ( guildnumber = 1; guildnumber < MAXGUILDS; guildnumber++)
		{
			if ( guilds[guildnumber].stone == Stone->serial) 
			{
				return guildnumber;
			}
		}
	}
	return pc->guildnumber;
}

// TESTED: OKAY
// guildsearchslot(guildnumber, search type) searches for a free slot of the 4 possible types, results
// the free slot or -1 of no free slot available
// Types  1:guildslots, 2:memberslots, 3: recruitslots, 4: warslots
int cGuilds::SearchSlot(int guildnumber, int type)
{
	int counter;

	switch(type)
	{
	case 1:												// guildslots
		for (counter=1; counter<MAXGUILDS; counter++)
			if (guilds[counter].free==1) return counter;
	    if (guildnumber<0 || guildnumber>=MAXGUILDS) return -1;
		break;
	case 2:												// memberslots
		for (counter=1; counter<MAXGUILDMEMBERS; counter++)
			if (guilds[guildnumber].member[counter]==0) return counter;
		break;
	case 3:												// recruitslots
		for (counter=1; counter<MAXGUILDRECRUITS; counter++)
			if (guilds[guildnumber].recruit[counter]==0) return counter;
		break;
	case 4:												// warslots
		for (counter=1; counter<MAXGUILDWARS; counter++)
			if (guilds[guildnumber].war[counter]==0) return counter;
		break;
	}
	return -1;
}


// TESTED: OKAY (i think so, but ugly -> redo it!)
// guildmastercalc(guildnumber) counts all fealty settings of all members of 'guildnumber' and sets
// a new guildmaster if there is a draw then there will be no master, til the next check ;)
void cGuilds::CalcMaster(int guildnumber)
{
	int member, member2;
	int guildmember[MAXGUILDMEMBERS]={0};
	int currentfealty, currenthighest=0, draw=0;

	if (guildnumber<0 || guildnumber>=MAXGUILDS) return;
	guild_st *Guild=&guilds[guildnumber];

	for (member=1;member<MAXGUILDMEMBERS;member++)
	{
		P_CHAR CurrMem = GetMember(Guild, member);

		if (!CurrMem) currentfealty=0; else currentfealty=CurrMem->guildfealty;

		for (member2=1;member2<MAXGUILDMEMBERS;member2++)
		{
			if ((Guild->member[member2]==currentfealty)&&(currentfealty!=0))
				guildmember[member2]++;
		}
	}
	for (member=1;member<MAXGUILDMEMBERS;member++)
	{
		if (guildmember[member]>guildmember[currenthighest]) {draw=0;currenthighest=member;}
		else if (guildmember[member]==guildmember[currenthighest]) draw=1;
	}
	if (draw==0) Guild->master=Guild->member[currenthighest];
	return;
}



cGuilds::~cGuilds()
{
}

// TESTED: OKAY
// guildinit() initializes the guild structure fields, marks them all as free.
// Called by: main()
cGuilds::cGuilds(void)
{
	int guildnumber, member, recruit, war;

	for (guildnumber=1;guildnumber<MAXGUILDS;guildnumber++)
	{
		guild_st *Guild=&guilds[guildnumber];
		Guild->free=1;
		Guild->name[0] = 0;
		Guild->abbreviation[0] = 0;
		Guild->type=0;
		Guild->charter[0] = 0;
		Guild->webpage[0] = 0;
		Guild->stone=0;
		Guild->master=0;
		Guild->members=0;
		for (member=1;member<MAXGUILDMEMBERS;member++)
		{
			Guild->member[member]=0;
		}
		Guild->recruits=0;
		for (recruit=1;recruit<MAXGUILDRECRUITS;recruit++)
		{
			Guild->recruit[recruit]=0;
		}
		Guild->wars=0;
		for (war=1;war<MAXGUILDWARS;war++)
		{
			Guild->war[war]=0;
		}
		Guild->priv=0;
	}
}


// TESTED: OKAY (fine fine.. now proove that it really works.. )
// guildtitle(viewing character socket, clicked character) displays players title string, over the name
// of clicked character, name color gets calculated from the guild relationship of both players
// Called by: textflags()
void cGuilds::Title(int s,P_CHAR pc)
{
	if (!pc) return;
	char title[150];
	char abbreviation[5];
	char guildtype[10];

	if (pc->guildnumber<0 || pc->guildnumber>=MAXGUILDS) return;

	if (pc->guildnumber!=0 && pc->guildtoggle==1)
	{
		strcpy(abbreviation,guilds[pc->guildnumber].abbreviation);
		if (!strcmp(abbreviation,""))
			strcpy(abbreviation,"none");
		if (guilds[pc->guildnumber].type!=0)
		{
			if (guilds[pc->guildnumber].type==1) strcpy(guildtype,"Order");
			else if (guilds[pc->guildnumber].type==2) strcpy(guildtype,"Chaos");
			if (strcmp(pc->guildtitle,"")) sprintf(title,"[%s, %s] [%s]",pc->guildtitle,abbreviation,guildtype);
			else sprintf(title,"[%s] [%s]",abbreviation, guildtype);
		}
		else
		{
			if (strcmp(pc->guildtitle,"")) sprintf(title,"[%s, %s]",pc->guildtitle,abbreviation);
			else sprintf(title,"[%s]",abbreviation);
		}
		int tl=44+strlen(title)+1;

		unsigned char talk[14];

		LongToCharPtr(pc->serial,&talk[3]);
		talk[7]=1;
		talk[8]=1;
		talk[9]=0;
		ShortToCharPtr(pc->emotecolor,&talk[10]);
		talk[12]=0;
		talk[13]=3;

		XStartPkt(0x1c, tl);
		XAddPkt(&talk[0+3], 14-3);
		XAddPkt((unsigned char*)&pc->name[0], 30);
		XAddPkt((unsigned char*)&title[0], strlen(title)+1);

		XFinishPkt(s);
	}
}

// TESTED: OKAY
// guildread(character) reads the guild structure from the wsc file, copies it to the 'character' structure.
// Called by: loadnewworld()
void cGuilds::Read(int guildnumber)
{
	int war=1, member=1, recruit=1,loopexit=0;

	if (guildnumber<0 || guildnumber>=MAXGUILDS)
	{
		sprintf(temp,"invalid guild infmormation entry in wppcs.wsc");
		LogError(temp);
		return;
	}
	guild_st *Guild=&guilds[guildnumber];

	do
	{
		readwsc2();
		if (!strcmp(script1, "NAME")) strcpy(Guild->name, script2);
		else if (!strcmp(script1, "ABBREVIATION")) strcpy(Guild->abbreviation, script2);
		else if (!strcmp(script1, "TYPE")) Guild->type = str2num(script2);
		else if (!strcmp(script1, "CHARTER")) strcpy(Guild->charter, script2);
		else if (!strcmp(script1, "WEBPAGE")) strcpy(Guild->webpage, script2);
		else if (!strcmp(script1, "STONE")) Guild->stone = str2num(script2);
		else if (!strcmp(script1, "MASTER")) Guild->master = str2num(script2);
		else if (!strcmp(script1, "RECRUITS")) Guild->recruits = str2num(script2);
		else if (!strcmp(script1, "RECRUIT")) { if (recruit<MAXGUILDRECRUITS) { Guild->recruit[recruit]=str2num(script2);recruit++; } }
		else if (!strcmp(script1, "MEMBERS")) Guild->members=str2num(script2);
		else if (!strcmp(script1, "MEMBER")) { if (member<MAXGUILDMEMBERS) { Guild->member[member]=str2num(script2);member++;} }
		else if (!strcmp(script1, "WARS")) Guild->wars = str2num(script2);
		else if (!strcmp(script1, "WAR")) { if (war<MAXGUILDWARS) { Guild->war[war]=str2num(script2);war++;} }
		Guild->free=0;
	}
	while ( (strcmp(script1,"}")) && (++loopexit < MAXLOOPS) );
}



// TESTED: OKAY
// guildwrite() writes the guild structure to the wsc file.
// Called by: worldmain()
void cGuilds::Write(FILE *wscfile)
{
	int guildnumber, member, recruit, war;

	for (guildnumber=1;guildnumber<MAXGUILDS;guildnumber++)
	{
		guild_st *Guild=&guilds[guildnumber];
		if (Guild->free==0)
		{
			fprintf(wscfile,"SECTION GUILD %i\n", guildnumber);
			fprintf(wscfile,"{\n");
			fprintf(wscfile,"NAME %s\n", Guild->name);
			fprintf(wscfile,"ABBREVIATION %s\n", Guild->abbreviation);
			fprintf(wscfile,"TYPE %i\n", Guild->type);
			fprintf(wscfile,"CHARTER %s\n", Guild->charter);
			fprintf(wscfile,"WEBPAGE %s\n", Guild->webpage);
			fprintf(wscfile,"STONE %i\n", Guild->stone);
			fprintf(wscfile,"MASTER %i\n", Guild->master);
			fprintf(wscfile,"MEMBERS %i\n", Guild->members);
			for (member=1;member<MAXGUILDMEMBERS;member++)
			{
				if (Guild->member[member]!=0)
				{
					fprintf(wscfile,"MEMBER %i\n", Guild->member[member]);
				}
			}
			fprintf(wscfile,"RECRUITS %i\n", Guild->recruits);
			for (recruit=1;recruit<MAXGUILDRECRUITS;recruit++)
			{
				if (Guild->recruit[recruit]!=0)
				{
					fprintf(wscfile,"RECRUIT %i\n", Guild->recruit[recruit]);
				}
			}
			fprintf(wscfile,"WARS %i\n", Guild->wars);
			for (war=1;war<MAXGUILDWARS;war++)
			{
				if (Guild->war[war]!=0)
				{
					fprintf(wscfile,"WAR %i\n", Guild->war[war]);
				}
			}
			fprintf(wscfile,"}\n\n");
		}
	}
}

int cGuilds::CheckValidPlace(P_PLAYER Player)
{
	if (!Player) return 0;
	PC_ITEM House = findHouseAt(Player->pos); 
	if (House)
	{
		if (Player->hasKeyFor(House))
			return 1;
	}
	Player->Msg("You must be close to a house and have a key in your pack to place that.");
	return 0;
}


/// LB 11'th NOV 2000
/// correkt incorrect guild settings
/// called at startup
void cGuilds::CheckConsistancy()
{
	int guildnumber,members,serial,ok=1,error=0;
	P_CHAR pc_a;
	
	Console.send("checking guild data consistancy\n");
	
	//////////// check the guilds
	
	for (guildnumber=1; guildnumber<MAXGUILDS; guildnumber++)
	{
		guild_st *Guild=&guilds[guildnumber];
		if (Guild->free==0)
		{
			// is the guildmaster still alive ?
			
			ok=1;
			P_CHAR Master = FindCharBySerial(Guild->master);
			if (!Master) // if not, erase the guild !
			{
				ok=0;
				sprintf(temp,"guild: %s erased because guildmaster vanished",Guild->name);
				LogWarning(temp);
				Guilds->EraseGuild(guildnumber);
			}
			
			// guildstone deleted ? yes -> erase guild !
			if (ok) // don't erease twice ;)
			{          		 
				P_ITEM Stone = FindItemBySerial(Guild->stone);
				if (!Stone)
				{
					ok=0;
					sprintf(temp,"guild: %s ereased because guildstone vanished",Guild->name);
					LogWarning(temp);
					Guilds->EraseGuild(guildnumber);
				}
			}
			
			if (ok)
			{
				// check for guildmembers that don't exist anymore and remove from guild structure if so
				for (members=1; members<MAXGUILDMEMBERS; members++)
				{
					serial=Guild->member[members];
					P_CHAR pc = FindCharBySerial( serial );
					
					if (!pc && serial !=0)
					{
						ok=0;							  
						sprintf(temp,"guild: %s had an member that didnt exist anymore, removed\n",Guild->name);
						LogWarning(temp);				
						Guild->member[members]=0;
						Guild->members--;			                 
					}
				}
			}
		}
		if (!ok) error=1;
	}
	
	//////////////// now check all characters for still being in a deleted guild
	
	AllCharsIterator aci;
	for (aci.Begin(); (pc_a=aci.GetData()) != NULL; aci++)
	{
		ok=1;
		
		if (pc_a->npc==0)
		{
			if (pc_a->guildnumber <0 || pc_a->guildnumber>=MAXGUILDS) // invalid guildnumber ?
			{  
				sprintf(temp,"player %s has invalid guild info. cancled his/her guild membership",pc_a->name);
				LogWarning(temp);
				pc_a->guildnumber=0;
				pc_a->guildfealty=0;
				strcpy(pc_a->guildtitle,"");
				pc_a->guildtoggle=0;
				ok=0;
			}
			
			if (ok)
			{
				if (guilds[pc_a->guildnumber].free && pc_a->guildnumber!=0)
				{
					sprintf(temp,"player %s belongs to a guild that is no more. cancled his/her guild membership",pc_a->name);
					LogWarning(temp);
					pc_a->guildnumber=0;
					pc_a->guildfealty=0;
					strcpy(pc_a->guildtitle,"");
					pc_a->guildtoggle=0;
					ok=0;
				}
			}
		}      
		if (!ok) error=1;
	}
	
	if (error) LogWarning("guild releated errors detected and corrected, check logs");
	else Console.send("no errors found\n");
}

void cGuilds::RemoveGuildShield(P_CHAR Player, P_ITEM pi)
{
	soundeffect2(Player, 0x01FE);
	staticeffect(Player, 0x372A, 0x09, 0x06);
	SndRemoveItemToAll(pi);
	Items->DeleItem( pi );
}
