/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#if !defined (__GUILDS_H__)
#define __GUILDS_H__

#include <cstdio>
#include "typedefs.h"
//using namespace std;
// DasRaetsels' stuff down, don't touch ;)

#define	MAXGUILDS 100
#define	MAXGUILDMEMBERS 30
#define	MAXGUILDRECRUITS 30
#define	MAXGUILDWARS 10
#define MAXMEMRECWAR 30 // max of max guildmembers, max recruits and max war
#define DEFAULTCHARTER "LONEWOLF Guildstone"
#define DEFAULTWEBPAGE "http://home1.tiscalinet.de/aduke/"  //this URL doesn't exist, changed to www.wpdev.com ;)

// New structure for basic guild related infos (DasRaetsel)
struct guild_st
{
	unsigned char	free;					// Guild slot used?
	char	name[41];						// Name of the guild
	char	abbreviation[4];				// Abbreviation of the guild
	int		type;							// Type of guild (0=standard/1=chaos/2=order)
	char	charter[51];					// Charter of guild
	char	webpage[51];					// Web url of guild
	int		stone;							// The serial of the guildstone
	int		master;							// The serial of the guildmaster
	int		recruits;						// Amount of recruits
	int		recruit[MAXGUILDRECRUITS + 1];	// Serials of candidates
	int		members;						// Amount of members
	int		member[MAXGUILDMEMBERS + 1];		// Serials of all the members
	int		wars;							// Amount of wars
	int		war[MAXGUILDWARS + 1];			// Numbers of Guilds we have declared war to
	int		priv;							// serial of member to set title
};

class cGuilds
{
private:
	void EraseMember(P_CHAR pc);
	void EraseGuild(int guildnumber);
	void ToggleAbbreviation(P_PLAYER Player);
	int  SearchSlot(int guildnumber, int type);
	void ChangeName(P_PLAYER Player, char *text);
	void ChangeAbbreviation(P_PLAYER Player, char *text);
	void ChangeTitle(P_PLAYER Player, char *text);
	void ChangeCharter(P_PLAYER Player, char *text);
	void ChangeWebpage(P_PLAYER Player, char *text);
	int  CheckValidPlace(P_PLAYER Player);
	void Broadcast(int guildnumber, char *text);
	void CalcMaster(int guildnumber);
	void SetType(int guildnumber, int type);
public:
	guild_st guilds[MAXGUILDS]; //lb, moved from WOLFPACK.h cauz global variabels cant be changed in constuctors ...
	cGuilds();
	virtual ~cGuilds();
	int	GetType(int guildnumber);
	void StonePlacement(P_PLAYER Player, P_ITEM Deed);
	void Menu(P_PLAYER Player, int page);
	void Resign(P_PLAYER Player);
	void Recruit(P_PLAYER Player, P_CHAR pc);
	void TargetWar(P_PLAYER Player, P_CHAR pc);
	void StoneMove(P_PLAYER Player);
	int Compare(P_CHAR Player1, P_CHAR Player2);
	void GumpInput(P_PLAYER Player, int type, int index, char *text);
	void GumpChoice(P_PLAYER Player, int main, int sub);
	int SearchByStone(P_PLAYER Player);
	void Title(int s, P_CHAR pc);
	void Read(int guildnumber);
	void Write(FILE *wscfile);
	void CheckConsistancy(void);
	void RemoveGuildShield(P_CHAR Player, P_ITEM pi);
};


#endif
