/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

// Newbie Stuff Code -- By McCleod

#include "newbie.h"

#include "scriptc.h"
#include "skills.h"

#include "wolfpack.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "newbie.cpp"

static int nextbestskill(P_CHAR pc, int first, int second)  // Which skills are the highest
{
	int i, a = 0, bestval = 0, skval = 0;

	int sk=SkillManager->getAllSkillsValue();
	for (i = 0; i < sk; i++) 
	{
		if (first != -1 && i==first) continue;
		if (second != -1 && i==second) continue;
		skval=pc->getRealSkill(i);
		if (skval > bestval)
		{
			a = i;
			bestval = skval;
		}
	}
	return a;
}


void newbieitems(P_PLAYER pc)
{
	if (!pc) return;
	int itemaddperskill, loopexit = 0;
	char whichsect[15];

	int first = bestskill(pc);
	int second = nextbestskill(pc, first, -1);
	int third = nextbestskill(pc, first, second);
	if (pc->getRealSkill(third) < 190)
		third = 46;	// MEDITATION = NO items

	for (itemaddperskill = 1; itemaddperskill <= 4; itemaddperskill++)
	{
		switch (itemaddperskill)
		{
			case 1: sprintf(whichsect, "BESTSKILL %i", first);	break;
			case 2: sprintf(whichsect, "BESTSKILL %i", second);	break;
			case 3: sprintf(whichsect, "BESTSKILL %i", third);	break;
			case 4: strcpy(whichsect, "DEFAULT");				break;
			default:
				LogError("Fallout of switch.");
		}
		Script* Scp = findSection(newbie_script,whichsect);
		if (!Scp) return;
		while (Scp->NextLineSplitted() &&(++loopexit < MAXLOOPS))
		{
			if (!strcmp("PACKITEM", script1))
			{
				int scpnum = -1, amt = 1;
				int numargs = sscanf(script2,"%i %i", &scpnum, &amt);
				scpMark m; Scp->Suspend(m);
				
				P_ITEM iN = Items->SpawnItemBackpack(pc,scpnum);
				if (iN!=NULL)
				{
					iN->newbieOn(); // Mark as a newbie item
					if (numargs == 2)	// did they give an amount ?
					{
						if (isTruelyPileable(iN->id()))
							iN->amount = amt;
					}
				}
				Scp->Resume(m);
			}
			/* pretty much nonsense imho. At the time of creation, NO newbie can already have a bankbox ! (Duke)
			else if (!strcmp("BANKITEM", script1))
			{
				storeval = str2num(script2);
				pos = ftell(scpfile);
				closescript();
			
				P_ITEM pi = Items->SpawnItemBank(pc, storeval); // Tauriel 11-24-98
				if (pi != NULL)
					pi->newbieOn(); // Mark as a newbie item
				strcpy(script1, "DUMMY");
				openscript("newbie.scp");
				fseek(scpfile, pos, SEEK_SET);
			} */
		}	
	    Scp->Close();
	}
}
 

  
