/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#if !defined (__POINTER_H__)
#define __POINTER_H__

#include "defines.h"	// only for EXP1
#include "platform.h"
#include "typedefs.h"

#include <vector>

// Duke (14.3.06), experimental stuff
#if EXP1
void setGameSerial(P_PLAYER Player);
void setCurrSerial(int gameSer,P_PLAYER Player);
P_CHAR getByGameSerial(void);
int gameSerial(int ser);
int trueSerial(int ser);
inline bool isSameSerial(int ser1, int ser2) {return (ser1==ser2 || gameSerial(ser1) == gameSerial(ser2));}
#else
inline int trueSerial(int ser) {return ser;}
inline int gameSerial(int ser) {return ser;}
inline bool isSameSerial(int ser1, int ser2) {return (ser1==ser2);}
#endif


struct lookuptr_st // Tauriel  used to create pointers to the items dynamically allocated
{               //         so don't mess with it unless you know what you are doing!
	int max;
	int *pointer;
};

bool BuildPointerArray();
int	ContainerCountItems(const int serial, short id=-1, short color=-1, short type=-1);
P_ITEM ContainerSearch(const int serial, int *ci);
P_ITEM ContainerSearchFor(const int serial, int *ci, short id, short color=-1);
P_CHAR FindCharBySerial(int serial);
P_CHAR FindCharBySerPtr(unsigned char *p);
P_CHAR FindWearerOf(PC_ITEM pi);
P_ITEM FindItemBySerial(int serial);
P_ITEM FindItemBySerPtr(unsigned char *p);
P_CHAR SearchOwnedPets(const int serial, int *ci);
P_ITEM SearchOwnedItems(const int serial, int *ci);
P_ITEM SearchSpawnedItems(const int serial, int *ci);
P_CHAR SearchSpawnedChars(const int serial, int *ci);
P_ITEM SearchGlowers(const int serial, int *ci);
void AllContainerItemsInStableOrder(const int contserial, std::vector<P_ITEM> & pitems);

void setptr(lookuptr_st *ptr, int item);
void setptr(lookuptr_st *ptr, P_CHAR pc);
void setptr(lookuptr_st *ptr, PC_ITEM pi);
void removefromptr(lookuptr_st *ptr, int nItem);// - remove item from pointer array
void removefromptr(lookuptr_st *ptr, P_CHAR pc);
void removefromptr(lookuptr_st *ptr, PC_ITEM pi);

void addToItemSp(const P_ITEM pi);
void addToCharSp(const P_CHAR pi);
void addToContSp(int serial,const P_ITEM pi);
void addToSpawnSp(int serial,const P_ITEM pi);
void addToCspawnSp(int serial,const P_CHAR pc);
void addToOwnSp(int serial,const P_ITEM pi);
void addToCownSp(int serial,const P_CHAR pc);
void addToGlowSp(const P_CHAR pc,PC_ITEM pi);
void delFromItemSp(const P_ITEM pi);
void delFromCharSp(const P_CHAR pc);
void delFromContSp(int serial,const P_ITEM pi);
void delFromSpawnSp(int serial,const P_ITEM pi);
void delFromCspawnSp(int serial,const P_CHAR pc);
void delFromOwnSp(int serial,const P_ITEM pi);
void delFromCownSp(int serial,const P_CHAR pc);
void delFromGlowSp(const P_CHAR pc,const P_ITEM pi);

#endif
