/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#ifndef __SKILLS_H__
#define __SKILLS_H__

#include "typedefs.h"
#include "CArray.h"
#include "globals.h"


enum skillenum
{
	ALCHEMY=0,
	ANATOMY=1,
	ANIMALLORE=2,
	ITEMID=3,
	ARMSLORE=4,
	PARRYING=5,
	BEGGING=6,
	BLACKSMITHING=7,
    BOWCRAFT=8,
    PEACEMAKING=9,
    CAMPING=10,
    CARPENTRY=11,
    CARTOGRAPHY=12,
    COOKING=13,
    DETECTINGHIDDEN=14,
    ENTICEMENT=15,
    EVALUATINGINTEL=16,
    HEALING=17,
    FISHING=18,
    FORENSICS=19,
    HERDING=20,
	HIDING=21,
    PROVOCATION=22,
    INSCRIPTION=23,
    LOCKPICKING=24,
    MAGERY=25,
    MAGICRESISTANCE=26,
    TACTICS=27,
    SNOOPING=28,
    MUSICIANSHIP=29,
    POISONING=30,
    ARCHERY=31,
    SPIRITSPEAK=32,
    STEALING=33,
    TAILORING=34,
    TAMING=35,
    TASTEID=36,
    TINKERING=37,
    TRACKING=38,
    VETERINARY=39,
    SWORDSMANSHIP=40,
    MACEFIGHTING=41,
    FENCING=42,
    WRESTLING=43,
    LUMBERJACKING=44,
    MINING=45,
	MEDITATION=46,
    STEALTH=47,
    REMOVETRAPS=48,	
	NECROMANCY=49,
	FOCUS=50,
	CHIVALRY=51,
	BUSHIDO=52,
	NINJITSO=53,
	ALLSKILLSNONAOS=49,
	ALLSKILLSAOS=52,
	ALLSKILLSSE=54,
	ALLSKILLSMAX=54, // for array declaration
	STR=54,        // for the set 
	DEX=55,
	INTELL=56,
	FAME=57,
	KARMA=58,
	SKILLS=59,
	ALL=123,
};

struct advance_st
{
	unsigned char skid;
	int base;
	int success;
	int failure;
};

struct skill_st
{
	int st;
	int dx;
	int in;
	int advance_like;
	int advance_index;
	char madeword[50]; // Added by Magius(CHE)
	bool reveals; //added by thrawn: skill reveals the player if true
};

struct sOreResource
{
	void InitNullValues();
	char Name[20];
	short OreColor;
	short IngotColor;
	short ItemColor;		// used for smelting items into ingots
	short MinSkill;
	int Chance;
	int SmithMenu;
	int TinkerMenu;
	int ScriptPos;
};

class cCrafting
{
private:		// variables
	sOreResource OreTable[50];
	int OreTableSize;
private:		// functions
	void LoadOreResource(int pos, int ResourceNumber);
public:
	cCrafting();
	void LoadOreTable();
	const sOreResource* GetByOreColor(unsigned short color);
	const sOreResource* GetByIngotColor(unsigned short color);
	const sOreResource* GetByItemColor(unsigned short color);
	const sOreResource* getColorFound(unsigned short skill);
};

class cSkills
{
public:		// variables
	cCrafting Crafting;
private:
	void Tracking(P_PLAYER Player, int selection);
	int  GetSubIngotAmt(int p, char id1, char id2, char color1, char color2);
	int  DeleSubIngot(int p, int id1, int id2, int color1, int color2, int amount);
	P_ITEM GetInstrument(P_PLAYER Player);
	int  calcRank(P_PLAYER Player, int skill); // by Magius(CHE)
	void applyRank(P_PLAYER Player, P_ITEM pi,int rank); // by Magius(CHE)
	void Zero_Itemmake(make_st* imk); // by Magius(CHE)
public:
	void Meditation(P_PLAYER Player);
	void Hide(P_PLAYER Player);
	void Stealth(P_PLAYER Player);
	void PeaceMaking(P_PLAYER Player);
	void InitCraftingClass();
	void RepairTarget(P_PLAYER Player, P_ITEM pi); // Ripper
	void SmeltItemTarget(P_PLAYER Player, P_ITEM pi); // Ripper
	void TasteIDTarget(P_PLAYER Player, P_ITEM pi);
	int  TrackingDirection(int s, P_CHAR pc_i);
	void CreatePotion(P_PLAYER Player, char type, char sub, P_ITEM Mortar);
	void TinkerAxel(P_PLAYER Player, P_ITEM pi);
	void TinkerAwg(P_PLAYER Player, P_ITEM pi);
	void TinkerClock(P_PLAYER Player, P_ITEM pi);
	void MakeDough(P_PLAYER Player, P_ITEM pi);
	void MakePizza(P_PLAYER Player, P_ITEM pi);
	void Track(P_PLAYER Player);
	void DoPotion(P_PLAYER Player, int type, int sub, P_ITEM Mortar);
	void Tailoring(P_PLAYER Player, P_ITEM pi);
	void Fletching(P_PLAYER Player, P_ITEM pi);
	void BowCraft(int s, P_PLAYER Player,const P_ITEM pi);
	void Carpentry(P_PLAYER Player, P_ITEM pi);
	void Smith(P_PLAYER Player, P_ITEM pi);
	void MakeMenuTarget(P_PLAYER Player, int x, int skill);
	void MakeMenu(P_PLAYER Player, int m, int skill); // Menus for playermade objects
	void Mine(P_PLAYER Player, const cCoord& minepos, short tmodel);
	void GraveDig(P_PLAYER Player);
	void SmeltOre(P_PLAYER Player, P_ITEM pi);
	void Wheel(P_PLAYER Player, P_ITEM pi, int mat);
	void Loom(P_PLAYER Player, P_ITEM pi);
	void CookOnFire(P_CHAR Player, P_ITEM pi);
	void TreeTarget(P_PLAYER Player, const cCoord& Tpos);
	void DetectHidden(P_PLAYER Player, const cCoord& Tpos);
	void ProvocationTarget1(P_PLAYER Player, P_CHAR pc);
	void ProvocationTarget2(UOXSOCKET s, P_PLAYER Player, P_CHAR pc);
	void EnticementTarget1(P_PLAYER Player, P_CHAR pc);
	void EnticementTarget2(P_PLAYER Player, P_CHAR pc);
	void AlchemyTarget(P_PLAYER Player, P_ITEM pi);
	void BottleTarget(P_PLAYER Player, P_ITEM pi);
	void PotionToBottle(P_PLAYER Player, P_ITEM Mortar);
	void CreateBandageTarget(P_PLAYER Player, P_ITEM pi);
	void HealingSkillTarget(P_PLAYER Player, P_CHAR pc);
	void SpiritSpeak(P_PLAYER Player);
	void ArmsLoreTarget(P_PLAYER Player, P_ITEM pi);
	void ItemIdTarget(P_PLAYER Player, P_ITEM pi);
	void EvaluateIntTarget(P_PLAYER Player, P_CHAR pc);
	void AnatomyTarget(P_PLAYER Player, P_CHAR pc);
	void TameTarget(P_PLAYER Player, P_CHAR pc);
	void TameTargetPart2(P_CHAR Tamer, P_CHAR Pet);
	void TameTargetPart3(P_CHAR Tamer, P_CHAR Pet);
	int  GetCombatSkill(P_CHAR pc);
	void StealingTarget(P_PLAYER Player, int serial);
	void PickPocketTarget(P_PLAYER Player);
	void CreateTrackingMenu(P_PLAYER Player, int m);
	void TrackingMenu(P_PLAYER Player, int gmindex);
	void BeggingTarget(P_PLAYER Player, P_CHAR pc);
	void AnimalLoreTarget(P_PLAYER Player, P_CHAR pc);
	void ForensicsTarget(P_PLAYER Player, P_ITEM pi);
	void PoisoningTarget(P_PLAYER Player, P_ITEM pi);
	void Inscribe(P_PLAYER Player, P_ITEM pi);
	int  EngraveAction(P_PLAYER Player, P_ITEM pi, int cir, int spl);
	void LockPick(P_PLAYER Player, P_ITEM pi);
	bool TDummy(P_CHAR Player, P_ITEM pi);
	void NewDummy(unsigned int currenttime);
	void Tinkering(P_PLAYER Player, P_ITEM pi);
	bool AButte(P_CHAR Player, P_ITEM pButte);
	void Persecute(P_PLAYER Player);//AntiChrist persecute stuff
	void Cartography(P_PLAYER Player); // By Polygon - opens the cartography skillmenu
	bool HasEmptyMap(P_CHAR Player); // By Polygon - checks if player has an empty map
	bool DelEmptyMap(P_CHAR Player); // By Polygon - deletes an empty map from the player's pack
	void Decipher(P_PLAYER Player, P_ITEM tmap);	// By Polygon - attempt to decipher a tattered treasure map
	int  GetAntiMagicalArmorDefence(P_CHAR pc);		// blackwind meditation armor stuff
	void Snooping(P_PLAYER Player, P_ITEM);
	void FishTarget(P_PLAYER Player, const cCoord& Tpos, const short landid);	
};


/// skill checks & advancement stuff
class cSkillManagement
{
   public:

	 cSkillManagement::cSkillManagement(void);
     bool AdvanceSkill(P_CHAR pc, int sk, char skillused);
	 char* getMadeWord(int sk);
	 const char* getSkillName(int sk);
	 void updateSkillLevel(P_CHAR pc, int skill);
	 void SkillUse(P_PLAYER Player, int x);
	 void loadskills(); // to be mvoed to c'tor
	 void skillVars();  // to be moved to c'tor
	 bool CheckSkill(P_CHAR pc,unsigned short int sk, int low, int high);
	 advance_st* FindAdvanceInfo(int sk, int val);
	 int calcStatIncrement(int stat, int val);
	 void AdvanceStats(P_CHAR pc, int sk);
	 int getAllSkillsValue(void);

   private:

	   CArray<1000, advance_st>wpadvance;
       CArray<SKILLS+1, skill_st>skill;
	   std::string skillname[SKILLS+1];	

};

class cAllMakeMenus
{
public:
	bool displayMenu(int mm, P_PLAYER Player);
	void executeSelection(int mm, int selected, P_PLAYER Player);
};


void TellScroll(P_PLAYER Player, char *menu_name, long item_param );

#endif
