/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#include "speech.h"

#include "boats.h"
#include "Client.h"
#include "commands.h"
#include "guilds.h"
#include "house.h"
#include "LoS.h"
#include "msgboard.h"
#include "npcinfo.h"
#include "regions.h"
#include "scriptc.h"
#include "skills.h"
#include "SndPkg.h"
#include "targeting.h"
#include "trigger.h"
#include "utilsys.h"
#include "network.h"

#include "wolfpack.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "speech.cpp"

int preProcessRawspeechData(UOXSOCKET s)
{
	int myoffset,mysize,i;
	int iWord = static_cast<int> (ShortFromCharPtr(&buffer[s][1])) ;			
	if ( (buffer[s][3]) >= 0xc0 )
	{
		wchar_t mytempbuf_wc[512];
		buffer[s][3] = buffer[s][3] & 0x0F ; // set to normal (cutting off the ascii indicator since we are converting back to unicode)					
		
		int num_words,/*idx=0,*/ bytes_speechmuldata;
		
		// number of distict trigger words
		num_words = ( (static_cast<int>(buffer[s][12])) << 24 ) + ( (static_cast<int>(buffer[s][13])) << 16 );
		num_words = num_words & 0xfff00000;
		num_words = (num_words >> 20);
		
		// 12 bits for number of words + 12 bits for index to speech.mul for each, padded to next byte

		bytes_speechmuldata = 12 + num_words*12;
		if ((bytes_speechmuldata % 8) == 0) bytes_speechmuldata/=8; else { bytes_speechmuldata/=8; bytes_speechmuldata++;}
		
		myoffset = 12 + bytes_speechmuldata;
				
		int aout=0 ;		
		mysize = iWord - myoffset ;	
	
		utf8_to_unicode_string(&buffer[s][myoffset], mysize, aout, mytempbuf_wc);	
		
		//	Now adjust the buffer		
		myoffset=12;
		for (i=0; i < aout ; i++)
		{				
		  buffer[s][myoffset+2*i+1]  = static_cast<unsigned char>(mytempbuf_wc[i]);
		  buffer[s][myoffset+2*i]    = static_cast<unsigned char>(mytempbuf_wc[i] >> 8);		 
		}
		
		iWord = ( 12 + (aout * 2) ) ;	
		ShortToCharPtr(iWord,&buffer[s][1]);
		
		return aout;
	}

	return (iWord-12)/2;
}

bool InputSpeech(char* comm, P_PLAYER Player)
{
	int i;
	
	if (Player->inputmode)		// Speech is directly used to set a member
	{
		P_ITEM iInputItem=FindItemBySerial(Player->inputitem);
		if (iInputItem!=NULL)
		{
			switch (Player->inputmode)
			{
			case 1:// Pricing an item //PlayerVendors
				i = str2num(comm);
				if (i>0)
				{						
					iInputItem->value = i;
					sprintf(temp,"This item's price has been set to %i.", i);
					Player->Msg(temp);				
				}
				else 
				{
					sprintf(temp,"No price entered, this item's price has been set to %i.", iInputItem->value);
					Player->Msg(temp);
				}
				Player->inputmode = 2;
				Player->Msg("Enter a description for this item.");
				return true;
			case 2:// Describing an item
				strcpy(iInputItem->desc, comm);
				sprintf(temp,"This item is now described as %s, ", comm);
				Player->Msg(temp);
				Player->setInput(0,NULL);
				return true;
			case 4:
				sprintf(iInputItem->name, "Rune to %s", comm);
				sprintf(temp,"Rune renamed to: Rune to %s", comm);
				Player->Msg(temp);
				Player->setInput(0,NULL);
				return true;
			case 5: // eagle rename deed
				strcpy(Player->name, comm);
				sprintf(temp,"Your new name is: %s", comm);
				Player->Msg(temp);
				Player->setInput(0,NULL);
				return true;
			case 6: // Morrolan key rename stuff
				strcpy(iInputItem->name, comm);
				sprintf(temp,"Renamed to: %s", comm);
				Player->Msg(temp);
				Player->setInput(0,NULL);
				return true;
			default:
				;	// do nothing
			}
		}
	}

	if (Player->pagegm)
		return Commands->GetPageReason(Player,comm);

	return false;
}

// returns true if the speech has been handled
bool StableSpeech(cChar* pMaster, char* comm, cChar* Player, UOXSOCKET s)
{
	if (pMaster->npc_type!=1)	// is it a stablemaster ?
		return 0;

    if (!strstr( comm, "STABLE"))	// lets check if the keyword stable is in the commandstring, if not return !
		return 0;
      
	/////////////////////////////////////////////////////////////////////
	//// so far we have a stablemaster! lets see if the caller has a pet
	//// if so check if the pets name is in the commandstring
	//// if not return
    ///////////////////////////////////////////////////////////////////
	
	bool found=false;
	cChar* Pet;
	int loopexit=0;

	RegGrid3x3Iterator4Chars rg3ic(Player->pos);
	while((Pet = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (Player->dist(Pet) <= 8)
		{
			if (Player->Owns(Pet) && Pet->stablemaster_serial==0) //owner of the pet ? and not already stabled ?
			{
				char pntmp[150];
				strcpy(pntmp,Pet->name);
				strupr(pntmp);
				if (strstr( comm, pntmp)) //if petname is in
				{
					found=true;
					break;
				}
			}
		}
	}

	if (!found) 
	{ 
		npctalk(s,pMaster,"which pet?");
		return 1;
	} 

	/////////////////////////////////////////////////////////////
	/// now we have a pet and stablemaster -> time to STABLE :-)
    ////////////////////////////////////////////////////////////
	
    // set stablesp && pets stablemaster serial
	
	// remove it from screen!

	cCoord PetPos(Pet->pos);
	short id=Pet->id(); 
	Pet->setId(0); 
	Pet->pos.x=0;
	Pet->pos.y=0;

	for (unsigned int j=0; j<now; j++)
	{	
		if (perm[j]) impowncreate(j, Pet, 0); 
	}

	Pet->setId(id); 
	Pet->war=0;
	Pet->setAttacker(NULL);
	Player->war=0;
	Player->ResetTarget();
	Pet->pos=PetPos;

	mapRegions->Remove(Pet);

	Pet->stablemaster_serial=pMaster->serial;

	// set timer for fee calculation

    Pet->time_unused=0;
	Pet->timeused_last = getNormalizedTime();

	stablesp.insert(pMaster->serial, Pet->serial);
//    setptr(&stablesp[stablemaster_serial%HASHMAX], pet);

	sprintf(temp,"Your pet is now stabled, say claim %s to claim your pet",Pet->name);
	npctalk(s,pMaster,temp);

	return 1;
}

bool UnStableSpeech(cChar* pMaster, char* comm, cChar* Player, UOXSOCKET s)
{
	if (pMaster->npc_type!=1)	// is it a stablemaster ?
		return 0;

	char *pn=strstr( comm, "CLAIM");	// lets check if the keyword CLAIM is in the commandstring, if not return !
	if (!pn)
		return 0;
	pn+=5;		// skip over keyword

	/////////////////////////////////////////////////////////////////////
	//// so far we have a stablemaster! lets see if the stablemaster has a pet
	//// stabled the petowner owns
	//// if not return
    ///////////////////////////////////////////////////////////////////
	unsigned int ci;	
	P_CHAR  Pet = NULL;
	bool found = false;
	vector<SERIAL> pets = stablesp.getData(pMaster->serial);
    for (ci = 0; ci < pets.size(); ci++)
	{
		Pet = FindCharBySerial(pets[ci]);
		if (Pet != NULL)
		{
			 if (Player->Owns(Pet) && Pet->stablemaster_serial!=0) // already stabled and owned by claimer ?
			 {
				char search3[150];
				strcpy(search3,Pet->name);
		        strupr(search3);
		        if (strstr( pn, search3)) //if petname is in
				{
					found=true;
					break;
				}
			}
		}
	}
	if (!found) 
	{ 
		npctalk(s,pMaster,"sorry, I can't return that pet");
		return 1;
	} 

	/////////////////////////////////////////////////////////////
	/// now we have the claimed pet and stablemaster -> time to UNSTABLE :-)
    ////////////////////////////////////////////////////////////

	/// calc fee
	float f_fee = ( (Pet->time_unused) / 600.0f) * SrvParms->stablingfee ; // (fee per 10 minutes) * number of 10 minute blocks
	int fee = ( (int) f_fee) + 5; // 5 basefee

	sprintf(temp,"That's %i gold pieces",fee);
	npctalk(s,pMaster,temp);

	/////////// check if customer can pay ! ///////////////    
	if (!Player->canAfford(fee)) // if not enough gold in bp, dont try to subtract gold !
	{
		sprintf(temp,"you can't afford that %i",fee);
		npctalk(s,pMaster,temp);
		return 1;
	}
	else
	{
		Player->pay(fee);
	}
	
    //// if paid -> return pet
	
	// remove from hash table
	stablesp.remove(pMaster->serial, Pet->serial);
	//	  removefromptr(&stablesp[stablemaster_serial%HASHMAX], pet);
	
	Pet->stablemaster_serial=0; // actual unstabling
	
	Pet->timeused_last=getNormalizedTime();
	Pet->time_unused=0;
	
	mapRegions->Add(Pet);
	
	for (unsigned int j=0; j<now; j++)
	{	
		if (perm[j]) impowncreate(j, Pet, 0); 
	}
	
	npctalk(s,pMaster,"Thx! Here's your pet");
	return 1;
}

bool ShieldSpeech(cChar* pGuard, char* comm, P_PLAYER Player)
{
	if (Player->dist(pGuard) > 3)	// lets be close to talk :)
		return 0;

	UOXSOCKET s = Player->cs;			
	if (pGuard->npcaitype == 6)	// chaos guard
	{
		if (strstr( comm, "CHAOS SHIELD")) //Ripper...if in chaos guild get a new shield.
		{	// if they say chaos shield
			if (Player->guildnumber==0)	// if not in a guild.
			{
				npctalk(s,pGuard,"You must be in a chaos guild to get a shield!");
			}
			else if (Guilds->GetType(Player->guildnumber)==1)	// if they are in a order guild.
			{
				npctalk(s,pGuard,"Sorry but you are in a order guild!");
			}
			else if (Guilds->GetType(Player->guildnumber)==2)	// if they are in a chaos guild.
			{
				if (Player->CountItems(0x1BC3)>0)
					// if they have a chaos shield in their pack lets stop here.
				{
					npctalk(s,pGuard,"you already have a shield!");
				}
				else
				{
					Player->removeItemsFromHands(0x1BC3);
					// if they are wearing a chaos shield lets just delete it.
					Items->SpawnItemBackpack(Player, SrvParms->hci.ChaosShield);	// lets give them a new chaos shield.
					npctalk(s,pGuard,"Hi fellow guild member,here is your new shield.");
				}
			}
			return 1;
		}
	}

	if (pGuard->npcaitype == 7)	// order guard
	{
		if (strstr( comm, "ORDER SHIELD")) //Ripper...if in order guild get a new shield.
			// if they say order shield
		{
			if (Player->guildnumber==0)	// if not in a guild.
			{
				npctalk(s,pGuard,"You must be in a order guild to get a shield!");
			}
			else if (Guilds->GetType(Player->guildnumber)==2)	// if they are in a chaos guild.
			{
				npctalk(s,pGuard,"Sorry but you are in a chaos guild!");
			}
			else if (Guilds->GetType(Player->guildnumber)==1)	// if they are in a order guild.
			{
				if (Player->CountItems(0x1BC4)>0)
					// if they have a order shield in their pack lets stop here.
				{
					npctalk(s,pGuard,"you already have a shield!");
				}
				else
				{
					Player->removeItemsFromHands(0x1BC4);
					// if they are wearing a order shield lets just delete it.
					Items->SpawnItemBackpack(Player, SrvParms->hci.OrderShield);	// lets give them a new order shield.
					npctalk(s,pGuard,"Hi fellow guild member,here is your new shield.");
				}
			}
			return 1;
		}
	}
	return 0;
}

bool QuestionSpeech(cChar* pc, char* comm, cChar* Player, UOXSOCKET s)
{
	if (pc->isAiMonster() || !pc->isHuman() || Player->dist(pc) > 3)
		return 0;
	
    if (strstr( comm, "NAME")) //Ripper...say name and a npc will tell you there name :).
	{
		sprintf(temp, "Hi my name is %s.", pc->name);
		npctalkall(pc,temp);
		return 1;
	}
	
    if (strstr( comm, "TIME")) //Ripper...say time and the npc gives the time.
	{
		sprintf(temp, "It is now %2.2d : %2.2d in the %s.", timeLight.hour, timeLight.minute,
				(timeLight.ampm || (!timeLight.ampm && timeLight.hour==12)) ? "evening" :"morning");
		npctalkall(pc,temp);
		return 1;
	}
	
    if (strstr( comm, "LOCATION") || strstr( comm, "WHERE AM I")) //Ripper...gives location of char.
	{
		if (strlen(region[Player->region].name)>0)
			sprintf(temp, "You are in %s",region[Player->region].name); 
		else strcpy(temp,"You are in the wilderness");
		npctalkall(pc,temp);
		
		sprintf(temp, "%i %i (%i)",Player->pos.x,Player->pos.y,Player->pos.z); 
		npctalkall(pc,temp);
		return 1;
	}
	return 0;
}

//Ripper...Packup a player vendor without redeeding house.
bool PackupSpeech(cChar* pc, char* comm, P_PLAYER Player)
{
	if (   !pc->isAiVendor()	// player vendor
		|| !Player->Owns(pc)	// you own the vendor
		|| Player->dist(pc) > 3) // must be within 3 tiles.
		return 0;

	if (strstr( comm, "PACKUP"))
	{
		// lets make the deed and place in your pack and delete vendor.
		eItemTypes ty = (pc->GetPriv4()==0) ? ITY_VendorDeed: ITY_VendorDeedWithoutHouse;
		P_ITEM pDeed = Items->SpawnItem(ty,1,"employment deed",0x14F0,0,Player);
		if (pDeed)
		{
			pDeed->value = 2000;
			Npcs->DeleteChar(pc);
			sprintf(temp,"Packed up vendor %s.", pc->name);
			Player->Msg(temp);
		}
		return 1;
	}
	return 0;
}

bool TriggerSpeech(cChar* pc, char* comm, P_PLAYER Player)
{
	if (inRange(Player->pos,pc->pos, 4) &&
		abs(Player->pos.z-pc->pos.z)<=5)
	{
		if (pc->trigger)
		{
			if (strlen(pc->trigword))
			{
				char twtmp[150];
				strcpy(twtmp, pc->trigword);
				strupr(twtmp);
				if (strstr( comm, twtmp))
				{
					if (pc->disabledTimer.IsRunning())//AntiChrist
					{
						npctalkall(pc,"I'm a little busy now! Leave me be!");
					}
					else
					{
						triggernpc(Player,pc,1);
					}
					return 1;
				}
			}
		}
	}
	return 0;
}

bool EscortSpeech(cChar* Escortee, char* comm, cChar* Player, UOXSOCKET s)
{
	// Dupois - Added Dec 20, 1999
	// Escort text matches
	if (Player->dist(Escortee) > 1 || Escortee->questType!=ESCORTQUEST )
		return 0;	// not close enough / not an escortee
	
	char *response1=strstr( comm, "I WILL TAKE THEE");
	char *response2=strstr( comm, "DESTINATION");
	if ( response1 || response2 )	// If either of the above responses match
	{
		// I WILL TAKE THEE
		// If this is a request for hire
		if ( response1 )
		{
			if ( !Escortee->IsFollowing() )
			{
				Escortee->SetFollowTarget(Player);// Set the NPC to follow the PC
				Escortee->npcWander = 1;			// Set the NPC to wander freely
				// Set the expire time if nobody excepts the quest
				Escortee->summontimer.setSecs(SrvParms->escortactiveexpire);
				// Send out the rant about accepting the escort
				sprintf(temp, "Lead on! Payment shall be made when we arrive at %s.", region[Escortee->questDestRegion].name);
				npctalkall(Escortee,temp);
				MsgBoardQuestEscortRemovePost(Escortee);	// Remove post from message board
				return 1;	// Return 1 so that we indicate that we handled the message
			}
			else
			{
				response2 = response1;	// If the current NPC already has an ftarg then respond to query for quest
			}
		}
		
		// DESTINATION
		// If this is a request to find out where a NPC wants to go and the PC is within range of the NPC and the NPC is waiting for an ESCORT
		if (response2)
		{
			if ( !Escortee->IsFollowing() )  // If nobody has been accepted for the quest yet
			{
				// Send out the rant about accepting the escort
				sprintf(temp, "I am seeking an escort to %s. Wilt thou take me there?", region[Escortee->questDestRegion].name);
			}
			else
			{
				P_CHAR Escort = Escortee->GetFollowTarget();
				if ( Escort->isSameAs(Player) )
				{
					// Send out the rant about accepting the escort
					sprintf(temp, "Lead on to %s. I shall pay thee when we arrive.", region[Escortee->questDestRegion].name);
				}
				else // The must be enroute
				{
					// Send out a message saying we are already being escorted
					sprintf(temp, "I am already being escorted to %s by %s.",
						region[Escortee->questDestRegion].name, Escort->name );
				}
			}
			npctalkall(Escortee,temp);
			return 1;	// Return success ( we handled the message )
		}
	}
	return 0;	// speech was not handled
}

bool BankerSpeech(cChar* pBanker, char* comm, P_PLAYER Player)
{
	if ( pBanker->npcaitype != 8 )	// not a banker
		return 0;
	if (Player->dist(pBanker) > 6)
		return 0;
	
	UOXSOCKET s = Player->cs;
	if (strstr(comm, "BANK"))
	{
		openbank(s, Player);
		return true;
	}
	if (strstr(comm, "BALANCE"))
	{
		sprintf(temp, "%s's balance as of now is %i.", Player->name, Player->CountBankGold());
		npctalkall(pBanker, temp);
		return true;
	}
	if (strstr(comm, "CHECK"))
	{
		int amt = 0;
		if (sscanf(comm,"CHECK %i", &amt) == 1)
		{
			bankcheck(pBanker, Player, amt);
			return true;
		}
		return false;
	}
	if (strstr(comm, "WITHDRAW"))
	{
		int amt = 0;
		if (sscanf(comm,"WITHDRAW %i", &amt) == 1)
		{
			bankwithdrawal(pBanker, Player, amt);
			return true;
		}
		return false;
	}

	if (SrvParms->usespecialbank)	//this only if specialbank is enabled - AntiChrist
	{
		if (strstr(comm, SrvParms->specialbanktrigger))
		{
			openspecialbank(Player);
			return true;
		}
	}
	return 0;
}

bool TrainerSpeech(cChar* Trainer, char* comm, cChar* Player, UOXSOCKET s)
{
	if (Player->dist(Trainer) > 3 || !Trainer->isHuman())
		return 0;
	if (!(strstr(comm,"TRAIN") || strstr(comm,"TEACH") || strstr(comm,"LEARN"))) //if the player wants to train
		return 0;

	int i,skill=-1;
	Player->trainer=-1; //this is to prevent errors when a player says "train <skill>" then don't pay the npc
	int sk=SkillManager->getAllSkillsValue();
	for(i=0;i<sk;i++)
	{
		if (strstr(comm, SkillManager->getSkillName(i)))
		{
			skill=i;  //Leviathan fix
			break;
		}
	}
		
	if (skill==-1) // Didn't ask to be trained in a specific skill - Leviathan fix
	{
		if (Player->trainer==-1) //not being trained, asking what skills they can train in
		{
			Trainer->trainingplayerin='\xFF'; // Like above, this is to prevent  errors when a player says "train <skill>" then doesn't pay the npc
			strcpy(temp,"I can teach thee the following skills: ");
			int j,y = 0;
			int sk=SkillManager->getAllSkillsValue();
			for(j=0;j<sk;j++)
			{
				if (Trainer->getRealSkill(j)>=10 && Player->getRealSkill(j)<250)
				{
					sprintf(temp2,"%s, ", SkillManager->getSkillName(j));
					strlwr(temp2);
					if (!y) temp2[0]=toupper(temp2[0]); // If it's the first skill,  capitalize it.
					strcat(temp,temp2);
					y++;
				}
			}
			if (y && Trainer->cantrain) // skills and a trainer ?
			{
				temp[strlen(temp)-2]='.'; // Make last character a . not a ,  just to look nicer
				npctalk(s, Trainer, temp);
			}
			else
			{
				npctalk(s, Trainer, "I am sorry, but I have nothing to teach thee");
			}
			return 1;
		}
	}
	else // They do want to learn a specific skill
	{
		if (Trainer->getRealSkill(skill)>10 && Trainer->cantrain)
		{
			strcpy(temp2,SkillManager->getSkillName(skill));
			strlwr(temp2);
			sprintf(temp,"Thou wishest to learn of %s?",temp2);
			if (Player->getRealSkill(skill)>=250)
			{
				strcat(temp, " I can teach thee no more than thou already knowest!");
			}
			else
			{
				int sum = Player->getSkillSum();
				if ((unsigned)sum >= SrvParms->skillcap * 10)
					strcat(temp, " I can teach thee no more. Thou already knowest too much!");
				else
				{
					int delta = Trainer->getTeachingDelta(Player, skill, sum);
					int val = (Player->getRealSkill(skill) + delta)/10;
					
					sprintf(temp2, " Very well I, can train thee up to the level of %i for %i gold. Pay for less and I shall teach thee less.",val,delta);
					strcat(temp, temp2);
					Player->trainer=Trainer->serial;
					Trainer->trainingplayerin=skill;
				}
			}
			npctalk(s, Trainer, temp);
		}
		else
		{
			npctalk(s, Trainer, "I am sorry but I cannot train thee in that skill.");
		}
		return 1;
	}
	return 0;	// speech was NOT handled
}

int PetCommand(cChar* Pet, char* comm, P_PLAYER Player, UOXSOCKET s)
{
	if (Pet->isDummy()) return 0;	// dont command "dummy" npcs
	if (!(Player->Owns(Pet) || Player->isGM())) //owner of the char or a GM
		return 0;
	if (Pet->isAiVendor())			// player vendor
		return 0;
	if (Player->dist(Pet) > 7)		// too far away to hear us
		return 0;
	
	char petname[60];
	strcpy(petname,Pet->name);
	strupr(petname);

	bool theySaidALL = false;
	addz[s] = 0;
	if (strstr(comm,"ALL "))
	{
		theySaidALL = true;
		addz[s] = 1;
	}

	if (!theySaidALL && !strstr(comm,petname))
		return 0;
		
	if (strstr(comm," FOLLOW"))
	{
		Player->guarded = false;
		if (strstr( comm, " ME"))	//if me is in
		{
			Pet->SetFollowTarget(Player);
			Pet->npcWander=1;
			playmonstersound(Pet, SND_STARTATTACK);
		}
		else
		{
			addx[s]=Pet->serial;
			target(Player, T_117, "Click on the target to follow.");
		}
		return 1;
	}
	
	if (strstr(comm," KILL") || strstr(comm," ATTACK"))
	{
		if (Pet->inGuardedArea()) // Ripper..No pet attacking in town.
		{
			Player->Msg("You cant have pets attack in town!");
			return 0;
		}
		Player->guarded = false;
		addx[s]=Pet->serial;
		target(Player, T_118, "Select the target to attack.");//AntiChrist
		return theySaidALL ? 2 : 1;
	}
	
	if (strstr(comm," PRACTICE"))
	{
		Player->guarded = false;
		Pet->setCraftAI(2);
		if (strstr(comm," PRACTICE ARCHERY"))
		{
			Player->guarded = false;
			Pet->setCraftAI(3);
		}
		return 1;
	}
	
	if (strstr(comm," FETCH") || strstr(comm," GET"))
	{
		Player->guarded = false;
		addx[s]=Pet->serial;
		target(Player, T_124, "Click on the object to fetch.");
		return 1;
	}
	
	if (strstr(comm," COME"))
	{
		Player->guarded = false;
		Pet->SetFollowTarget(Player);
		Pet->npcWander=1;
		Player->Msg("Your pet begins following you.");
		return 1;
	}
	
	if (strstr(comm," GUARD")) //if guard
	{
		addx[s] = Pet->serial;	// the pet's serial
		addy[s] = 0;
		if (strstr( comm, " ME"))
			addy[s]=1;	// indicates we already know whom to guard (for future use)
		// for now they still must click on themselves (Duke)
		target(Player, T_120, "Click on the char to guard.");
		return 1;
	}
	
	if (strstr(comm," STOP") || strstr(comm," STAY"))
	{
		Player->guarded = false;
		Pet->ResetFollowTarget();
		Pet->ResetTarget();
		Pet->resetCraftAI();
		if (Pet->war) npcToggleCombat(Pet);
		Pet->npcWander=0;
		return 1;
	}

	if (strstr(comm," TRANSFER"))
	{
		Player->guarded = false;
		addx[s]=Pet->serial;
		target(Player, T_119, "Select character to transfer your pet to.");
		return 1;
	}

	if (strstr(comm," RELEASE"))
	{
		Player->guarded = false;
		if (Pet->summontimer.IsRunning())
		{
			Pet->summontimer.setSecs(0);
		}
		Pet->ResetFollowTarget();
		Pet->npcWander=4;
		Pet->SetOwnSerial(-1);
		Pet->tamed = false;
		sprintf(temp, "*%s appears to have decided that it is better off without a master *", Pet->name);
		npctalkall(Pet,temp);
		soundeffect2(Pet, 0x01FE);
		if (SrvParms->tamed_disappear==1)
			Npcs->DeleteChar(Pet) ;
		return 1;
	}
	return 0;
}

void PlVGetgold(P_PLAYER Player, cChar* Vendor)//PlayerVendors
{
	unsigned int pay=0, give=Vendor->holdg, t=0;
	if (!Player) return;
	
	if (Player->Owns(Vendor))
	{
		char answer[300];
		if (Vendor->holdg<1)
		{
			npctalk(Player->cs,Vendor,"I have no gold waiting for you.");
			Vendor->holdg=0;
			return;
		}
		else if (Vendor->holdg<=65535)
		{
			if (Vendor->holdg>9)
			{
				pay=(int)(Vendor->holdg*.1);
				give-=pay;
			}
			else
			{
				pay=Vendor->holdg;
				give=0;
			}
			sprintf(answer, "Today's purchases total %i gold. I am keeping %i gold for myself. Here is the remaining %i gold. Have a nice day.",Vendor->holdg,pay,give);
		}
		else
		{
			t=Vendor->holdg-65535;		
			pay=6554;
			give=58981;

			sprintf(answer, "Total %i gold. Paying %i today. I am keeping %i gold for myself. Here is the remaining %i gold. Have a nice day.",Vendor->holdg, 65535, pay, give);
		}

		if (give) Items->SpawnItem(ITY_None,give,"#",0x0EED,0,Player);	
		npctalk(Player->cs,Vendor,answer);
		Vendor->holdg=t;
	}
	else
		npctalk(Player->cs,Vendor,"I don't work for you!");
}

bool VendorChkName(cChar* Vendor, char* comm)
{
	if (strstr(comm, "VENDOR") || strstr(comm, "SHOPKEEPER"))
	{
		return true;
	}
	else
	{
		char vntmp[90];
		strcpy(vntmp,Vendor->name);
		strupr(vntmp);
		if (strstr( comm, vntmp))
			return true;
	}
	return false;
}

bool VendorSpeech(cChar* Vendor, char* comm, P_PLAYER Player)
{
	UOXSOCKET s = Player->cs;
	if (Player->dist(Vendor) > 4)
		return 0;
	
	if (strstr(comm, " BUY"))
	{
		if (!VendorChkName(Vendor,comm))
			return false;

		if (Vendor->isAiVendor())
		{					
			addx[s]=Vendor->serial;
			npctalk(s,Vendor,"What would you like to buy?");
			target(Player,T_224," ");
			return true;
		}
		else
			if (Targ->BuyShop(Player, Vendor))
				return true;
	}
	
	if (strstr( comm, " GOLD"))
	{
		if (!VendorChkName(Vendor,comm))
			return false;

		if (Vendor->isAiVendor())	//PlayerVendors
		{
			PlVGetgold(Player, Vendor);
			return true;
		}
	}
	
	if (strstr( comm, " SELL"))
	{						
		if (!VendorChkName(Vendor,comm))
			return false;

		if (Vendor->isAiVendor()) return false;

		sellstuff(Player, Vendor);						
		return true;
	}
	
	if (strstr( comm, " BULK ORDER"))
	{						
		if (!VendorChkName(Vendor,comm))
			return false;

		if (Vendor->isAiVendor()) return false;

		return giveBulkOrder(Player, Vendor);
	}
	return false;
}

/////////////////
// name:	response
// purpose:	tries to get a response from an npc standing around
// history:	heavily revamped/rewritten by Duke, Oct 2001
// remark:	The new logic tries to minimize the # of strstr() calls by *first* checking
//			what kind of npcs are standing around and then checking only those keywords
//			that they might be interested in.
//			This is especially usefull in crowded places.

int response(P_PLAYER Player, char* SpeechUpr)
{
	char *comm=SpeechUpr;

    if (strstr( comm, "#EMPTY") && Player->InGame() && !Player->dead && Player->isGM())
	{ // restricted to GMs for now. It's too powerful (Duke, 5.6.2001)
		target(Player, T_71, "Select container to empty:");
		return 1;
	}

    if (!Player->InGame() || Player->dead)
		return 0;

	UOXSOCKET s = Player->cs;
	int rc = 0;
	cChar* pc;
	int loopexit=0;
	RegGrid3x3Iterator4Chars rg3ic(Player->pos);
	while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (!pc->npc && !pc->automode)	// only npcs will respond automagically, players still have to do that themselves ;)
			continue;
		if (Player->dist(pc) > 16)		// at least they should be on the screen
			continue;
		if (Player->isSameAs(pc))		// not talking to ourselves
			continue;

		int rcp = PetCommand(pc, comm, Player, s);	// pet commands don't need LoS
		if (rcp == 1) {rc=1;continue;}	// handled, but check the other pets
		if (rcp == 2) return 1;			// handled and break the loop (certain ALL-cmds)
		
		if (!line_of_sight(Player->pos, pc->pos))
			continue;
		
		if (StableSpeech(pc, comm, Player, s))
			return 1;
		
		if (UnStableSpeech(pc, comm, Player, s))
			return 1;
		
		if (ShieldSpeech(pc, comm, Player))
			return 1;
		
		if (QuestionSpeech(pc, comm, Player, s))
			return 1;
		
		if (PackupSpeech(pc, comm, Player))
			return 1;
		
		if (TriggerSpeech(pc, comm, Player))
			return 1;
		
		if (EscortSpeech(pc, comm, Player, s))
			return 1;
		
		if (BankerSpeech(pc, comm, Player))
			return 1;
		
		if (TrainerSpeech(pc, comm, Player, s))
			return 1;
		
		if (VendorSpeech(pc, comm, Player))
			return 1;
	}
	
	return rc;
}

bool checkON(char* SpeechUpr, bool plural)
{
	char scpUpr[500];
	strcpy(scpUpr,script2);
	strupr(scpUpr);
	char* found = strstr(SpeechUpr,scpUpr);
	if (found)								// the speech contains the string somehow,
	{										// make sure it's not part of another word
		int len = strlen(scpUpr);
		if ((found == SpeechUpr || *(found-1) == ' ')	// at the very beginning or preceeded by a space
			&& ((found[len] == 0 || found[len] == ' ')	// at the very end or followed by space
			|| (plural && found[len] == 'S'				// if plural is allowed AND there is an s
			&& (found[len+1] == 0 || found[len+1] == ' '))))	// at the end of the word
		{
			return true;
		}
	}
	return false;
}

void talking(P_PLAYER Player, string speech) // PC speech
{
/*
	Unicode speech format
	byte = char, short = char[2], int = char[4], wchar = char[2] = unicode character

	Message Sent By Client:
	0xAD - Unicode Speech Request
	BYTE cmd(0xAD)
	short msgsize 1, 2
	byte type(0 = say, 2 = emote, 8 = whisper, 9 = yell) 3
	short color 4, 5
	short font 6, 7
	BYTE[4] lang(null terminated, "enu " for US english.) 8, 9, 10, 11
	wchar[?] text(null terminated, ?=(msgsize - 12)/2) 13
  
	Message Sent By Server:
	0xAE - Unicode Speech Message
	BYTE cmd(0xAE) 0
	short msgsize 1, 2
	BYTE[4] ser(ser of speaker, all 0xFF if none) 3, 4, 5, 6
	BYTE[2] model(id of speaker, all 0xFF if none)7, 8
	BYTE type 9
	short color 10, 11
	short font 12, 13
	BYTE[4] language(same as before) 14, 15, 16, 17
	BYTE[30] speaker's name(normal chars, not wchars) 18 - 48
	WCHAR[?] text(null terminated, ?=(msgsize - 48)/2

    Important note regarding 0xAD: since 2.0.7 clients send between lang and text 0...10 bytes. (we can ignore them safely)
	Those bytes get cut out in network.cpp correctly, so the buffer THIS functions sees is actualy what is written above.
    The actual data the client sends is differently though.
	Just noted this to prevent from debugging if somebody finds out client data doesn't fit to this description (LB) 

*/
	
	char nonuni[512];
	unsigned char talk2[19];
	char unicodetext[512];
	char lang[4];
	char name[50] = {0,};	// it **IS** important to 0 out the remaining gaps
	
	if (!Player) return;
	UOXSOCKET s = Player->cs;
	strcpy(nonuni, speech.c_str());

	// len+font+color+type = same postion for non unicode and unicode speech packets
	// but 8 ... x DIFFER a lot for unicode and non unicode packets !!!

	strncpy(name, Player->name, 50);

	char speech_type       = buffer[s][3]; 
	UI16 speech_color	   = ShortFromCharPtr(&buffer[s][4]);
	char speech_fontbyte1  = buffer[s][6];
	char speech_fontbyte2  = buffer[s][7];

	if (speech_color<0x0002 || speech_color>0x03E9 ) speech_color = 0x02B2; // prevents client crash

	int ucl = ( strlen ( nonuni ) * 2 ) + 2 ;	
	int tl = ucl + 48 ;

	if (Player->unicode)
	{
		lang[0]=buffer[s][8];
		lang[1]=buffer[s][9];
		lang[2]=buffer[s][10];
		lang[3]=buffer[s][11];
		
		memcpy(unicodetext, &buffer[s][12], ucl);
	}
	else
	{
		lang[0]='E';
		lang[1]='N';
		lang[2]='U';
		lang[3]=0;
		
		char2wchar(nonuni);		// we are sending unicode response no matter if the speech request was non unicode or not
								// so convert to uni-text in case of non unicode
		memcpy(unicodetext, temp, ucl);  
	}

	/*
	Console.send("speech: %s\n",nonuni);
	Console.send("unicode speech:\n");
	for ( a=0; a < tl-48; a++) Console.send("%02i ",unicodetext[a]);
	Console.send("\n");*/

	//// Very important: do not use buffer[s][] anymore in this function !!!!
	//// unicode text that gets send is in unicodetext, nonunicode text for normal string processing in non uni code

	if (InputSpeech(nonuni, Player))	// handle things like renaming or describing an item
		return;

	if (Player->squelched)					// not allowed to talk
	{
		Player->Msg("You have been squelched.");
		return;
	}
			
	// AntiChrist
	Player->unhide();
		
	if (nonuni[0] == SrvParms->commandPrefix)
	{
		Commands->Command(Player, speech);
		return;
	}

	if (nonuni[0] == SrvParms->chatPrefix)
	{
		Commands->broadcast(Player, nonuni+1);	// skip the preceeding char that indicates 'chat'
		return;
	}

	if ( speech_type == '\x09' && Player->canBroadcast() )
	{
		broadcast(s,Player);
		return;
	}
	
	talk2[0] = 0xAE;
	//ShortToCharPtr(tl, &talk2[1]);
	LongToCharPtr(Player->serial, &talk2[3]);
	ShortToCharPtr(Player->id(), &talk2[7]);
	talk2[9] =  speech_type;
	ShortToCharPtr(speech_color, &talk2[10]);
	talk2[12] = speech_fontbyte1;
	talk2[13] = speech_fontbyte2;

	talk2[14] = lang[0];
	talk2[15] = lang[1];
	talk2[16] = lang[2];
	talk2[17] = lang[3];

	XStartPkt(0xAE, tl);
	XAddPkt(&talk2[0+3], 18-3);
	XAddPkt((unsigned char*)&name[0], 30);   
	XAddPkt((unsigned char*)&unicodetext[0], ucl);  
	XFinishPkt(s);
	
	if (speech_type == 0 || speech_type == 2)
	{
		Player->saycolor = speech_color;
	}
	if (SrvParms->speech_log) // Logging bugfixed by LB
	{
		char temp2[512];
		sprintf(temp2, "%s.speech_log", Player->name);
		sprintf(temp, "%s [%x] [%i] said:\n%s\n", Player->name, Player->serial, Player->account, nonuni);
		savelog(temp, temp2);
	}
	
	char SpeechUpr[512];
	strcpy(SpeechUpr, nonuni);
	strupr(SpeechUpr);

	if (!strcmp(SpeechUpr, "I RESIGN FROM MY GUILD"))
		Guilds->Resign(Player);
	
	if (response(Player,SpeechUpr))
		return;  // Vendor responded already
	
	if (strstr(SpeechUpr, "GUARDS"))
		callguards(Player);
	
	if (Boats->Speech(Player, SpeechUpr))
		return;
	
	house_speech(Player, SpeechUpr); // houses crackerjack 8/12/99			
	
	P_CHAR pc;
	AllPlayersIterator api;
	for (pc = api.First(); pc != NULL; pc = api.Next())
	{
		int i=api.getSocket();
		if (inrange1p(Player, pc) && i!=s)
		{

			XStartPkt(0XAE, ucl+48);
			XAddPkt((unsigned char*)&talk2[0+3], 18-3);
			XAddPkt((unsigned char*)&name[0], 30);

			if (Player->dead				// a ghost is talking
				&& !pc->dead				// Ghost can talk normally to other ghosts
				&& !pc->isGMorCounselor()	// GM/Counselors can see ghosts talking always  Seers?
				&& !pc->spiritspeaktimer.IsRunning())
			{
				unsigned char ghostspeech[512];
				memcpy(&ghostspeech, &unicodetext, ucl);
				int j;
				for (j = 1; j < ucl-2 ; j += 2)	// -2: dont override /0 /0 terminator !
				{
					if (ghostspeech[j] != 32)	// keep the blanks
						ghostspeech[j] = (ghostspeech[j]%2) ? 'O' : 'o';
				}
				XAddPkt(&ghostspeech[0], ucl);		// send 'ghostified' speech "OOoooOo  Ooo"
				XFinishPkt(i);
			}
			else
			{
				XAddPkt((unsigned char*)&unicodetext, ucl);   
				XFinishPkt(i);
			}
		}
	}
	
	if (Player->dead) return; // this makes it so npcs do not respond to dead people
	
	cChar* pNpc=NULL;
	int loopexit=0;
	RegGrid3x3Iterator4Chars rg3ic(Player->pos);
	while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (!pc->isSameAs(Player) 
			&& pc->npc
			&& pc->dist(Player) <= 2)
		{
			pNpc=pc;
			break;
		}
	}
	if (pNpc && pNpc->speech)
	{
		Script* Scp = findSection(speech_script,"SPEECH",pNpc->speech);
		if (!Scp) return;

		char sect[512];
		int match = 0;
		int deftrg = 0;
		strcpy(sect, "NO DEFAULT TEXT DEFINED");
		int loopexit = 0;
		while (Scp->NextLineSplitted() && (++loopexit < MAXLOOPS))
		{		
			if (!Scp->cmpTag("DEFAULT"))
			{
				strcpy(sect, script2);

				if (SrvParms->unicodehack)
				{
					Scp->translate_scpt2_to_Unicode();
					wcsncpy(wscript3, wscript2,512);			
				}
			}

			if (!Scp->cmpTag("ONS"))		// allows for plural 's'
			{
				if (checkON(SpeechUpr,true))
					match=1;
			}

			if (!Scp->cmpTag("ON"))
			{
				if (checkON(SpeechUpr,false))
					match=1;
			}

			if (!Scp->cmpTag("SAY"))
			{
				if (match == 1)
				{
					if (SrvParms->unicodehack)
					{
					    Scp->translate_scpt2_to_Unicode();
						npctalk_new(s, pNpc, wscript2, NULL, 0);
					}
					else npctalk(s, pNpc, script2);
					match = 2;
					deftrg = 0;		// Voids DEFTRG if another ON is prevalent over DEFTRG
				}
			}
			
			if (!Scp->cmpTag("TRG")) // Added by Magius(CHE) 
			{							  
				if (match == 1)
				{
					pNpc->trigger = str2num(script2);
					scpMark m; Scp->Suspend(m);
					
					triggernpc(Player, pNpc, 1);
					
					Scp->Resume(m);
					strcpy(script1, "DUMMY");
					
					match = 2;
					deftrg = 0;		// Voids DEFTRG if another ON is prevalent over DEFTRG
				}
			}

			if (!strcmp("DEFTRG", script1)) // Added by Skyfire for DEFAULT TRIGGER use.
											// Considered adding it to work with the existing
											// TRG keyword, but decided that this would be
											// better in the event that you dont want the npc
											// to even have a DEFAULT saying.
			{
				pNpc->trigger = str2num(script2);
				deftrg = 1; // Sets the trigger to fire if no other phrase matches found.
			}

			if (match == 2)	break;	// the npc talked and/or was triggered
		}

		if (match == 0)		// nothing they said was recognized
		{
			if (SrvParms->unicodehack) npctalk_new(s, pNpc, wscript3, NULL, 0);
			else npctalk(s, pNpc, sect);
		}
		if (deftrg == 1) // Fires if not zerod out by other SAY or TRG
		{
			triggernpc(Player, pNpc, 1);
		}

		Scp->Close();
	}
}


void char2wchar (const char* str)
{
	memset(&temp[0], 0, 1024);
	unsigned int size = strlen(str);
	
	// client wants to have a 0 as very fist byte.
	// after that 0 the unicode text
	// after it two(!) 0's as termintor

	unsigned int j=1;
	// temp[0]=0; //redundant, plz leave as comment

	for (unsigned int i = 0; i < size; i++) // bugfix LB ... temp[i+1] = str[i] .... wrong
	{
		temp[j]   = str[i];
		// temp[j+1] = 0; // redundant line, plz leave as comment
		j+=2;
	}

	// basicly redundant as well, plz leave as comment
	// temp[j]=0;
	// temp[j+1]=0;
}


inline unsigned char map_uc_to_char(unsigned char uc1, unsigned char uc2)
{
 if (uc1==0) return uc2; else return uc2+0x80;
}


/////
// maps U-00000000 - U-0000007F to ascii-0-7f
// others ... to ascii 80-ff ... of course this aint lossless, only works ok if (non latin) alphabet <0x80
//
// unicode (in) input
// size (in): #elements (wchar_ts) in input stream 
// bigendian(in): out big
// result (out): output buffer (char)
//
// result buffer has to be allocated allocated before calling ! (size) bytes

void unicode_to_char(wchar_t *unicode, int size, bool bigendian, unsigned char* out)
{
   unsigned char b1=0,b2=0;  
   wchar_t uc;
   int a;

   for (a=0; a<size; a++)
   {
	  uc = unicode[a];
	  if (!bigendian) { b1 = static_cast<unsigned char>(uc); b2 = static_cast<unsigned char>(uc >> 8); } else { b2 = static_cast<unsigned char>(uc); b1 = static_cast<unsigned char>(uc >> 8); }
	  out[a] = map_uc_to_char(b1,b2);	  
   } 
}


////
/// utf8 (in) : utf-8 input stream (chars)
/// insize (in): size of the input stream in bytes
/// out (out): wchar_t (short) buffer (result)
/// actualout (out): number of actual unicode chars returned.
///
/// note: out-buffer has to be allocated before calling, has to have room for insize+1 (wchar_t) elements.
/// (worst case: 1 byte input -> 2 bytes unicode -> 1 wchar_t (plus 0 term=+1)
///

void utf8_to_unicode_string(const unsigned char *utf8, int insize, int &actualoutsize, wchar_t* out)
{   
  unsigned char d;
  int size = 0, index = 0, out_index = 0;
  
    /* calc size of the target string */
  
    d = utf8[index++];
    while(d || index<insize) 
	{
      if((d & 0x80) == 0) 
	  {
        index += 0;
      } 
	  else if((d & 0xe0) == 0xe0) 
	  {
		//printf("UTF8-B2 @ %x \n", index);
        index += 2;
      } 
	  else 
	  {
		//printf("UTF8-B3 @ %x\n", index);
        index += 1;
      }
      size += 1;
      d = utf8[index++];
    }   	

	int out_buffersize = insize+1; // worst case: each byte in inputstream = 1 wchar_t plus 00

	// this and above test code to be removed after sucessfull testing
	if (out_buffersize<size) 
	{
		printf("Error in utf8\n");
		LogError("Error in utf8\n");
		return;
	}	

   //sz=size+1;
   //out = new wchar_t[size+1];
   // if (out == NULL) return NULL;
  
    index = 0;

    d = utf8[index++];
    while(d || index<insize )
    {
        if((d & 0x80) == 0) 
		{
          out[out_index++] = d;
        } 
		else if((d & 0xe0) == 0xe0) 
		{
          out[out_index] = (d & 0x1F) << 12;
          d = utf8[index++];
          out[out_index] |= (d & 0x3F) << 6;
          d = utf8[index++];
          out[out_index++] |= (d & 0x3F);
        } 
		else 
		{
          out[out_index] = (d & 0x3F) << 6;
          d = utf8[index++];
          out[out_index++] |= (d & 0x3F);
        }
        d = utf8[index++];
    }
    out[out_index] = 0;

	actualoutsize=out_index+1;

    //return out;
}


