/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#include "trigger.h"

#include "Client.h"
#include "commands.h"
#include "gumps.h"
#include "magic_new.h"
#include "mapstuff.h"
#include "network.h"
#include "regions.h"
#include "scriptc.h"
#include "skills.h"
#include "SndPkg.h"
#include "targeting.h"
#include "teleport.h"
#include "tiledata.h"
#include "walking.h"
#include "weight.h"

#include "wolfpack.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "trigger2.cpp"

static void handle_NADD(UOXSOCKET const ts, P_CHAR pc_ts, Script* Scp, cTriggerContext& TC) 
{ 
	enum addways {onGround, same, atLocation, relativeToPlayer}; 
	cline = &script2[0]; 
	splitline(); 
	cCoord TrgPos;
	unsigned int NPCNum = makenumber(0); 
	addways addHow = (addways)makenumber(1); 
	TrgPos.x = makenumber(2);
	TrgPos.y = makenumber(3); 
	TrgPos.z = makenumber(4); 
	TrgPos.map = pc_ts->pos.map;
	if (tnum<2) addHow=same;
	if (NPCNum<1) 
	{ 
		sysmessage(ts, "Contact GM: Invalid NPC Nr in NADD"); 
		return; 
	} 
	if (addHow<0 || addHow>3) 
	{ 
		sysmessage(ts, "Contact GM: Invalid NADD Type"); 
		return; 
	} 
	if (addHow==same) 
	{ 
		if (TC.TrigItem && TC.TrigItem->isInWorld())
		{
			TrgPos.Add(TC.TrigItem->pos.x,TC.TrigItem->pos.y,TC.TrigItem->pos.z);
		}
		else if (TC.TrigChar) 
		{
			TrgPos.Add(TC.TrigChar->pos.x,TC.TrigChar->pos.y,TC.TrigChar->pos.z);
		}
		else addHow=onGround;
	}
	if (addHow==onGround) 
	{ 
		TrgPos = pc_ts->pos;
		TrgPos.Add(1,1);
	} 
	else if (addHow==relativeToPlayer) 
	{ 
		TrgPos.Add(pc_ts->pos.x , pc_ts->pos.y , pc_ts->pos.z); 
	} 
	
	scpMark m; Scp->Suspend(m);
	TC.Spawned = Npcs->AddNPC(ts, NULL, NPCNum, TrgPos);
	Scp->Resume(m);
	strcpy(script1, "DUMMY");
}

static void handle_IADD(UOXSOCKET const ts, P_CHAR pc_ts, Script* Scp, cTriggerContext& TC) 
{ 
	enum addways {onGround, inBackPack, atLocation, relativeToPlayer, same}; 
	cline = &script2[0]; 
	splitline(); 
	unsigned int ItemNum = makenumber(0); 
	addways addHow = (addways)makenumber(1); 
	int x = makenumber(2), y = makenumber(3); 
	signed char z = makenumber(4);
	if (tnum<2) addHow=inBackPack;
	if (ItemNum<1) 
	{ 
		sysmessage(ts, "Contact GM: Invalid Item Nr in IADD"); 
		return; 
	} 
	if (addHow<0 || addHow>4) 
	{ 
		sysmessage(ts, "Contact GM: Invalid IADD Type"); 
		return; 
	} 
	if (addHow==same) 
	{ 
		if (TC.TrigItem && TC.TrigItem->isInWorld())
		{
			x += TC.TrigItem->pos.x;
			y += TC.TrigItem->pos.y;
			z += TC.TrigItem->pos.z;
		}
		else if (TC.TrigChar) 
		{
			x += TC.TrigChar->pos.x;
			y += TC.TrigChar->pos.y;
			z += TC.TrigChar->pos.z;
		}
		else addHow=onGround;
	}
	if (addHow==onGround) 
	{ 
		x = pc_ts->pos.x; 
		y = pc_ts->pos.y; 
		GetXYfromDir(pc_ts->dir, &x, &y); 
		z = pc_ts->pos.z;
	} 
	else if (addHow==relativeToPlayer) 
	{ 
		x += pc_ts->pos.x; 
		y += pc_ts->pos.y; 
		z += pc_ts->pos.z;
	} 
	
	scpMark m; Scp->Suspend(m); 
 
	P_ITEM iItem=Items->CreateScriptItem(ts, ItemNum, 0); 
	
	if (iItem!=NULL) 
	{ 
		if (TC.coloring>-1) 
			iItem->setColor(TC.memColor); 
		if (addHow != inBackPack) 
		{
			iItem->MoveTo(x,y,z); 
			iItem->refresh();
		}
		else 
		{ 
			P_ITEM iPack = pc_ts->getBackpack(); 
			iPack->AddItem(iItem); 
			Weight->NewCalc(pc_ts); 
			statwindow(ts, pc_ts); 
		} 
	} 
	TC.SpawnedItem=iItem; 
	
	Scp->Resume(m); 
	strcpy(script1, "DUMMY"); 
}

static void handle_PLAYERCURE(P_CHAR pc_ts) 
{
	cline = &script2[0] ;
	splitline();
	if (pc_ts->Poisoned() && pc_ts->Poisoned() <= makenumber(0))
		pc_ts->ResetPoisoned();
}

static void handle_PLAYERPOISONED(UOXSOCKET const ts, P_CHAR pc_ts) 
{
	cline = &script2[0] ;
	splitline();
	if (pc_ts->Poisoned())
	{
		pc_ts->PoisonStart(ts,makenumber(0));
		soundeffect2(pc_ts, 0x0246);
	}
}

// I do not understand api or what allplayersiterator is so i commented this out untell i can find a way to fix it.
//static void handle_PLAYMUSIC(P_CHAR pc_ts) 
//{
	//cline = &script2[0];
	//splitline();
	//if (makenumber(1) > 0)
	//{
		//P_CHAR pc_l;
		//AllPlayersIterator api;
		//for (pc_l = api.First(); pc_l != NULL; pc_l = api.Next())
		//{
		//	playmidi(api.getSocket(), 0, makenumber(0));
		//}
	//} 
     // else 
     // {
		//P_CHAR pc_l;
		//AllPlayersInRangeIterator api(pc_ts->pos);
		//for (pc_l = api.First(); pc_l != NULL; pc_l = api.Next())
		//{
		//	playmidi(api.getSocket(), 0, makenumber(0));
		//}
	//}
//}

static int handle_PAY(P_CHAR pc_ts) // Pays from pack or bank
{
	if (pc_ts->canAfford(str2num(script2)))
	{
		pc_ts->pay(str2num(script2));
		Weight->NewCalc(pc_ts);
		return 1;
	}
	return 2;
}

static int handle_USEUPAMOUNT(UOXSOCKET const ts, P_CHAR pc_ts, cTriggerContext& TC) 
{
	cline = &script2[0];
	splitline();
	int amount = makenumber(0);
	if (!TC.NeedItem)
	{
		sysmessage(ts, "It appears as though you have insufficient supplies to make that with.");
		return 2;
	} 
      else 
      {
		if (amount > 0)
		{
			if (TC.NeedItem->amount >= amount)
			{
				TC.NeedItem->ReduceAmount(amount);
				Weight->NewCalc(pc_ts);
				return 1;
			} 
                  else 
                  {
				sysmessage(ts, "You need more of these..");
				return 2;
		      }
		}
		TC.NeedItem->ReduceAmount(1);
		Weight->NewCalc(pc_ts);
		return 1;
	}
}


/////////////
// name:	handle_RiskyTags
// purpose: handle the tags that are created by our newbie coders
//			calledfrom=1 means from triggerwitem(), 2 means from triggernpc()
// returns: 0=tag not handled, 1=handled it, 2= abort trigger
// history:	by Duke, 16.11.2005
//
int handle_RiskyTags(P_PLAYER Player, cTriggerContext& TC, Script* Scp, int calledfrom)
{
	if (calledfrom == 1)
	{
		P_ITEM pi = TC.TrigItem;
		if (!strcmp("NEWBIEITEM", script1)) // Set item newbie
		{
			if (pi->isContainerType() == false)
			{
				if (pi->newbie() == false)
				{
					sprintf(pi->name,"%s [Blessed]",pi->name);
					pi->newbieOn();
				}
			}
			return 1;
		}
		else if (!strcmp("NADD", script1))
		{
			handle_NADD(Player->cs, Player, Scp, TC);
			return 1;
		}
		else if (!strcmp("FREEZEON", script1))
		{
			if (Player)
			       Player->Freeze();
		}
		else if (!strcmp("FREEZEOFF", script1))
		{
			if (Player)
			       Player->Unfreeze();
		}
		else if (!strcmp("IADD", script1))
		{
			handle_IADD(Player->cs, Player, Scp, TC);
			return 1;
		}
		else if (!strcmp("PLAYERCURE", script1))
		{ 
			handle_PLAYERCURE(Player); 
			return 1; 
		} 
		else if (!strcmp("PLAYERPOISONED", script1))
		{ 
			handle_PLAYERPOISONED(Player->cs, Player); 
			return 1; 
		}
		//else if (!strcmp("PLAYMUSIC", script1))
		//{ 
		//	handle_PLAYMUSIC(Player); 
		//	return 1; 
		//} 
		else if (!strcmp("PAY", script1))
		{
			return handle_PAY(Player);
		}
		else if (!strcmp("USEUPAMOUNT", script1))
		{
			return handle_USEUPAMOUNT(Player->cs, Player,TC);
		}
	}
	
	return 0;	// not handled
}

